// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include "build.h"
#include "names.h"

#define MAXMENUFILES 256

extern char picsiz[MAXTILES];
extern short numwalls, numscans, numhits, numbunches;
extern short page;
static long pageoffset, ydim16, startposx, startposy, startposz, startang;
extern long frameplace;

static short localartfreq[MAXTILES];
static short localartlookup[MAXTILES], localartlookupnum;

static short asksave;
extern short editstatus, searchit;
extern long searchx, searchy;                          //search input
extern short searchsector, searchwall, searchstat;     //search output

static short pointhighlight, linehighlight;
static unsigned short grid, gridlock;
static long zoom;

extern char palette[768];
static short highlights[MAXWALLS], highlightcnt;
extern char textfont[128][8];

static short temppicnum, tempcstat;
static char tempshade, tempxrepeat, tempyrepeat, somethingintab;
static char boardfilename[13];

static char menuname[MAXMENUFILES][17], curpath[80], menupath[80];
static long menunamecnt, menuhighlight;

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux checkvesa =\
	"mov ax, 0x4f00",\
	"int 0x10",\
	"cmp ax, 0x004f",\
	"sete al",\
	"and eax, 0x000000ff",\
	modify [eax]\

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"sar cx, 1",\
	"sar dx, 1",\
	"mov mousx, cx",\
	"mov mousy, dx",\
	"mov ax, 5d",\
	"int 33h",\
	"mov bx, bstatus",\
	"mov obstatus, bx",\
	"mov bstatus, ax",\
	modify [eax ecx edx]\

#pragma aux getpixel =\
	"xor eax, eax",\
	"mov al, [edi]",\
	parm [edi]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

#pragma aux drawpixels =\
	"mov word ptr [edi], ax",\
	parm [edi][eax]\

#pragma aux drawpixeles =\
	"mov dword ptr [edi], eax",\
	parm [edi][eax]\

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux copybuf =\
	"rep movsd",\
	parm [esi][edi][ecx]\

#pragma aux setcolor16 =\
	"mov dx, 0x3ce",\
	"shl ax, 8",\
	"out dx, ax",\
	parm [eax]\

#pragma aux vlin16first =\
	"mov al, byte ptr [edi]",\
	"mov eax, ecx",\
	"shr ecx, 2",\
	"begvlin16firsta: mov byte ptr [edi], al",\
	"mov byte ptr [edi+80], al",\
	"mov byte ptr [edi+160], al",\
	"mov byte ptr [edi+240], al",\
	"add edi, 320",\
	"loop begvlin16firsta",\
	"mov ecx, eax",\
	"and ecx, 3",\
	"jz skipfirst",\
	"begvlin16firstb: mov byte ptr [edi], al",\
	"add edi, 80",\
	"loop begvlin16firstb",\
	"skipfirst:",\
	parm [edi][ecx]\
	modify [eax esi]\

#pragma aux vlin16 =\
	"mov esi, edi",\
	"begvlin16: movsb",\
	"add edi, 79",\
	"add esi, 79",\
	"loop begvlin16",\
	parm [edi][ecx]\
	modify [eax esi]\

#pragma aux hlin16 =\
	"mov eax, ecx",\
	"shr ecx, 2",\
	"rep stosd",\
	"mov ecx, eax",\
	"and ecx, 3",\
	"rep stosb",\
	"mov eax, edi",\
	parm [edi][ecx]\

#pragma aux drawpixel16 =\
	"mov cx, di",\
	"and cl, 7",\
	"xor cl, 7",\
	"mov ah, 1",\
	"shl ah, cl",\
	"mov dx, 0x3ce",\
	"mov al, 0x8",\
	"out dx, ax",\
	"shr edi, 3",\
	"mov al, byte ptr [edi+0xa0000]",\
	"mov byte ptr [edi+0xa0000], al",\
	parm [edi]\
	modify [eax ecx edx]\

#pragma aux fillscreen16 =\
	"mov dx, 0x3ce",\
	"shl ax, 8",\
	"out dx, ax",\
	"mov ax, 0xff08",\
	"out dx, ax",\
	"shr ecx, 5",\
	"add edi, 0xa0000",\
	"rep stosd",\
	parm [edi][eax][ecx]\
	modify [edx]\

#pragma aux limitrate =\
	"mov dx, 0x3da",\
	"wait1: in al, dx",\
	"test al, 8",\
	"jnz wait1",\
	"wait2: in al, dx",\
	"test al, 8",\
	"jz wait2",\

main(short int argc,char **argv)
{
	char ch;
	long i, j, k, dax, day, daz;

	initengine();
	initeditor();

	if (argc >= 2)
	{
		strcpy(&boardfilename,argv[1]);
		if(strchr(boardfilename,'.') == 0)
			strcat(boardfilename,".map");
	}
	else
		strcpy(&boardfilename,"newboard.map");

	loadpics("tiles000.art");

	setgamemode();

	for (i=0;i<XDIM;i++)
	{
		startumost[i] = 0;
		startdmost[i] = YDIM;
	}

	editstatus = 1;
	somethingintab = 0;

	initmenupaths(argv[0]);
	menunamecnt = 0;
	menuhighlight = 0;

	if (loadboard(boardfilename) == -1)
	{
		posx = 32768;
		posy = 32768;
		posz = 0;
		ang = 1536;
		numsectors = 0;
		numwalls = 0;
		cursectnum = -1;
		overheadeditor();
		keystatus[0x9c] = 0;
	}

	startposx = posx;
	startposy = posy;
	startposz = posz;
	startang = ang;

	while (keystatus[1] != 2)
	{
		drawrooms();
		drawmasks();

		editinput();
		engineinput();

		if (keystatus[0x3b] > 0) posx--;
		if (keystatus[0x3c] > 0) posx++;
		if (keystatus[0x3d] > 0) posy--;
		if (keystatus[0x3e] > 0) posy++;
		if (keystatus[0x3f] > 0) ang--;
		if (keystatus[0x40] > 0) ang++;

		nextpage();

		if (keystatus[1] > 0)
		{
			keystatus[1] = 0;
			printext(0,0,"Really want to quit?",ALPHABET,255);
			nextpage();
			while ((keystatus[1]|keystatus[0x1c]|keystatus[0x39]|keystatus[0x31]|keystatus[0x15]) == 0);
			if (keystatus[0x15] > 0)
				keystatus[1] = 2;
		}
	}
	uninitengine();
	setvmode(0x3);

	if (asksave == 0)
		showengineinfo();
	else
	{
		printf("Save changes?\n");
		do
		{
			ch = getch();
		}
		while ((ch != 'y') && (ch != 'Y') && (ch != 'n') && (ch != 'N'));
		if ((ch == 'y') || (ch == 'Y'))
		{
			posx = startposx;
			posy = startposy;
			posz = startposz;
			ang = startang;
			saveboard(boardfilename);
		}
	}
	printf("BUILD programmed by Ken Silverman\n");
	return(0);
}

initeditor()
{
	editstatus = 1;
	somethingintab = 0;
	asksave = 0;
	zoom = 768, grid = 3, gridlock = 1;
}

int getcard()         //returns: 0 = nothing, 1 = TSENG ET4000, 2 = VESA
{
	int value, newvalue, oldvalue, bas, tseng, vesa, card;

	outp(0x3bf,3);                       //Check TSENG
	if ((inp(0x3cc)&1) == 1)
		outp(0x3d8, 0xa0);
	else
		outp(0x3b8, 0xa0);
	inp(0x3da); outp(0x3c0,0x16); oldvalue = inp(0x3c1);
	inp(0x3da); outp(0x3c0,0x16); newvalue = (oldvalue^16);
	outp(0x3c0, newvalue);
	inp(0x3da); outp(0x3c0,0x16); value = inp(0x3c1);
	inp(0x3da); outp(0x3c0,0x16); outp(0x3c0,oldvalue);
	tseng = 0;
	if (value == newvalue)
	{
		if ((inp(0x3cc)&1) == 1)
			bas = 0x3d0;
		else
			bas = 0x3b0;
		outp(bas+4,0x33); oldvalue = inp(bas+5);
		outp(bas+5,oldvalue^15); newvalue = inp(bas+5);
		outp(bas+5,oldvalue);
		if (newvalue == (oldvalue^15))
			tseng = 4000;  //TSENG ET4000
		else
			tseng = 3000;  //TSENG ET3000
	}

	vesa = checkvesa();                   //Check VESA

	if (tseng == 4000)
		card = 1;
	else if (vesa == 1)
		card = 2;
	else
		card = 0;

	return(card);
}

showmouse320200()
{
	long i;

	if (option[0] == 0)
	{
		for(i=1;i<=4;i++)
		{
			if ((startumost[searchx+i] <= searchy) && (startdmost[searchx+i] > searchy))
			{
				outpw(0x3c4,2+(256<<((searchx+i)&3)));
				drawpixel(0xa0000+(searchy)*80+((searchx+i)>>2)+(((long)page)<<14),31);
			}
			if ((startumost[searchx-i] <= searchy) && (startdmost[searchx-i] > searchy))
			{
				outpw(0x3c4,2+(256<<((searchx-i)&3)));
				drawpixel(0xa0000+(searchy)*80+((searchx-i)>>2)+(((long)page)<<14),31);
			}
			if ((startumost[searchx] <= (searchy-i)) && (startdmost[searchx] > (searchy-i)))
			{
				outpw(0x3c4,2+(256<<((searchx)&3)));
				drawpixel(0xa0000+(searchy-i)*80+((searchx)>>2)+(((long)page)<<14),31);
			}
			if ((startumost[searchx] <= (searchy+i)) && (startdmost[searchx] > (searchy+i)))
			{
				outpw(0x3c4,2+(256<<((searchx)&3)));
				drawpixel(0xa0000+(searchy+i)*80+((searchx)>>2)+(((long)page)<<14),31);
			}
		}
	}
	else
	{
		for(i=1;i<=4;i++)
		{
			if ((startumost[searchx+i] <= searchy) && (startdmost[searchx+i] > searchy))
				drawpixel(frameplace+(searchy)*320+(searchx+i),31);
			if ((startumost[searchx-i] <= searchy) && (startdmost[searchx-i] > searchy))
				drawpixel(frameplace+(searchy)*320+(searchx-i),31);
			if ((startumost[searchx] <= (searchy-i)) && (startdmost[searchx] > (searchy-i)))
				drawpixel(frameplace+(searchy-i)*320+(searchx),31);
			if ((startumost[searchx] <= (searchy+i)) && (startdmost[searchx] > (searchy+i)))
				drawpixel(frameplace+(searchy+i)*320+(searchx),31);
		}
	}
}

editinput()
{
	long i, templong, smooshyalign, doubvel;

	if (moustat == 1)
	{
		readmouse();
		searchx += mousx;
		searchy += mousy;
	}
	if (searchx < 4) searchx = 4;
	if (searchx > 315) searchx = 315;
	if (searchy < 4) searchy = 4;
	if (searchy > 195) searchy = 195;
	showmouse320200();

	if (angvel != 0)
	{
		doubvel = lockspeed;
		if (keystatus[0x2a] > 0)
			doubvel += (lockspeed>>1);

		ang += ((angvel*doubvel)>>5);
		ang = (ang+2048)&2047;
	}

	doubvel = lockspeed;
	if (keystatus[0x2a] > 0)
		doubvel += lockspeed;

	if (vel != 0)
		clipmove(&posx,&posy,&posz,&cursectnum,(long)(vel*doubvel*sintable[(ang+2560)&2047])>>4,(long)(vel*doubvel*sintable[ang&2047])>>4,128L);
	if (svel != 0)
		clipmove(&posx,&posy,&posz,&cursectnum,(long)(svel*doubvel*sintable[ang&2047])>>4,(long)(svel*doubvel*sintable[(ang+1536)&2047])>>4,128L);

	if (keystatus[0x1e] > 0)                            //A
	{
		if (heightofffloor < (sector[cursectnum].floorz-sector[cursectnum].ceilingz-(8<<8)))
		{
			heightoffceiling -= (2<<8);
			heightofffloor += (2<<8);
		}
		if ((keystatus[0x2a]|keystatus[0x36]) > 0)       //Either shift key
			if (heightofffloor < (sector[cursectnum].floorz-sector[cursectnum].ceilingz-(8<<8)))
			{
				heightoffceiling -= (2<<8);
				heightofffloor += (2<<8);
			}
	}
	if (keystatus[0x2c] > 0)                            //Z
	{
		if (heightofffloor > (4<<8))
		{
			heightoffceiling += (2<<8);
			heightofffloor -= (2<<8);
		}
		if ((keystatus[0x2a]|keystatus[0x36]) > 0)       //Either shift key
			if (heightofffloor > (4<<8))
			{
				heightoffceiling += (2<<8);
				heightofffloor -= (2<<8);
			}
	}


	searchit = 2;
	if (searchstat >= 0)
	{
		if ((bstatus&1) > 0)
			searchit = 0;
		if (keystatus[0x4a] > 0)  // -
		{
			if (searchstat == 0) wall[searchwall].shade++;
			if (searchstat == 1) sector[searchsector].ceilingshade++;
			if (searchstat == 2) sector[searchsector].floorshade++;
			if (searchstat == 3) sprite[searchwall].shade++;
			if (searchstat == 4) wall[searchwall].shade++;
			asksave = 1;
			keystatus[0x4a] = 0;
		}
		if (keystatus[0x4e] > 0)  // +
		{
			if (searchstat == 0) wall[searchwall].shade--;
			if (searchstat == 1) sector[searchsector].ceilingshade--;
			if (searchstat == 2) sector[searchsector].floorshade--;
			if (searchstat == 3) sprite[searchwall].shade--;
			if (searchstat == 4) wall[searchwall].shade--;
			asksave = 1;
			keystatus[0x4e] = 0;
		}
		if (keystatus[0xc9] > 0) // PGUP
		{
			if ((searchstat == 0) || (searchstat == 1))
			{
				i = headspritesect[searchsector];
				while (i != -1)
				{
					templong = sector[searchsector].ceilingz;
					templong += ((tilesizy[sprite[i].picnum]*sprite[i].yrepeat)<<2);
					if (sprite[i].z == templong)
						sprite[i].z -= 1024;
					i = nextspritesect[i];
				}

				sector[searchsector].ceilingz -= 1024;
			}
			if (searchstat == 2)
			{
				i = headspritesect[searchsector];
				while (i != -1)
				{
					if (sprite[i].z == sector[searchsector].floorz)
						sprite[i].z -= 1024;
					i = nextspritesect[i];
				}

				sector[searchsector].floorz -= 1024;
			}
			if (sector[searchsector].floorz < sector[searchsector].ceilingz)
				sector[searchsector].floorz = sector[searchsector].ceilingz;
			if (searchstat == 3)
			{
				if (keystatus[0x9d] > 0)  //Right CTRL - put sprite on ceiling
				{
					sprite[searchwall].z = sector[searchsector].ceilingz;
					sprite[searchwall].z += ((tilesizy[sprite[searchwall].picnum]*sprite[searchwall].yrepeat)<<2);
				}
				else
					sprite[searchwall].z -= (4<<8);
			}
			asksave = 1;
			keystatus[0xc9] = 0;
		}
		if (keystatus[0xd1] > 0) // PGDN
		{
			if ((searchstat == 0) || (searchstat == 1))
			{
				i = headspritesect[searchsector];
				while (i != -1)
				{
					templong = sector[searchsector].ceilingz;
					templong += ((tilesizy[sprite[i].picnum]*sprite[i].yrepeat)<<2);
					if (sprite[i].z == templong)
						sprite[i].z += 1024;
					i = nextspritesect[i];
				}

				sector[searchsector].ceilingz += 1024;
			}
			if (searchstat == 2)
			{
				i = headspritesect[searchsector];
				while (i != -1)
				{
					if (sprite[i].z == sector[searchsector].floorz)
						sprite[i].z += 1024;
					i = nextspritesect[i];
				}

				sector[searchsector].floorz += 1024;
			}
			if (sector[searchsector].ceilingz > sector[searchsector].floorz)
				sector[searchsector].ceilingz = sector[searchsector].floorz;
			if (searchstat == 3)
			{
				if (keystatus[0x9d] > 0)  //Right CTRL - put sprite on ground
					sprite[searchwall].z = sector[searchsector].floorz;
				else
					sprite[searchwall].z += (4<<8);
			}
			asksave = 1;
			keystatus[0xd1] = 0;
		}
		if (keystatus[0x0f] > 0)  //TAB
		{
			if (searchstat == 0)
			{
				temppicnum = wall[searchwall].picnum;
				tempshade = wall[searchwall].shade;
				tempxrepeat = wall[searchwall].xrepeat;
				tempyrepeat = wall[searchwall].yrepeat;
				tempcstat = wall[searchwall].cstat;
			}
			if (searchstat == 1)
			{
				temppicnum = sector[searchsector].ceilingpicnum;
				tempshade = sector[searchsector].ceilingshade;
				tempxrepeat = 8;
				tempyrepeat = 8;
				tempcstat = 0;
			}
			if (searchstat == 2)
			{
				temppicnum = sector[searchsector].floorpicnum;
				tempshade = sector[searchsector].floorshade;
				tempxrepeat = 8;
				tempyrepeat = 8;
				tempcstat = 0;
			}
			if (searchstat == 3)
			{
				temppicnum = sprite[searchwall].picnum;
				tempshade = sprite[searchwall].shade;
				tempxrepeat = sprite[searchwall].xrepeat;
				tempyrepeat = sprite[searchwall].yrepeat;
				tempcstat = 0;
			}
			if (searchstat == 4)
			{
				temppicnum = wall[searchwall].picnum;
				tempshade = wall[searchwall].shade;
				tempxrepeat = wall[searchwall].xrepeat;
				tempyrepeat = wall[searchwall].yrepeat;
				tempcstat = wall[searchwall].cstat;
			}
			somethingintab = 1;
			keystatus[0x0f] = 0;
		}
		if ((keystatus[0x1c] > 0) && (somethingintab > 0))  //Left ENTER
		{
			if ((keystatus[0x2a]|keystatus[0x36]) > 0)       //Either shift key
			{
				if (searchstat == 0) wall[searchwall].shade = tempshade;
				if (searchstat == 1) sector[searchsector].ceilingshade = tempshade;
				if (searchstat == 2) sector[searchsector].floorshade = tempshade;
				if (searchstat == 3) sprite[searchwall].shade = tempshade;
				if (searchstat == 4) wall[searchwall].shade = tempshade;
			}
			else if ((searchstat == 0) && (keystatus[0x1d]|keystatus[0x9d]) > 0)  //Either ctrl key
			{
				i = searchwall;
				do
				{
					wall[i].picnum = temppicnum;
					wall[i].shade = tempshade;
					wall[i].xrepeat = tempxrepeat;
					wall[i].yrepeat = tempyrepeat;
					wall[i].cstat = tempcstat;
					fixrepeats((short)i,temppicnum);
					i = wall[i].point2;
				}
				while (i != searchwall);
			}
			else
			{
				if (searchstat == 0)
				{
					wall[searchwall].picnum = temppicnum;
					wall[searchwall].shade = tempshade;
					wall[searchwall].xrepeat = tempxrepeat;
					wall[searchwall].yrepeat = tempyrepeat;
					wall[searchwall].cstat = tempcstat;
					fixrepeats(searchwall,temppicnum);
				}
				if (searchstat == 1)
				{
					sector[searchsector].ceilingpicnum = temppicnum;
					sector[searchsector].ceilingshade = tempshade;
				}
				if (searchstat == 2)
				{
					sector[searchsector].floorpicnum = temppicnum;
					sector[searchsector].floorshade = tempshade;
				}
				if (searchstat == 3)
				{
					sprite[searchwall].picnum = temppicnum;
					sprite[searchwall].shade = tempshade;
					sprite[searchwall].xrepeat = tempxrepeat;
					sprite[searchwall].yrepeat = tempyrepeat;
				}
				if (searchstat == 4)
				{
					wall[searchwall].picnum = temppicnum;
					wall[searchwall].shade = tempshade;
					wall[searchwall].xrepeat = tempxrepeat;
					wall[searchwall].yrepeat = tempyrepeat;
					wall[searchwall].cstat = tempcstat;
					fixrepeats(searchwall,temppicnum);
				}
			}
			asksave = 1;
			keystatus[0x1c] = 0;
		}
		if (keystatus[0x2f] > 0)  //V
		{
			if (searchstat == 0) templong = wall[searchwall].picnum;
			if (searchstat == 1) templong = sector[searchsector].ceilingpicnum;
			if (searchstat == 2) templong = sector[searchsector].floorpicnum;
			if (searchstat == 3) templong = sprite[searchwall].picnum;
			if (searchstat == 4) templong = wall[searchwall].picnum;
			templong = gettile(templong);
			if (searchstat == 0) wall[searchwall].picnum = templong;
			if (searchstat == 1) sector[searchsector].ceilingpicnum = templong;
			if (searchstat == 2) sector[searchsector].floorpicnum = templong;
			if (searchstat == 3) sprite[searchwall].picnum = templong;
			if (searchstat == 4) wall[searchwall].picnum = templong;
			asksave = 1;
			keystatus[0x2f] = 0;
		}
		if (keystatus[0x23] > 0)  //H
		{
			if (searchstat < 3)
			{
				if (searchstat == 0) templong = sector[searchsector].floorheinum;
				if (searchstat == 1) templong = sector[searchsector].ceilingheinum;
				if (searchstat == 2) templong = sector[searchsector].floorheinum;
				templong = gettile(templong);
				if (searchstat == 0) sector[searchsector].floorheinum = templong;
				if (searchstat == 1) sector[searchsector].ceilingheinum = templong;
				if (searchstat == 2) sector[searchsector].floorheinum = templong;
			}
			asksave = 1;
			keystatus[0x23] = 0;
		}
		smooshyalign = keystatus[0x4c];
		if (keystatus[0x4b] > 0)  //4 (keypad)
		{
			if ((searchstat == 0) || (searchstat == 4))
				if (wall[searchwall].xrepeat > 0)
				{
					wall[searchwall].xrepeat--;
					if (smooshyalign > 0)
						wall[searchwall].xrepeat = (wall[searchwall].xrepeat&0xf8);
				}
			if ((searchstat == 1) || (searchstat == 2))
			{
				i = searchwall;
				do
				{
					if (wall[i].xrepeat > 0)
					{
						wall[i].xrepeat--;
						if (smooshyalign > 0)
							wall[searchwall].xrepeat = (wall[searchwall].xrepeat&0xf8);
					}
					i = wall[i].point2;
				}
				while (i != searchwall);
			}
			if (searchstat == 3)
			{
				if (sprite[searchwall].xrepeat > 2)
				{
					sprite[searchwall].xrepeat--;
					if (smooshyalign > 0)
						wall[searchwall].xrepeat = (wall[searchwall].xrepeat&0xf8);
				}
			}
			if (smooshyalign != 0)
				keystatus[0x4b] = 0;
			asksave = 1;
		}
		if (keystatus[0x4d] > 0)  //6 (keypad)
		{
			if ((searchstat == 0) || (searchstat == 4))
				if (wall[searchwall].xrepeat < 255)
				{
					wall[searchwall].xrepeat++;
					if (smooshyalign > 0)
						wall[searchwall].xrepeat = ((wall[searchwall].xrepeat+7)&0xf8);
				}
			if ((searchstat == 1) || (searchstat == 2))
			{
				i = searchwall;
				do
				{
					if (wall[i].xrepeat < 255)
					{
						wall[i].xrepeat++;
						if (smooshyalign > 0)
							wall[searchwall].xrepeat = ((wall[searchwall].xrepeat+7)&0xf8);
					}
					i = wall[i].point2;
				}
				while (i != searchwall);
			}
			if (searchstat == 3)
			{
				if (sprite[searchwall].xrepeat < 255)
				{
					sprite[searchwall].xrepeat++;
					if (smooshyalign > 0)
						wall[searchwall].xrepeat = ((wall[searchwall].xrepeat+7)&0xf8);
				}
			}
			if (smooshyalign != 0)
				keystatus[0x4d] = 0;
			asksave = 1;
		}
		if (keystatus[0x48] > 0)  //2 (keypad)
		{
			if ((searchstat == 0) || (searchstat == 4))
				if (wall[searchwall].yrepeat > 0)
				{
					wall[searchwall].yrepeat--;
					if (smooshyalign > 0)
						wall[searchwall].yrepeat = (wall[searchwall].yrepeat&0xf8);
				}
			if ((searchstat == 1) || (searchstat == 2))
			{
				i = searchwall;
				do
				{
					if (wall[i].yrepeat > 0)
					{
						wall[i].yrepeat--;
						if (smooshyalign > 0)
							wall[searchwall].yrepeat = (wall[searchwall].yrepeat&0xf8);
					}
					i = wall[i].point2;
				}
				while (i != searchwall);
			}
			if (searchstat == 3)
			{
				if (sprite[searchwall].yrepeat > 2)
				{
					sprite[searchwall].yrepeat--;
					if (smooshyalign > 0)
						wall[searchwall].yrepeat = (wall[searchwall].yrepeat&0xf8);
				}
			}
			if (smooshyalign != 0)
				keystatus[0x48] = 0;
			asksave = 1;
		}
		if (keystatus[0x50] > 0)  //8 (keypad)
		{
			if ((searchstat == 0) || (searchstat == 4))
				if (wall[searchwall].yrepeat < 255)
				{
					wall[searchwall].yrepeat++;
					if (smooshyalign > 0)
						wall[searchwall].yrepeat = ((wall[searchwall].yrepeat+7)&0xf8);
				}
			if ((searchstat == 1) || (searchstat == 2))
			{
				i = searchwall;
				do
				{
					if (wall[i].yrepeat < 255)
					{
						wall[i].yrepeat++;
						if (smooshyalign > 0)
							wall[searchwall].yrepeat = ((wall[searchwall].yrepeat+7)&0xf8);
					}
					i = wall[i].point2;
				}
				while (i != searchwall);
			}
			if (searchstat == 3)
			{
				if (sprite[searchwall].yrepeat < 255)
				{
					sprite[searchwall].yrepeat++;
					if (smooshyalign > 0)
						wall[searchwall].yrepeat = ((wall[searchwall].yrepeat+7)&0xf8);
				}
			}
			if (smooshyalign != 0)
				keystatus[0x50] = 0;
			asksave = 1;
		}
		if (keystatus[0x33] > 0)  // <,
		{
			if ((searchstat == 0) || (searchstat == 4))
			{
				wall[searchwall].panning = ((wall[searchwall].panning+1)&255);
				if (smooshyalign > 0)
					wall[searchwall].panning = ((wall[searchwall].panning+7)&0xf8);
			}
			if (searchstat == 1)
			{
				sector[searchsector].ceilingpanning = ((sector[searchsector].ceilingpanning+1)&255);
				if (smooshyalign > 0)
					sector[searchsector].ceilingpanning = ((sector[searchsector].ceilingpanning+7)&0xf8);

			}
			if (searchstat == 2)
			{
				sector[searchsector].floorpanning = ((sector[searchsector].floorpanning+1)&255);
				if (smooshyalign > 0)
					sector[searchsector].floorpanning = ((sector[searchsector].floorpanning+7)&0xf8);
			}
			if (smooshyalign != 0)
				keystatus[0x33] = 0;
			asksave = 1;
		}
		if (keystatus[0x34] > 0)  // >.
		{
			if ((searchstat == 0) || (searchstat == 4))
			{
				wall[searchwall].panning = ((wall[searchwall].panning+255)&255);
				if (smooshyalign > 0)
					wall[searchwall].panning = (wall[searchwall].panning&0xf8);
			}
			if (searchstat == 1)
			{
				sector[searchsector].ceilingpanning = ((sector[searchsector].ceilingpanning+255)&255);
				if (smooshyalign > 0)
					sector[searchsector].ceilingpanning = (sector[searchsector].ceilingpanning&0xf8);

			}
			if (searchstat == 2)
			{
				sector[searchsector].floorpanning = ((sector[searchsector].floorpanning+255)&255);
				if (smooshyalign > 0)
					sector[searchsector].floorpanning = (sector[searchsector].floorpanning&0xf8);
			}
			if (smooshyalign != 0)
				keystatus[0x34] = 0;
			asksave = 1;
		}

		if (keystatus[0x19] > 0)  // P (parallax)
		{
			sector[searchsector].ceilingstat ^= 1;
			asksave = 1;
			keystatus[0x19] = 0;
		}
		if (keystatus[0x22] > 0)  // G (groudraw)
		{
			sector[searchsector].floorstat ^= 2;
			asksave = 1;
			keystatus[0x22] = 0;
		}
		if (keystatus[0x30] > 0)  // B (clip Blocking xor)
		{
			if (searchstat == 3)
			{
				sprite[searchwall].cstat ^= 1;
				asksave = 1;
			}
			else
			{
				wall[searchwall].cstat ^= 1;
				if (wall[searchwall].nextwall1 >= 0)
				{
					wall[wall[searchwall].nextwall1].cstat &= 0xfe;
					wall[wall[searchwall].nextwall1].cstat |= (wall[searchwall].cstat&1);
				}
				asksave = 1;
			}
			keystatus[0x30] = 0;
		}
		if (keystatus[0x2] > 0)  // 1 (make 1-way wall)
		{
			if (searchstat != 3)
			{
				wall[searchwall].cstat ^= 32;
				asksave = 1;
			}
			keystatus[0x2] = 0;
		}
		if (keystatus[0x3] > 0)  // 2 (bottom wall swapping)
		{
			if (searchstat != 3)
			{
				wall[searchwall].cstat ^= 2;
				asksave = 1;
			}
			keystatus[0x3] = 0;
		}
		if (keystatus[0x18] > 0)  // O (top/bottom orientation - for doors)
		{
			if ((searchstat == 0) || (searchstat == 4))
			{
				wall[searchwall].cstat ^= 4;
				asksave = 1;
			}
			keystatus[0x18] = 0;
		}
		if (keystatus[0x32] > 0)  // M (masking walls)
		{
			if (searchstat != 3)
			{
				wall[searchwall].cstat ^= 16;
				if ((wall[searchwall].cstat&16) > 0)
				{
					wall[searchwall].cstat |= 2;

					wall[searchwall].cstat |= 1;         //auto block (B)
					if (wall[searchwall].nextwall1 >= 0)
						wall[wall[searchwall].nextwall1].cstat |= 1;

					wall[searchwall].cstat |= 8;         //auto other-side flip
				}
				else
				{
					wall[searchwall].cstat &= (255-2);

					wall[searchwall].cstat &= (255-1);   //auto unblock (B)
					if (wall[searchwall].nextwall1 >= 0)
						wall[wall[searchwall].nextwall1].cstat &= (255-1);

					wall[searchwall].cstat &= (255-8);   //auto other-side unflip
				}

				if (wall[searchwall].nextwall1 >= 0)
				{
					i = wall[wall[searchwall].nextwall1].cstat;
					i &= (255-2-16);
					i |= (wall[searchwall].cstat&(2+16));
					wall[wall[searchwall].nextwall1].cstat = i;
				}
				asksave = 1;
			}
			keystatus[0x32] = 0;
		}
		if (keystatus[0x12] > 0)  // E (expand)
		{
			if (searchstat == 1)
			{
				sector[searchsector].ceilingstat ^= 8;
				asksave = 1;
			}
			if (searchstat == 2)
			{
				sector[searchsector].floorstat ^= 8;
				asksave = 1;
			}
			keystatus[0x12] = 0;
		}
		if (keystatus[0x21] > 0)  //F (x-Flip)
		{
			if ((searchstat == 0) || (searchstat == 4))
			{
				wall[searchwall].cstat ^= 8;
				asksave = 1;
			}
			if (searchstat == 3)
			{
				sprite[searchwall].cstat ^= 4;
				asksave = 1;
			}
			keystatus[0x21] = 0;
		}
	}
	if (keystatus[0x9c] > 0)  // Enter
	{
		overheadeditor();
		keystatus[0x9c] = 0;
	}
}

gettile(long tilenum)
{
	long i, j, otilenum, topleft, gap, temp, templong;

	otilenum = tilenum;

	keystatus[0x2f] = 0;
	for(i=0;i<MAXTILES;i++)
	{
		localartfreq[i] = 0;
		localartlookup[i] = i;
	}
	if ((searchstat == 1) || (searchstat == 2))
		for(i=0;i<numsectors;i++)
		{
			localartfreq[sector[i].ceilingpicnum]++;
			localartfreq[sector[i].floorpicnum]++;
		}
	if ((searchstat == 0) || (searchstat == 4))
		for(i=0;i<numwalls;i++)
			localartfreq[wall[i].picnum]++;
	if (searchstat == 3)
		for(i=0;i<MAXSPRITES;i++)
			if (sprite[i].statnum < MAXSTATUS)
				localartfreq[sprite[i].picnum]++;
	gap = (MAXTILES>>1);
	do
	{
		for(i=0;i<MAXTILES-gap;i++)
		{
			temp = i;
			while ((localartfreq[temp] < localartfreq[temp+gap]) && (temp >= 0))
			{
				templong = localartfreq[temp];
				localartfreq[temp] = localartfreq[temp+gap];
				localartfreq[temp+gap] = templong;
				templong = localartlookup[temp];
				localartlookup[temp] = localartlookup[temp+gap];
				localartlookup[temp+gap] = templong;

				if (tilenum == temp)
					tilenum = temp+gap;
				else if (tilenum == temp+gap)
					tilenum = temp;

				temp -= gap;
			}
		}
		gap >>= 1;
	}
	while (gap > 0);
	localartlookupnum = 0;
	while (localartfreq[localartlookupnum] > 0)
		localartlookupnum++;

	if (localartfreq[0] == 0)
	{
		tilenum = otilenum;
		localartlookupnum = MAXTILES;
		for(i=0;i<MAXTILES;i++)
			localartlookup[i] = i;
	}

	topleft = ((tilenum/5)*5)-5;
	if (topleft < 0) topleft = 0;
	if (topleft > MAXTILES-15) topleft = MAXTILES-15;
	while ((keystatus[0x1c]|keystatus[1]) == 0)
	{
		drawtilescreen(topleft,tilenum);
		nextpage();
		if ((keystatus[0xcb] > 0) && (tilenum > 0))
			tilenum--, keystatus[0xcb] = 0;
		if ((keystatus[0xcd] > 0) && (tilenum < MAXTILES-1))
			tilenum++, keystatus[0xcd] = 0;
		if ((keystatus[0xc8] > 0) && (tilenum >= 5))
			tilenum-=5, keystatus[0xc8] = 0;
		if ((keystatus[0xd0] > 0) && (tilenum < MAXTILES-5))
			tilenum+=5, keystatus[0xd0] = 0;
		if ((keystatus[0xc9] > 0) && (tilenum >= 5))
		{
			tilenum-=15;
			if (tilenum < 0) tilenum = 0;
			keystatus[0xc9] = 0;
		}
		if ((keystatus[0xd1] > 0) && (tilenum < MAXTILES-5))
		{
			tilenum+=15;
			if (tilenum >= MAXTILES) tilenum = MAXTILES;
			keystatus[0xd1] = 0;
		}
		if (keystatus[0x2f] > 0)   //V
		{
			keystatus[0x2f] = 0;
			if (tilenum < localartlookupnum)
				tilenum = localartlookup[tilenum];
			else
				tilenum = 0;
			localartlookupnum = MAXTILES;
			for(i=0;i<MAXTILES;i++)
				localartlookup[i] = i;
		}
		while (tilenum < topleft) topleft -= 5;
		while (tilenum >= topleft+15) topleft += 5;
	}

	if (keystatus[0x1c] == 0)
	{
		tilenum = otilenum;
	}
	else
	{
		if (tilenum < localartlookupnum)
		{
			tilenum = localartlookup[tilenum];
			if ((tilesizx[tilenum] == 0) || (tilesizy[tilenum] == 0))
				tilenum = otilenum;
		}
		else
			tilenum = otilenum;
	}
	keystatus[0x1] = 0;
	keystatus[0x1c] = 0;
	return(tilenum);
}

drawtilescreen(long pictopleft, long picbox)
{
	long i, j, vidpos, vidpos2, dat, wallnum, xdime, ydime, cnt, pinc;
	long dax, day, scaledown;
	char *picptr;

	if (option[0] == 0)
	{
		outpw(0x3c4,0x0f02);
		clearbuf(0xa0000+(((short)page)<<14),4000L,0L); //clear frame first
		pinc = 80;
	}
	else
	{
		clearbuf(frameplace,16000L,0L); //clear frame first
		pinc = 320;
	}
	for(cnt=0;cnt<15;cnt++)         //draw the 5*3 grid of tiles
	{
		wallnum = cnt+pictopleft;
		if (wallnum < localartlookupnum)
		{
			wallnum = localartlookup[wallnum];
			if ((tilesizx[wallnum] != 0) && (tilesizy[wallnum] != 0))
			{
				picptr = (char *)(waloff[wallnum]);
				xdime = tilesizx[wallnum];
				ydime = tilesizy[wallnum];

				dax = ((cnt%5)<<6);
				day = ((cnt/5)<<6);
				if (option[0] == 0)
					vidpos = day*80+(dax>>2)+0xa0000+(((short)page)<<14);
				else
					vidpos = day*320+dax+frameplace;
				if ((xdime <= 64) && (ydime <= 64))
				{
					for(i=0;i<xdime;i++)
					{
						if (option[0] == 0)
						{
							outpw(0x3c4,2+(256<<(i&3)));
							vidpos2 = vidpos+(i>>2);
						}
						else
							vidpos2 = vidpos+i;
						for(j=0;j<ydime;j++)
						{
							dat = *picptr++;
							drawpixel(vidpos2, dat);
							vidpos2 += pinc;
						}
					}
				}
				else                          //if 1 dimension > 64
				{
					if (xdime > ydime)
						scaledown = ((xdime+63)>>6);
					else
						scaledown = ((ydime+63)>>6);

					dax = 0;
					for(i=0;i<xdime;i+=scaledown)
					{
						picptr = (char *)(waloff[wallnum]) + ydime*i;
						if (option[0] == 0)
							outpw(0x3c4,2+(256<<(dax&3)));
						vidpos2 = vidpos;
						for(j=0;j<ydime;j+=scaledown)
						{
							dat = *picptr;
							picptr += scaledown;
							drawpixel(vidpos2, dat);
							vidpos2 += pinc;
						}
						dax++;
						if ((option[0] != 0) || ((dax&3) == 0))
							vidpos++;
					}
				}
			}
		}
	}

	cnt = picbox-pictopleft;    //draw open white box
	dax = ((cnt%5)<<6);
	day = ((cnt/5)<<6);

	if (option[0] == 0)
	{
		vidpos = day*80+(dax>>2)+0xa0000+(((short)page)<<14);
		vidpos2 = vidpos+(63*80);
		j = 0;
		for(i=0;i<64;i++)
		{
			outpw(0x3c4,2+(256<<(i&3)));
			drawpixel(vidpos+(i>>2),31);
			drawpixel(vidpos2+(i>>2),31);
			outpw(0x3c4,2+(256<<(j&3)));
			drawpixel(vidpos+j,31);
			outpw(0x3c4,2+(256<<((j+63)&3)));
			drawpixel(vidpos+j+(63>>2),31);
			j += pinc;
		}
	}
	else
	{
		vidpos = day*320+dax+frameplace;
		vidpos2 = vidpos+(63*320);
		j = 0;
		for(i=0;i<64;i++)
		{
			drawpixel(vidpos+i,31);
			drawpixel(vidpos2+i,31);
			drawpixel(vidpos+j,31);
			drawpixel(vidpos+j+63,31);
			j += pinc;
		}
	}

	return(0);
}

drawline16(long x0, long y0, long x1, long y1, char col)
{
	char lmask, rmask;
	long i, xdime, ydime, cnt, pinc, p;

	if ((x0 < 0) && (x1 < 0)) return(0);
	if ((x0 >= 640) && (x1 >= 640)) return(0);
	if ((y0 < 0) && (y1 < 0)) return(0);
	if ((y0 >= ydim16) && (y1 >= ydim16)) return(0);

	setcolor16((long)col);
	if (x0 == x1)
	{
		if (y1 < y0) i = y0, y0 = y1, y1 = i;
		if (y0 < 0) y0 = 0;
		if (y1 >= ydim16) y1 = ydim16-1;
		ydime = y1-y0+1;
		p = ((y0 * 640 + x0 + pageoffset)>>3)+0xa0000;
		outp(0x3ce,0x8); outp(0x3cf,1<<(x0&7^7));  //bit mask
		vlin16(p,ydime);
		return(0);
	}
	if (y0 == y1)
	{
		if (x1 < x0) i = x0, x0 = x1, x1 = i;
		if (x0 < 0) x0 = 0;
		if (x1 >= 640) x1 = 639;

		lmask = (0x00ff>>(x0&7));
		rmask = (0xff80>>(x1&7));

		p = ((y0 * 640 + x0 + pageoffset)>>3)+0xa0000;

		outp(0x3ce,8);
		if ((x0|7) == (x1|7))
		{
			outp(0x3cf,lmask&rmask);
			drawpixel(p,getpixel(p));
		}
		else
		{
			outp(0x3cf,lmask);
			drawpixel(p,getpixel(p));
			p++;

			outp(0x3cf,0xff);
			xdime = (((x1|7)-(x0|7))>>3)-1;
			if (XDIM > 0) p = hlin16(p,xdime);

			outp(0x3cf,rmask);
			drawpixel(p,getpixel(p));
		}
		return(0);
	}

	if ((x0 < 0) && (x0 != x1)) y0 -= ((y1-y0)*x0) / (x1-x0), x0 = 0;
	if ((x1 < 0) && (x0 != x1)) y1 -= ((y1-y0)*x1) / (x1-x0), x1 = 0;
	if ((y0 < 0) && (y0 != y1)) x0 -= ((x1-x0)*y0) / (y1-y0), y0 = 0;
	if ((y1 < 0) && (y0 != y1)) x1 -= ((x1-x0)*y1) / (y1-y0), y1 = 0;
	if ((x0 >= 640) && (x0 != x1)) y0 += ((y1-y0)*(639-x0)) / (x1-x0), x0 = 639;
	if ((x1 >= 640) && (x0 != x1)) y1 += ((y1-y0)*(639-x1)) / (x1-x0), x1 = 639;
	if ((y0 >= ydim16) && (y0 != y1)) x0 += ((x1-x0)*(ydim16-1-y0)) / (y1-y0), y0 = ydim16-1;
	if ((y1 >= ydim16) && (y0 != y1)) x1 += ((x1-x0)*(ydim16-1-y1)) / (y1-y0), y1 = ydim16-1;

	if ((x0 < 0) && (x1 < 0)) return(0);
	if ((x0 >= 640) && (x1 >= 640)) return(0);
	if ((y0 < 0) && (y1 < 0)) return(0);
	if ((y0 >= ydim16) && (y1 >= ydim16)) return(0);

	if (x1 > x0) xdime = x1-x0+1; else xdime = x0-x1+1;
	if (y1 > y0) ydime = y1-y0+1; else ydime = y0-y1+1;

	if (xdime >= ydime)
	{
		if (x1 < x0)
		{
			i = x0; x0 = x1; x1 = i;
			i = y0; y0 = y1; y1 = i;
		}
		p = y0 * 640 + x0 + pageoffset;
		cnt = 0;
		if (y1 > y0) pinc = 640; else pinc = -640;
		for(i=xdime;i>0;i--)
		{
			drawpixel16(p);
			cnt += ydime;
			if (cnt >= xdime)
				cnt -= xdime, p += pinc;
			p++;
		}
	}
	if (xdime < ydime)
	{
		if (y1 < y0)
		{
			i = x0; x0 = x1; x1 = i;
			i = y0; y0 = y1; y1 = i;
		}
		p = y0 * 640 + x0 + pageoffset;
		cnt = 0;
		if (x1 > x0) pinc = 1; else pinc = -1;
		for(i=ydime;i>0;i--)
		{
			drawpixel16(p);
			cnt += xdime;
			if (cnt >= ydime)
				cnt -= ydime, p += pinc;
			p += 640;
		}
	}
	return(0);
}

qsetmode320200()
{
	short i;

	//uninit 16-color mode
	outp(0x3ce,8); outp(0x3cf,255);   //bit mask
	outp(0x3ce,1); outp(0x3cf,0);     //enable set/reset

	setgamemode();
	return(0);
}

qsetmode640480()
{
	short i;

	setvmode(0x12);

	i = 479-144;
	outp(0x3d4,0x18); outp(0x3d5,i&255);             //line compare
	outp(0x3d4,0x7); outp(0x3d5,(inp(0x3d5)&239)|((i&256)>>4));
	outp(0x3d4,0x9); outp(0x3d5,(inp(0x3d5)&191)|((i&512)>>3));

	pageoffset = 92160;
	outp(0x3d4,0xc), outp(0x3d5,pageoffset>>11);

	outp(0x3ce,0x0); outp(0x3cf,15);  //set/reset
	outp(0x3ce,0x1); outp(0x3cf,15);  //enable set/reset
	fillscreen16(0L,8L,640L*144L);
	fillscreen16((640L*144L)>>3,0L,640L*336L);

	pageoffset = 0;
	ydim16 = 144;
	drawline16(0,0,639,0,7);
	drawline16(0,143,639,143,7);
	drawline16(0,0,0,143,7);
	drawline16(639,0,639,143,7);
	drawline16(0,24,639,24,7);
	drawline16(176,0,176,24,7);
	printext16(9L,9L,4,-1,"BUILD Editor 4/18/94");
	printext16(8L,8L,12,-1,"BUILD Editor 4/18/94");
	printmessage16("");
	drawline16(0,143-24,639,143-24,7);
	drawline16(256,143-24,256,143,7);
	printcoords16();

	pageoffset = 92160;
	ydim16 = 336;
	return(0);
}

drawoverhead(long posxe, long posye, short ange, long zoome, short danumwalls)
{
	long i, j, k, xp1, yp1, xp2, yp2, tempx, tempy, templong;
	char col, mask;

	ydim16 = 336;
	if (danumwalls < 0)
		danumwalls = numwalls;

	if (grid > 0)
	{
		tempx = 0;
		yp1 = (((posye-65536)*zoome)>>14);
		yp2 = ((posye*zoome)>>14);
		templong = yp2;
		yp2 = 200-yp1;
		yp1 = 200-templong;
		if (yp1 < 0) yp1 = 0;
		if (yp2 >= ydim16) yp2 = ydim16-1;
		if ((yp1 < ydim16) && (yp2 >= 0) && (yp2 >= yp1))
		{
			setcolor16(8);
			outp(0x3ce,0x8);
			templong = ((yp1*640+pageoffset)>>3)+0xa0000;
			yp2 = yp2-yp1+1;
			mask = 0;
			xp1 = (320-((posxe*zoome)>>14));
			for(i=0;i<=65536;i+=(2048>>grid))
			{
				xp2 = xp1;
				xp1 = (320-(((posxe-i)*zoome)>>14));
				if ((xp1 >= 0) && (xp1 < 640))
				{
					if ((xp1|7) != (xp2|7))
					{
						outp(0x3cf,mask);
						if ((xp2>>3) >= 0) vlin16first(templong+(xp2>>3),yp2);
						mask = 0;
					}
					mask |= (1<<(xp1&7^7));
				}
				if (xp1 >= 640)
					break;
			}
			if ((i >= 65536) && (xp1 < 640))
				xp2 = xp1;
			if ((mask != 0) && ((xp2>>3) < 80))
			{
				outp(0x3cf,mask);
				vlin16first(templong+(xp2>>3),yp2);
			}
		}

		xp1 = ((posxe*zoome)>>14);
		xp2 = (((posxe-65536)*zoome)>>14);
		for(i=0;i<=65536;i+=(2048>>grid))
		{
			yp1 = (((posye-i)*zoome)>>14);
			if ((yp1 > -200) && (yp1 <= 200))
				drawline16(320-xp1,200-yp1,320-xp2,200-yp1,8);
		}
	}

	for(i=0;i<danumwalls;i++)
	{
		if (wall[i].nextwall1 == -1)
			col = 7;
		else
		{
			col = 4;
			if ((wall[i].cstat&1) > 0)
				col = 5;
		}
		if (i == linehighlight)
			col += ((numframes&2)<<2);

		xp1 = (((wall[i].x-posxe)*zoome)>>14);
		yp1 = (((wall[i].y-posye)*zoome)>>14);
		xp2 = (((wall[wall[i].point2].x-posxe)*zoome)>>14);
		yp2 = (((wall[wall[i].point2].y-posye)*zoome)>>14);
		drawline16(320+xp1,200+yp1,320+xp2,200+yp2,col);
		if (zoome >= 256)
			if (((320+xp1) >= 2) && ((320+xp1) <= 637))
				if (((200+yp1) >= 2) && ((200+yp1) <= ydim16-3))
				{
					col = 2;
					if (i == pointhighlight)
						col += ((numframes&2)<<2);
					else if (highlightcnt > 0)
					{
						for(k=0;k<highlightcnt;k++)
							if (i == highlights[k])
								col += ((numframes&2)<<2);
					}

					templong = (200+yp1)*640L+(320+xp1)+pageoffset;
					setcolor16((long)col);
					drawpixel16(templong-2-1280);
					drawpixel16(templong-1-1280);
					drawpixel16(templong+0-1280);
					drawpixel16(templong+1-1280);
					drawpixel16(templong+2-1280);

					drawpixel16(templong-2+1280);
					drawpixel16(templong-1+1280);
					drawpixel16(templong+0+1280);
					drawpixel16(templong+1+1280);
					drawpixel16(templong+2+1280);

					drawpixel16(templong-2-640);
					drawpixel16(templong-2+0);
					drawpixel16(templong-2+640);

					drawpixel16(templong+2-640);
					drawpixel16(templong+2+0);
					drawpixel16(templong+2+640);
				}
	}

	if (zoome >= 256)
		for(i=0;i<numsectors;i++)
		{
			j = headspritesect[i];
			while (j != -1)
			{
				col = 1;
				if ((sprite[j].cstat&1) > 0)
					col = 5;
				if (j+4096 == pointhighlight)
					col += ((numframes&2)<<2);
				else if (highlightcnt > 0)
				{
					for(k=0;k<highlightcnt;k++)
						if (j+4096 == highlights[k])
							col += ((numframes&2)<<2);
				}

				xp1 = (((sprite[j].x-posxe)*zoome)>>14);
				yp1 = (((sprite[j].y-posye)*zoome)>>14);
				if (((320+xp1) >= 2) && ((320+xp1) <= 637))
					if (((200+yp1) >= 2) && ((200+yp1) <= ydim16-3))
					{
						templong = (200+yp1)*640L+(320+xp1)+pageoffset;
						setcolor16((long)col);
						drawpixel16(templong-1-1280);
						drawpixel16(templong+0-1280);
						drawpixel16(templong+1-1280);

						drawpixel16(templong-1+1280);
						drawpixel16(templong+0+1280);
						drawpixel16(templong+1+1280);

						drawpixel16(templong-2-640);
						drawpixel16(templong-2+0);
						drawpixel16(templong-2+640);

						drawpixel16(templong+2-640);
						drawpixel16(templong+2+0);
						drawpixel16(templong+2+640);

						drawpixel16(templong+1+640);
						drawpixel16(templong-1+640);
						drawpixel16(templong+1-640);
						drawpixel16(templong-1-640);

						xp2 = (((sintable[(sprite[j].ang+2560)&2047]*zoome)>>11)/768);
						yp2 = (((sintable[(sprite[j].ang+2048)&2047]*zoome)>>11)/768);

						drawline16(320+xp1,200+yp1,320+xp1+xp2,200+yp1+yp2,col);
					}

				j = nextspritesect[j];
			}
		}

	xp2 = (((startposx-posxe)*zoome)>>14);          //Draw brown arrow (start)
	yp2 = (((startposy-posye)*zoome)>>14);
	if (((320+xp2) >= 2) && ((320+xp2) <= 637))
		if (((200+yp2) >= 2) && ((200+yp2) <= ydim16-3))
		{
			xp1 = (((sintable[(startang+2560)&2047]*zoome)>>11)/768);
			yp1 = (((sintable[(startang+2048)&2047]*zoome)>>11)/768);
			drawline16((320+xp2)+xp1,(200+yp2)+yp1,(320+xp2)-xp1,(200+yp2)-yp1,6);
			drawline16((320+xp2)+xp1,(200+yp2)+yp1,(320+xp2)+yp1,(200+yp2)-xp1,6);
			drawline16((320+xp2)+xp1,(200+yp2)+yp1,(320+xp2)-yp1,(200+yp2)+xp1,6);
		}


	xp1 = (((sintable[(ange+2560)&2047]*zoome)>>11)/768); //Draw white arrow
	yp1 = (((sintable[(ange+2048)&2047]*zoome)>>11)/768);
	drawline16(320+xp1,200+yp1,320-xp1,200-yp1,15);
	drawline16(320+xp1,200+yp1,320+yp1,200-xp1,15);
	drawline16(320+xp1,200+yp1,320-yp1,200+xp1,15);

	printcoords16();
}

overheadeditor()
{
	char buffer[80];
	long i, j, k, m, n, mousxplc, mousyplc, firstx, firsty, oposz, col, cnt;
	long templong, templong1, templong2, opageoffset, doubvel;
	long startwall, endwall, dax, day, daz, daang, x1, y1, x2, y2;
	long highlightx1, highlighty1, highlightx2, highlighty2;
	short pag, newall, suckwall, sucksect, newnumwalls, tempshort, split, bad;
	short splitsect, danumwalls, secondstartwall, joinsector[2], joinsectnum;
	short splitstartwall, splitendwall, loopnum;

	searchx <<= 1;
	searchy <<= 1;
	oposz = posz;

	qsetmode640480();
	outpw(0x3d4,0x000c);
	outpw(0x3d4,0x000d);
	pag = 0;
	highlightcnt = -1;
	newnumwalls = -1;
	joinsector[0] = -1;
	keystatus[0x9c] = 0;
	while ((keystatus[0x9c]>>1) == 0)
	{
		if (moustat == 1)
		{
			readmouse();
			searchx += mousx;
			searchy += mousy;
		}
		if (searchx < 8) searchx = 8;
		if (searchx > 631) searchx = 631;
		if (searchy < 8) searchy = 8;
		if (searchy > 341) searchy = 341;
		getpoint(searchx,searchy,&mousxplc,&mousyplc);
		linehighlight = getlinehighlight(mousxplc, mousyplc);

		if (newnumwalls >= 0)
		{
			dax = mousxplc;
			day = mousyplc;
			adjustmark(&dax,&day,newnumwalls);
			wall[newnumwalls].x = dax;
			wall[newnumwalls].y = day;
		}

		fillscreen16(pageoffset>>3,0L,640L*336L);
		drawoverhead(posx,posy,ang,zoom,newnumwalls);
		col = 15-((gridlock<<1)+gridlock);
		ydim16 = 336;
		drawline16(searchx,searchy-8,searchx,searchy-1,col);
		drawline16(searchx+1,searchy-8,searchx+1,searchy-1,col);
		drawline16(searchx,searchy+2,searchx,searchy+9,col);
		drawline16(searchx+1,searchy+2,searchx+1,searchy+9,col);
		drawline16(searchx-8,searchy,searchx-1,searchy,col);
		drawline16(searchx-8,searchy+1,searchx-1,searchy+1,col);
		drawline16(searchx+2,searchy,searchx+9,searchy,col);
		drawline16(searchx+2,searchy+1,searchx+9,searchy+1,col);

		if (angvel != 0)
		{
			doubvel = lockspeed;
			if (keystatus[0x2a] > 0)
				doubvel += (lockspeed>>1);

			ang += ((angvel*doubvel)>>5);
			ang = (ang+2048)&2047;
		}

		doubvel = lockspeed;
		if (keystatus[0x2a] > 0)
			doubvel += lockspeed;

		if (vel != 0)
			clipmove(&posx,&posy,&posz,&cursectnum,(long)(vel*doubvel*sintable[(ang+2560)&2047])>>4,(long)(vel*doubvel*sintable[ang&2047])>>4,128L);
		if (svel != 0)
			clipmove(&posx,&posy,&posz,&cursectnum,(long)(svel*doubvel*sintable[ang&2047])>>4,(long)(svel*doubvel*sintable[(ang+1536)&2047])>>4,128L);

		if (keystatus[0x33] > 0)  // <,
		{
			if (pointhighlight >= 4096)
			{
				i = pointhighlight-4096;
				if ((keystatus[0x2a]|keystatus[0x36]) > 0)
					sprite[i].ang = ((sprite[i].ang+2048-1)&2047);
				else
				{
					sprite[i].ang = ((sprite[i].ang+2048-128)&2047);
					keystatus[0x33] = 0;
				}

				clearmidstatbar16();
				showspriteattributes(pointhighlight-4096);
			}
		}
		if (keystatus[0x34] > 0)  // >.
		{
			if (pointhighlight >= 4096)
			{
				i = pointhighlight-4096;
				if ((keystatus[0x2a]|keystatus[0x36]) > 0)
					sprite[i].ang = ((sprite[i].ang+2048+1)&2047);
				else
				{
					sprite[i].ang = ((sprite[i].ang+2048+128)&2047);
					keystatus[0x34] = 0;
				}

				clearmidstatbar16();
				showspriteattributes(pointhighlight-4096);
			}
		}
		if (keystatus[0x46] > 0)  //Scroll lock (set starting position)
		{
			startposx = posx;
			startposy = posy;
			startposz = posz;
			startang = ang;
			keystatus[0x46] = 0;
		}
		if (keystatus[0x14] > 0)  //T (tag)
		{
			if (keystatus[0x38] > 0)  //Left ALT
			{
				if (pointhighlight >= 4096)
				{
					i = pointhighlight-4096;
					sprintf(buffer,"Sprite (%ld) Lo-tag: ",i);
					sprite[i].tag = (sprite[i].tag&0xffff0000)+getnumber16(buffer,sprite[i].tag&65535,65536L);
					clearmidstatbar16();
					showspriteattributes((short)i);
				}
				else if (linehighlight >= 0)
				{
					i = linehighlight;
					sprintf(buffer,"Wall (%ld) Lo-tag: ",i);
					wall[i].tag = (wall[i].tag&0xffff0000)+getnumber16(buffer,wall[i].tag&65535,65536L);
					clearmidstatbar16();
					showwallattributes((short)i);
				}
			}
			else
			{
				for (i=0;i<numsectors;i++)
					if (inside(mousxplc,mousyplc,i) == 1)
					{
						sprintf(buffer,"Sector (%ld) Lo-tag: ",i);
						sector[i].tag = (sector[i].tag&0xffff0000)+getnumber16(buffer,sector[i].tag&65535,65536L);
						clearmidstatbar16();
						showsectorattributes((short)i);
						break;
					}
			}
			printmessage16("");

			keystatus[0x14] = 0;
		}
		if (keystatus[0x23] > 0)  //H (Hi 16 bits of tag)
		{
			if (keystatus[0x38] > 0)  //Left ALT
			{
				if (pointhighlight >= 4096)
				{
					i = pointhighlight-4096;
					sprintf(buffer,"Sprite (%ld) Hi-tag: ",i);
					sprite[i].tag = (sprite[i].tag&65535)+(getnumber16(buffer,(((unsigned long)sprite[i].tag)>>16),65536L)<<16);
					clearmidstatbar16();
					showspriteattributes((short)i);
				}
				else if (linehighlight >= 0)
				{
					i = linehighlight;
					sprintf(buffer,"Wall (%ld) Hi-tag: ",i);
					wall[i].tag = (wall[i].tag&65535)+(getnumber16(buffer,(((unsigned long)wall[i].tag)>>16),65536L)<<16);
					clearmidstatbar16();
					showwallattributes((short)i);
				}
			}
			else
			{
				for (i=0;i<numsectors;i++)
					if (inside(mousxplc,mousyplc,i) == 1)
					{
						sprintf(buffer,"Sector (%ld) Hi-tag: ",i);
						sector[i].tag = (sector[i].tag&65535)+(getnumber16(buffer,(((unsigned long)sector[i].tag)>>16),65536L)<<16);
						clearmidstatbar16();
						showsectorattributes((short)i);
						break;
					}
			}
			printmessage16("");

			keystatus[0x23] = 0;
		}

		if (keystatus[0x0f] > 0)  //TAB
		{
			clearmidstatbar16();

			if (keystatus[0x38] > 0)  //Left ALT
			{
				if (pointhighlight >= 4096)
					showspriteattributes(pointhighlight-4096);
				else if (linehighlight >= 0)
					showwallattributes(linehighlight);
			}
			else
			{
				for (i=0;i<numsectors;i++)
					if (inside(mousxplc,mousyplc,i) == 1)
					{
						showsectorattributes((short)i);
						break;
					}
			}
			keystatus[0x0f] = 0;
		}

		if (keystatus[0x36] > 0)  //Right shift (highlighting)
		{
			if (highlightcnt == 0)
			{
				highlightx2 = searchx, highlighty2 = searchy;
				ydim16 = 336;
				drawline16(highlightx2,highlighty1,highlightx1,highlighty1,5);
				drawline16(highlightx2,highlighty2,highlightx1,highlighty2,5);
				drawline16(highlightx1,highlighty2,highlightx1,highlighty1,5);
				drawline16(highlightx2,highlighty2,highlightx2,highlighty1,5);
			}
			if (highlightcnt != 0)
			{
				highlightx1 = searchx;
				highlighty1 = searchy;
				highlightx2 = searchx;
				highlighty2 = searchx;
				highlightcnt = 0;
			}
		}
		else
		{
			if (highlightcnt == 0)
			{
				getpoint(highlightx1,highlighty1,&highlightx1,&highlighty1);
				getpoint(highlightx2,highlighty2,&highlightx2,&highlighty2);

				for(i=0;i<numwalls;i++)
					if ((highlightx1 <= wall[i].x) == (wall[i].x <= highlightx2))
						if ((highlighty1 <= wall[i].y) == (wall[i].y <= highlighty2))
							highlights[highlightcnt++] = i;
				for(i=0;i<MAXSPRITES;i++)
					if ((highlightx1 <= sprite[i].x) == (sprite[i].x <= highlightx2))
						if ((highlighty1 <= sprite[i].y) == (sprite[i].y <= highlighty2))
							highlights[highlightcnt++] = i+4096;

				if (highlightcnt <= 0)
					highlightcnt = -1;
			}
		}

		outp(0x3d4,0xc), outp(0x3d5,pageoffset>>11);
		limitrate();
		pageoffset = 399360 - pageoffset;

		if ((bstatus&1) < (obstatus&1))   //after dragging
		{
			dax = wall[pointhighlight].x;
			day = wall[pointhighlight].y;

			for(i=numwalls-1;i>=0;i--)     //delete points
			{
				if (wall[i].x == wall[wall[i].point2].x)
					if (wall[i].y == wall[wall[i].point2].y)
					{
						deletepoint((short)i);
						asksave = 1;
					}
			}
			for(i=0;i<numwalls;i++)        //make new red lines?
			{
				if ((wall[i].x == dax) && (wall[i].y == day))
				{
					checksectorpointer((short)i,sectorofwall((short)i));
					fixrepeats((short)i,wall[i].picnum);
					asksave = 1;
				}
				else if ((wall[wall[i].point2].x == dax) && (wall[wall[i].point2].y == day))
				{
					checksectorpointer((short)i,sectorofwall((short)i));
					fixrepeats((short)i,wall[i].picnum);
					asksave = 1;
				}
			}

		}
		if ((bstatus&1) > 0)                //drag points
		{
			if ((bstatus&1) > (obstatus&1))
				pointhighlight = getpointhighlight(mousxplc, mousyplc);
			if (pointhighlight >= 0)
			{
				dax = mousxplc;
				day = mousyplc;
				if ((gridlock > 0) && (grid > 0))
				{
					dax = ((dax+(1024>>grid))&(0xffffffff<<(11-grid)));
					day = ((day+(1024>>grid))&(0xffffffff<<(11-grid)));
				}

				j = 1;
				if (highlightcnt > 0)
					for (i=0;i<highlightcnt;i++)
						if (pointhighlight == highlights[i])
						{
							j = 0;
							break;
						}

				if (j == 0)
				{
					dax -= wall[pointhighlight].x;
					day -= wall[pointhighlight].y;
					for(i=0;i<highlightcnt;i++)
					{
						if ((highlights[i]&0xf000) == 0)
						{
							wall[highlights[i]].x += dax;
							wall[highlights[i]].y += day;
						}
						else
						{
							sprite[highlights[i]&4095].x += dax;
							sprite[highlights[i]&4095].y += day;
						}
					}
				}
				else
				{
					if ((pointhighlight&0xf000) == 0)
					{
						wall[pointhighlight].x = dax;
						wall[pointhighlight].y = day;

						cnt = MAXWALLS;
						tempshort = pointhighlight;    //search points CCW
						do
						{
							if (wall[tempshort].nextwall1 >= 0)
							{
								tempshort = wall[wall[tempshort].nextwall1].point2;
								wall[tempshort].x = dax;
								wall[tempshort].y = day;
							}
							else
							{
								tempshort = pointhighlight;    //search points CW if not searched all the way around
								do
								{
									if (wall[lastwall(tempshort)].nextwall1 >= 0)
									{
										tempshort = wall[lastwall(tempshort)].nextwall1;
										wall[tempshort].x = dax;
										wall[tempshort].y = day;
									}
									else
									{
										break;
									}
									cnt--;
								}
								while ((tempshort != pointhighlight) && (cnt > 0));
								break;
							}
							cnt--;
						}
						while ((tempshort != pointhighlight) && (cnt > 0));
					}
					if ((pointhighlight&0xf000) == 4096)
					{
						for(i=0;i<numsectors;i++)
							if (inside(dax,day,i) == 1)
							{
								sprite[pointhighlight&4095].x = dax;
								sprite[pointhighlight&4095].y = day;
								if (sprite[pointhighlight&4095].sectnum != i)
									changespritesect(pointhighlight&4095,(short)i);
								break;
							}
					}
				}
				asksave = 1;
			}
		}
		else
			pointhighlight = getpointhighlight(mousxplc, mousyplc);
		if ((bstatus&6) > 0)
		{
			searchx = 320;
			searchy = 200;
			posx = mousxplc;
			posy = mousyplc;
		}

		posz = 256;
		getsector();
		engineinput();
		if ((keystatus[0x1e] > 0) && (zoom < 4096)) zoom += (zoom>>4);
		if ((keystatus[0x2c] > 0) && (zoom > 48)) zoom -= (zoom>>4);
		if (keystatus[0x22] > 0)  // G (grid on/off)
		{
			grid++;
			if (grid == 6)
				grid = 0;
			keystatus[0x22] = 0;
		}
		if (keystatus[0x26] > 0)  // L (grid lock)
		{
			gridlock = 1-gridlock, keystatus[0x26] = 0;
			if (gridlock == 0)
				printmessage16("Grid locking OFF");
			else
				printmessage16("Grid locking ON");
		}

		if (keystatus[0x24] > 0)  // J (join sectors)
		{
			if (joinsector[0] >= 0)
			{
				joinsector[1] = -1;
				for(i=0;i<numsectors;i++)
					if (inside(mousxplc,mousyplc,i) == 1)
					{
						joinsector[1] = i;
						break;
					}
				if ((joinsector[1] >= 0) && (joinsector[0] != joinsector[1]))
				{
					newnumwalls = numwalls;

					for(k=0;k<2;k++)
					{
						startwall = sector[joinsector[k]].wallptr;
						endwall = startwall + sector[joinsector[k]].wallnum - 1;
						for(j=startwall;j<=endwall;j++)
						{
							if (wall[j].cstat == 255)
								continue;
							joinsectnum = k;
							if (wall[j].nextsector1 == joinsector[1-joinsectnum])
							{
								wall[j].cstat = 255;
								continue;
							}

							i = j;
							m = newnumwalls;
							do
							{
								memcpy(&wall[newnumwalls],&wall[i],sizeof(wall[0]));
								wall[newnumwalls].point2 = newnumwalls+1;
								newnumwalls++;
								wall[i].cstat = 255;

								i = wall[i].point2;
								if (wall[i].nextsector1 == joinsector[1-joinsectnum])
								{
									i = wall[wall[i].nextwall1].point2;
									joinsectnum = 1 - joinsectnum;
								}
							}
							while ((wall[i].cstat != 255) && (wall[i].nextsector1 != joinsector[1-joinsectnum]));
							wall[newnumwalls-1].point2 = m;
						}
					}

					if (newnumwalls > numwalls)
					{
						memcpy(&sector[numsectors],&sector[joinsector[0]],sizeof(sector[0]));
						sector[numsectors].wallptr = numwalls;
						sector[numsectors].wallnum = newnumwalls-numwalls;
						headspritesect[numsectors] = headspritesect[joinsector[0]];

						//what about sprites in joinsector[1]? - got to fix it.

						numsectors++;

						for(i=numwalls;i<newnumwalls;i++)
						{
							if (wall[i].nextwall1 >= 0)
							{
								wall[wall[i].nextwall1].nextwall1 = i;
								wall[wall[i].nextwall1].nextsector1 = numsectors-1;
							}
						}

						numwalls = newnumwalls;
						newnumwalls = -1;

						for(k=0;k<2;k++)
						{
							startwall = sector[joinsector[k]].wallptr;
							endwall = startwall + sector[joinsector[k]].wallnum - 1;
							for(j=startwall;j<=endwall;j++)
							{
								wall[j].nextwall1 = -1;
								wall[j].nextsector1 = -1;
							}
						}

						deletesector((short)joinsector[0]);
						if (joinsector[0] < joinsector[1])
							joinsector[1]--;
						deletesector((short)joinsector[1]);
						printmessage16("Sectors joined.");
					}
				}
				joinsector[0] = -1;
			}
			else
			{
				joinsector[0] = -1;
				for(i=0;i<numsectors;i++)
					if (inside(mousxplc,mousyplc,i) == 1)
					{
						joinsector[0] = i;
						printmessage16("Join sector - press J again on sector to join with.");
						break;
					}
			}
			keystatus[0x24] = 0;
		}

		if (((keystatus[0x38]|keystatus[0xb8])&keystatus[0x1f]) > 0) //ALT-S
		{
			if ((linehighlight >= 0) && (wall[linehighlight].nextwall1 == -1))
			{
				sucksect = sectorofwall(linehighlight);

				memcpy(&sector[numsectors],&sector[sucksect],sizeof(sector[0]));
				sector[numsectors].wallptr = numwalls;
				sector[numsectors].wallnum = 0;
				i = linehighlight;
				newnumwalls = numwalls;
				do
				{
					j = lastwall((short)i);
					if (wall[j].nextwall1 >= 0)
					{
						j = wall[j].point2;
						for(k=0;k<numwalls;k++)
						{
							if (wall[wall[k].point2].x == wall[j].x)
								if (wall[wall[k].point2].y == wall[j].y)
									if (wall[k].nextwall1 == -1)
									{
										j = k;
										break;
									}
						}
					}

					memcpy(&wall[newnumwalls],&wall[i],sizeof(wall[0]));

					wall[newnumwalls].nextwall1 = j;
					wall[newnumwalls].nextsector1 = sectorofwall((short)j);

					newnumwalls++;
					sector[numsectors].wallnum++;

					i = j;
				}
				while (i != linehighlight);

				for(i=numwalls;i<newnumwalls-1;i++)
					wall[i].point2 = i+1;
				wall[newnumwalls-1].point2 = numwalls;

				if (clockdir(numwalls) == 1)
				{
					newnumwalls = -1;
					printmessage16("Can't make a sector out there.");
				}
				else
				{
					for(i=numwalls;i<newnumwalls;i++)
					{
						wall[wall[i].nextwall1].nextwall1 = i;
						wall[wall[i].nextwall1].nextsector1 = numsectors;
					}
					numwalls = newnumwalls;
					newnumwalls = -1;
					headspritesect[numsectors] = -1;
					numsectors++;
					printmessage16("Inner loop made into new sector.");
				}
			}
			keystatus[0x1f] = 0;
		}
		else if (keystatus[0x1f] > 0)  //S
		{
			sucksect = -1;
			for(i=0;i<numsectors;i++)
				if (inside(mousxplc,mousyplc,i) == 1)
				{
					sucksect = i;
					break;
				}

			if (sucksect >= 0)
			{
				dax = mousxplc;
				day = mousyplc;
				if ((gridlock > 0) && (grid > 0))
				{
					dax = ((dax+(1024>>grid))&(0xffffffff<<(11-grid)));
					day = ((day+(1024>>grid))&(0xffffffff<<(11-grid)));
				}

				i = insertsprite(sucksect,0);
				sprite[i].x = dax, sprite[i].y = day;
				sprite[i].cstat = 0;
				sprite[i].shade = 0, sprite[i].z = sector[sucksect].floorz;
				sprite[i].xrepeat = 64, sprite[i].yrepeat = 64;
				sprite[i].ang = 1536, sprite[i].vel = 0;
				sprite[i].zvel = 0; sprite[i].owner = -1;
				sprite[i].tag = 0L;

				for(k=0;k<MAXTILES;k++)
					localartfreq[k] = 0;
				for(k=0;k<MAXSPRITES;k++)
					if (sprite[k].statnum < MAXSTATUS)
						localartfreq[sprite[k].picnum]++;
				j = 0;
				for(k=0;k<MAXTILES;k++)
					if (localartfreq[k] > localartfreq[j])
						j = k;
				if (localartfreq[j] > 0)
					sprite[i].picnum = j;
				else
					sprite[i].picnum = 0;

				printmessage16("Sprite inserted.");
				asksave = 1;
			}

			keystatus[0x1f] = 0;
		}

		bad = (keystatus[0x39] > 0);  //Gotta do this to save lots of 3 spaces!
		if (bad > 0)
		{
			keystatus[0x39] = 0;
			adjustmark(&mousxplc,&mousyplc,newnumwalls);
			if (checkautoinsert(mousxplc,mousyplc,newnumwalls) == 1)
			{
				printmessage16("You must insert a point there first.");
				bad = 0;
			}
		}

		if (bad > 0)  //Space
		{
			if ((newnumwalls < 0) && (numwalls < MAXWALLS-1))
			{
				firstx = mousxplc, firsty = mousyplc;  //Make first point
				newnumwalls = numwalls;
				suckwall = -1;
				split = 0;
				wall[newnumwalls].x = mousxplc;
				wall[newnumwalls].y = mousyplc;
				wall[newnumwalls].nextsector1 = -1;
				wall[newnumwalls].nextwall1 = -1;
				for(i=0;i<numwalls;i++)
					if ((wall[i].x == mousxplc) && (wall[i].y == mousyplc))
						suckwall = i;
				wall[newnumwalls].point2 = newnumwalls+1;
				printmessage16("Sector drawing started.");
				newnumwalls++;
			}
			else
			{  //if not back to first point
				if ((firstx != mousxplc) || (firsty != mousyplc))  //nextpoint
				{
					j = 0;
					for(i=numwalls;i<newnumwalls;i++)
						if ((mousxplc == wall[i].x) && (mousyplc == wall[i].y))
							j = 1;
					if (j == 0)
					{
							//check if starting to split a sector
						if (newnumwalls == numwalls+1)
						{
							dax = ((wall[numwalls].x+mousxplc)>>1);
							day = ((wall[numwalls].y+mousyplc)>>1);
							j = -1;
							for(i=0;i<numsectors;i++)
								if (inside(dax,day,i) == 1)
								{
									j = i;
									break;
								}
							if (j >= 0)   //check if first point at point of sector
							{
								m = -1;
								startwall = sector[j].wallptr;
								endwall = startwall + sector[j].wallnum - 1;
								for(k=startwall;k<=endwall;k++)
									if (wall[k].x == wall[numwalls].x)
										if (wall[k].y == wall[numwalls].y)
										{
											m = k;
											break;
										}
								if (m >= 0)
									if ((wall[wall[k].point2].x != mousxplc) || (wall[wall[k].point2].y != mousyplc))
										if ((wall[lastwall((short)k)].x != mousxplc) || (wall[lastwall((short)k)].y != mousyplc))
										{
											split = 1;
											splitsect = j;
											splitstartwall = m;
										}
							}
						}

							//make new point

						//make sure not drawing over old red line
						bad = 0;
						for(i=0;i<numwalls;i++)
						{
							if (wall[i].nextwall1 >= 0)
							{
								if ((wall[i].x == mousxplc) && (wall[i].y == mousyplc))
									if ((wall[wall[i].point2].x == wall[newnumwalls-1].x) && (wall[wall[i].point2].y == wall[newnumwalls-1].y))
										bad = 1;
								if ((wall[i].x == wall[newnumwalls-1].x) && (wall[i].y == wall[newnumwalls-1].y))
									if ((wall[wall[i].point2].x == mousxplc) && (wall[wall[i].point2].y == mousyplc))
										bad = 1;
							}
						}

						if (bad == 0)
						{
							wall[newnumwalls].x = mousxplc;
							wall[newnumwalls].y = mousyplc;
							wall[newnumwalls].nextsector1 = -1;
							wall[newnumwalls].nextwall1 = -1;
							for(i=0;i<numwalls;i++)
								if ((wall[i].x == mousxplc) && (wall[i].y == mousyplc))
									suckwall = i;
							wall[newnumwalls].point2 = newnumwalls+1;
							newnumwalls++;
						}
						else
						{
							printmessage16("You can't draw new lines over red lines.");
						}
					}
				}

					//if not split and back to first point
				if ((split == 0) && (firstx == mousxplc) && (firsty == mousyplc) && (newnumwalls >= numwalls+3))
				{
					wall[newnumwalls-1].point2 = numwalls;

					if (suckwall == -1)  //if no connections to other sectors
					{
						k = -1;
						for(i=0;i<numsectors;i++)
							if (inside(firstx,firsty,i) == 1)
								k = i;
						if (k == -1)   //if not inside another sector either
						{              //add island sector
							if (clockdir(numwalls) == 1)
								flipwalls(numwalls,newnumwalls);
							sector[numsectors].wallptr = numwalls;
							sector[numsectors].wallnum = newnumwalls-numwalls;
							sector[numsectors].ceilingstat = 0;
							sector[numsectors].floorstat = 0;
							sector[numsectors].ceilingpanning = 0;
							sector[numsectors].floorpanning = 0;
							sector[numsectors].ceilingshade = 0;
							sector[numsectors].floorshade = 0;
							sector[numsectors].ceilingz = (-32<<8);
							sector[numsectors].floorz = (32<<8);
							sector[numsectors].ceilingpicnum = 0;
							sector[numsectors].floorpicnum = 0;
							sector[numsectors].ceilingheinum = 0;
							sector[numsectors].floorheinum = 0;
							for(i=numwalls;i<newnumwalls;i++)
							{
								wall[i].cstat = 0;
								wall[i].shade = 0;
								wall[i].yrepeat = 8;
								fixrepeats((short)i,0);
								wall[i].picnum = 0;
								wall[i].nextsector1 = -1;
								wall[i].nextwall1 = -1;
								wall[i].nextsector2 = -1;
								wall[i].nextwall2 = -1;
							}
							headspritesect[numsectors] = -1;
							numsectors++;
						}
						else       //else add loop to sector
						{
							if (clockdir(numwalls) == 0)
								flipwalls(numwalls,newnumwalls);

							j = newnumwalls-numwalls;

							sector[k].wallnum += j;
							for(i=k+1;i<numsectors;i++)
								sector[i].wallptr += j;
							suckwall = sector[k].wallptr;

							for(i=0;i<numwalls;i++)
							{
								if (wall[i].nextwall1 >= suckwall)
									wall[i].nextwall1 += j;
								if (wall[i].point2 >= suckwall)
									wall[i].point2 += j;
							}

							for(i=newnumwalls-1;i>=suckwall;i--)
								memcpy(&wall[i+j],&wall[i],sizeof(wall[0]));
							for(i=0;i<j;i++)
								memcpy(&wall[i+suckwall],&wall[i+newnumwalls],sizeof(wall[0]));

							for(i=suckwall;i<suckwall+j;i++)
							{
								wall[i].point2 += (suckwall-numwalls);

								wall[i].cstat = wall[suckwall+j].cstat;
								wall[i].shade = wall[suckwall+j].shade;
								wall[i].yrepeat = wall[suckwall+j].yrepeat;
								fixrepeats((short)i,wall[suckwall+j].picnum);
								wall[i].picnum = wall[suckwall+j].picnum;

								wall[i].nextsector1 = -1;
								wall[i].nextwall1 = -1;
								wall[i].nextsector2 = -1;
								wall[i].nextwall2 = -1;
							}
						}
					}
					else
					{
						  //add new sector with connections
						if (clockdir(numwalls) == 1)
							flipwalls(numwalls,newnumwalls);

						sector[numsectors].wallptr = numwalls;
						sector[numsectors].wallnum = newnumwalls-numwalls;
						sucksect = sectorofwall(suckwall);
						sector[numsectors].ceilingstat = sector[sucksect].ceilingstat;
						sector[numsectors].floorstat = sector[sucksect].floorstat;
						sector[numsectors].ceilingpanning = sector[sucksect].ceilingpanning;
						sector[numsectors].floorpanning = sector[sucksect].floorpanning;
						sector[numsectors].ceilingshade = sector[sucksect].ceilingshade;
						sector[numsectors].floorshade = sector[sucksect].floorshade;
						sector[numsectors].ceilingz = sector[sucksect].ceilingz;
						sector[numsectors].floorz = sector[sucksect].floorz;
						sector[numsectors].ceilingpicnum = sector[sucksect].ceilingpicnum;
						sector[numsectors].floorpicnum = sector[sucksect].floorpicnum;
						sector[numsectors].ceilingheinum = sector[sucksect].ceilingheinum;
						sector[numsectors].floorheinum = sector[sucksect].floorheinum;
						for(i=numwalls;i<newnumwalls;i++)
						{
							wall[i].cstat = wall[suckwall].cstat;
							wall[i].shade = wall[suckwall].shade;
							wall[i].yrepeat = wall[suckwall].yrepeat;
							fixrepeats((short)i,wall[suckwall].picnum);
							wall[i].picnum = wall[suckwall].picnum;
							checksectorpointer((short)i,(short)numsectors);
							wall[i].nextsector2 = -1;
							wall[i].nextwall2 = -1;
						}
						headspritesect[numsectors] = -1;
						numsectors++;
					}
					numwalls = newnumwalls;
					newnumwalls = -1;
					asksave = 1;
				}
				if (split == 1)
				{
						 //split sector
					startwall = sector[splitsect].wallptr;
					endwall = startwall + sector[splitsect].wallnum - 1;
					for(k=startwall;k<=endwall;k++)
						if (wall[k].x == wall[newnumwalls-1].x)
							if (wall[k].y == wall[newnumwalls-1].y)
							{
								bad = 0;
								if (loopnumofsector(splitsect,splitstartwall) != loopnumofsector(splitsect,(short)k))
									bad = 1;

								if (bad == 0)
								{
									//SPLIT IT!
									//Split splitsect given: startwall,
									//   new points: numwalls to newnumwalls-2

									splitendwall = k;
									newnumwalls--;  //first fix up the new walls
									for(i=numwalls;i<newnumwalls;i++)
									{
										wall[i].cstat = wall[startwall].cstat;
										wall[i].shade = wall[startwall].shade;
										wall[i].yrepeat = wall[startwall].yrepeat;
										fixrepeats((short)i,wall[startwall].picnum);
										wall[i].picnum = wall[startwall].picnum;

										wall[i].nextwall1 = -1;
										wall[i].nextsector1 = -1;
										wall[i].point2 = i+1;
									}
									danumwalls = newnumwalls;  //where to add more walls
									m = splitendwall;          //copy rest of loop next
									while (m != splitstartwall)
									{
										memcpy(&wall[danumwalls],&wall[m],sizeof(wall[0]));
										wall[danumwalls].point2 = danumwalls+1;
										danumwalls++;
										m = wall[m].point2;
									}
									wall[danumwalls-1].point2 = numwalls;

										//Add other loops for 1st sector
									loopnum = loopnumofsector(splitsect,splitstartwall);
									i = loopnum;
									for(j=startwall;j<=endwall;j++)
									{
										k = loopnumofsector(splitsect,(short)j);
										if ((k != i) && (k != loopnum))
										{
											i = k;
											if (loopinside(wall[j].x,wall[j].y,numwalls) == 1)
											{
												m = j;          //copy loop
												k = danumwalls;
												do
												{
													memcpy(&wall[danumwalls],&wall[m],sizeof(wall[0]));
													wall[danumwalls].point2 = danumwalls+1;
													danumwalls++;
													m = wall[m].point2;
												}
												while (m != j);
												wall[danumwalls-1].point2 = k;
											}
										}
									}

									secondstartwall = danumwalls;
										//copy split points for other sector backwards
									for(j=newnumwalls;j>numwalls;j--)
									{
										memcpy(&wall[danumwalls],&wall[j],sizeof(wall[0]));
										wall[danumwalls].nextwall1 = -1;
										wall[danumwalls].nextsector1 = -1;
										wall[danumwalls].point2 = danumwalls+1;
										danumwalls++;
									}
									m = splitstartwall;     //copy rest of loop next
									while (m != splitendwall)
									{
										memcpy(&wall[danumwalls],&wall[m],sizeof(wall[0]));
										wall[danumwalls].point2 = danumwalls+1;
										danumwalls++;
										m = wall[m].point2;
									}
									wall[danumwalls-1].point2 = secondstartwall;

										//Add other loops for 2nd sector
									loopnum = loopnumofsector(splitsect,splitstartwall);
									i = loopnum;
									for(j=startwall;j<=endwall;j++)
									{
										k = loopnumofsector(splitsect,(short)j);
										if ((k != i) && (k != loopnum))
										{
											i = k;
											if (loopinside(wall[j].x,wall[j].y,secondstartwall) == 1)
											{
												m = j;          //copy loop
												k = danumwalls;
												do
												{
													memcpy(&wall[danumwalls],&wall[m],sizeof(wall[0]));
													wall[danumwalls].point2 = danumwalls+1;
													danumwalls++;
													m = wall[m].point2;
												}
												while (m != j);
												wall[danumwalls-1].point2 = k;
											}
										}
									}

										//fix all next pointers on old sector line
									for(j=numwalls;j<danumwalls;j++)
									{
										if (wall[j].nextwall1 >= 0)
										{
											wall[wall[j].nextwall1].nextwall1 = j;
											if (j < secondstartwall)
												wall[wall[j].nextwall1].nextsector1 = numsectors;
											else
												wall[wall[j].nextwall1].nextsector1 = numsectors+1;
										}
									}
										//set all next pointers on split
									for(j=numwalls;j<newnumwalls;j++)
									{
										m = secondstartwall+(newnumwalls-1-j);
										wall[j].nextwall1 = m;
										wall[j].nextsector1 = numsectors+1;
										wall[m].nextwall1 = j;
										wall[m].nextsector1 = numsectors;
									}
										//copy sector attributes & fix wall pointers
									memcpy(&sector[numsectors],&sector[splitsect],sizeof(sector[0]));
									memcpy(&sector[numsectors+1],&sector[splitsect],sizeof(sector[0]));
									sector[numsectors].wallptr = numwalls;
									sector[numsectors].wallnum = secondstartwall-numwalls;
									sector[numsectors+1].wallptr = secondstartwall;
									sector[numsectors+1].wallnum = danumwalls-secondstartwall;

										//fix sprites
									j = headspritesect[splitsect];
									while (j != -1)
									{
										k = nextspritesect[j];
										if (loopinside(sprite[j].x,sprite[j].y,numwalls) == 1)
											changespritesect(j,numsectors);
										else if (loopinside(sprite[j].x,sprite[j].y,secondstartwall) == 1)
											changespritesect(j,numsectors+1);
										j = k;
									}

									numsectors+=2;

										//clear out old sector's next pointers for clean deletesector
									numwalls = danumwalls;
									for(j=startwall;j<=endwall;j++)
									{
										wall[j].nextwall1 = -1;
										wall[j].nextsector1 = -1;
									}
									deletesector(splitsect);

									newnumwalls = -1;
									printmessage16("Sector split.");
									break;
								}
								else
								{
									newnumwalls = -1;
									printmessage16("You can't split sector by connecting different loops.");
								}
							}
				}
			}
		}

		if (keystatus[0x1c] > 0) //Left Enter
		{
			checksectorpointer(linehighlight,sectorofwall(linehighlight));
			printmessage16("Highlighted line pointers checked.");
			asksave = 1;
			keystatus[0x1c] = 0;
		}

		if ((keystatus[0x0e] > 0) && (newnumwalls >= numwalls)) //Backspace
		{
			if (newnumwalls > numwalls)
			{
				newnumwalls--;
				asksave = 1;
				keystatus[0x0e] = 0;
			}
			if (newnumwalls == numwalls)
			{
				newnumwalls = -1;
				asksave = 1;
				keystatus[0x0e] = 0;
			}
		}

		if ((keystatus[0xd3] > 0) && (keystatus[0x9d] > 0) && (numwalls >= 0))
		{                                                      //sector delete
			sucksect = -1;
			for(i=0;i<numsectors;i++)
				if (inside(mousxplc,mousyplc,i) == 1)
				{
					deletesector((short)i);
					printmessage16("Sector deleted.");
					asksave = 1;
					keystatus[0xd3] = 0;
					break;
				}
		}

		if ((keystatus[0xd3] > 0) && (pointhighlight >= 0))
		{
			if ((pointhighlight&0xf000) == 4096)   //Sprite Delete
			{
				deletesprite(pointhighlight&4095);
				printmessage16("Sprite deleted.");
				asksave = 1;
			}
			keystatus[0xd3] = 0;
		}

		if ((keystatus[0xd2] > 0) && (linehighlight >= 0))  //InsertPoint
		{
			dax = ((wall[linehighlight].x+wall[wall[linehighlight].point2].x)>>1);
			day = ((wall[linehighlight].y+wall[wall[linehighlight].point2].y)>>1);
			insertpoint(linehighlight,dax,day);
			printmessage16("Point inserted.");
			asksave = 1;
			keystatus[0xd2] = 0;
		}

		numframes++;
		lockspeed = clockspeed;
		clockspeed -= lockspeed;
		totalclock += lockspeed;
		if (keystatus[0x9c] > 0)
		{
			if (cursectnum >= 0)
				keystatus[0x9c] = 2;
			else
				printmessage16("Arrow must be inside a sector before entering 3D mode.");
		}
		if (keystatus[1] > 0)
		{
			keystatus[1] = 0;
			printmessage16("(N)ew, (L)oad, (S)ave, (Q)uit");
			bad = 1;
			while (bad == 1)
			{
				if (keystatus[1] > 0)
				{
					keystatus[1] = 0;
					bad = 0;
					printmessage16("");
				}
				if (keystatus[0x31] > 0)  //N
				{
					bad = 0;
					keystatus[0x31] = 0;
					printmessage16("Are you sure you want to start a new board?");
					while ((keystatus[1]|keystatus[0x1c]|keystatus[0x39]|keystatus[0x31]|keystatus[0x15]) == 0);
					if (keystatus[0x15] > 0)
					{
						keystatus[0x15] = 0;

						posx = 32768;          //new board!
						posy = 32768;
						posz = 0;
						ang = 1536;
						numsectors = 0;
						numwalls = 0;
						cursectnum = -1;
						initspritelists();
						strcpy(&boardfilename,"newboard.map");
					}
					printmessage16("");
				}
				if (keystatus[0x26] > 0)  //L
				{
					bad = 0;
					keystatus[0x26] = 0;
					i = menuselect();
					if (i < 0)
					{
						if (i == -2)
							printmessage16("No .MAP files found.");
					}
					else
					{
						strcpy(&boardfilename,menuname[menuhighlight]);
						loadboard(boardfilename);
						startposx = posx;      //this is same
						startposy = posy;
						startposz = posz;
						startang = ang;
					}
					chdir(curpath);
					printmessage16("");
				}
				if (keystatus[0x1f] > 0)  //S
				{
					bad = 0;
					keystatus[0x1f] = 0;
					printmessage16("Saving board...");
					fixspritesectors();   //Do this before saving!
					dax = posx, day = posy, daz = posz, daang = ang;
					posx = startposx, posy = startposy, posz = startposz, ang = startang;
					saveboard(boardfilename);
					posx = dax, posy = day, posz = daz, ang = daang;
					printmessage16("Board saved.");
				}
				if (keystatus[0x10] > 0)  //Q
				{
					bad = 0;
					keystatus[0x10] = 0;
					printmessage16("Are you sure you want to quit?");
					while ((keystatus[1]|keystatus[0x1c]|keystatus[0x39]|keystatus[0x31]|keystatus[0x15]) == 0);
					if (keystatus[0x15] > 0)
					{
						keystatus[0x15] = 0;             //QUIT!

						printmessage16("Save changes?");
						while ((keystatus[1]|keystatus[0x1c]|keystatus[0x39]|keystatus[0x31]|keystatus[0x15]) == 0);
						if (keystatus[0x15] > 0)
						{
							keystatus[0x15] = 0;

							fixspritesectors();   //Do this before saving!

							posx = startposx;
							posy = startposy;
							posz = startposz;
							ang = startang;
							saveboard(boardfilename);
						}
						uninitengine();
						setvmode(0x3);
						printf("BUILD programmed by Ken Silverman\n");
						exit(0);
					}
					printmessage16("");
				}
			}
		}
	}
	fixspritesectors();
	qsetmode320200();

	posz = oposz;
	searchx >>= 1;
	searchy >>= 1;
}

getpoint(long searchxe, long searchye, long *x1, long *y1)
{
	long x2, y2;

	x2 = ((searchxe-320)<<14)/zoom;
	y2 = ((searchye-200)<<14)/zoom;
	*x1 = posx+x2;
	*y1 = posy+y2;
	if (*x1 < 0) *x1 = 0;
	if (*x1 >= 65536) *x1 = 65535;
	if (*y1 < 0) *y1 = 0;
	if (*y1 >= 65536) *y1 = 65535;
}

getlinehighlight(long xplc, long yplc)
{
	long i, dst, dist, closest, x1, y1, x2, y2;

	if (numwalls == 0)
		return(-1);
	dist = 0x7fffffff;
	closest = numwalls-1;
	for(i=0;i<numwalls;i++)
	{
		dst = labs(xplc - ((wall[i].x + wall[wall[i].point2].x)>>1));
		dst += labs(yplc - ((wall[i].y + wall[wall[i].point2].y)>>1));
		if (dst <= dist)
			dist = dst, closest = i;
	}

	if (wall[closest].nextwall1 >= 0)
	{    //if red line, allow highlighting of both sides
		x1 = wall[closest].x;
		y1 = wall[closest].y;
		x2 = wall[wall[closest].point2].x;
		y2 = wall[wall[closest].point2].y;
		if ((xplc-x1)*(y2-y1) > (x2-x1)*(yplc-y1))
			closest = wall[closest].nextwall1;
	}

	return(closest);
}

getpointhighlight(long xplc, long yplc)
{
	long i, dst, dist, closest;

	if (numwalls == 0)
		return(-1);
	dist = 512;
	closest = -1;
	for(i=0;i<numwalls;i++)
	{
		dst = labs(xplc - wall[i].x) + labs(yplc - wall[i].y);
		if (dst <= dist)
			dist = dst, closest = i;
	}
	for(i=0;i<MAXSPRITES;i++)
		if (sprite[i].statnum < MAXSTATUS)
		{
			dst = labs(xplc - sprite[i].x) + labs(yplc - sprite[i].y);
			if (dst <= dist)
				dist = dst, closest = i+4096;
		}
	return(closest);
}

adjustmark(long *xplc, long *yplc, short danumwalls)
{
	long i, dst, dist, dax, day, x1, y1, x2, y2;

	if (danumwalls < 0)
		danumwalls = numwalls;
	dist = 192;
	dax = *xplc;
	day = *yplc;
	for(i=0;i<danumwalls;i++)
	{
		dst = labs((*xplc) - wall[i].x) + labs((*yplc) - wall[i].y);
		if (dst < dist)
		{
			dist = dst;
			dax = wall[i].x;
			day = wall[i].y;
		}
	}
	if (dist == 192L)
		if ((gridlock > 0) && (grid > 0))
		{
			dax = ((dax+(1024>>grid))&(0xffffffff<<(11-grid)));
			day = ((day+(1024>>grid))&(0xffffffff<<(11-grid)));
		}

	*xplc = dax;
	*yplc = day;
	return(0);
}

checkautoinsert(long dax, long day, short danumwalls)
{
	long i, x1, y1, x2, y2;

	if (danumwalls < 0)
		danumwalls = numwalls;
	for(i=0;i<danumwalls;i++)       // Check if a point should be inserted
	{
		x1 = wall[i].x;
		y1 = wall[i].y;
		x2 = wall[wall[i].point2].x;
		y2 = wall[wall[i].point2].y;

		if ((x1 != dax) || (y1 != day))
			if ((x2 != dax) || (y2 != day))
				if (((x1 <= dax) && (dax <= x2)) || ((x2 <= dax) && (dax <= x1)))
					if (((y1 <= day) && (day <= y2)) || ((y2 <= day) && (day <= y1)))
						if ((dax-x1)*(y2-y1) == (day-y1)*(x2-x1))
							return(1);          //insertpoint((short)i,dax,day);
	}
	return(0);
}

clockdir(short wallstart)   //Returns: 0 is CW, 1 is CCW
{
	short i, themin;
	long minx, templong, x0, x1, x2, y0, y1, y2;

	minx = 0x7fffffff;
	themin = -1;
	i = wallstart-1;
	do
	{
		i++;
		if (wall[wall[i].point2].x < minx)
		{
			minx = wall[wall[i].point2].x;
			themin = i;
		}
	}
	while ((wall[i].point2 != wallstart) && (i < MAXWALLS));

	x0 = wall[themin].x;
	y0 = wall[themin].y;
	x1 = wall[wall[themin].point2].x;
	y1 = wall[wall[themin].point2].y;
	x2 = wall[wall[wall[themin].point2].point2].x;
	y2 = wall[wall[wall[themin].point2].point2].y;

	if ((y1 >= y2) && (y1 <= y0)) return(0);
	if ((y1 >= y0) && (y1 <= y2)) return(1);

	templong = (x0-x1)*(y2-y1) - (x2-x1)*(y0-y1);
	if (templong < 0)
		return(0);
	else
		return(1);
}

flipwalls(short numwalls, short newnumwalls)
{
	long i, j, nume, templong;

	nume = newnumwalls-numwalls;

	for(i=numwalls;i<numwalls+(nume>>1);i++)
	{
		j = numwalls+newnumwalls-i-1;
		templong = wall[i].x; wall[i].x = wall[j].x; wall[j].x = templong;
		templong = wall[i].y; wall[i].y = wall[j].y; wall[j].y = templong;
	}
}

insertpoint(short linehighlight, long dax, long day)
{
	short sucksect;
	long i, j, k;

	j = linehighlight;
	sucksect = sectorofwall((short)j);

	sector[sucksect].wallnum++;
	for(i=sucksect+1;i<numsectors;i++)
		sector[i].wallptr++;

	movewalls((long)j+1,+1L);
	memcpy(&wall[j+1],&wall[j],sizeof(wall[0]));

	wall[j].point2 = j+1;
	wall[j+1].x = dax;
	wall[j+1].y = day;
	fixrepeats((short)j,wall[j].picnum);
	fixrepeats((short)j+1,wall[j+1].picnum);

	if (wall[j].nextwall1 >= 0)
	{
		k = wall[j].nextwall1;

		sucksect = sectorofwall((short)k);

		sector[sucksect].wallnum++;
		for(i=sucksect+1;i<numsectors;i++)
			sector[i].wallptr++;

		movewalls((long)k+1,+1L);
		memcpy(&wall[k+1],&wall[k],sizeof(wall[0]));

		wall[k].point2 = k+1;
		wall[k+1].x = dax;
		wall[k+1].y = day;
		fixrepeats((short)k,wall[k].picnum);
		fixrepeats((short)k+1,wall[k+1].picnum);

		j = wall[k].nextwall1;
		wall[j].nextwall1 = k+1;
		wall[j+1].nextwall1 = k;
		wall[k].nextwall1 = j+1;
		wall[k+1].nextwall1 = j;
	}
}

deletepoint(point)
{
	long i, j, k, sucksect;

	sucksect = sectorofwall(point);

	sector[sucksect].wallnum--;
	for(i=sucksect+1;i<numsectors;i++)
		sector[i].wallptr--;

	j = lastwall(point);
	k = wall[point].point2;
	wall[j].point2 = k;

	if (wall[j].nextwall1 >= 0)
	{
		wall[wall[j].nextwall1].nextwall1 = -1;
		wall[wall[j].nextwall1].nextsector1 = -1;
	}
	if (wall[point].nextwall1 >= 0)
	{
		wall[wall[point].nextwall1].nextwall1 = -1;
		wall[wall[point].nextwall1].nextsector1 = -1;
	}
	movewalls((long)point,-1L);

	checksectorpointer((short)j,(short)sucksect);
}

deletesector(short sucksect)
{
	long i, j, k, nextk, startwall, endwall;

	while (headspritesect[sucksect] >= 0)
		deletesprite(headspritesect[sucksect]);

	startwall = sector[sucksect].wallptr;
	endwall = startwall + sector[sucksect].wallnum - 1;
	j = sector[sucksect].wallnum;

	for(i=sucksect;i<numsectors-1;i++)
	{
		k = headspritesect[i+1];
		while (k != -1)
		{
			nextk = nextspritesect[k];
			changespritesect((short)k,(short)i);
			k = nextk;
		}

		memcpy(&sector[i],&sector[i+1],sizeof(sector[0]));
		sector[i].wallptr -= j;
	}
	numsectors--;

	j = endwall-startwall+1;
	for (i=startwall;i<=endwall;i++)
		if (wall[i].nextwall1 != -1)
		{
			wall[wall[i].nextwall1].nextwall1 = -1;
			wall[wall[i].nextwall1].nextsector1 = -1;
		}
	movewalls(startwall,-j);
	for(i=0;i<numwalls;i++)
		if (wall[i].nextwall1 >= startwall)
			wall[i].nextsector1--;
	return(0);
}

fixspritesectors()
{
	long i, j, dax, day;

	for(i=numsectors-1;i>=0;i--)
		if ((sector[i].wallnum <= 0) || (sector[i].wallptr >= numwalls))
			deletesector((short)i);

	for(i=0;i<MAXSPRITES;i++)
		if (sprite[i].statnum < MAXSTATUS)
		{
			dax = sprite[i].x;
			day = sprite[i].y;
			if (inside(dax,day,sprite[i].sectnum) != 1)
				for(j=0;j<numsectors;j++)
					if (inside(dax,day,(short)j) == 1)
					{
						changespritesect((short)i,(short)j);
						break;
					}
		}
}

movewalls(long start, long offs)
{
	long i, j, k;

	if (offs < 0)  //Delete
	{
		for(i=start;i<numwalls+offs;i++)
			memcpy(&wall[i],&wall[i-offs],sizeof(wall[0]));
	}
	else if (offs > 0)  //Insert
	{
		for(i=numwalls+offs-1;i>=start+offs;i--)
			memcpy(&wall[i],&wall[i-offs],sizeof(wall[0]));
	}
	numwalls += offs;
	for(i=0;i<numwalls;i++)
	{
		if (wall[i].nextwall1 >= start) wall[i].nextwall1 += offs;
		if (wall[i].point2 >= start) wall[i].point2 += offs;
	}
	return(0);
}

sectorofwall(short theline)
{
	short i, startwall, endwall, sucksect;

	sucksect = -1;
	for(i=0;i<numsectors;i++)
	{
		startwall = sector[i].wallptr;
		endwall = startwall + sector[i].wallnum - 1;
		if ((theline >= startwall) && (theline <= endwall))
		{
			sucksect = i;
			break;
		}
	}
	return(sucksect);
}

checksectorpointer(short i, short sectnum)
{
	long j, k, startwall, endwall, x1, y1, x2, y2;

	wall[i].nextsector1 = -1;
	wall[i].nextwall1 = -1;
	x1 = wall[i].x;
	y1 = wall[i].y;
	x2 = wall[wall[i].point2].x;
	y2 = wall[wall[i].point2].y;
	for(j=0;j<numsectors;j++)
	{
		startwall = sector[j].wallptr;
		endwall = startwall + sector[j].wallnum - 1;
		for(k=startwall;k<=endwall;k++)
		{
			if ((wall[k].x == x2) && (wall[k].y == y2))
				if ((wall[wall[k].point2].x == x1) && (wall[wall[k].point2].y == y1))
				{
					wall[i].nextsector1 = j;
					wall[i].nextwall1 = k;
					wall[k].nextsector1 = sectnum;
					wall[k].nextwall1 = i;
				}
		}
	}
	return(0);
}

fixrepeats(short i, short tilenum)
{
	char owallxrepeat, owallyrepeat;
	long dax, day, dist;

	dax = wall[i].x-wall[wall[i].point2].x;
	day = wall[i].y-wall[wall[i].point2].y;
	dist = ksqrt(dax*dax+day*day);
	owallxrepeat = wall[i].xrepeat;
	owallyrepeat = wall[i].yrepeat;
	wall[i].xrepeat = (unsigned char)((dist*owallyrepeat)>>10);
	return(0);
}

printext16(long xpos, long ypos, short col, short backcol, char name[82])
{
	char ch, dat;
	short mask;
	long p, startp, z, zz;

	startp = ypos*80 + (xpos>>3)+0xa0000;

	outp(0x3ce,0x5); outp(0x3cf,(inp(0x3cf)&(255-3))+2);
	outp(0x3ce,0x8);

	z = 0;
	mask = (1<<(8-(xpos&7)))-1;
	while (name[z] != 0)
	{
		ch = name[z];
		z++;

		p = startp;
		if ((xpos&7) == 0)
		{
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					outp(0x3cf,255);
					drawpixel(p,(long)backcol);
				}
				outp(0x3cf,textfont[ch][zz]);
				getpixel(p), drawpixel(p,col);
				p += 80;
			}
		}
		else
		{
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					outp(0x3cf,mask);
					getpixel(p), drawpixel(p,backcol);
					outp(0x3cf,255-mask);
					getpixel(p+1), drawpixel(p+1,backcol);
				}
				dat = textfont[ch][zz];
				outp(0x3cf,mask&(dat>>(xpos&7)));
				getpixel(p), drawpixel(p,col);
				outp(0x3cf,(255-mask)&(dat<<(8-(xpos&7))));
				getpixel(p+1), drawpixel(p+1,col);
				p += 80;
			}
		}
		startp++;
	}
	outp(0x3ce,0x5); outp(0x3cf,(inp(0x3cf)&(255-3))+0);
}

printmessage16(char name[82])
{
	char snotbuf[60];
	long i;

	i = 0;
	while ((name[i] != 0) && (i < 56))
	{
		snotbuf[i] = name[i];
		i++;
	}
	while (i < 56)
	{
		snotbuf[i] = 32;
		i++;
	}
	snotbuf[56] = 0;

	printext16(184, 8, 0, 6, snotbuf);
}

printcoords16()
{
	char snotbuf[40];
	long i;

	sprintf(snotbuf,"x=%ld y=%ld ang=%ld",posx,posy,ang);
	i = 0;
	while ((snotbuf[i] != 0) && (i < 30))
		i++;
	while (i < 30)
	{
		snotbuf[i] = 32;
		i++;
	}
	snotbuf[30] = 0;

	printext16(8, 128, 11, 6, snotbuf);
}

clearmidstatbar16()
{
	long opageoffset;

	opageoffset = pageoffset;    //clear bottom part of status bar
	pageoffset = 0;
	ydim16 = 144;
	fillscreen16((640L*25L)>>3,8L,640L*(143L-(25<<1)));
	drawline16(0,0,0,143,7);
	drawline16(639,0,639,143,7);
	pageoffset = opageoffset;
	ydim16 = 336;
}

showsectorattributes(short sectnum)
{
	char snotbuf[80];

	sprintf(snotbuf,"Sector %d",sectnum);
	printext16(8,32,11,-1,snotbuf);
	sprintf(snotbuf,"Firstwall: %d",sector[sectnum].wallptr);
	printext16(8,48,11,-1,snotbuf);
	sprintf(snotbuf,"Numberofwalls: %d",sector[sectnum].wallnum);
	printext16(8,56,11,-1,snotbuf);

	sprintf(snotbuf,"Firstsprite: %d",headspritesect[sectnum]);
	printext16(8,72,11,-1,snotbuf);

	sprintf(snotbuf,"Tag: %ld, %ld",((unsigned long)sector[sectnum].tag)>>16,sector[sectnum].tag&65535);
	printext16(8,88,11,-1,snotbuf);

	printext16(200,32,11,-1,"CEILINGS:");
	sprintf(snotbuf,"Flags (hex): %x",sector[sectnum].ceilingstat);
	printext16(200,48,11,-1,snotbuf);
	sprintf(snotbuf,"Panning byte: %d",sector[sectnum].ceilingpanning);
	printext16(200,56,11,-1,snotbuf);
	sprintf(snotbuf,"Shade byte: %d",sector[sectnum].ceilingshade);
	printext16(200,64,11,-1,snotbuf);
	sprintf(snotbuf,"Z-coordinate: %ld",sector[sectnum].ceilingz);
	printext16(200,72,11,-1,snotbuf);
	sprintf(snotbuf,"Tile number: %d",sector[sectnum].ceilingpicnum);
	printext16(200,80,11,-1,snotbuf);
	sprintf(snotbuf,"Bump-map number: %d",sector[sectnum].ceilingheinum);
	printext16(200,88,11,-1,snotbuf);

	printext16(400,32,11,-1,"FLOORS:");
	sprintf(snotbuf,"Flags (hex): %x",sector[sectnum].floorstat);
	printext16(400,48,11,-1,snotbuf);
	sprintf(snotbuf,"Panning byte: %d",sector[sectnum].floorpanning);
	printext16(400,56,11,-1,snotbuf);
	sprintf(snotbuf,"Shade byte: %d",sector[sectnum].floorshade);
	printext16(400,64,11,-1,snotbuf);
	sprintf(snotbuf,"Z-coordinate: %ld",sector[sectnum].floorz);
	printext16(400,72,11,-1,snotbuf);
	sprintf(snotbuf,"Tile number: %d",sector[sectnum].floorpicnum);
	printext16(400,80,11,-1,snotbuf);
	sprintf(snotbuf,"Bump-map number: %d",sector[sectnum].floorheinum);
	printext16(400,88,11,-1,snotbuf);
}

showwallattributes(short wallnum)
{
	char snotbuf[80];

	sprintf(snotbuf,"Wall %d",wallnum);
	printext16(8,32,11,-1,snotbuf);
	sprintf(snotbuf,"X-coordinate: %ld",wall[wallnum].x);
	printext16(8,48,11,-1,snotbuf);
	sprintf(snotbuf,"Y-coordinate: %ld",wall[wallnum].y);
	printext16(8,56,11,-1,snotbuf);
	sprintf(snotbuf,"Point2: %d",wall[wallnum].point2);
	printext16(8,64,11,-1,snotbuf);

	sprintf(snotbuf,"Tag: %ld, %ld",((unsigned long)wall[wallnum].tag)>>16,wall[wallnum].tag&65535);
	printext16(8,80,11,-1,snotbuf);

	sprintf(snotbuf,"Flags (hex): %x",wall[wallnum].cstat);
	printext16(200,48,11,-1,snotbuf);
	sprintf(snotbuf,"Shade: %d",wall[wallnum].shade);
	printext16(200,56,11,-1,snotbuf);
	sprintf(snotbuf,"Xrepeat: %d",wall[wallnum].xrepeat);
	printext16(200,64,11,-1,snotbuf);
	sprintf(snotbuf,"Yrepeat: %d",wall[wallnum].yrepeat);
	printext16(200,72,11,-1,snotbuf);
	sprintf(snotbuf,"Panning: %d",wall[wallnum].panning);
	printext16(200,80,11,-1,snotbuf);
	sprintf(snotbuf,"Tile number: %d",wall[wallnum].picnum);
	printext16(200,88,11,-1,snotbuf);
	sprintf(snotbuf,"OverTile number: %d",wall[wallnum].overpicnum);
	printext16(200,96,11,-1,snotbuf);

	sprintf(snotbuf,"Nextsector1: %d",wall[wallnum].nextsector1);
	printext16(400,48,11,-1,snotbuf);
	sprintf(snotbuf,"Nextwall1: %d",wall[wallnum].nextwall1);
	printext16(400,56,11,-1,snotbuf);
	sprintf(snotbuf,"Nextsector2: %d",wall[wallnum].nextsector2);
	printext16(400,64,11,-1,snotbuf);
	sprintf(snotbuf,"Nextwall2: %d",wall[wallnum].nextwall2);
	printext16(400,72,11,-1,snotbuf);

}

showspriteattributes(short spritenum)
{
	char snotbuf[80];

	sprintf(snotbuf,"Sprite %d",spritenum);
	printext16(8,32,11,-1,snotbuf);
	sprintf(snotbuf,"X-coordinate: %ld",sprite[spritenum].x);
	printext16(8,48,11,-1,snotbuf);
	sprintf(snotbuf,"Y-coordinate: %ld",sprite[spritenum].y);
	printext16(8,56,11,-1,snotbuf);
	sprintf(snotbuf,"Z-coordinate: %ld",sprite[spritenum].z);
	printext16(8,64,11,-1,snotbuf);

	sprintf(snotbuf,"Sectnum: %d",sprite[spritenum].sectnum);
	printext16(8,80,11,-1,snotbuf);
	sprintf(snotbuf,"Statnum: %d",sprite[spritenum].statnum);
	printext16(8,88,11,-1,snotbuf);

	sprintf(snotbuf,"Tag: %ld, %ld",((unsigned long)sprite[spritenum].tag)>>16,sprite[spritenum].tag&65535);
	printext16(8,104,11,-1,snotbuf);

	sprintf(snotbuf,"Flags (hex): %x",sprite[spritenum].cstat);
	printext16(200,48,11,-1,snotbuf);
	sprintf(snotbuf,"Shade: %d",sprite[spritenum].shade);
	printext16(200,56,11,-1,snotbuf);
	sprintf(snotbuf,"Xrepeat: %d",sprite[spritenum].xrepeat);
	printext16(200,64,11,-1,snotbuf);
	sprintf(snotbuf,"Yrepeat: %d",sprite[spritenum].yrepeat);
	printext16(200,72,11,-1,snotbuf);
	sprintf(snotbuf,"Tile number: %d",sprite[spritenum].picnum);
	printext16(200,80,11,-1,snotbuf);

	sprintf(snotbuf,"Angle (2048 degrees): %d",sprite[spritenum].ang);
	printext16(400,48,11,-1,snotbuf);
	sprintf(snotbuf,"Forward Velocity: %d",sprite[spritenum].vel);
	printext16(400,56,11,-1,snotbuf);
	sprintf(snotbuf,"Z-Velocity: %d",sprite[spritenum].zvel);
	printext16(400,64,11,-1,snotbuf);
	sprintf(snotbuf,"Owner: %d",sprite[spritenum].owner);
	printext16(400,72,11,-1,snotbuf);
	sprintf(snotbuf,"Extra pointer: %ld",sprite[spritenum].extra);
	printext16(400,80,11,-1,snotbuf);
}

loopinside(long x, long y, short startwall)
{
	long x1, y1, x2, y2, templong;
	short i, cnt;

	cnt = clockdir(startwall);
	i = startwall;
	do
	{
		x1 = wall[i].x; x2 = wall[wall[i].point2].x;
		if ((x1 >= x) || (x2 >= x))
		{
			y1 = wall[i].y; y2 = wall[wall[i].point2].y;
			if (y1 > y2)
			{
				templong = x1, x1 = x2, x2 = templong;
				templong = y1, y1 = y2, y2 = templong;
			}
			if ((y1 <= y) && (y2 > y))
				if (x1*(y-y2)+x2*(y1-y) <= x*(y1-y2))
					cnt ^= 1;
		}
		i = wall[i].point2;
	}
	while (i != startwall);
	return(cnt);
}

numloopsofsector(short sectnum)
{
	short startwall, endwall;
	long i, numloops;

	startwall = sector[sectnum].wallptr;
	endwall = startwall + sector[sectnum].wallnum - 1;
	numloops = 0;
	for(i=startwall;i<=endwall;i++)
		if (wall[i].point2 < i)
			numloops++;
	return(numloops);
}

loopnumofsector(short sectnum, short wallnum)
{
	short startwall, endwall;
	long i, numloops, loopnum;

	startwall = sector[sectnum].wallptr;
	endwall = startwall + sector[sectnum].wallnum - 1;
	loopnum = -1;
	numloops = 0;
	for(i=startwall;i<=endwall;i++)
	{
		if (i == wallnum)
			loopnum = numloops;
		if (wall[i].point2 < i)
			numloops++;
	}
	return(loopnum);
}

getnumber16(char namestart[80], long num, long maxnumber)
{
	char buffer[80];
	long oldnum, j, k, n;

	oldnum = num;
	while ((keystatus[0x1c] != 2) && (keystatus[0x1] == 0))
	{
		sprintf(&buffer,"%s%ld_ ",namestart,num);
		printmessage16(buffer);

		for(j=2;j<=11;j++)
			if (keystatus[j] > 0)
			{
				keystatus[j] = 0;
				k = j-1;
				if (k == 10) k = 0;
				n = (num*10)+k;
				if (n < maxnumber) num = n;
			}
		if (keystatus[0xe] > 0)    // backspace
		{
			num /= 10;
			keystatus[0xe] = 0;
		}
		if (keystatus[0x1c] == 1)
		{
			oldnum = num;
			keystatus[0x1c] = 2;
			asksave = 1;
		}
	}
	keystatus[0x1c] = 0;
	keystatus[0x1] = 0;
	return(oldnum);
}

initmenupaths(char filename[80])
{
	long i;

	strcpy(&curpath,filename);
	i = 0;
	while ((i < 80) && (curpath[i] != 0)) i++;
	while ((i > 0) && (curpath[i] != 92)) i--;
	curpath[i] = 0;
	strcpy(&menupath,curpath);
}

getfilenames(char kind[6])
{
	short type;
	struct find_t fileinfo;

	if (strcmp(kind,"SUBD") == 0)
	{
		strcpy(kind,"*.*");
		if (_dos_findfirst(kind,_A_SUBDIR,&fileinfo) != 0)
			return(-1);
		type = 1;
	}
	else
	{
		if (_dos_findfirst(kind,_A_NORMAL,&fileinfo) != 0)
			return(-1);
		type = 0;
	}
	do
	{
		if ((type == 0) || ((fileinfo.attrib&16) > 0))
			if ((fileinfo.name[0] != '.') || (fileinfo.name[1] != 0))
			{
				strcpy(menuname[menunamecnt],fileinfo.name);
				menuname[menunamecnt][16] = type;
				menunamecnt++;
			}
	}
	while (_dos_findnext(&fileinfo) == 0);

	return(0);
}

sortfilenames()
{
	char sortbuffer[17];
	long i, j, k, m;

	for(i=1;i<menunamecnt;i++)
		for(j=0;j<i;j++)
		{
			 k = 0;
			 while ((menuname[i][k] == menuname[j][k]) && (menuname[i][k] != 0) && (menuname[j][k] != 0))
				 k++;
			if (menuname[i][k] < menuname[j][k])
			{
				memcpy(&sortbuffer[0],&menuname[i][0],sizeof(menuname[0]));
				memcpy(&menuname[i][0],&menuname[j][0],sizeof(menuname[0]));
				memcpy(&menuname[j][0],&sortbuffer[0],sizeof(menuname[0]));
			}
		}
}

menuselect()
{
	long newhighlight, i, j, topplc;
	char ch, buffer[42];

	chdir(menupath);
	menunamecnt = 0;
	getfilenames("SUBD");
	getfilenames("*.MAP");
	sortfilenames();
	if (menunamecnt == 0)
		return(-2);

	printmessage16("Select .MAP file with arrows&enter.");
	fillscreen16((399360-pageoffset)>>3,0L,640L*336L);
	if (menuhighlight < 0) menuhighlight = 0;
	if (menuhighlight >= menunamecnt) menuhighlight = menunamecnt-1;

	newhighlight = menuhighlight;
	do
	{
		if (menunamecnt <= 36)
		{
			topplc = 0;
		}
		else
		{
			topplc = newhighlight-11;
			if (topplc < 0) topplc = 0;
			if (topplc > menunamecnt-37) topplc = menunamecnt-37;
		}

		for(i=0;i<menunamecnt;i++)
		{
			for(j=0;j<38;j++)
				buffer[j] = 32;
			buffer[38] = 0;
			if (i == newhighlight)
			{
				buffer[0] = '-';
				buffer[1] = '-';
				buffer[2] = '>';
			}
			j = 0;
			while (menuname[i][j] != 0)
			{
				buffer[j+4] = menuname[i][j];
				j++;
			}
			if ((i-topplc >= 0) && (i-topplc <= 36))
			{
				if (menuname[i][16] == 1)
				{
					printext16(0L,((i-topplc)<<3)+16L+((399360-pageoffset)/640),4,0,buffer);
				}
				else
				{
					printext16(0L,((i-topplc)<<3)+16L+((399360-pageoffset)/640),7,0,buffer);
				}
			}
		}

		keystatus[0xcb] = 0;
		keystatus[0xcd] = 0;
		keystatus[0xc8] = 0;
		keystatus[0xd0] = 0;
		keystatus[0x1c] = 0;
		keystatus[1] = 0;
		ch = 0;                      //Interesting fakery of ch = getch()
		while (ch == 0)
		{
			if (keystatus[0xcb] > 0) ch = 75;
			if (keystatus[0xcd] > 0) ch = 77;
			if (keystatus[0xc8] > 0) ch = 72;
			if (keystatus[0xd0] > 0) ch = 80;
			if (keystatus[0x1c] > 0) ch = 13;
			if (keystatus[1] > 0) ch = 27;
		}

		if ((ch == 75) || (ch == 72))
		{
			newhighlight--;
			if (newhighlight < 0)
				newhighlight = menunamecnt-1;
		}
		if ((ch == 77) || (ch == 80))
		{
			newhighlight++;
			if (newhighlight >= menunamecnt)
				newhighlight = 0;
		}
		if ((ch == 13) && (menuname[newhighlight][16] == 1))
		{
			if ((menuname[newhighlight][0] == '.') && (menuname[newhighlight][1] == '.'))
			{
				i = 0;
				while ((i < 80) && (menupath[i] != 0)) i++;
				while ((i > 0) && (menupath[i] != 92)) i--;
				menupath[i] = 0;
			}
			else
			{
				strcat(&menupath,"\\");
				strcat(&menupath,menuname[newhighlight]);
			}
			chdir(menuname[newhighlight]);
			menunamecnt = 0;
			getfilenames("SUBD");
			getfilenames("*.MAP");
			sortfilenames();
			newhighlight = 0;
			ch = 0;
			fillscreen16((399360-pageoffset)>>3,0L,640L*336L);
		}
	}
	while ((ch != 13) && (ch != 27));
	if (ch == 13)
	{
		menuhighlight = newhighlight;
		return(newhighlight);
	}
	return(-1);
}
