// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>

#define NUMOPTIONS 6

static char screeninfo[4000];
static char strtable[][80] =
{
	"Graphics Mode",
	"Digitized Sound",
	"Music",
	"Input Devices",
	"Serial-Link",
	"",
	"Ignore Changes and Quit",
	"Save Changes and Quit",

	"320*200 - Chained-VGA mode (VGA compatible)",
	"320*200 - Screen-Buffer mode (VGA compatible)",
	"320*200 - Specially-optimized TSENG ET4000 mode",
	"320*200 - Specially-optimized Paradise WD90Cxx mode",
	"320*200 - Specially-optimized S3 chipset mode",

	"No digitized sound",
	"",
	"Sound Blaster (Port 220 hex) DEFAULT",
	"Sound Blaster (Port 230 hex)",
	"Sound Blaster (Port 240 hex)",
	"Sound Blaster (Port 250 hex)",
	"Sound Blaster (Port 260 hex)",

	"No music",
	"Adlib (Sound Blaster) music",

	"Keyboard only",
	"Keyboard & Mouse",

	"Off",
	"",
	"COM1",
	"COM2",
	"COM3",
	"COM4",

	"2400 bps",
	"4800 bps",
	"9600 bps",
	"14400 bps",
	"19200 bps",
	"28800 bps",
};

char option[NUMOPTIONS];

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux printchrasm =\
	"rep stosw",\
	parm [edi][ecx][eax]\

#pragma aux savescreen =\
	"mov esi, 0xb8000",\
	"mov edi, offset screeninfo",\
	"mov ecx, 1000",\
	"rep movsd",\
	modify [ecx esi edi]\

#pragma aux restorescreen =\
	"mov esi, offset screeninfo",\
	"mov edi, 0xb8000",\
	"mov ecx, 1000",\
	"rep movsd",\
	modify [ecx esi edi]\

main()
{
	short i, j;
	char ch, col;

	loadsetup();
	drawscreen();
	savescreen();
	i = 0;
	do
	{
		restorescreen();
		printstr(35,7,"Main Menu",32);
		i = menu(0,8,i);
		restorescreen();
		if (i == 0)
		{
			printstr(29,8,"Graphics Mode Selection",32);
			if ((j = menu(8,5,option[0])) >= 0)
				option[0] = j;
		}
		if (i == 1)
		{
			printstr(29,7,"Digitized Sound Selection",32);
			if ((j = menu(13,7,option[1])) >= 0)
				option[1] = j;
		}
		if (i == 2)
		{
			printstr(29,9,"Music Selection",32);
			if ((j = menu(20,2,option[2])) >= 0)
				option[2] = j;
		}
		if (i == 3)
		{
			printstr(29,9,"Input Device Selection",32);
			if ((j = menu(22,2,option[3])) >= 0)
				option[3] = j;
		}
		if (i == 4)
		{
			printstr(29,7,"Serial-Link Selection",32);
			if ((j = menu(24,6,option[4])) >= 0)
			{
				option[4] = j;

				printstr(29,7,"   COM Speed Selection   ",32);
				if ((j = menu(30,6,option[5])) >= 0)
					option[5] = j;
			}
		}
		if (i == 6)
			savesetup();
	}
	while ((i >= 0) && (i <= 4));
	setvmode(0x3);
}

loadsetup()
{
	short fil, i, j;

	if ((fil = open("tables.dat",O_BINARY|O_RDONLY,S_IREAD)) == -1)
	{
		printf("Cannot load options");
		exit(0);
	}
	lseek(fil,4096L+4096L+640L+1024L,SEEK_SET);
	read(fil,&option[0],NUMOPTIONS);
	close(fil);
}

savesetup()
{
	short fil, i, j;

	if ((fil = open("tables.dat",O_BINARY|O_WRONLY,S_IWRITE)) == -1)
	{
		printf("Cannot save options");
		exit(0);
	}
	lseek(fil,4096L+4096L+640L+1024L,SEEK_SET);
	write(fil,&option[0],NUMOPTIONS);
	close(fil);
}

printchr(short x, short y, char character, char attribute, short len)
{
	short pos;

	pos = (y*80+x)<<1;
	printchrasm(0xb8000+(long)pos,(long)len,((long)attribute<<8)+(long)character);
}

printstr(short x, short y, char string[81], char attribute)
{
	char character;
	short i, pos;

	pos = (y*80+x)<<1;
	i = 0;
	while (string[i] != 0)
	{
		character = string[i];
		printchrasm(0xb8000+(long)pos,1L,((long)attribute<<8)+(long)character);
		i++;
		pos+=2;
	}
}

drawscreen()
{
	short i;

	setvmode(0x3);
	outp(0x3d4,0x0e); outp(0x3d5,255);
	printchr(0,0,218,78,1);
	printchr(1,0,196,78,78);
	printchr(79,0,191,78,1);
	for(i=1;i<24;i++)
	{
		printchr(0,i,179,78,1);
		printchr(1,i,32,78,78);
		printchr(79,i,179,78,1);
	}
	printchr(0,24,192,78,1);
	printchr(1,24,196,78,78);
	printchr(79,24,217,78,1);
	printstr(31,1,"BUILD Setup Screen",79);
	printstr(29,21,"ARROWS to move cursor.",71);
	printstr(32,22,"ENTER to select.",71);
	printstr(33,23,"ESC to cancel.",71);
}

menu(short firstring, short numstrings, short selection)
{
	char ch, col, buffer[80];
	short i, j, k, xdim, ydim, x1, y1;

	xdim = 0;
	for(i=firstring;i<firstring+numstrings;i++)
	{
		k = strlen(&strtable[i][0]);
		if (k > xdim)
			xdim = strlen(&strtable[i][0]);
	}
	xdim += 4;
	ydim = numstrings+2;
	x1 = 39-(xdim>>1);
	y1 = 12-(ydim>>1);
	buffer[0] = 218;
	for(i=1;i<xdim-1;i++)
		buffer[i] = 196;
	buffer[xdim-1] = 191;
	buffer[xdim] = 0;
	printstr(x1,y1,buffer,19);
	for(i=y1+1;i<y1+ydim-1;i++)
	{
		if (strtable[firstring+i-(y1+1)][0] == 196)
		{
			buffer[0] = 195;
			for(j=1;j<xdim-1;j++)
				buffer[j] = 196;
			buffer[xdim-1] = 180;
			buffer[xdim] = 0;
			printstr(x1,i,buffer,19);
			if (selection >= i-(y1+1))
				selection++;
		}
		else
		{
			buffer[0] = 179;
			for(j=1;j<xdim-1;j++)
				buffer[j] = 32;
			buffer[xdim-1] = 179;
			buffer[xdim] = 0;
			printstr(x1,i,buffer,19);
		}
	}
	buffer[0] = 192;
	for(i=1;i<xdim-1;i++)
		buffer[i] = 196;
	buffer[xdim-1] = 217;
	buffer[xdim] = 0;
	printstr(x1,y1+ydim-1,buffer,19);
	ch = 0;
	while ((ch != 13) && (ch != 27))
	{
		for(i=firstring;i<firstring+numstrings;i++)
		{
			if (i == selection+firstring)
				col = 75;
			else
				col = 19;
			if (strtable[i][0] != 196)
				printstr(x1+2,y1+1+i-firstring,&strtable[i][0],col);

		}
		ch = getch();
		if (ch == 0)
		{
			ch = getch();
			if ((ch == 72) || (ch == 75))
			{
				do
				{
					selection--;
					if (selection < 0)
						selection = numstrings-1;
				}
				while (strtable[firstring+selection][0] == 196);
			}
			if ((ch == 80) || (ch == 77))
			{
				do
				{
					selection++;
					if (selection >= numstrings)
						selection = 0;
				}
				while (strtable[firstring+selection][0] == 196);
			}
			ch = 0;
		}
	}
	for(i=ydim-1;i>=0;i--)
		if (strtable[firstring+i][0] == 196)
			if (selection >= i)
				selection--;
	if (ch == 27)
		return(-1-selection);
	else
		return(selection);
}
