DECLARE FUNCTION insertsprite% (sectnum%, statnum%)
DECLARE FUNCTION changespritestat% (spritenum%, newstatnum%)
DECLARE SUB showsprites ()
DECLARE SUB initspritelists ()
DECLARE FUNCTION insertspritestat% (statnum%)
DECLARE FUNCTION deletespritestat% (deleteme%)
DECLARE FUNCTION insertspritesect% (sectnum%)
DECLARE FUNCTION deletespritesect% (deleteme%)
DECLARE FUNCTION deletesprite% (spritenum%)
DECLARE FUNCTION changespritesect% (spritenum%, newsectnum%)
CONST MAXSTATUS = 2
CONST MAXSECTORS = 3
CONST MAXSPRITES = 20

COMMON SHARED pag%

DIM SHARED spritesect%(MAXSPRITES)
DIM SHARED headspritesect%(MAXSECTORS)
DIM SHARED prevspritesect%(MAXSPRITES)
DIM SHARED nextspritesect%(MAXSPRITES)

DIM SHARED spritestat%(MAXSPRITES)
DIM SHARED headspritestat%(MAXSTATUS)
DIM SHARED prevspritestat%(MAXSPRITES)
DIM SHARED nextspritestat%(MAXSPRITES)

CALL initspritelists
pag% = 0: SCREEN 0, , pag%, pag%
DO
   CALL showsprites
   DO
      valid% = 0
      SELECT CASE INT(3 * RND)
         CASE 0:
            sectnum% = INT(MAXSECTORS * RND)
            statnum% = INT(MAXSTATUS * RND)
            zx% = insertsprite%(sectnum%, statnum%)
            IF zx% >= 0 THEN
               LOCATE 25, 1: PRINT "Insert at status"; statnum%; "and sector"; sectnum%;
               valid% = 1
            END IF
         CASE 1:
            spritenum% = INT(MAXSPRITES * RND)
            zx% = deletesprite%(spritenum%)
            IF zx% >= 0 THEN
               LOCATE 25, 1: PRINT "Delete sprite"; spritenum%;
               valid% = 1
            END IF
         CASE 2:
            spritenum% = INT(MAXSPRITES * RND)
            newstatnum% = INT(MAXSTATUS * RND)
            zx% = changespritestat%(spritenum%, newstatnum%)
            IF zx% >= 0 THEN
               LOCATE 25, 1: PRINT "Change sprite"; spritenum%; "to status"; newstatnum%;
               valid% = 1
            END IF
         CASE 3:
            spritenum% = INT(MAXSPRITES * RND)
            newsectnum% = INT(MAXSECTORS * RND)
            zx% = changespritestat%(spritenum%, newsectnum%)
            IF zx% >= 0 THEN
               LOCATE 25, 1: PRINT "Change sprite"; spritenum%; "to sector"; newsectnum%;
               valid% = 1
            END IF
      END SELECT
   LOOP WHILE valid% = 0

   pag% = 1 - pag%: SCREEN 0, , pag%, 1 - pag%
   DO: LOOP WHILE INKEY$ = ""
LOOP WHILE z$ <> CHR$(27)

FUNCTION changespritesect% (spritenum%, newsectnum%)
   IF spritesect%(spritenum%) = newsectnum% OR spritesect%(spritenum%) = MAXSECTORS THEN
      changespritesect% = -1
      EXIT FUNCTION
   END IF
   zx% = deletespritesect%(spritenum%)
   IF zx% >= 0 THEN
      zx% = insertspritesect%(newsectnum%)
      changespritesect% = 0
   ELSE
      changespritesect% = -1
   END IF
END FUNCTION

FUNCTION changespritestat% (spritenum%, newstatnum%)
   IF spritestat%(spritenum%) = newstatnum% OR spritestat%(spritenum%) = MAXSTATUS THEN
      changespritestat% = -1
      EXIT FUNCTION
   END IF
   zx% = deletespritestat%(spritenum%)
   IF zx% >= 0 THEN
      zx% = insertspritestat%(newstatnum%)
      changespritestat% = 0
   ELSE
      changespritestat% = -1
   END IF
END FUNCTION

FUNCTION deletesprite% (spritenum%)
   spritenum1% = deletespritestat(spritenum%)
   spritenum2% = deletespritesect(spritenum%)
   IF spritenum1% <> spritenum2% THEN SOUND 131, 1
   deletesprite% = spritenum1%
END FUNCTION

FUNCTION deletespritesect% (deleteme%)
   IF spritesect%(deleteme%) = MAXSECTORS THEN
      deletespritesect% = -1
      EXIT FUNCTION
   END IF

   IF headspritesect%(spritesect%(deleteme%)) = deleteme% THEN headspritesect%(spritesect%(deleteme%)) = nextspritesect%(deleteme%)

   IF prevspritesect%(deleteme%) >= 0 THEN nextspritesect%(prevspritesect%(deleteme%)) = nextspritesect%(deleteme%)
   IF nextspritesect%(deleteme%) >= 0 THEN prevspritesect%(nextspritesect%(deleteme%)) = prevspritesect%(deleteme%)

   IF headspritesect%(MAXSECTORS) >= 0 THEN prevspritesect%(headspritesect%(MAXSECTORS)) = deleteme%
   prevspritesect%(deleteme%) = -1
   nextspritesect%(deleteme%) = headspritesect%(MAXSECTORS)
   headspritesect%(MAXSECTORS) = deleteme%

   spritesect%(deleteme%) = MAXSECTORS
   deletespritesect% = 0
END FUNCTION

FUNCTION deletespritestat% (deleteme%)
   IF spritestat%(deleteme%) = MAXSTATUS THEN
      deletespritestat% = -1
      EXIT FUNCTION
   END IF
  
   IF headspritestat%(spritestat%(deleteme%)) = deleteme% THEN headspritestat%(spritestat%(deleteme%)) = nextspritestat%(deleteme%)

   IF prevspritestat%(deleteme%) >= 0 THEN nextspritestat%(prevspritestat%(deleteme%)) = nextspritestat%(deleteme%)
   IF nextspritestat%(deleteme%) >= 0 THEN prevspritestat%(nextspritestat%(deleteme%)) = prevspritestat%(deleteme%)
  
   IF headspritestat%(MAXSTATUS) >= 0 THEN prevspritestat%(headspritestat%(MAXSTATUS)) = deleteme%
   prevspritestat%(deleteme%) = -1
   nextspritestat%(deleteme%) = headspritestat%(MAXSTATUS)
   headspritestat%(MAXSTATUS) = deleteme%
  
   spritestat%(deleteme%) = MAXSTATUS
   deletespritestat% = 0
END FUNCTION

SUB initspritelists
   FOR z% = 0 TO MAXSECTORS - 1     'Init doubly-linked sprite sector lists
      headspritesect%(z%) = -1
   NEXT z%
   headspritesect%(MAXSECTORS) = 0
   FOR z% = 0 TO MAXSPRITES - 1
      prevspritesect%(z%) = z% - 1
      nextspritesect%(z%) = z% + 1
      spritesect%(z%) = MAXSECTORS
   NEXT z%
   prevspritesect%(0) = -1
   nextspritesect%(MAXSPRITES - 1) = -1

  
   FOR z% = 0 TO MAXSTATUS - 1      'Init doubly-linked sprite status lists
      headspritestat%(z%) = -1
   NEXT z%
   headspritestat%(MAXSTATUS) = 0
   FOR z% = 0 TO MAXSPRITES - 1
      prevspritestat%(z%) = z% - 1
      nextspritestat%(z%) = z% + 1
      spritestat%(z%) = MAXSTATUS
   NEXT z%
   prevspritestat%(0) = -1
   nextspritestat%(MAXSPRITES - 1) = -1
END SUB

FUNCTION insertsprite% (sectnum%, statnum%)
   spritenum1% = insertspritesect%(sectnum%)
   spritenum2% = insertspritestat%(statnum%)
   IF spritenum1% <> spritenum2% THEN SOUND 131, 1
   insertsprite% = spritenum1%
END FUNCTION

FUNCTION insertspritesect% (sectnum%)
   IF sectnum% >= MAXSECTORS OR headspritesect%(MAXSECTORS) = -1 THEN
      insertspritesect% = -1: EXIT FUNCTION   'list full
   END IF
 
   blanktouse% = headspritesect%(MAXSECTORS)
 
   headspritesect%(MAXSECTORS) = nextspritesect%(blanktouse%)
   IF headspritesect%(MAXSECTORS) >= 0 THEN prevspritesect%(headspritesect%(MAXSECTORS)) = -1
 
   prevspritesect%(blanktouse%) = -1
   nextspritesect%(blanktouse%) = headspritesect%(sectnum%)
   IF headspritesect%(sectnum%) >= 0 THEN prevspritesect%(headspritesect%(sectnum%)) = blanktouse%
   headspritesect%(sectnum%) = blanktouse%
 
   spritesect%(blanktouse%) = sectnum%
 
   insertspritesect% = blanktouse%
END FUNCTION

FUNCTION insertspritestat% (statnum%)
   IF statnum% >= MAXSTATUS OR headspritestat%(MAXSTATUS) = -1 THEN
      insertspritestat% = -1: EXIT FUNCTION   'list full
   END IF
  
   blanktouse% = headspritestat%(MAXSTATUS)
  
   headspritestat%(MAXSTATUS) = nextspritestat%(blanktouse%)
   IF headspritestat%(MAXSTATUS) >= 0 THEN prevspritestat%(headspritestat%(MAXSTATUS)) = -1
  
   prevspritestat%(blanktouse%) = -1
   nextspritestat%(blanktouse%) = headspritestat%(statnum%)
   IF headspritestat%(statnum%) >= 0 THEN prevspritestat%(headspritestat%(statnum%)) = blanktouse%
   headspritestat%(statnum%) = blanktouse%
  
   spritestat%(blanktouse%) = statnum%
  
   insertspritestat% = blanktouse%
END FUNCTION

SUB showsprites
   CLS
   LOCATE 1, 1: PRINT "Statblank   Status0     Status1     SectorBlank Sector0     Sector1     Sector2";
   FOR x% = 1 TO 73 STEP 12
      y% = 2
      IF x% = 1 THEN z% = headspritestat%(MAXSTATUS)
      IF x% = 13 THEN z% = headspritestat%(0)
      IF x% = 25 THEN z% = headspritestat%(1)
      IF x% = 37 THEN z% = headspritesect%(MAXSECTORS)
      IF x% = 49 THEN z% = headspritesect%(0)
      IF x% = 61 THEN z% = headspritesect%(1)
      IF x% = 73 THEN z% = headspritesect%(2)
      IF x% <= 25 THEN
         WHILE z% <> -1
            LOCATE y%, x%: PRINT z%;
            y% = y% + 1
            z% = nextspritestat%(z%)
         WEND
      ELSE
         WHILE z% <> -1
            LOCATE y%, x%: PRINT z%;
            y% = y% + 1
            z% = nextspritesect%(z%)
         WEND
      END IF
   NEXT x%
END SUB

