// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <dos.h>
#include <conio.h>

#define COMBUFSIZ 32768
#define MAXWINDOWS 2

static short numwindows;
static short windowx1[MAXWINDOWS], windowy1[MAXWINDOWS];
static short windowx2[MAXWINDOWS], windowy2[MAXWINDOWS];
static short windowxplc[MAXWINDOWS], windowyplc[MAXWINDOWS];

static char syncbuffer[1024], synccnt, synclen;
volatile long comnum, comport, comvect, comspeed;
volatile char inbuf[COMBUFSIZ], outbuf[COMBUFSIZ], mstat, lstat;
volatile long inbufplc, inbufend, outbufplc, outbufend, globali, globalj;

void (__interrupt __far *oldcomhandler)();
void __interrupt __far comhandler(void);

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux getchrasm =\
	"xor eax, eax",\
	"mov ax, word ptr [edi]",\
	parm [edi]\

#pragma aux printchrasm =\
	"rep stosw",\
	parm [edi][ecx][eax]\

#pragma aux getlong =\
	"mov eax, dword ptr [eax]",\
	parm [eax]\

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\
	modify [eax]\

#pragma aux removecursor =\
	"mov dx, 0x3d4",\
	"mov al, 0xa",\
	"out dx, al",\
	"inc dx",\
	"in al, dx",\
	"or al, 32",\
	"out dx, al",\

main(int argc, char **argv)
{
	char ch;
	short dat;
	long i, j;

	comnum = 1;
	comspeed = 19200;
	if (argc == 1)
	{
		printf("Term [comnum(1)][comspeed(19200)]                     by Kenneth Silverman\n");
		printf("Example:  C:\\>term 2 19200\n");
		exit(0);
	}
	if ((argc == 2) || (argc == 3))
	{
		comnum = atoi(argv[1]);
		if (argc == 3)
			comspeed = atoi(argv[2]);
	}

	if (comon() == -1)
	{
		printf("COM%d not found.\n",comnum);
		exit(0);
	}

	setvmode(0x3);
	removecursor();
	numwindows = 2;
	windowx1[0] = 0, windowy1[0] = 0, windowx2[0] = 79, windowy2[0] = 11;
	windowxplc[0] = 0; windowyplc[0] = 0;
	windowx1[1] = 0, windowy1[1] = 12, windowx2[1] = 79, windowy2[1] = 23;
	windowxplc[1] = 0; windowyplc[1] = 0;
	setupwindows();

	ch = 0;
	while (ch != 27)
	{
		while (kbhit() != 0)
		{
			ch = getch();
			windowprintchar(0,ch);
			if (ch != 27)
				comsend((long)ch,1L);
		}
		while ((dat = comgetchar()) >= 0)
		{
			windowprintchar(1,(char)dat);
		}
	}
	setvmode(0x3);
	printf("Hangup?\n");
	ch = 0;
	while ((ch != 'Y') && (ch != 'y') && (ch != 'N') && (ch != 'n'))
		ch = getch();
	if ((ch == 'Y') || (ch == 'y'))
		comoff(1);
	else
		comoff(0);
}

comon()
{
	long divisor;
	short *ptr;

	inbufplc = 0;
	inbufend = 0;
	outbufplc = 0;
	outbufend = 0;

	if ((comnum < 1) || (comnum > 4)) return(-1);
	comvect = 0xb+(comnum&1);
	ptr = (short *)(0x400L+(long)((comnum-1)<<1));
	comport = (long)(*ptr);
	if (comport == 0) return(-1);
	if ((comspeed <= 0) || (comspeed > 115200)) return(-1);

	  // Baud-Setting,?,?,Parity O/E,Parity Off/On, Stop-1/2,Bits-5/6/7/8
	  // 0x0b is odd parity,1 stop bit, 8 bits

	_disable();

	outp(comport+3,0x80);                  //enable latch registers
	divisor = 115200 / comspeed;
	outp(comport+0,divisor&255);           //# = 115200 / bps
	outp(comport+1,divisor>>8);
	outp(comport+3,0x03);                  //0x03 = n,8,1

	oldcomhandler = _dos_getvect(comvect);
	_dos_setvect(comvect, comhandler);

	outp(comport+4,0x0b);             //setup for interrupts (modem control)
	outp(comport+1,0);                //com interrupt disable
	outp(0x21,inp(0x21)&(255-(1<<(comvect&7))));          //Unmask vector
	mstat = inp(comport+6);
	lstat = inp(comport+5);
	inp(comport+0);
	inp(comport+2);
	outp(comport+1,0x03);             //com interrupt enable
	outp(0x20,0x20);

	_enable();

	return(0);
}

comoff(short hangup)
{
	while ((outbufplc != outbufend) && (kbhit() == 0));

	_disable();
	outp(0x21,inp(0x21)|(1<<(comvect&7)));          //Mask vector
	if (hangup == 1)
	{
		outp(comport+1,0);
		outp(comport+4,0);
	}
	_dos_setvect(comvect, oldcomhandler);
	_enable();
}

comsend(long dat, long numbytes)
{
	long i;

	_disable();
	i = 0;
	while (numbytes > 0)
	{
		outbuf[outbufend] = (char)((dat>>i)&255);
		outbufend = ((outbufend+1)&(COMBUFSIZ-1));

		numbytes--;
		i += 8;
	}
	if ((inp(comport+5)&0x20) > 0)
	{
		if (outbufplc != outbufend)
		{
			outp(comport,outbuf[outbufplc]);
			outbufplc = ((outbufplc+1)&(COMBUFSIZ-1));
		}
	}
	_enable();
	return(0);
}

comgetchar()
{
	short i;

	i = -1;
	if (inbufplc != inbufend)
	{
		i = (short)inbuf[inbufplc];
		inbufplc = ((inbufplc+1)&(COMBUFSIZ-1));
	}
	return(i);
}

void __interrupt __far comhandler(void)
{
	while (1)
	{
		 switch(inp(comport+2)&7)
		 {
			 case 0:
				 mstat = inp(comport+6);
				 break;
			 case 2:
				 if (outbufplc != outbufend)
				 {
					 outp(comport,outbuf[outbufplc]);
					 outbufplc = ((outbufplc+1)&(COMBUFSIZ-1));
				 }
				 break;
			 case 4:
				 inbuf[inbufend] = inp(comport);
				 inbufend = ((inbufend+1)&(COMBUFSIZ-1));
				 break;
			 case 6:
				 lstat = inp(comport+5);
				 break;
			 default:
				 outp(0x20, 0x20);
				 return;
		}
		globali = inp(comport+2);
	}
}

readchr(short x, short y)
{
	return (getchrasm(0xb8000+(long)((y*80+x)<<1)));
}

printchr(short x, short y, char character, char attribute, short len)
{
	short pos;

	pos = (y*80+x)<<1;
	printchrasm(0xb8000+(long)pos,(long)len,((long)attribute<<8)+(long)character);
}

setupwindows()
{
	long i, x, y;

	for(i=0;i<numwindows;i++)
	{
		for(y=windowy1[i];y<=windowy2[i];y++)
		{
			if (y == windowy1[i])
			{
				printchr(windowx1[i],y,'',4,1);
				printchr(windowx1[i]+1,y,'',4,windowx2[i]-windowx1[i]-1);
				printchr(windowx2[i],y,'',4,1);
			}
			else if (y == windowy2[i])
			{
				printchr(windowx1[i],y,'',4,1);
				printchr(windowx1[i]+1,y,'',4,windowx2[i]-windowx1[i]-1);
				printchr(windowx2[i],y,'',4,1);
			}
			else
			{
				printchr(windowx1[i],y,'',4,1);
				printchr(windowx1[i]+1,y,' ',4,windowx2[i]-windowx1[i]-1);
				printchr(windowx2[i],y,'',4,1);
			}
		}
		printchr(windowx1[i]+1,windowy1[i]+1,'_',4,1);
	}
}

windowprintchar(short windownum, char thechar)
{
	short dat;
	long dax, day, i, j;

	dax = windowx1[windownum]+windowxplc[windownum]+1;
	day = windowy1[windownum]+windowyplc[windownum]+1;
	printchr(dax,day,' ',4,1);
	if (thechar >= 32)
	{
		printchr(dax,day,thechar,4,1);
		windowxplc[windownum]++;
		if (windowxplc[windownum] >= windowx2[windownum]-windowx1[windownum]-1)
		{
			windowxplc[windownum] = 0;
			windowyplc[windownum]++;
			if (windowyplc[windownum] >= windowy2[windownum]-windowy1[windownum]-1)
			{
				for(j=windowy1[windownum]+1;j<windowy2[windownum]-1;j++)
					for(i=windowx1[windownum]+1;i<windowx2[windownum];i++)
					{
						dat = readchr(i,j+1);
						printchr(i,j,dat,4,1);
					}
				printchr(windowx1[windownum]+1,windowy2[windownum]-1,' ',4,windowx2[windownum]-windowx1[windownum]-1);
				windowyplc[windownum]--;
			}
		}
	}
	else if (thechar == 8)
	{
		if (windowxplc[windownum] > 0)
			windowxplc[windownum]--;
	}
	else if (thechar == 12)
	{
		windowxplc[windownum] = 0;
		windowyplc[windownum] = 0;
		for(j=windowy1[windownum]+1;j<windowy2[windownum];j++)
			printchr(windowx1[windownum]+1,j,' ',4,windowx2[windownum]-windowx1[windownum]-1);
	}
	else if (thechar == 13)
	{
		windowxplc[windownum] = 0;
		windowyplc[windownum]++;
		if (windowyplc[windownum] >= windowy2[windownum]-windowy1[windownum]-1)
		{
			for(j=windowy1[windownum]+1;j<windowy2[windownum]-1;j++)
				for(i=windowx1[windownum]+1;i<windowx2[windownum];i++)
				{
					dat = readchr(i,j+1);
					printchr(i,j,dat,4,1);
				}
			printchr(windowx1[windownum]+1,windowy2[windownum]-1,' ',4,windowx2[windownum]-windowx1[windownum]-1);
			windowyplc[windownum]--;
		}
	}

	dax = windowx1[windownum]+windowxplc[windownum]+1;
	day = windowy1[windownum]+windowyplc[windownum]+1;
	printchr(dax,day,'_',4,1);
}
