// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <string.h>
#include <stdlib.h>
#include "spw_int.h"
#include "build.h"
#include "names.h"

/***************************************************************************
	KEN'S TAG DEFINITIONS:      (Please define your own tags for your games)

 sector[?].tag = 0    Normal sector
 sector[?].tag = 1    Being in sector with tag 1 opens all door sectors
								 with tag 2 and turns all sprites in sectors with
								 tag 3 to active brown monsters. (Walk in the
								 middle of the animated floor tiles in the
								 beginning of DOOM1.DAT)
 sector[?].tag = 2    A sector that will be opened as soon as you first
								 stand in a sector with tag 1.
 sector[?].tag = 3    A sector where all the sprites will be converted to
								 brown monsters as soon as you first step into a
								 sector with tag 3.
 sector[?].tag = 4    A sector where you are put closer to the floor
								 (such as the slime in DOOM1.DAT)
 sector[?].tag = 5    A really stupid sector that really does nothing now.
 sector[?].tag = 6    A normal door - instead of pressing D, you tag the
								 sector with a 6.  The reason I make you edit doors
								 this way is so that can program the doors
								 yourself.
 sector[?].tag = 7    A door the goes down to open.
 sector[?].tag = 8    A door that opens horizontally in the middle.
 sector[?].tag = 9    A sliding door that opens vertically in the middle.
								 -Example of the advantages of not using BSP tree.
 sector[?].tag = 10   A warping sector with floor and walls that shade.
 sector[?].tag = 11   A sector with all walls that do X-panning.
 sector[?].tag = 12   A sector with walls using the dragging function.
 sector[?].tag = 13   A sector with some swinging doors in it.
 sector[?].tag = 14   A revolving door sector.
 sector[?].tag = 15   A subway track.
 sector[?].tag = 16   A true double-sliding door.
 sector[?].tag = 17   A true double-sliding door for subways only.

	wall[?].tag = 0    Normal wall
	wall[?].tag = 1    Y-panning wall
	wall[?].tag = 2    Switch
	wall[?].tag = 3    Marked wall to detemine starting dir. (sector tag 12)
	wall[?].tag = 4    Mark on the shorter wall closest to the pivot point
								 of a swinging door. (sector tag 13)
	wall[?].tag = 5    Mark where a subway should stop. (sector tag 15)
	wall[?].tag = 6    Mark for true double-sliding doors (sector tag 16)

 sprite[?].tag = 0    Normal sprite
 sprite[?].tag = 1    If you press space bar on an AL, and the AL is tagged
								 with a 1, he will turn evil.


KEN'S STATUS DEFINITIONS:  (Please define your own statuses for your games)
 status = 0            Inactive sprite
 status = 1            Active monster sprite
 status = 2            Monster that becomes active only when it sees you
 status = 3            Smoke on the wall for chainguns
 status = 4            Splashing sprites (When you shoot slime)
 status = 5            Explosion!
 status = 6            Travelling bullet
 status = MAXSTATUS    Non-existent sprite (this will be true for your
														  code also)
**************************************************************************/

	//individual player variables
static long posx[MAXPLAYERS], posy[MAXPLAYERS], posz[MAXPLAYERS];
static long horiz[MAXPLAYERS], hvel[MAXPLAYERS];
static short ang[MAXPLAYERS], cursectnum[MAXPLAYERS];
static short playersprite[MAXPLAYERS], deaths[MAXPLAYERS];
static long lastchaingun[MAXPLAYERS], selectedgun[MAXPLAYERS+1];
static long health[MAXPLAYERS], score[MAXPLAYERS];
static long dimensionmode[MAXPLAYERS], zoom[MAXPLAYERS];

static short oldmousebstatus = 0;
static char tempbuf[576], boardfilename[80];
static long lockclock;

extern long comerror;
static short masterconnectnum, screenpeek = 0, myconnectindex = 0;
extern short numplayers, myconnectnum;
extern short connectindex[MAXCONNECTIONS];
extern short connecthead, connectnum[MAXPLAYERS], connectpoint2[MAXPLAYERS];

static short neartagsector, neartagwall, neartagsprite;
static long neartagdist, neartaghitdist;
extern void __interrupt __far ksmhandler(void);

	//Board animation variables
static short warpsectorlist[16], warpsectorcnt, warpsectorflag[MAXPLAYERS];
static short xpanningsectorlist[16], xpanningsectorcnt;
static short ypanningwalllist[64], ypanningwallcnt;
static short floorpanninglist[16], floorpanningcnt;
static short dragsectorlist[16], dragxdir[16], dragydir[16], dragsectorcnt;
static long dragx1[16], dragy1[16], dragx2[16], dragy2[16], dragfloorz[16];
static short swingcnt, swingwall[16][4], swingsector[16];
static short swingangopen[16], swingangclosed[16], swingangopendir[16];
static short swingang[16], swinganginc[16];
static long swingx[16][4], swingy[16][4];
static short revolvesector[4], revolveang[4], revolvecnt;
static long revolvex[4][12], revolvey[4][12];
static long revolvepivotx[4], revolvepivoty[4];
static short subwaytracksector[4][128], subwaynumsectors[4], subwaytrackcnt;
static long subwaystop[4][8], subwaystopcnt[4];
static long subwaytrackx1[4], subwaytracky1[4];
static long subwaytrackx2[4], subwaytracky2[4];
static long subwayx[4], subwaygoalstop[4], subwayvel[4], subwaypausetime[4];

static long reccnt;               //Can only record 1-player game
static short recsyncvel[16384];
static short recsyncsvel[16384];
static short recsyncangvel[16384];
static short recsyncbits[16384];
static short recsynctics[16384];

static short syncvel[MAXPLAYERS+1];
static short syncsvel[MAXPLAYERS+1];
static short syncangvel[MAXPLAYERS+1];
static short syncbits[MAXPLAYERS+1];
static short synctics;

	//Here are some nice in-line assembly pragmas that make life easier.
	//(at least for Ken)
#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux getshort =\
	"mov ax, word ptr [eax]",\
	parm [eax]\

#pragma aux putshort =\
	"mov word ptr [ebx], ax",\
	parm [ebx][eax]\

main(short int argc,char **argv)
{
	short waitplayers;
	long i, j, k;

	if (argc >= 2)
	{
		strcpy(&boardfilename,argv[1]);
		if(strchr(boardfilename,'.') == 0)
			strcat(boardfilename,".map");
	}
	else
		strcpy(&boardfilename,"nukeland.map");

	initengine();
	initsb(165);                                   //Init digitized sound
	if (option[2] == 1)                            //Init music
	{
		loadmusic("eviltune.ksm");
		musicon(); kenchaintimer(ksmhandler,120);
	}

	loadpics("tiles000.art");                      //Load artwork
	prepareboard(boardfilename);                   //Load board

	if (option[4] > 0)
	{
		printext256(68L,92L,31,0,"Waiting for other player...");
		tempbuf[0] = 0;
		sendpacket(-1,tempbuf,1);

		waitplayers = 2;

		if ((option[4] >= 1) && (option[4] <= 4))
			waitplayers = 2;

		while (numplayers < waitplayers)
		{
			getpackets();
			if (keystatus[1] > 0)
			{
				if (numplayers > 1)            //Signing off
				{
					tempbuf[0] = 255;
					sendpacket(-1,tempbuf,1);
				}
				if (option[2] == 1)
				{
					kenchaintimer(0,0); musicoff();
				}
				uninitengine();
				uninitsb();
				setvmode(0x3);        //Set back to text mode
				exit(0);
			}
		}
		screenpeek = myconnectindex;
	}

	initplayersprites();

	totalclock = 0;
	reccnt = 0;

		//This is the whole game loop!
	while ((keystatus[1] == 0) && (sector[cursectnum[myconnectindex]].tag != 65535))
	{
		if (numplayers <= 1)
		{
			drawscreen(0);
			getinput(0);
			movethings();
		}
		else
		{
			drawscreen(screenpeek);
			sync();
		}
	}

	for(i=0;i<65536;i++)
		i += 0;

	if (numplayers > 1)            //Signing off
	{
		tempbuf[0] = 255;
		sendpacket(-1,tempbuf,1);
	}

	if (option[2] == 1)
	{
		kenchaintimer(0,0); musicoff();
	}
	uninitengine();
	uninitsb();
	setvmode(0x3);        //Set back to text mode
	showengineinfo();     //Show speed statistics
	return(0);
}

operatesector(short dasector)
{     //Door code
	short startwall, endwall, wallfind[2];
	long i, j, k, s, nexti, good, cnt;
	long dax, day, daz, dax2, day2, daz2, centx, centy;
	
	startwall = sector[dasector].wallptr;
	endwall = startwall + sector[dasector].wallnum - 1;
	centx = 0L, centy = 0L;
	for(i=startwall;i<=endwall;i++)
	{
		centx += wall[i].x;
		centy += wall[i].y;
	}
	centx /= (endwall-startwall+1);
	centy /= (endwall-startwall+1);

		//Simple door that moves up  (tag 8 is a combination of tags 6 & 7)
	if ((sector[dasector].tag == 6) || (sector[dasector].tag == 8))    //If the sector in front is a door
	{
		i = getanimationgoal(&sector[dasector].ceilingz);
		if (i >= 0)      //If door already moving, reverse its direction
		{
			if (sector[dasector].tag == 8)
				daz = ((sector[dasector].ceilingz+sector[dasector].floorz)>>1);
			else
				daz = sector[dasector].floorz;

			if (animategoal[i] == daz)
				animategoal[i] = sector[nextsectorneighborz(dasector,sector[dasector].floorz,-1,-1)].ceilingz;
			else
				animategoal[i] = daz;
		}
		else      //else insert the door's ceiling on the animation list
		{
			if (sector[dasector].ceilingz == sector[dasector].floorz)
				daz = sector[nextsectorneighborz(dasector,sector[dasector].floorz,-1,-1)].ceilingz;
			else
			{
				if (sector[dasector].tag == 8)
					daz = ((sector[dasector].ceilingz+sector[dasector].floorz)>>1);
				else
					daz = sector[dasector].floorz;
			}
			if ((j = setanimation(&sector[dasector].ceilingz,daz,128)) >= 0)
			{
				wsay("updowndr.wav",sndvol(centx,centy));
			}
		}
	}
		//Simple door that moves down
	if ((sector[dasector].tag == 7) || (sector[dasector].tag == 8)) //If the sector in front's elevator
	{
		i = getanimationgoal(&sector[dasector].floorz);
		if (i >= 0)      //If elevator already moving, reverse its direction
		{
			if (sector[dasector].tag == 8)
				daz = ((sector[dasector].ceilingz+sector[dasector].floorz)>>1);
			else
				daz = sector[dasector].ceilingz;

			if (animategoal[i] == daz)
				animategoal[i] = sector[nextsectorneighborz(dasector,sector[dasector].ceilingz,1,1)].floorz;
			else
				animategoal[i] = daz;

		}
		else      //else insert the elevator's ceiling on the animation list
		{
			if (sector[dasector].floorz == sector[dasector].ceilingz)
				daz = sector[nextsectorneighborz(dasector,sector[dasector].ceilingz,1,1)].floorz;
			else
			{
				if (sector[dasector].tag == 8)
					daz = ((sector[dasector].ceilingz+sector[dasector].floorz)>>1);
				else
					daz = sector[dasector].ceilingz;
			}
			if ((j = setanimation(&sector[dasector].floorz,daz,128)) >= 0)
				wsay("updowndr.wav",sndvol(centx,centy));
		}
	}

	if (sector[dasector].tag == 9)   //Smooshy-wall sideways double-door
	{
		//find any points with either same x or same y coordinate
		//  as center (centx, centy) - should be 2 points found.
		wallfind[0] = -1;
		wallfind[1] = -1;
		for(i=startwall;i<=endwall;i++)
			if ((wall[i].x == centx) || (wall[i].y == centy))
			{
				if (wallfind[0] == -1)
					wallfind[0] = i;
				else
					wallfind[1] = i;
			}

		for(j=0;j<2;j++)
		{
			if ((wall[wallfind[j]].x == centx) && (wall[wallfind[j]].y == centy))
			{
				//find what direction door should open by averaging the
				//  2 neighboring points of wallfind[0] & wallfind[1].
				i = wallfind[j]-1; if (i < startwall) i = endwall;
				dax2 = ((wall[i].x+wall[wall[wallfind[j]].point2].x)>>1)-wall[wallfind[j]].x;
				day2 = ((wall[i].y+wall[wall[wallfind[j]].point2].y)>>1)-wall[wallfind[j]].y;
				if (dax2 != 0)
				{
					dax2 = wall[wall[wall[wallfind[j]].point2].point2].x;
					dax2 -= wall[wall[wallfind[j]].point2].x;
					setanimation(&wall[wallfind[j]].x,wall[wallfind[j]].x+dax2,4);
					setanimation(&wall[i].x,wall[i].x+dax2,4);
					setanimation(&wall[wall[wallfind[j]].point2].x,wall[wall[wallfind[j]].point2].x+dax2,4);
				}
				else if (day2 != 0)
				{
					day2 = wall[wall[wall[wallfind[j]].point2].point2].y;
					day2 -= wall[wall[wallfind[j]].point2].y;
					setanimation(&wall[wallfind[j]].y,wall[wallfind[j]].y+day2,4);
					setanimation(&wall[i].y,wall[i].y+day2,4);
					setanimation(&wall[wall[wallfind[j]].point2].y,wall[wall[wallfind[j]].point2].y+day2,4);
				}
			}
			else
			{
				i = wallfind[j]-1; if (i < startwall) i = endwall;
				dax2 = ((wall[i].x+wall[wall[wallfind[j]].point2].x)>>1)-wall[wallfind[j]].x;
				day2 = ((wall[i].y+wall[wall[wallfind[j]].point2].y)>>1)-wall[wallfind[j]].y;
				if (dax2 != 0)
				{
					setanimation(&wall[wallfind[j]].x,centx,4);
					setanimation(&wall[i].x,centx+dax2,4);
					setanimation(&wall[wall[wallfind[j]].point2].x,centx+dax2,4);
				}
				else if (day2 != 0)
				{
					setanimation(&wall[wallfind[j]].y,centy,4);
					setanimation(&wall[i].y,centy+day2,4);
					setanimation(&wall[wall[wallfind[j]].point2].y,centy+day2,4);
				}
			}
		}
		wsay("updowndr.wav",sndvol(centx,centy));
	}

	if (sector[dasector].tag == 13)  //Swinging door
	{
		for(i=0;i<swingcnt;i++)
		{
			if (swingsector[i] == dasector)
			{
				if (swinganginc[i] == 0)
				{
					if (swingang[i] == swingangclosed[i])
					{
						swinganginc[i] = swingangopendir[i];
						wsay("opendoor.wav",sndvol(centx,centy));
					}
					else
						swinganginc[i] = -swingangopendir[i];
				}
				else
				{
					swinganginc[i] = -swinganginc[i];
				}
			}
		}
	}

	if (sector[dasector].tag == 16)  //True sideways double-sliding door
	{
		 //get 2 closest line segments to center (dax, day)
		wallfind[0] = -1;
		wallfind[1] = -1;
		for(i=startwall;i<=endwall;i++)
			if (wall[i].tag == 6)
			{
				if (wallfind[0] == -1)
					wallfind[0] = i;
				else
					wallfind[1] = i;
			}

		for(j=0;j<2;j++)
		{
			if ((((wall[wallfind[j]].x+wall[wall[wallfind[j]].point2].x)>>1) == centx) && (((wall[wallfind[j]].y+wall[wall[wallfind[j]].point2].y)>>1) == centy))
			{     //door was closed
					//find what direction door should open
				i = wallfind[j]-1; if (i < startwall) i = endwall;
				dax2 = wall[i].x-wall[wallfind[j]].x;
				day2 = wall[i].y-wall[wallfind[j]].y;
				if (dax2 != 0)
				{
					dax2 = wall[wall[wall[wall[wallfind[j]].point2].point2].point2].x;
					dax2 -= wall[wall[wall[wallfind[j]].point2].point2].x;
					setanimation(&wall[wallfind[j]].x,wall[wallfind[j]].x+dax2,4);
					setanimation(&wall[i].x,wall[i].x+dax2,4);
					setanimation(&wall[wall[wallfind[j]].point2].x,wall[wall[wallfind[j]].point2].x+dax2,4);
					setanimation(&wall[wall[wall[wallfind[j]].point2].point2].x,wall[wall[wall[wallfind[j]].point2].point2].x+dax2,4);
				}
				else if (day2 != 0)
				{
					day2 = wall[wall[wall[wall[wallfind[j]].point2].point2].point2].y;
					day2 -= wall[wall[wall[wallfind[j]].point2].point2].y;
					setanimation(&wall[wallfind[j]].y,wall[wallfind[j]].y+day2,4);
					setanimation(&wall[i].y,wall[i].y+day2,4);
					setanimation(&wall[wall[wallfind[j]].point2].y,wall[wall[wallfind[j]].point2].y+day2,4);
					setanimation(&wall[wall[wall[wallfind[j]].point2].point2].y,wall[wall[wall[wallfind[j]].point2].point2].y+day2,4);
				}
			}
			else
			{    //door was not closed
				i = wallfind[j]-1; if (i < startwall) i = endwall;
				dax2 = wall[i].x-wall[wallfind[j]].x;
				day2 = wall[i].y-wall[wallfind[j]].y;
				if (dax2 != 0)
				{
					setanimation(&wall[wallfind[j]].x,centx,4);
					setanimation(&wall[i].x,centx+dax2,4);
					setanimation(&wall[wall[wallfind[j]].point2].x,centx,4);
					setanimation(&wall[wall[wall[wallfind[j]].point2].point2].x,centx+dax2,4);
				}
				else if (day2 != 0)
				{
					setanimation(&wall[wallfind[j]].y,centy,4);
					setanimation(&wall[i].y,centy+day2,4);
					setanimation(&wall[wall[wallfind[j]].point2].y,centy,4);
					setanimation(&wall[wall[wall[wallfind[j]].point2].point2].y,centy+day2,4);
				}
			}
		}
		wsay("updowndr.wav",sndvol(centx,centy));
	}
}

changehealth(short snum, short deltahealth)
{
	long dax, day;
	short good, k, startwall, endwall, s;
	
	health[snum] += deltahealth;
	
	if (health[snum] <= 0)
	{
		wsay("death.wav",sndvol(posx[snum],posy[snum]));
		health[snum] = 100;
		deaths[snum]++;
		good = 0;
		while (good == 0)
		{
			k = (krand()%numsectors);

			startwall = sector[k].wallptr;
			endwall = startwall+sector[k].wallnum-1;
			if (endwall > startwall)
			{
				dax = 0L;
				day = 0L;
				for(s=startwall;s<=endwall;s++)
				{
					dax += wall[s].x;
					day += wall[s].y;
				}
				dax /= (endwall-startwall+1);
				day /= (endwall-startwall+1);
			}
			if (inside(dax,day,k) == 1)
				good = 1;
		}
		posx[snum] = dax;
		posy[snum] = day;
		posz[snum] = sector[k].floorz-(32<<8);
		cursectnum[snum] = k;

		setsprite(playersprite[snum],posx[snum],posy[snum],posz[snum]+(32<<8));
		sprite[playersprite[snum]].ang = ang[snum];
	}
}

prepareboard(char *daboardfilename)
{
	short startwall, endwall, dasector;
	long i, j, k, s, dax, day, daz, dax2, day2;

	setgamemode();
	permanentwritesprite(0,YDIM-32,STATUSBAR,0);  //Draw status bar only once
	for (i=0;i<XDIM;i++)                          //define 3d picture boundaries
	{
		startumost[i] = 0;
		startdmost[i] = YDIM-32;     //Leave 32 lines on bottom for status bar
	}

	randomseed = 17L;

		//Clear (do)animation's list
	animatecnt = 0;

	if (loadboard(daboardfilename,&posx[0],&posy[0],&posz[0],&ang[0],&cursectnum[0]) == -1)
	{
		printf("Board not found\n");
		exit(0);
	}

	for(i=0;i<MAXPLAYERS;i++)
	{
		posx[i] = posx[0];
		posy[i] = posy[0];
		posz[i] = posz[0];
		ang[i] = ang[0];
		cursectnum[i] = cursectnum[0];
		horiz[i] = 100;
		lastchaingun[i] = 0;
		health[i] = 100;
		score[i] = 0L;
		dimensionmode[i] = 3;
		zoom[i] = 768L;
		deaths[i] = 0L;
		playersprite[i] = -1;
	}

		//Scan sector tags

	for(i=0;i<MAXPLAYERS;i++)
		warpsectorflag[i] = 0;  //Make sure you don't warp more than once
	warpsectorcnt = 0;      //Make a list of warping sectors
	xpanningsectorcnt = 0;  //Make a list of wall x-panning sectors
	floorpanningcnt = 0;    //Make a list of slime sectors
	dragsectorcnt = 0;      //Make a list of moving platforms
	swingcnt = 0;           //Make a list of swinging doors
	revolvecnt = 0;         //Make a list of revolving doors
	subwaytrackcnt = 0;     //Make a list of subways

	for(i=0;i<numsectors;i++)
	{
		switch(sector[i].tag)
		{
			case 4:
				floorpanninglist[floorpanningcnt++] = i;
				break;
			case 10:
				warpsectorlist[warpsectorcnt++] = i;
				break;
			case 11:
				xpanningsectorlist[xpanningsectorcnt++] = i;
				break;
			case 12:
				dasector = i;
				dax = 0x7fffffff;
				day = 0x7fffffff;
				dax2 = 0x80000000;
				day2 = 0x80000000;
				startwall = sector[i].wallptr;
				endwall = startwall+sector[i].wallnum-1;
				for(j=startwall;j<=endwall;j++)
				{
					if (wall[j].x < dax) dax = wall[j].x;
					if (wall[j].y < day) day = wall[j].y;
					if (wall[j].x > dax2) dax2 = wall[j].x;
					if (wall[j].y > day2) day2 = wall[j].y;
					if (wall[j].tag == 3) k = j;
				}
				if (wall[k].x == dax) dragxdir[dragsectorcnt] = -16;
				if (wall[k].y == day) dragydir[dragsectorcnt] = -16;
				if (wall[k].x == dax2) dragxdir[dragsectorcnt] = 16;
				if (wall[k].y == day2) dragydir[dragsectorcnt] = 16;

				dasector = wall[startwall].nextsector1;
				dragx1[dragsectorcnt] = 0x7fffffff;
				dragy1[dragsectorcnt] = 0x7fffffff;
				dragx2[dragsectorcnt] = 0x80000000;
				dragy2[dragsectorcnt] = 0x80000000;
				startwall = sector[dasector].wallptr;
				endwall = startwall+sector[dasector].wallnum-1;
				for(j=startwall;j<=endwall;j++)
				{
					if (wall[j].x < dragx1[dragsectorcnt]) dragx1[dragsectorcnt] = wall[j].x;
					if (wall[j].y < dragy1[dragsectorcnt]) dragy1[dragsectorcnt] = wall[j].y;
					if (wall[j].x > dragx2[dragsectorcnt]) dragx2[dragsectorcnt] = wall[j].x;
					if (wall[j].y > dragy2[dragsectorcnt]) dragy2[dragsectorcnt] = wall[j].y;
				}

				dragx1[dragsectorcnt] += (wall[sector[i].wallptr].x-dax);
				dragy1[dragsectorcnt] += (wall[sector[i].wallptr].y-day);
				dragx2[dragsectorcnt] -= (dax2-wall[sector[i].wallptr].x);
				dragy2[dragsectorcnt] -= (day2-wall[sector[i].wallptr].y);

				dragfloorz[dragsectorcnt] = sector[i].floorz;

				dragsectorlist[dragsectorcnt++] = i;
				break;
			case 13:
				startwall = sector[i].wallptr;
				endwall = startwall+sector[i].wallnum-1;
				for(j=startwall;j<=endwall;j++)
				{
					if (wall[j].tag == 4)
					{
						k = wall[wall[wall[wall[j].point2].point2].point2].point2;
						if ((wall[j].x == wall[k].x) && (wall[j].y == wall[k].y))
						{     //Door opens counterclockwise
							swingwall[swingcnt][0] = j;
							swingwall[swingcnt][1] = wall[j].point2;
							swingwall[swingcnt][2] = wall[wall[j].point2].point2;
							swingwall[swingcnt][3] = wall[wall[wall[j].point2].point2].point2;
							swingangopen[swingcnt] = 1536;
							swingangclosed[swingcnt] = 0;
							swingangopendir[swingcnt] = -1;
						}
						else
						{     //Door opens clockwise
							swingwall[swingcnt][0] = wall[j].point2;
							swingwall[swingcnt][1] = j;
							swingwall[swingcnt][2] = lastwall(j);
							swingwall[swingcnt][3] = lastwall(swingwall[swingcnt][2]);
							swingangopen[swingcnt] = 512;
							swingangclosed[swingcnt] = 0;
							swingangopendir[swingcnt] = 1;
						}
						for(k=0;k<4;k++)
						{
							swingx[swingcnt][k] = wall[swingwall[swingcnt][k]].x;
							swingy[swingcnt][k] = wall[swingwall[swingcnt][k]].y;
						}

						swingsector[swingcnt] = i;
						swingang[swingcnt] = swingangclosed[swingcnt];
						swinganginc[swingcnt] = 0;
						swingcnt++;
					}
				}
				break;
			case 14:
				startwall = sector[i].wallptr;
				endwall = startwall+sector[i].wallnum-1;
				dax = 0L;
				day = 0L;
				for(j=startwall;j<=endwall;j++)
				{
					dax += wall[j].x;
					day += wall[j].y;
				}
				revolvepivotx[revolvecnt] = dax / (endwall-startwall+1);
				revolvepivoty[revolvecnt] = day / (endwall-startwall+1);
				for(k=0;k<12;k++)
				{
					revolvex[revolvecnt][k] = wall[k+startwall].x;
					revolvey[revolvecnt][k] = wall[k+startwall].y;
				}
				revolvesector[revolvecnt] = i;
				revolveang[revolvecnt] = 0;
				revolvecnt++;
				break;
			case 15:
				subwaytracksector[subwaytrackcnt][0] = i;

				subwaystopcnt[subwaytrackcnt] = 0;
				dax = 0x7fffffff;
				day = 0x7fffffff;
				dax2 = 0x80000000;
				day2 = 0x80000000;
				startwall = sector[i].wallptr;
				endwall = startwall+sector[i].wallnum-1;
				for(j=startwall;j<=endwall;j++)
				{
					if (wall[j].x < dax) dax = wall[j].x;
					if (wall[j].y < day) day = wall[j].y;
					if (wall[j].x > dax2) dax2 = wall[j].x;
					if (wall[j].y > day2) day2 = wall[j].y;
				}
				for(j=startwall;j<=endwall;j++)
				{
					if (wall[j].tag == 5)
					{
						if ((wall[j].x > dax) && (wall[j].y > day) && (wall[j].x < dax2) && (wall[j].y < day2))
						{
							subwayx[subwaytrackcnt] = wall[j].x;
						}
						else
						{
							subwaystop[subwaytrackcnt][subwaystopcnt[subwaytrackcnt]] = wall[j].x;
							subwaystopcnt[subwaytrackcnt]++;
						}
					}
				}

				for(j=1;j<subwaystopcnt[subwaytrackcnt];j++)
					for(k=0;k<j;k++)
						if (subwaystop[subwaytrackcnt][j] < subwaystop[subwaytrackcnt][k])
						{
							s = subwaystop[subwaytrackcnt][j];
							subwaystop[subwaytrackcnt][j] = subwaystop[subwaytrackcnt][k];
							subwaystop[subwaytrackcnt][k] = s;
						}

				subwaygoalstop[subwaytrackcnt] = 0;
				for(j=0;j<subwaystopcnt[subwaytrackcnt];j++)
					if (labs(subwaystop[subwaytrackcnt][j]-subwayx[subwaytrackcnt]) < labs(subwaystop[subwaytrackcnt][subwaygoalstop[subwaytrackcnt]]-subwayx[subwaytrackcnt]))
						subwaygoalstop[subwaytrackcnt] = j;

				subwaytrackx1[subwaytrackcnt] = dax;
				subwaytracky1[subwaytrackcnt] = day;
				subwaytrackx2[subwaytrackcnt] = dax2;
				subwaytracky2[subwaytrackcnt] = day2;

				subwaynumsectors[subwaytrackcnt] = 1;
				for(j=0;j<numsectors;j++)
					if (j != i)
					{
						startwall = sector[j].wallptr;
						if (wall[startwall].x > subwaytrackx1[subwaytrackcnt])
							if (wall[startwall].y > subwaytracky1[subwaytrackcnt])
								if (wall[startwall].x < subwaytrackx2[subwaytrackcnt])
									if (wall[startwall].y < subwaytracky2[subwaytrackcnt])
									{
										if (sector[j].tag == 16)
											sector[j].tag = 17;     //Make special subway door
										subwaytracksector[subwaytrackcnt][subwaynumsectors[subwaytrackcnt]] = j;
										subwaynumsectors[subwaytrackcnt]++;
									}
					}

				subwayvel[subwaytrackcnt] = 64;
				subwaypausetime[subwaytrackcnt] = 720;
				subwaytrackcnt++;
				break;
		}
	}


		//Scan wall tags

	ypanningwallcnt = 0;
	for(i=0;i<numwalls;i++)
	{
		if (wall[i].tag == 1)
			ypanningwalllist[ypanningwallcnt++] = i;
	}


		//Scan sprite picnum's

	for(i=0;i<MAXSPRITES;i++)
		if (sprite[i].statnum < MAXSTATUS)   //That is, if sprite exists
		{
			switch(sprite[i].picnum)
			{
				case SKELETON:               //All cases here put the sprite
				case BROWNMONSTER:           //on waiting for you (list 2)
				case DOOMGUY:
					changespritestat(i,2);
					sprite[i].tag = 100;
					break;
			}
			switch(sprite[i].picnum)
			{
				case SKELETON:               //These sprites will be
				case AL:                     //sensitive to the hitscan function
				case BROWNMONSTER:
				case EVILAL:
				case DOOMGUY:
					sprite[i].cstat |= 1;     //Set the hitscan sensitivity bit
					break;
			}
		}

		//Map starts out completed
	for(i=0;i<(MAXWALLS>>3);i++)
		show2dwall[i] = 0xff;
	for(i=0;i<(MAXSPRITES>>3);i++)
		show2dsprite[i] = 0xff;

		//Map starts out blank; you map out what you see in 3D mode
	//automapping = 1;

	lockclock = 0;
}


checktouchsprite()
{
	long i, j, nexti;

	j = connecthead;
	while (j != -1)
	{
		if ((cursectnum[j] >= 0) && (cursectnum[j] < numsectors))
		{
			i = headspritesect[cursectnum[j]];
			while (i != -1)
			{
				nexti = nextspritesect[i];

				if ((labs(posx[j]-sprite[i].x)+labs(posy[j]-sprite[i].y) < 512) && (labs((posz[j]>>8)-((sprite[i].z>>8)-(tilesizy[sprite[i].picnum]>>1))) <= 40))
				{
					switch(sprite[i].picnum)
					{
						case COINSTACK:
							wsay("getstuff.wav",sndvol(sprite[i].x,sprite[i].y));
							score[j] += 1000L;
							changehealth(j,25);
							deletesprite((short)i);
							break;
						case GIFTBOX:
							wsay("getstuff.wav",sndvol(sprite[i].x,sprite[i].y));
							score[j] += 1000L;
							changehealth(j,10);
							deletesprite((short)i);
							break;
						case COIN:
							wsay("getstuff.wav",sndvol(sprite[i].x,sprite[i].y));
							score[j] += 100L;
							changehealth(j,5);
							deletesprite((short)i);
							break;
						case DIAMONDS:
							wsay("getstuff.wav",sndvol(sprite[i].x,sprite[i].y));
							score[j] += 500L;
							changehealth(j,15);
							deletesprite((short)i);
							break;
					}
				}

				i = nexti;
			}
		}

		j = connectpoint2[j];
	}
}

shootgun(short snum, char guntype)
{
	short hitsect, hitwall, hitsprite, daang2, daowner;
	long i, j, daz2, hitx, hity, hitz;

	daowner = snum+4096;

	switch(guntype)
	{
		case 0:    //Shoot silver sphere bullet (L. Ctrl key)
			wsay("shoot2.wav",sndvol(posx[snum],posy[snum]));
			j = insertsprite(cursectnum[snum],6);
			sprite[j].x = posx[snum];
			sprite[j].y = posy[snum];
			sprite[j].z = posz[snum]+(8<<8);
			sprite[j].cstat = 0;        //Hitscan does not hit other bullets
			sprite[j].picnum = BULLET;
			sprite[j].shade = 0;
			sprite[j].xrepeat = 64;
			sprite[j].yrepeat = 64;
			sprite[j].ang = ang[snum];
			sprite[j].xvel = (sintable[(ang[snum]+2560)&2047]>>5);
			sprite[j].yvel = (sintable[(ang[snum]+2048)&2047]>>5);
			sprite[j].zvel = ((100-horiz[snum])*64);
			sprite[j].owner = daowner;
			sprite[j].tag = 0L;
			break;
		case 1:    //Shoot chain gun (L. Alt key)
			daang2 = ((ang[snum] + 2048 + (krand()&63)-32)&2047);
			daz2 = ((100-horiz[snum])*2000) + (krand()-32768);

			hitscan(posx[snum],posy[snum],posz[snum],cursectnum[snum],  //Start position
				sintable[(daang2+2560)&2047],           //X vector of 3D ang
				sintable[(daang2+2048)&2047],           //Y vector of 3D ang
				daz2,                                   //Z vector of 3D ang
				&hitsect,&hitwall,&hitsprite,&hitx,&hity,&hitz);

			if (wall[hitwall].picnum == KENPICTURE)
			{
				wsay("hello.wav",sndvol(wall[hitwall].x,wall[hitwall].y));   //Ken says, "Hello... how are you today!"
			}
			else if (((hitwall < 0) && (hitsprite < 0) && (hitz >= posz[snum]) && (sector[hitsect].floorpicnum == SLIME)) || ((hitwall >= 0) && (wall[hitwall].picnum == SLIME)))
			{    //If you shoot slime, make a splash
				wsay("splash.wav",sndvol(hitx,hity));

				j = insertsprite(hitsect,4);
				sprite[j].x = hitx;
				sprite[j].y = hity;
				sprite[j].z = hitz;
				sprite[j].cstat = 2;
				sprite[j].picnum = SPLASH;
				sprite[j].shade = 0;
				sprite[j].xrepeat = 64;
				sprite[j].yrepeat = 64;
				sprite[j].ang = ang[snum];
				sprite[j].xvel = 0;
				sprite[j].yvel = 0;
				sprite[j].zvel = 0;
				sprite[j].owner = daowner;
				sprite[j].tag = 63;       //Time left for splash to be alive
			}
			else
			{
				wsay("shoot.wav",sndvol(hitx,hity));

				if ((hitsprite >= 0) && (sprite[hitsprite].statnum < MAXSTATUS))
					switch(sprite[hitsprite].picnum)
					{
						case BROWNMONSTER:
							if (sprite[hitsprite].tag > 0)
								sprite[hitsprite].tag -= 10;
							if (sprite[hitsprite].tag > 0)
							{
								wsay("hurt.wav",sndvol(hitx,hity));
								if (sprite[hitsprite].tag <= 25)
									sprite[hitsprite].cstat |= 2;
							}
							else
							{
								wsay("blowup.wav",sndvol(hitx,hity));
								sprite[hitsprite].picnum = GIFTBOX;
								sprite[hitsprite].cstat &= ~3;    //Should not clip
								changespritestat(hitsprite,0);
								score[snum] += 200L;

								j = insertsprite(hitsect,5);
								sprite[j].x = hitx;
								sprite[j].y = hity;
								sprite[j].z = hitz+(32<<8);
								sprite[j].cstat = 0;        //Hitscan does not hit explosion
								sprite[j].picnum = EXPLOSION;
								sprite[j].shade = -4;
								sprite[j].xrepeat = 64;
								sprite[j].yrepeat = 64;
								sprite[j].ang = ang[snum];
								sprite[j].xvel = 0;
								sprite[j].yvel = 0;
								sprite[j].zvel = 0;
								sprite[j].owner = daowner;
								sprite[j].tag = 31;  //Time left for explosion to stay
							}
							break;
						case DOOMGUY:
							j = connecthead;
							while (j != -1)
							{
								if (playersprite[j] == hitsprite)
								{
									wsay("ouch.wav",sndvol(hitx,hity));
									changehealth(j,-10);
									break;
								}
								j = connectpoint2[j];
							}
							break;
					}

				j = insertsprite(hitsect,3);
				sprite[j].x = hitx;
				sprite[j].y = hity;
				sprite[j].z = hitz+(8<<8);
				sprite[j].cstat = 2;        //Hitscan does not hit smoke on wall
				sprite[j].picnum = EXPLOSION;
				sprite[j].shade = -4;
				sprite[j].xrepeat = 16;    // 25% normal size
				sprite[j].yrepeat = 16;    // 25% normal size
				sprite[j].ang = ang[snum];
				sprite[j].xvel = 0;
				sprite[j].yvel = 0;
				sprite[j].zvel = 0;
				sprite[j].owner = daowner;
				sprite[j].tag = 63;       //Time left for smoke to be alive
					//Sprite starts out with center exactly on wall.
					//This moves it back enough to see it at all angles.
				movesprite(j,-(sintable[(512+ang[snum])&2047]>>7),-(sintable[ang[snum]]>>7),0L,128L,1,4L);
			}
			break;
	}
}

analyzesprites()
{
	long i, j, k, scrx, scry, lockx, locky, dist, mindist;
	short spritetarget;

		//Between drawrooms() and drawmasks()
		//is the perfect time to animate sprites / lock on a target

	for(i=0;i<spritesortcnt;i++)
	{
		j = thesprite[i];
		switch(sprite[j].picnum)
		{
			case DOOMGUY:
					//Get which of the 8 angles of the sprite to draw (0-7)
					//k ranges from 0-7
				k = ((((sprite[j].ang+3072+128-ang[screenpeek])&2047)>>8)&7);
					//This guy has only 5 pictures for 8 angles (3 are x-flipped)
				if (k <= 4)
				{
					spritepicnum[i] += (k<<2);
					sprite[j].cstat &= (255-4);   //clear x-flipping bit
				}
				else
				{
					spritepicnum[i] += ((8-k)<<2);
					sprite[j].cstat |= 4;         //set x-flipping bit
				}
				break;
		}
	}

	//if (keystatus[0x3a] > 0)  // (Caps Lock) - Hold to lock on target
	//{
	//   mindist = 0x7fffffff;
	//   for(i=0;i<spritesortcnt;i++)
	//      if ((spritepicnum[i] == SKELETON) || (spritepicnum[i] == AL) || (spritepicnum[i] == BROWNMONSTER) || (spritepicnum[i] == EVILAL) || (spritepicnum[i] == DOOMGUY))
	//      {
	//         getspritescreencoord((short)i,&scrx,&scry);
	//         dist = labs(scrx-160) + labs(scry-100);
	//         if (dist < mindist)
	//         {
	//            lockx = scrx;
	//            locky = scry;
	//            mindist = dist;
	//         }
	//      }
	//   if (mindist < 0x7fffffff)
	//   {
	//      ang += ((lockx-160)>>3);
	//      horiz[0] -= ((locky-100)>>3);
	//   }
	//}
}

tagcode()
{
	short startwall, endwall, dasector, p;
	long i, j, k, s, dax, day, daz, dax2, day2, cnt, good;

	p = connecthead;
	while (p != -1)
	{
		if (sector[cursectnum[p]].tag == 1)
		{
			for(i=0;i<numsectors;i++)
			{
				if (sector[i].tag == 2)
				{
					setanimation(&sector[i].ceilingz,sector[i].floorz-16384,64);
					wsay("updowndr.wav",sndvol(wall[sector[i].wallptr].x,wall[sector[i].wallptr].y));
				}
				if (sector[i].tag == 3)
				{
					j = headspritesect[i];
					while (j != -1)
					{
						k = nextspritesect[j];
						sprite[j].picnum = BROWNMONSTER;
						sprite[j].tag = 100;
						sprite[j].cstat = 1;
						changespritestat(j,2);
						j = k;
					}
				}
			}
			sector[cursectnum[p]].tag = 0;
		}

		p = connectpoint2[p];
	}

	for(i=0;i<warpsectorcnt;i++)
	{
		dasector = warpsectorlist[i];
		j = ((lockclock&127)>>2);
		if (j >= 16) j = 31 - j;
		{
			sector[dasector].ceilingshade = j;
			sector[dasector].floorshade = j;
			startwall = sector[dasector].wallptr;
			endwall = startwall+sector[dasector].wallnum-1;
			for(s=startwall;s<=endwall;s++)
				wall[s].shade = j;
		}
	}

	p = connecthead;
	while (p != -1)
	{
		if (sector[cursectnum[p]].tag == 10)  //warp sector
		{
			if (warpsectorflag[p] == 0)
			{
				wsay("warp.wav",sndvol(wall[sector[cursectnum[p]].wallptr].x,wall[sector[cursectnum[p]].wallptr].y));

				for(i=0;i<warpsectorcnt;i++)
				{
					if (warpsectorlist[i] == cursectnum[p])
					{
						if (i == warpsectorcnt-1)
							cursectnum[p] = warpsectorlist[0];
						else
							cursectnum[p] = warpsectorlist[i+1];
						break;
					}
				}
					//Find center of sector
				startwall = sector[cursectnum[p]].wallptr;
				endwall = startwall+sector[cursectnum[p]].wallnum-1;
				dax = 0L, day = 0L;
				for(s=startwall;s<=endwall;s++)
				{
					dax += wall[s].x, day += wall[s].y;
					if (wall[s].nextsector1 >= 0)
						i = s;
				}
				posx[p] = dax / (endwall-startwall+1);
				posy[p] = day / (endwall-startwall+1);
				posz[p] = sector[cursectnum[p]].floorz-(32<<8);
				updatesector(posx[p],posy[p],&cursectnum[p]);
				dax = ((wall[i].x+wall[wall[i].point2].x)>>1);
				day = ((wall[i].y+wall[wall[i].point2].y)>>1);
				ang[p] = getangle(dax-posx[p],day-posy[p]);

					//Update sprite representation of player
				setsprite(playersprite[p],posx[p],posy[p],posz[p]+(32<<8));
				sprite[playersprite[p]].ang = ang[p];

				warpsectorflag[p] = 1;
			}
		}
		else
			warpsectorflag[p] = 0;

		p = connectpoint2[p];
	}

	for(i=0;i<xpanningsectorcnt;i++)   //animate wall x-panning sectors
	{
		dasector = xpanningsectorlist[i];

		startwall = sector[dasector].wallptr;
		endwall = startwall+sector[dasector].wallnum-1;
		for(s=startwall;s<=endwall;s++)
			wall[s].xpanning = ((lockclock>>2)&255);
	}

	for(i=0;i<ypanningwallcnt;i++)
		wall[ypanningwalllist[i]].ypanning = ~(lockclock&255);

	for(i=0;i<floorpanningcnt;i++)   //animate floor of slime sectors
	{
		sector[floorpanninglist[i]].floorxpanning = ((lockclock>>2)&255);
		sector[floorpanninglist[i]].floorypanning = ((lockclock>>2)&255);
	}

	for(i=0;i<dragsectorcnt;i++)
	{
		dasector = dragsectorlist[i];

		startwall = sector[dasector].wallptr;
		endwall = startwall+sector[dasector].wallnum-1;

		if (wall[startwall].x+dragxdir[i] < dragx1[i]) dragxdir[i] = 16;
		if (wall[startwall].y+dragydir[i] < dragy1[i]) dragydir[i] = 16;
		if (wall[startwall].x+dragxdir[i] > dragx2[i]) dragxdir[i] = -16;
		if (wall[startwall].y+dragydir[i] > dragy2[i]) dragydir[i] = -16;

		for(j=startwall;j<=endwall;j++)
			dragpoint(j,wall[j].x+dragxdir[i],wall[j].y+dragydir[i]);
		sector[dasector].floorxpanning -= (dragxdir[i]>>2);
		sector[dasector].floorypanning -= (dragydir[i]>>2);
		j = sector[dasector].floorz;
		sector[dasector].floorz = dragfloorz[i]+(sintable[(lockclock<<4)&2047]>>3);

		p = connecthead;
		while (p != -1)
		{
			if (cursectnum[p] == dasector)
			{
				posx[p] += dragxdir[i];
				posy[p] += dragydir[i];
				posz[p] += (sector[dasector].floorz-j);

					//Update sprite representation of player
				setsprite(playersprite[p],posx[p],posy[p],posz[p]+(32<<8));
				sprite[playersprite[p]].ang = ang[p];
			}

			p = connectpoint2[p];
		}
	}

	for(i=0;i<swingcnt;i++)
	{
		if (swinganginc[i] != 0)
		{
			for(j=0;j<(synctics<<2);j++)
			{
				swingang[i] = ((swingang[i]+2048+swinganginc[i])&2047);
				if (swingang[i] == swingangclosed[i])
				{
					wsay("closdoor.wav",sndvol(swingx[i][0],swingy[i][0]));
					swinganginc[i] = 0;
				}
				if (swingang[i] == swingangopen[i]) swinganginc[i] = 0;
			}
			for(k=1;k<=3;k++)
				rotatepoint(swingx[i][0],swingy[i][0],swingx[i][k],swingy[i][k],swingang[i],&wall[swingwall[i][k]].x,&wall[swingwall[i][k]].y);
		}
	}

	for(i=0;i<revolvecnt;i++)
	{
		startwall = sector[revolvesector[i]].wallptr;

		revolveang[i] = ((revolveang[i]+2048-(synctics<<2))&2047);
		for(k=0;k<12;k++)
		{
			rotatepoint(revolvepivotx[i],revolvepivoty[i],revolvex[i][k],revolvey[i][k],revolveang[i],&dax,&day);
			dragpoint(startwall+k,dax,day);
		}

		p = connecthead;
		while (p != -1)
		{
			if ((cursectnum[p] == revolvesector[i]) || (cursectnum[p] == wall[startwall].nextsector1))
			{
				cnt = 256;
				do
				{
					good = 1;
					for(k=0;k<12;k++)
					{
						dax = wall[startwall+k].x-posx[p]+64;
						day = wall[startwall+k].y-posy[p]+64;
						dax2 = wall[wall[startwall+k].point2].x-posx[p]+64;
						day2 = wall[wall[startwall+k].point2].y-posy[p]+64;
						if (clipinsidebox(dax,day,dax2,day2,128L) == 1)
						{
							revolveang[i] = ((revolveang[i]+1)&2047);
							for(k=0;k<12;k++)
							{
								rotatepoint(revolvepivotx[i],revolvepivoty[i],revolvex[i][k],revolvey[i][k],revolveang[i],&dax,&day);
								dragpoint(startwall+k,dax,day);
							}
							good = 0;
							cnt--;
							break;
						}
					}
				} while ((good == 0) && (cnt > 0));
			}

			p = connectpoint2[p];
		}
	}

	for(i=0;i<subwaytrackcnt;i++)
	{
		dasector = subwaytracksector[i][0];
		startwall = sector[dasector].wallptr;
		endwall = startwall+sector[dasector].wallnum-1;
		for(k=startwall;k<=endwall;k++)
		{
			if (wall[k].x > subwaytrackx1[i])
				if (wall[k].y > subwaytracky1[i])
					if (wall[k].x < subwaytrackx2[i])
						if (wall[k].y < subwaytracky2[i])
							wall[k].x += ((subwayvel[i]>>2)<<2);
		}

		for(j=1;j<subwaynumsectors[i];j++)
		{
			dasector = subwaytracksector[i][j];

			if (sector[dasector].floorz != sector[subwaytracksector[i][0]].floorz)
			{
				sector[dasector].floorxpanning -= (subwayvel[i]>>2);
				sector[dasector].ceilingxpanning -= (subwayvel[i]>>2);
			}

			startwall = sector[dasector].wallptr;
			endwall = startwall+sector[dasector].wallnum-1;
			for(k=startwall;k<=endwall;k++)
				wall[k].x += ((subwayvel[i]>>2)<<2);

			s = headspritesect[dasector];
			while (s != -1)
			{
				k = nextspritesect[s];
				sprite[s].x += ((subwayvel[i]>>2)<<2);
				s = k;
			}
		}

		p = connecthead;
		while (p != -1)
		{
			if (cursectnum[p] != subwaytracksector[i][0])
				if (sector[cursectnum[p]].floorz != sector[subwaytracksector[i][0]].floorz)
					if (posx[p] > subwaytrackx1[i])
						if (posy[p] > subwaytracky1[i])
							if (posx[p] < subwaytrackx2[i])
								if (posy[p] < subwaytracky2[i])
								{
									posx[p] += ((subwayvel[i]>>2)<<2);

										//Update sprite representation of player
									setsprite(playersprite[p],posx[p],posy[p],posz[p]+(32<<8));
									sprite[playersprite[p]].ang = ang[p];
								}

			p = connectpoint2[p];
		}

		subwayx[i] += ((subwayvel[i]>>2)<<2);

		k = subwaystop[i][subwaygoalstop[i]] - subwayx[i];
		if (k > 0)
		{
			if (k > 2048)
			{
				if (subwayvel[i] < 128) subwayvel[i]++;
			}
			else
				subwayvel[i] = (k>>4)+1;
		}
		else if (k < 0)
		{
			if (k < -2048)
			{
				if (subwayvel[i] > -128) subwayvel[i]--;
			}
			else
				subwayvel[i] = ((k>>4)-1);
		}

		if (((subwayvel[i]>>2) == 0) && (labs(k) < 2048))
		{
			if (subwaypausetime[i] == 720)
			{
				for(j=1;j<subwaynumsectors[i];j++)   //Open all subway doors
				{
					dasector = subwaytracksector[i][j];
					if (sector[dasector].tag == 17)
					{
						sector[dasector].tag = 16;
						operatesector(dasector);
						sector[dasector].tag = 17;
					}
				}
			}
			if ((subwaypausetime[i] >= 120) && (subwaypausetime[i]-synctics < 120))
			{
				for(j=1;j<subwaynumsectors[i];j++)   //Close all subway doors
				{
					dasector = subwaytracksector[i][j];
					if (sector[dasector].tag == 17)
					{
						sector[dasector].tag = 16;
						operatesector(dasector);
						sector[dasector].tag = 17;
					}
				}
			}

			subwaypausetime[i] -= synctics;
			if (subwaypausetime[i] < 0)
			{
				subwaypausetime[i] = 720;
				if (subwayvel[i] < 0)
				{
					subwaygoalstop[i]--;
					if (subwaygoalstop[i] < 0)
						subwaygoalstop[i] = 1;
				}
				if (subwayvel[i] > 0)
				{
					subwaygoalstop[i]++;
					if (subwaygoalstop[i] >= subwaystopcnt[i])
						subwaygoalstop[i] = subwaystopcnt[i]-2;
				}
			}
		}
	}
}

statuslistcode()
{
	short p, target;
	long i, nexti, j, k, dax, day, daz, dist, mindist;

	i = headspritestat[1];     //Go through active monster sprites
	while (i != -1)
	{
		nexti = nextspritestat[i];

			//Choose a target player
		mindist = 0x7fffffff; target = connecthead;
		p = connecthead;
		while (p != -1)
		{
			dist = labs(sprite[i].x-posx[p])+labs(sprite[i].y-posy[p]);
			if (dist < mindist) mindist = dist, target = p;

			p = connectpoint2[p];
		}

		switch(sprite[i].picnum)
		{
			case SKELETON:
				dax = (sintable[(sprite[i].ang+512)&2047]>>9);   //move skeleton
				day = (sintable[sprite[i].ang]>>9);
				if (movesprite(i,dax,day,0L,128L,0,synctics) == 0)
					sprite[i].ang = getangle(posx[target]-sprite[i].x,posy[target]-sprite[i].y);
				else
					sprite[i].z = sector[sprite[i].sectnum].floorz;
				break;

			case BROWNMONSTER:
				if ((krand()&31) == 0)    //brown monster decides to shoot bullet
				{
					if (cansee(posx[target],posy[target],posz[target],cursectnum[target],sprite[i].x,sprite[i].y,sprite[i].z-(tilesizy[sprite[i].picnum]<<7),sprite[i].sectnum) == 1)
					{
						wsay("zipguns.wav",sndvol(sprite[i].x,sprite[i].y));
						j = insertsprite(sprite[i].sectnum,6);
						sprite[j].x = sprite[i].x;
						sprite[j].y = sprite[i].y;
						sprite[j].z = sector[sprite[i].sectnum].floorz-(24<<8);
						sprite[j].cstat = 0;        //Hitscan does not hit other bullets
						sprite[j].picnum = BULLET;
						sprite[j].shade = 0;
						sprite[j].xrepeat = 64;
						sprite[j].yrepeat = 64;
						sprite[j].ang = (((getangle(posx[target]-sprite[j].x,posy[target]-sprite[j].y)+(krand()&15)-8)+2048)&2047);
						sprite[j].xvel = (sintable[(sprite[j].ang+2560)&2047]>>6);
						sprite[j].yvel = (sintable[(sprite[j].ang+2048)&2047]>>6);
						sprite[j].zvel = ((posz[target]+(8<<8)-sprite[j].z)<<8)/ksqrt((posx[target]-sprite[j].x)*(posx[target]-sprite[j].x)+(posy[target]-sprite[j].y)*(posy[target]-sprite[j].y));
						sprite[j].owner = i;
						sprite[j].tag = 0L;
					}
				}

				sprite[i].z = sector[sprite[i].sectnum].floorz;

				//Move brown monster
				dax = (sintable[(sprite[i].ang+512)&2047]>>8);
				day = (sintable[sprite[i].ang]>>8);
				if (movesprite(i,dax,day,0L,128L,0,synctics) == 0)
					sprite[i].ang = (krand()&2047);
				break;

			case EVILAL:
				if (sprite[i].yrepeat >= 38)
				{
					if (sprite[i].yrepeat < 64)
					{
						sprite[i].xrepeat++;
						sprite[i].yrepeat++;
					}
					else
					{
						if ((krand()&31) == 0)
						{                   //Al decides to reproduce
							wsay("zipguns.wav",sndvol(sprite[i].x,sprite[i].y));
							j = insertsprite(sprite[i].sectnum,1);
							sprite[j].x = sprite[i].x;
							sprite[j].y = sprite[i].y;
							sprite[j].z = 0;
							sprite[j].cstat = 3;     //Hitscan should hit new monsters / Make him transluscent
							sprite[j].picnum = EVILAL;
							sprite[j].shade = 0;
							sprite[j].xrepeat = 38;
							sprite[j].yrepeat = 38;
							sprite[j].ang = (krand()&2047);
							sprite[j].xvel = 0;
							sprite[j].yvel = 0;
							sprite[j].zvel = 0;
							sprite[j].owner = i;
							sprite[j].tag = 0L;
						}
						if ((krand()&31) == 0)     //Al decides to shoot bullet
						{
							if (cansee(posx[target],posy[target],posz[target],cursectnum[target],sprite[i].x,sprite[i].y,sprite[i].z-(tilesizy[sprite[i].picnum]<<7),sprite[i].sectnum) == 1)
							{
								wsay("zipguns.wav",sndvol(sprite[i].x,sprite[i].y));
								j = insertsprite(sprite[i].sectnum,6);
								sprite[j].x = sprite[i].x;
								sprite[j].y = sprite[i].y;
								sprite[j].z = sector[sprite[i].sectnum].floorz-(24<<8);
								sprite[j].cstat = 0;            //Hitscan does not hit other bullets
								sprite[j].picnum = BULLET;
								sprite[j].shade = 0;
								sprite[j].xrepeat = 64;
								sprite[j].yrepeat = 64;
								sprite[j].ang = (((getangle(posx[target]-sprite[j].x,posy[target]-sprite[j].y)+(krand()&15)-8)+2048)&2047);
								sprite[j].xvel = (sintable[(sprite[j].ang+2560)&2047]>>6);
								sprite[j].yvel = (sintable[(sprite[j].ang+2048)&2047]>>6);
								sprite[j].zvel = ((posz[target]+(8<<8)-sprite[j].z)<<8)/ksqrt((posx[target]-sprite[j].x)*(posx[target]-sprite[j].x)+(posy[target]-sprite[j].y)*(posy[target]-sprite[j].y));
								sprite[j].owner = i;
								sprite[j].tag = 0L;
							}
						}

						sprite[i].z = sector[sprite[i].sectnum].floorz;

						//Move Al
						dax = (sintable[(sprite[i].ang+512)&2047]>>7);
						day = (sintable[sprite[i].ang]>>7);
						if (movesprite(i,dax,day,0L,128L,0,synctics) == 0)
						{
							if ((krand()&1) == 0)
								sprite[i].ang = getangle(posx[target]-sprite[i].x,posy[target]-sprite[i].y);
							else
								sprite[i].ang = (krand()&2047);
						}
					}
				}
				break;
		}

		i = nexti;
	}

	i = headspritestat[6];     //Go through travelling bullet sprites
	while (i != -1)
	{
		nexti = nextspritestat[i];

			 //If the sprite is a bullet then...
		if (sprite[i].picnum == BULLET)
		{
			dax = sprite[i].xvel;
			day = sprite[i].yvel;
			daz = sprite[i].zvel;

			if (movesprite(i,dax,day,daz,32L,1,synctics) == 0)
			{
					//If the bullet was unable to move (ex: hits a wall)
				wsay("bullseye.wav",sndvol(sprite[i].x,sprite[i].y));
				deletesprite((short)i);
				goto bulletisdeletedskip;
			}
			else
			{
				dax = sprite[i].x;
				day = sprite[i].y;
				daz = sprite[i].z;
				if ((daz < sector[sprite[i].sectnum].ceilingz) || (daz > sector[sprite[i].sectnum].floorz))
				{
					//If the bullet hits a ceiling / floor
					wsay("bullseye.wav",sndvol(dax,day));
					deletesprite((short)i);
					goto bulletisdeletedskip;
				}

					//Choose a target player
				mindist = 0x7fffffff; target = connecthead;
				p = connecthead;
				while (p != -1)
				{
					dist = labs(sprite[i].x-posx[p])+labs(sprite[i].y-posy[p]);
					if (dist < mindist) mindist = dist, target = p;

					p = connectpoint2[p];
				}

				if ((labs(posx[target]-dax)+labs(posy[target]-day) < 256) && (sprite[i].owner != target+4096))
				{
					  //If the bullet hits the target player
					wsay("ouch.wav",sndvol(posx[target],posy[target]));
					changehealth(target,-25);

					deletesprite((short)i);
					goto bulletisdeletedskip;
				}
				else
				{
					//Check to see it the bullet hits any monsters in the
					//current sector by scanning through the linked list
					//of all sprites in the bullet's sector

					j = headspritesect[sprite[i].sectnum];
					while (j >= 0)
					{
						if (sprite[i].owner != j)
							if ((labs(sprite[j].x-dax)+labs(sprite[j].y-day)) < 512)
							{
								if (sprite[j].picnum == BROWNMONSTER)
								{
									if (sprite[j].tag > 0)
										sprite[j].tag -= 25;
									if (sprite[j].tag > 0)
									{
										if (sprite[j].tag <= 25)
											sprite[j].cstat |= 2;
										wsay("hurt.wav",sndvol(dax,day));
										if (sprite[i].owner == target+4096)
											score[target] += 200L;
										deletesprite((short)i);
										goto bulletisdeletedskip;
									}
									else
									{
										wsay("blowup.wav",sndvol(dax,day));
										sprite[j].picnum = GIFTBOX;
										sprite[j].cstat &= ~3;    //Should not clip
										if (sprite[i].owner == target+4096)
											score[target] += 200L;

										k = insertsprite(sprite[j].sectnum,5);
										sprite[k].x = sprite[j].x;
										sprite[k].y = sprite[j].y;
										sprite[k].z = sprite[j].z;
										sprite[k].cstat = 0;        //Hitscan does not hit explosion
										sprite[k].picnum = EXPLOSION;
										sprite[k].shade = -4;
										sprite[k].xrepeat = 64;
										sprite[k].yrepeat = 64;
										sprite[k].ang = sprite[j].ang;
										sprite[k].xvel = 0;
										sprite[k].yvel = 0;
										sprite[k].zvel = 0;
										sprite[k].owner = j;
										sprite[k].tag = 31;  //Time left for explosion to stay

										changespritestat(j,0);

										deletesprite((short)i);
										goto bulletisdeletedskip;
									}
								}
								if (sprite[j].picnum == EVILAL)
								{
									wsay("blowup.wav",sndvol(dax,day));
									sprite[j].picnum = EVILALGRAVE;
									sprite[j].xrepeat = (krand()&63)+16;
									sprite[j].yrepeat = sprite[j].xrepeat;
									if (sprite[i].owner == target+4096)
										score[target] += 200L;
									deletesprite((short)i);
									goto bulletisdeletedskip;
								}
								if (sprite[j].picnum == AL)
								{
									wsay("blowup.wav",sndvol(dax,day));
									sprite[j].xrepeat += 2;
									sprite[j].yrepeat += 2;
									if (sprite[j].yrepeat >= 38)
									{
										sprite[j].picnum = EVILAL;
										sprite[j].cstat |= 2;      //Make him transluscent
									}
									changespritestat(j,1);
									deletesprite((short)i);
									goto bulletisdeletedskip;
								}
							}
						j = nextspritesect[j];
					}
				}
			}
		}

bulletisdeletedskip:
		i = nexti;
	}

	i = headspritestat[2];     //Go through monster waiting for you list
	while (i != -1)
	{
		nexti = nextspritestat[i];

		p = connecthead;
		while (p != -1)
		{
			if (cansee(posx[p],posy[p],posz[p],cursectnum[p],sprite[i].x,sprite[i].y,sprite[i].z-(tilesizy[sprite[i].picnum]<<7),sprite[i].sectnum) == 1)
			{
				changespritestat(i,1);
				wsay("iseeyou.wav",sndvol(sprite[i].x,sprite[i].y));
			}
			p = connectpoint2[p];
		}

		i = nexti;
	}

	i = headspritestat[3];     //Go through smoke sprites
	while (i >= 0)
	{
		nexti = nextspritestat[i];

		sprite[i].z -= (synctics<<6);
		sprite[i].tag -= synctics;
		if (sprite[i].tag < 0)
			deletesprite(i);

		i = nexti;
	}

	i = headspritestat[4];     //Go through splash sprites
	while (i >= 0)
	{
		nexti = nextspritestat[i];

		sprite[i].tag -= synctics;
		sprite[i].picnum = SPLASH + ((63-sprite[i].tag)>>4);
		if (sprite[i].tag < 0)
			deletesprite(i);

		i = nexti;
	}

	i = headspritestat[5];     //Go through explosion sprites
	while (i >= 0)
	{
		nexti = nextspritestat[i];

		sprite[i].tag -= synctics;
		if (sprite[i].tag < 0)
			deletesprite(i);

		i = nexti;
	}
}

processinput(short snum)
{
	char *ptr;
	short startwall, endwall;
	long oldposx, oldposy, i, j, k, doubvel, xvect, yvect, goalz;

		//SHARED KEYS:

		//Movement code
	if (((syncbits[snum]&8) > 0) && (horiz[snum] > 0)) horiz[snum] -= 4;     //-
	if (((syncbits[snum]&4) > 0) && (horiz[snum] < 199)) horiz[snum] += 4;   //+

	if (syncangvel[snum] != 0)          //ang += angvel * constant
	{                         //ENGINE calculates angvel for you
		doubvel = synctics;
		if ((syncbits[snum]&256) > 0)  //Lt. shift makes turn velocity 50% faster
			doubvel += (synctics>>1);
		ang[snum] += ((syncangvel[snum]*doubvel)>>5);
		ang[snum] = (ang[snum]+2048)&2047;
	}
	if ((syncvel[snum]|syncsvel[snum]) != 0)
	{
		doubvel = (synctics<<((syncbits[snum]&256)>0));

		xvect = 0, yvect = 0;
		if (syncvel[snum] != 0)
		{
			xvect += ((syncvel[snum]*doubvel*(long)sintable[(ang[snum]+2560)&2047])>>4);
			yvect += ((syncvel[snum]*doubvel*(long)sintable[(ang[snum]+2048)&2047])>>4);
		}
		if (syncsvel[snum] != 0)
		{
			xvect += ((syncsvel[snum]*doubvel*(long)sintable[(ang[snum]+2048)&2047])>>4);
			yvect += ((syncsvel[snum]*doubvel*(long)sintable[(ang[snum]+1536)&2047])>>4);
		}
		clipmove(&posx[snum],&posy[snum],&posz[snum],&cursectnum[snum],xvect,yvect,128L,0);
	}

	goalz = sector[cursectnum[snum]].floorz-(32<<8);         //32 pixels above floor
	if (sector[cursectnum[snum]].tag == 4)   //slime sector
	{
		goalz = sector[cursectnum[snum]].floorz-(8<<8);
		if (posz[snum] >= goalz-(2<<8))
			clipmove(&posx[snum],&posy[snum],&posz[snum],&cursectnum[snum],-(synctics<<14),-(synctics<<14),128L,0);
	}
	if (goalz < sector[cursectnum[snum]].ceilingz+(16<<8))   //ceiling&floor too close
		goalz = ((sector[cursectnum[snum]].ceilingz+sector[cursectnum[snum]].floorz)>>1);
	//goalz += mousz;
	if ((syncbits[snum]&1) > 0)                         //A (stand high)
	{
		goalz -= (16<<8);
		if ((syncbits[snum]&256) > 0)                    //Either shift key
			goalz -= (24<<8);
	}
	if ((syncbits[snum]&2) > 0)                         //Z (stand low)
	{
		goalz += (12<<8);
		if ((syncbits[snum]&256) > 0)                    //Either shift key
			goalz += (12<<8);
	}
	if ((sector[cursectnum[snum]].floorstat&2) > 0) //Groudraw
	{
		if (waloff[sector[cursectnum[snum]].floorheinum] == -1) loadtile(sector[cursectnum[snum]].floorheinum);
		ptr = (char *)(waloff[sector[cursectnum[snum]].floorheinum]+(((posx[snum]>>4)&63)<<6)+((posy[snum]>>4)&63));
		goalz -= ((*ptr)<<8);
	}

	if (goalz != posz[snum])
	{
		if (posz[snum] < goalz) hvel[snum] += 32;
		if (posz[snum] > goalz) hvel[snum] = ((goalz-posz[snum])>>3);

		posz[snum] += hvel[snum];
		if (posz[snum] > sector[cursectnum[snum]].floorz-(4<<8))
			posz[snum] = sector[cursectnum[snum]].floorz-(4<<8);
		if (posz[snum] < sector[cursectnum[snum]].ceilingz+(4<<8))
			posz[snum] = sector[cursectnum[snum]].ceilingz+(4<<8);
	}

	if (dimensionmode[snum] == 2)
	{
		if (((syncbits[snum]&32) > 0) && (zoom[snum] > 48)) zoom[snum] -= (zoom[snum]>>4);
		if (((syncbits[snum]&16) > 0) && (zoom[snum] < 4096)) zoom[snum] += (zoom[snum]>>4);
	}


		//Update sprite representation of player
		//   -should be after movement, but before shooting code
	setsprite(playersprite[snum],posx[snum],posy[snum],posz[snum]+(32<<8));
	sprite[playersprite[snum]].ang = ang[snum];

	if ((syncbits[snum]&1024) > 0)  //Space bar
	{
		neartag(posx[snum],posy[snum],posz[snum],cursectnum[snum],ang[snum],&neartagsector,&neartagwall,&neartagsprite,&neartaghitdist,1024L);  //1024 is range (1024 = 1 largest grid unit)

		if (neartagsector >= 0)
		{
			operatesector(neartagsector);
			syncbits[snum] &= ~1024;
		}

		if (neartagwall >= 0)
		{
			if (wall[neartagwall].tag == 2)  //Switch
			{
				i = wall[neartagwall].overpicnum;
				if (i == SWITCH1ON) wall[neartagwall].overpicnum = GIFTBOX;
				if (i == GIFTBOX) wall[neartagwall].overpicnum = SWITCH1ON;
				if (i == SWITCH2ON) wall[neartagwall].overpicnum = SWITCH2OFF;
				if (i == SWITCH2OFF) wall[neartagwall].overpicnum = SWITCH2ON;
				syncbits[snum] &= ~1024;
			}
		}

		if (neartagsprite >= 0)
		{
			if (sprite[neartagsprite].tag == 1)
			{     //if you're shoving innocent little AL around, he gets mad!
				if (sprite[neartagsprite].picnum == AL)
				{
					sprite[neartagsprite].picnum = EVILAL;
					sprite[neartagsprite].cstat |= 2;   //Make him transluscent
					sprite[neartagsprite].xrepeat = 38;
					sprite[neartagsprite].yrepeat = 38;
				}
				changespritestat(neartagsprite,1);
				syncbits[snum] &= ~1024;
			}
		}
	}
	if ((syncbits[snum]&2048) > 0)      //Shoot a bullet
		switch((syncbits[snum]>>13)&7)
		{
			case 0:
				shootgun(snum,0);
				syncbits[snum] &= ~2048;
				break;
			case 1:
				if (lockclock > lastchaingun[snum]+8)
				{
					lastchaingun[snum] = lockclock;
					shootgun(snum,1);
				}
				break;
		}
	if ((syncbits[snum]&4096) > 0)  //Keypad enter
	{
		if (dimensionmode[snum] == 3)
		{
			dimensionmode[snum] = 2;
			if (screenpeek == snum)
				qsetmode640350();
		}
		else
		{
			dimensionmode[snum] = 3;
			if (screenpeek == snum)
			{
				setgamemode();
				permanentwritesprite(0,YDIM-32,STATUSBAR,0);   //Draw status bar only once
			}
		}
		syncbits[snum] &= ~4096;
	}


		//PRIVATE KEYS:

	if (keystatus[0xb7] > 0)  //Printscreen
	{
		printscreeninterrupt();
		keystatus[0xb7] = 0;
	}
	if (keystatus[0x14] > 0)  //T
		resettiming();
	if (keystatus[0x58] > 0)   //F12
	{
		screencapture();
		keystatus[0x58] = 0;
	}


	//if (numplayers == 2)
	//{
	//       //Record & send a sound to remote computer
	//   if (keystatus[0x1c] != 0)
	//   {
	//      if (lockclock > 240)
	//      {
	//         record();
	//         keystatus[0x1c] = 0;
	//      }
	//      else
	//      {
	//         keystatus[0x1c] = 0;
	//      }
	//   }
	//}

	if (keystatus[0x19] > 0)  //P
	{
		keystatus[0x19] = 0;
		parallaxtype++;
		if (parallaxtype > 2) parallaxtype = 0;
	}
	if (keystatus[0x2f] > 0)  // V
	{
		keystatus[0x2f] = 0;
		visibility--;
		if (visibility == 7)
			visibility = 15;
	}
}

drawscreen(short snum)
{
	if (dimensionmode[snum] == 3)
	{
		drawrooms(posx[snum],posy[snum],posz[snum],ang[snum],horiz[snum],&cursectnum[snum]);
		analyzesprites();    //Analyze / animate sprites - this is the time to animate sprites!
		drawmasks();
		if (lockclock < 120)
			overwritesprite(160L,100L,DEMOSIGN,0L,1);  //Build Engine by Ken Silverman thing

		if (numplayers >= 2)   //Serial play only
		{
			sprintf(&tempbuf,"Health: %3d",health[snum]);
			printext(160-(strlen(tempbuf)<<2),176,tempbuf,ALPHABET,80);
			sprintf(&tempbuf,"Deaths: %d",deaths[snum]);
			printext(160-(strlen(tempbuf)<<2),184,tempbuf,ALPHABET,80);
		}

		sprintf(&tempbuf,"Score:%ld",score[snum]);
		printext(160-(strlen(tempbuf)<<2),192,tempbuf,ALPHABET,80);
	}
	else if (dimensionmode[snum] == 2)
	{
		draw2dscreen(posx[snum],posy[snum],ang[snum],zoom[snum],0);  // 0 is grid type, range:0-5
	}

	nextpage();
}

movethings()
{
	short i;

	//if (option[4] > 0)
	//{
	//   printf("%x",synctics);
	//   printf("%x",randomseed);
	//   i = connecthead;
	//   while (i != -1)
	//   {
	//      printf("%x ",syncvel[i]);
	//      printf("%x ",syncsvel[i]);
	//      printf("%x ",syncangvel[i]);
	//      printf("%x",syncbits[i]);
	//      i = connectpoint2[i];
	//   }
	//   printf("\n");
	//}

	lockclock += synctics;

	i = connecthead;
	while (i != -1)
	{
		processinput(i);
		i = connectpoint2[i];
	}

	doanimations(synctics);
	tagcode();            //Door code, moving sector code, other stuff
	statuslistcode();     //Monster / bullet code / explosions
	checktouchsprite();       //Pick up coins, travelling enemy bullets hit you

	synctics = 0;
}

getinput(short snum)
{
	static struct Spw_IntPacket packet, oldpacket;
	long i, j;
	short mousx, mousy, bstatus, oscreenpeek;

	if (keystatus[0x1c] > 0)
	{
		keystatus[0x1c] = 0;
		if (numplayers <= 0)
		{
			prepareboard(boardfilename);
			initplayersprites();

			for(i=0;i<reccnt;i++)
			{
				if (keystatus[1] > 0)
				{
					if (option[2] == 1)
					{
						kenchaintimer(0,0); musicoff();
					}
					uninitengine();
					uninitsb();
					setvmode(0x3);        //Set back to text mode
					exit(0);
				}
				drawscreen(0);
				syncvel[0] = recsyncvel[i];
				syncsvel[0] = recsyncsvel[i];
				syncangvel[0] = recsyncangvel[i];
				syncbits[0] = recsyncbits[i];
				synctics = recsynctics[i];
				movethings();
			}

			if (option[2] == 1)
			{
				kenchaintimer(0,0); musicoff();
			}
			uninitengine();
			uninitsb();
			setvmode(0x3);        //Set back to text mode
			exit(0);
		}
		else
		{
			oscreenpeek = screenpeek;

			screenpeek = connectpoint2[screenpeek];
			if (screenpeek == -1) screenpeek = connecthead;

			if (dimensionmode[screenpeek] < dimensionmode[oscreenpeek])
				qsetmode640350();

			if (dimensionmode[screenpeek] > dimensionmode[oscreenpeek])
			{
				setgamemode();
				permanentwritesprite(0,YDIM-32,STATUSBAR,0);   //Draw status bar only once
			}
			else if (dimensionmode[screenpeek] == 3)
				permanentwritesprite(0,YDIM-32,STATUSBAR,0);  //Draw status bar only once
		}
	}

	if (keystatus[0x2] > 0) selectedgun[snum] = 0, keystatus[0x2] = 0;
	if (keystatus[0x3] > 0) selectedgun[snum] = 1, keystatus[0x3] = 0;
	if (keystatus[0x4] > 0) selectedgun[snum] = 2, keystatus[0x4] = 0;
	if (keystatus[0x5] > 0) selectedgun[snum] = 3, keystatus[0x5] = 0;
	if (keystatus[0x6] > 0) selectedgun[snum] = 4, keystatus[0x6] = 0;
	if (keystatus[0x7] > 0) selectedgun[snum] = 5, keystatus[0x7] = 0;
	if (keystatus[0x8] > 0) selectedgun[snum] = 6, keystatus[0x8] = 0;
	if (keystatus[0x9] > 0) selectedgun[snum] = 7, keystatus[0x9] = 0;

	syncvel[snum] = vel;
	syncsvel[snum] = svel;
	syncangvel[snum] = angvel;

	switch(moustat)
	{
		case 0:
			bstatus = 0;
			break;
		case 1:
			getmousevalues(&mousx,&mousy,&bstatus);
			syncangvel[snum] += (mousx<<3);
			syncvel[snum] -= (mousy<<3);
			if (syncangvel[snum] < -512) syncangvel[snum] = -512;
			if (syncangvel[snum] > 512) syncangvel[snum] = 512;
			if (syncvel[snum] < -512) syncvel[snum] = -512;
			if (syncvel[snum] > 512) syncvel[snum] = 512;
			break;
		case 2:
			SPW_IntCommand(SPW_INTCMD_GFORCE, &packet);
			if (packet.period == 0)
				memcpy(&packet,&oldpacket,sizeof(packet));
			else
				memcpy(&oldpacket,&packet,sizeof(packet));

			//mousz = 0;
			bstatus = packet.button;

			if (labs((long)packet.rx) > 4096)
			{
				//horiz[snum] = (((horiz[snum]*7)+(100+(packet.rx>>8)))>>3);

				i = 0;
				j = labs((long)packet.ry);
				if (labs((long)packet.tz) > labs((long)packet.ry))
				{
					i = 1;
					j = labs((long)packet.tz);
				}
				if (labs((long)packet.tx) > j) i = 2;

				switch(i)
				{
					case 0: syncangvel[snum] = -(packet.ry>>6); break;
					case 1: syncvel[snum] = -(packet.tz>>4); break;
					case 2: syncsvel[snum] = -(packet.tx>>4); break;
				}

				//if (labs((long)packet.ty) > 512) mousz = -packet.ty;
			}
			else
			{
				//horiz[snum] = ((horiz[snum]+(horiz[snum]<<1)+100)>>2);
				syncangvel[snum] = -(packet.ry>>6);
				syncvel[snum] = -(packet.tz>>4);
				syncsvel[snum] = -(packet.tx>>4);
				//if (labs((long)packet.ty) > 512) mousz = -packet.ty;
			}

			if (syncvel[snum] < -512) syncvel[snum] = -512;
			if (syncvel[snum] > 512) syncvel[snum] = 512;
			if (syncsvel[snum] < -512) syncsvel[snum] = -512;
			if (syncsvel[snum] > 512) syncsvel[snum] = 512;
			if (syncangvel[snum] < -512) syncangvel[snum] = -512;
			if (syncangvel[snum] > 512) syncangvel[snum] = 512;
			break;
	}

	syncbits[snum] = keystatus[0x1e];
	syncbits[snum] += (keystatus[0x2c]<<1);
	syncbits[snum] += (keystatus[0x4e]<<2);
	syncbits[snum] += (keystatus[0x4a]<<3);
	syncbits[snum] += (keystatus[0xd]<<4);
	syncbits[snum] += (keystatus[0xc]<<5);
	syncbits[snum] += ((keystatus[0x2a]|keystatus[0x36])<<8);
	syncbits[snum] += ((keystatus[0x39]|((bstatus&6)>(oldmousebstatus&6)))<<10);
	syncbits[snum] += ((keystatus[0x1d]|((bstatus&1)>(oldmousebstatus&1)))<<11);
	syncbits[snum] += ((keystatus[0x9c]|keystatus[0x28])<<12);
	syncbits[snum] += (selectedgun[snum]<<13);

	oldmousebstatus = bstatus;

	if ((syncbits[snum]&1024) > 0) keystatus[0x39] = 0;
	if (((syncbits[snum]&2048) > 0) && (selectedgun[snum] == 0))
		keystatus[0x1d] = 0;
	if ((syncbits[snum]&4096) > 0) keystatus[0x9c] = 0, keystatus[0x28] = 0;

	if (snum < MAXPLAYERS)
		synctics += (totalclock-lockclock);

	if (numplayers <= 1)
	{
		recsyncvel[reccnt] = syncvel[snum];
		recsyncsvel[reccnt] = syncsvel[snum];
		recsyncangvel[reccnt] = syncangvel[snum];
		recsyncbits[reccnt] = syncbits[snum];
		recsynctics[reccnt] = synctics;
		reccnt++; if (reccnt > 16383) reccnt = 16383;
	}
}

sync()
{
	char otherconnectnum;
	long i, j;

	if (myconnectnum == masterconnectnum)   //I am the MASTER!
	{
		getinput(myconnectindex);
		getpackets();

		if (synctics > 1)
		{
			tempbuf[0] = 2;
			putshort((long)(&tempbuf[1]),synctics);

			j = 3;
			i = connecthead;
			while (i != -1)
			{
				putshort((long)(&tempbuf[j+0]),syncvel[i]);
				putshort((long)(&tempbuf[j+2]),syncsvel[i]);
				putshort((long)(&tempbuf[j+4]),syncangvel[i]);
				putshort((long)(&tempbuf[j+6]),syncbits[i]);
				j += 8;
				i = connectpoint2[i];
			}

			if (numplayers == 2)
			{
				if (myconnectnum == connectnum[connecthead])
					otherconnectnum = connectnum[connectpoint2[connecthead]];
				else
					otherconnectnum = connectnum[connecthead];
				sendpacket(otherconnectnum,tempbuf,j);
			}
			else if (numplayers > 2)
				sendpacket(-1,tempbuf,j);

			movethings();  //Move EVERYTHING (you too!)
		}
	}
	else    //I am a SLAVE
	{
		getinput(MAXPLAYERS);

		tempbuf[0] = 3;
		putshort((long)(&tempbuf[1]),syncvel[MAXPLAYERS]);
		putshort((long)(&tempbuf[3]),syncsvel[MAXPLAYERS]);
		putshort((long)(&tempbuf[5]),syncangvel[MAXPLAYERS]);
		putshort((long)(&tempbuf[7]),syncbits[MAXPLAYERS]);
		sendpacket(masterconnectnum,tempbuf,9);
		getpackets();
	}
}

getpackets()
{
	short otherconnectnum, otherconnectindex, tempbufleng;
	long i, j;

	while ((tempbufleng = getpacket(&otherconnectnum,tempbuf)) > 0)
	{
		//for(i=0;i<tempbufleng;i++)
		//   printf("%d ",tempbuf[i]);
		//printf("\n");

		switch(tempbuf[0])
		{
			case 0:  //[0] (login, if myconnectnum's lowest, then respond with packet type 1)
				if (option[4] < 5)
				{
					tempbuf[0] = 1;
					sendpacket(-1,tempbuf,1);
					myconnectnum = 0;
					myconnectindex = 0;
					masterconnectnum = 0;
					numplayers = 2;
				}
				else if (option[4] == 5)
				{
					netinitconnection(otherconnectnum);

						//Set masterconnectnum to first connection number
					masterconnectnum = myconnectnum;
					i = connecthead;
					while (i != -1)
					{
						if (connectnum[i] != otherconnectnum)
							if (connectnum[i] < masterconnectnum)
								masterconnectnum = connectnum[i];
						i = connectpoint2[i];
					}

					if (masterconnectnum == myconnectnum)
					{
						tempbuf[0] = 1;
						j = 1;
						i = connecthead;
						while (i != -1)
						{
							if (connectnum[i] != otherconnectnum)
								tempbuf[j++] = connectnum[i];
							i = connectpoint2[i];
						}
						tempbuf[j++] = connectindex[otherconnectnum];
						sendpacket(otherconnectnum,tempbuf,j);
					}
				}
				return;
			case 1:  //[1][connectnum][connectnum]...(Packet type 0 response)
				if (option[4] < 5)
				{
					myconnectnum = 1;
					myconnectindex = 1;
					masterconnectnum = 0;
					numplayers = 2;
				}
				else if (option[4] == 5)
				{
					for(i=1;i<tempbufleng-1;i++)
						netinitconnection(tempbuf[i]);
					myconnectindex = tempbuf[tempbufleng-1];
					masterconnectnum = otherconnectnum;
				}
				return;
			case 2:  //[2] (receive master sync buffer)
				synctics = getshort((long)(&tempbuf[1]));
				j = 3;
				i = connecthead;
				while (i != -1)
				{
					syncvel[i] = getshort((long)(&tempbuf[j+0]));
					syncsvel[i] = getshort((long)(&tempbuf[j+2]));
					syncangvel[i] = getshort((long)(&tempbuf[j+4]));
					syncbits[i] = getshort((long)(&tempbuf[j+6]));
					j += 8;

					i = connectpoint2[i];
				}

				movethings();        //Move all players and sprites

				break;
			case 3:  //[3] (receive slave sync buffer)
				otherconnectindex = connectindex[otherconnectnum];
				syncvel[otherconnectindex] = getshort((long)(&tempbuf[1]));
				syncsvel[otherconnectindex] = getshort((long)(&tempbuf[3]));
				syncangvel[otherconnectindex] = getshort((long)(&tempbuf[5]));
				syncbits[otherconnectindex] = getshort((long)(&tempbuf[7]));
				break;
			case 255:  //[255] (logout)
				keystatus[1] = 1;
				netuninitconnection(otherconnectnum);
				break;
		}
	}
	if (tempbufleng < 0)
	{
		printf("%ld\n",comerror);
		keystatus[1] = 1;
	}
}

sndvol(long xplc, long yplc)
{
	long sqrdist;

	sqrdist = (posx[screenpeek]-xplc)*(posx[screenpeek]-xplc);
	sqrdist += (posy[screenpeek]-yplc)*(posy[screenpeek]-yplc);
	if (sqrdist < 2097152)
		return(255);
	else
		return(1023 / ((sqrdist>>21)+4));
}

initplayersprites()
{
	short i;

	i = connecthead;
	while (i != -1)
	{
		playersprite[i] = insertsprite(cursectnum[i],0);

		sprite[playersprite[i]].x = posx[i];
		sprite[playersprite[i]].y = posy[i];
		sprite[playersprite[i]].z = posz[i]+(32<<8);
		sprite[playersprite[i]].cstat = 1;            //Hitscan should hit opponent
		sprite[playersprite[i]].picnum = DOOMGUY;
		sprite[playersprite[i]].shade = 0;
		sprite[playersprite[i]].xrepeat = 64;
		sprite[playersprite[i]].yrepeat = 64;
		sprite[playersprite[i]].ang = ang[i];
		sprite[playersprite[i]].xvel = 0;
		sprite[playersprite[i]].yvel = 0;
		sprite[playersprite[i]].zvel = 0;
		sprite[playersprite[i]].owner = i+4096;
		sprite[playersprite[i]].tag = 0L;

		i = connectpoint2[i];
	}
}
