// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#define numwalls 16

static int jmptable[10], numlines;
static unsigned pic, walseg[numwalls+1], pageoffset, lastpageoffset;
static unsigned times90[256], less64inc[64], scrsize;
static long posx, posy, vel, svel, hvel, angvel;
static long xa1[512], ya1[512], xa2[512], ya2[512];
static long xb1[512], yb1[512], xb2[512], yb2[512];
static int lastx[240], picnum[512], clockspeed, numframes;
static int vidmode, xdim, ydim, halfwidth, halfheight;
static unsigned char ztop[512], zsiz[512], xr1[512];
static unsigned char xr2[512], yr[512], attr[512];
static long sintable[2048], tantable[1024], totalclock;
static unsigned char tempbuf[4096], palette[768];
static int height[384], linum[384], walnum[384], ang, dside, minheight;
static int kind[384];
static unsigned char readch, oldreadch, keystatus[256], extended;
static unsigned char paldef[16][3] =
{
	0,30,63,28,34,60,0,50,20,41,52,28,63,63,25,63,63,63,63,20,20,63,0,63,
	63,48,27,63,40,25,63,48,48,45,63,45,55,55,63,63,40,63,63,30,20,55,25,30
};
void interrupt far ksmhandler(void);
void (interrupt far *oldhand)();
void interrupt far keyhandler(void);
void (interrupt far *oldkeyhandler)();


main(int argc,char **argv)
{
	unsigned l;
	long templong, templong1, templong2, xp1, yp1, xp2, yp2;
	int i, j, k, linesatonce, posz, mousx, mousy, angle, good;

	vidmode = 0;
	xdim = 320;
	ydim = 200;
	scrsize = 18000;
	if (argc == 2)
		if (atoi(argv[1]) < 0)
		{
			vidmode = 1;
			xdim = 360;
			ydim = 240;
			scrsize = 21600;
		}
	if ((pic = convallocate(numwalls*256)) == -1)
	{
		printf("Allocation failed!");
		exit(-1);
	}
	l = pic;
	for(i=0;i<numwalls;i++)
	{
		walseg[i] = l;
		l += 256;
	}
	pageoffset = 0;
	lastpageoffset = 0;
	dside = ydim;
	halfwidth = (xdim>>1);
	halfheight = (ydim>>1);
	loadtables();
	l = 0;
	for(i=0;i<240;i++)
	{
		times90[i] = l;
		l += 90;
	}
	less64inc[0] = 16384;
	for(i=1;i<64;i++)
		less64inc[i] = 16384 / i;
	_asm \
	{
		mov ax, 0
		int 0x33

		mov ax, 0x13
		int 0x10
	}
	if (vidmode == 1)
		setmode360240();
	for(i=0;i<256;i++)
		keystatus[i] = 0;
	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();
	numframes = 0;
	clockspeed = 0;
	totalclock = 0;
	outp(0x43,54); outp(0x40,4972&255); outp(0x40,4972>>8);
	oldhand = _dos_getvect(0x8);
	_disable(); _dos_setvect(0x8, ksmhandler); _enable();
	k = 0;
	for(i=0;i<16;i++)
		for(j=1;j<17;j++)
		{
			palette[k++] = (paldef[i][0]*j)/17;
			palette[k++] = (paldef[i][1]*j)/17;
			palette[k++] = (paldef[i][2]*j)/17;
		}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	outp(0x3d4,0x17); outp(0x3d5, inp(0x3d5)|64);      //WORD MODE
	outp(0x3d4,0x14); outp(0x3d5, inp(0x3d5)&191);     //2-WORD MODE
	outp(0x3c4,0x4); outp(0x3c5, inp(0x3c5)&247);      //CHAIN 4 OFF
	outp(0x3d4,0x13); outp(0x3d5, 45);                 //Bytes per line
	loadpics();
	loadboard();
	posz = 32;
	while (keystatus[1] == 0)
	{
		for(i=0;i<numlines;i++)
		{
			j = 0;
			if ((((ang+1792)&2047) < 512) && (ya1[i] < posy) && (ya2[i] < posy)) j = 1;
			if ((((ang+1280)&2047) < 512) && (xa1[i] > posx) && (xa2[i] > posx)) j = 1;
			if ((((ang+768)&2047) < 512) && (ya1[i] > posy) && (ya2[i] > posy)) j = 1;
			if ((((ang+256)&2047) < 512) && (xa1[i] < posx) && (xa2[i] < posx)) j = 1;
			yb1[i] = -1;
			yb2[i] = -1;
			if (j == 0)
			{
				xp1 = (((xa1[i]-posx)*sintable[(2048+ang)&2047]-(ya1[i]-posy)*sintable[(2560+ang)&2047])>>4);
				yp1 = (((xa1[i]-posx)*sintable[(2560+ang)&2047]+(ya1[i]-posy)*sintable[(2048+ang)&2047])>>4);
				xp2 = (((xa2[i]-posx)*sintable[(2048+ang)&2047]-(ya2[i]-posy)*sintable[(2560+ang)&2047])>>4);
				yp2 = (((xa2[i]-posx)*sintable[(2560+ang)&2047]+(ya2[i]-posy)*sintable[(2048+ang)&2047])>>4);
				if (xp1 > xp2)
				{
					templong = xp1;
					xp1 = xp2;
					xp2 = templong;
					templong = yp1;
					yp1 = yp2;
					yp2 = templong;
				}
				good = 7;
				if ((labs(xp1) <= yp1) && (yp1 > 0)) good--;
				if ((labs(xp2) <= yp2) && (yp2 > 0)) good-=2;
				if ((good == 7) && (yp1 > 0) && (yp2 > 0) && ((xp1 < 0) == (0 < xp2)))
					good = 3;
				if (good < 7)
				{
					if ((good&1) > 0)
					{
						if (xp1 < 0)
						{
							xb1[i] = (long)(xdim-1);
							templong = ((xp2>>12)*(yp1>>12)-(xp1>>12)*(yp2>>12));
							if (templong != 0)
								yb1[i] = ((yp2-yp1+xp2-xp1)<<6)/templong;
						}
						else
						{
							xb1[i] = -1L;
							templong = ((xp1>>12)*(yp2>>12)-(xp2>>12)*(yp1>>12));
							if (templong != 0)
								yb1[i] = ((yp2-yp1+xp1-xp2)<<6)/templong;
						}
					}
					else
					{
						xb1[i] = ((long)halfwidth)-((xp1*((long)halfwidth))/yp1);
						yb1[i] = (256L*4194304L)/yp1;
					}
					if ((good&2) > 0)
					{
						if (xp2 < 0)
						{
							xb2[i] = (long)(xdim-1);
							templong = ((xp2>>12)*(yp1>>12)-(xp1>>12)*(yp2>>12));
							if (templong != 0)
								yb2[i] = ((yp2-yp1+xp2-xp1)<<6)/templong;
						}
						else
						{
							xb2[i] = -1L;
							templong = ((xp1>>12)*(yp2>>12)-(xp2>>12)*(yp1>>12));
							if (templong != 0)
								yb2[i] = ((yp2-yp1+xp1-xp2)<<6)/templong;
						}
					}
					else
					{
						xb2[i] = ((long)halfwidth)-((xp2*((long)halfwidth))/yp2);
						yb2[i] = (256L*4194304L)/yp2;
					}
				}
			}
		}
		for(i=0;i<=xdim;i++)
			kind[i] = -1;
		if (vidmode == 0)
		{
			for(i=0;i<=xdim;i+=64)
				raytrace((long)i);
			for(j=32;j>=1;j>>=1)
				for(i=j;i<=xdim;i+=(j<<1))
				{
					if (kind[i-j] == kind[i+j] && ((height[i-j]|height[i+j]) > 0))
					{
						height[i] = (height[i-j] + height[i+j])>>1;
						linum[i] = ((((long)linum[i-j])*((long)height[i-j])) + (((long)linum[i+j])*((long)height[i+j])))/(labs(((long)height[i-j])+((long)height[i+j])));
						walnum[i] = walnum[i-j];
						kind[i] = kind[i-j];
					}
					else
						raytrace((long)i);
				}
		}
		else
		{
			for(i=0;i<=360;i+=8)
				raytrace((long)i);
			for(j=4;j>=1;j>>=1)
				for(i=j;i<=360;i+=(j<<1))
				{
					if (kind[i-j] == kind[i+j] && ((height[i-j]|height[i+j]) > 0))
					{
						height[i] = (height[i-j] + height[i+j])>>1;
						linum[i] = ((((long)linum[i-j])*((long)height[i-j])) + (((long)linum[i+j])*((long)height[i+j])))/(labs(((long)height[i-j])+((long)height[i+j])));
						walnum[i] = walnum[i-j];
						kind[i] = kind[i-j];
					}
					else
						raytrace((long)i);
				}
		}
		minheight = 32767;
		for(i=0;i<xdim;i++)
			if (height[i] < minheight)
				minheight = height[i];
		outp(0x3c4,2); outp(0x3c5,15);
		j = halfheight-((minheight*posz)>>6);
		for(i=1;i<=halfheight;i++)
			if ((halfheight-i) <= j)
			{
				templong = (256L*((long)posz))/((long)i);
				templong1 = templong*sintable[(2048+ang)&2047];
				templong2 = templong*sintable[(2560+ang)&2047];
				yp2 = ((templong1+templong2)>>11);
				yp1 = ((templong1-templong2)>>11);
				hline(0,xdim-1,halfheight-i,2,-yp2-posx,yp1+posy,yp1-posx,yp2+posy,(char)0);    //shadecoffs = (char)(4-(templong>>7))
			}
		for(i=1;i<=halfheight;i++)
			if ((halfheight-1+i) >= j+minheight)
			{
				templong = (256L*(63-(long)posz))/((long)i);
				templong1 = templong*sintable[(2048+ang)&2047];
				templong2 = templong*sintable[(2560+ang)&2047];
				yp2 = ((templong1+templong2)>>11);
				yp1 = ((templong1-templong2)>>11);
				hline(0,xdim-1,halfheight-1+i,1,-yp2-posx,yp1+posy,yp1-posx,yp2+posy,(char)0);    //shadecoffs = (char)(4-(templong>>7))
			}
		_asm \
		{
			mov dx, 0x3c4
			mov al, 0x2
			out dx, al
		}
		for(i=0;i<xdim;i++)
			linum[i] &= 0xfc0;
		for(i=0;i<xdim;i++)
		{
			_asm \
			{
				mov dx, 0x3c5
				mov cl, i
				and cl, 3
				mov al, 1
				shl al, cl
				out dx, al
			}
			linesatonce = 0;
			if (((i&3) < 3) && (kind[i] == kind[i+1]) && (linum[i] == linum[i+1]))
			{
				_asm \
				{
					mov dx, 0x3c5
					mov cl, i
					and cl, 3
					mov al, 3
					shl al, cl
					out dx, al
				}
				linesatonce = 1;
				if (((i&3) < 2) && (kind[i] == kind[i+2]) && (linum[i] == linum[i+2]))
				{
					_asm \
					{
						mov dx, 0x3c5
						mov cl, i
						and cl, 3
						mov al, 7
						shl al, cl
						out dx, al
					}
					linesatonce = 2;
					if (((i&3) == 0) && (kind[i] == kind[i+3]) && (linum[i] == linum[i+3]))
					{
						_asm \
						{
							mov dx, 0x3c5
							mov al, 15
							out dx, al
						}
						linesatonce = 3;
					}
				}
			}
			vline(i,halfheight-((height[i]*posz)>>6),height[i],walnum[i],linum[i]);
			i += linesatonce;
		}
		lastpageoffset = pageoffset;
		outp(0x3d4,0xc); outp(0x3d5,lastpageoffset>>8);
		outp(0x3d4,0xd); outp(0x3d5,lastpageoffset&255);
		if (lastpageoffset < 21600) pageoffset = 21600;
		if (lastpageoffset == 21600) pageoffset = 43200;
		if (lastpageoffset > 21600) pageoffset = 0;
		vel = 0;
		svel = 0;
		hvel = 0;
		angvel = 0;
		_asm \
		{
			mov ax, 11
			int 0x33
			sar cx, 1
			sar dx, 1
			mov mousx, cx
			mov mousy, dx
		}
		vel = -mousy;
		if (mousx != 0) angvel = mousx;
		if (keystatus[0x9d] == 0)
		{
			if (keystatus[0xcb] > 0) angvel -= 16;
			if (keystatus[0xcd] > 0) angvel += 16;
		}
		else
		{
			if (keystatus[0xcb] > 0) svel += 8;
			if (keystatus[0xcd] > 0) svel -= 8;
		}
		if (keystatus[0x1e] > 0) hvel -= 8;
		if (keystatus[0x2c] > 0) hvel += 8;
		if (keystatus[0xc8] > 0) vel += 8;
		if (keystatus[0xd0] > 0) vel -= 8;
		if (keystatus[0x2a] > 0)
		{
			vel += vel;
			svel += svel;
		}
		if (keystatus[0x19] > 0)
		{
			keystatus[0x19] = 0;
			while ((keystatus[0x19] == 0) && (keystatus[1] == 0));
			keystatus[0x19] = 0;
		}
		if (angvel != 0)
		{
			ang += ((angvel*clockspeed)>>3);
			ang = (ang+2048)&2047;
		}
		if (vel != 0)
		{
			posx += (int)((((long)vel)*((long)clockspeed)*sintable[(2560+ang)&2047])>>15);
			posy += (int)((((long)vel)*((long)clockspeed)*sintable[(2048+ang)&2047])>>15);
		}
		if (svel != 0)
		{
			posx += (int)((((long)svel)*((long)clockspeed)*sintable[(2048+ang)&2047])>>15);
			posy -= (int)((((long)svel)*((long)clockspeed)*sintable[(2560+ang)&2047])>>15);
		}
		if (hvel != 0)
		{
			posz += ((hvel*clockspeed)>>6);
			if (posz < 4) posz = 4;
			if (posz > 60) posz = 60;
		}
		numframes++;
		totalclock += ((long)clockspeed);
		clockspeed = 0;
	}
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	_disable(); _dos_setvect(0x8, oldhand); _enable();
	_disable(); _dos_setvect(0x9, oldkeyhandler); _enable();
	convdeallocate(pic);
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	if (totalclock != 0)
	{
		templong = (numframes*24000L)/totalclock;
		printf("%d.%1d%1d frames per second\n",(int)(templong/100),(int)((templong/10)%10),(int)(templong%10));
	}
}

raytrace(count)
long count;
{
	long x, y, x2, y2, closey;
	int i, closei;

	closey = 0;
	closei = -1;
	for(i=0;i<numlines;i++)
		if ((yb1[i]|yb2[i]) > 0)
			if (((count-xb1[i]) <= 0) != ((count-xb2[i]) <= 0))
				if (xb1[i] != xb2[i])
				{
					y = (count-xb1[i]) * (yb2[i]-yb1[i]);
					y = (y / (xb2[i]-xb1[i])) + yb1[i];
					if (y > closey)
						closey = y, closei = i;
				}
	height[count] = 0;
	if ((closei >= 0) && (closey > 0))
	{
		if ((closey&0xffff8000) == 0)
			height[count] = (((int)closey)>>3);
		kind[count] = closei;
		walnum[count] = picnum[closei];
		y = (2097152L/closey);
		if (vidmode == 0)
			x = ((((long)halfwidth)-count)<<16)/(closey*5);
		else
			x = ((((long)halfwidth)-count)<<19)/(closey*45);
		x2 = posx-((x*sintable[(2048-ang)&2047] - y*sintable[(2560-ang)&2047])>>15);
		y2 = posy-((x*sintable[(2560-ang)&2047] + y*sintable[(2048-ang)&2047])>>15);
		if (labs(xa1[closei]-xa2[closei]) >= labs(ya1[closei]-ya2[closei]))
		{
			if ((xa1[closei]>=x2) == (x2<=xa2[closei]))
			{
				if (labs(xa1[closei]-x2) < labs(x2-xa2[closei]))
					x2 = xa1[closei];
				else
					x2 = xa2[closei];
			}
			linum[count] = (int)(((labs(xa1[closei]-x2))<<12)/labs(xa2[closei]-xa1[closei]));
		}
		else
		{
			if ((ya1[closei]>=y2) == (y2<=ya2[closei]))
			{
				if (labs(ya1[closei]-y2) < labs(y2-ya2[closei]))
					y2 = ya1[closei];
				else
					y2 = ya2[closei];
			}
			linum[count] = (int)(((labs(ya1[closei]-y2))<<12)/labs(ya2[closei]-ya1[closei]));
		}
	}
}

vline(x, y, siz, walnume, picplc)
int x, y, siz, walnume, picplc;
{
	unsigned int picseg, plc;

	if ((siz < 1) || (siz > 4096) || (y > dside) || (y+siz < 0))
		return(0);
	picseg = walseg[walnume];
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov bx, y
		or bx, bx
		jns notovertop
		xor bx, bx
notovertop:
		shl bx, 1
		mov ax, times90[bx]
		mov bx, x
		shr bx, 1
		shr bx, 1
		add ax, bx
		add ax, pageoffset
		mov plc, ax
	}
	if (siz < 64)
	{
		_asm \
		{
			mov bx, siz
			shl bx, 1
			mov cx, less64inc[bx]
			mov si, picplc
			mov dx, cx
			shr dx, 1
			xor bh, bh
			mov di, plc
			push ds
			mov ds, picseg
startspri1:
			mov bl, dh
			mov al, ds:[si+bx]
			cmp al, 255
			jb skipitspri1
			add di, 90
			add dx, cx
			cmp dh, 63
			jbe startspri1
			jmp enditspri1
skipitspri1:
			mov es:[di], al
			add di, 90
			add dx, cx
			cmp dh, 63
			jbe startspri1
enditspri1:
			pop ds
		}
		return(0);
	}
	if (y < 0)
	{
		_asm \
		{
			mov ax, y
			neg ax
			mov cl, 6
			rol ax, cl
			mov dx, ax
			and al, 0xc0
			and dx, 0x0f
			mov cx, siz
			div cx
			add picplc, ax           ;ax is dividend
			sub dx, siz              ;dx is remainder
			neg dx

			mov di, x
			shr di, 1
			shr di, 1
			add di, pageoffset
			push ds
			mov ds, picseg
			mov si, picplc           ;remember dx is (siz - remainder)
			lodsb
prespridraw:
			cmp al, 255
			je prespriskip
			mov es:[di], al
prespriskip:
			add di, 90
			sub dx, 64
			jns prespridraw
			pop ds
			mov plc, di
			mov picplc, si
		}
	}
	if (y+siz < dside)
	{
		_asm \
		{
			mov word ptr jmptable[2], offset begless128a
			mov word ptr jmptable[4], offset begless192a
			mov word ptr jmptable[6], offset begless256a
			mov word ptr jmptable[8], offset begmore256a
			mov bx, siz
			mov cl, 6
			shr bx, cl
			cmp bx, 4
			jge dontjumpmorethan256
			shl bx, 1
			cmp bx, 8
			jmp jmptable[bx]
dontjumpmorethan256:
			jmp begmore256a
begless128a:
			mov si, picplc
			mov cx, si
			and cx, 0x0fc0
			add cx, 65
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri2:
			lodsw
			cmp si, cx
			jae skipspri2d
startspri2a:
			cmp ax, 0xffff
			je skipspri2e
			xor dh, dh
			add dx, bx
			cmp dh, 3
			je startspri2b
			ja startspri2c
			add di, 180
			cmp al, 255
			je skipspri2a
			mov es:[di-180], al
			cmp ah, 255
			je startspri2
skipspri2a:
			mov es:[di-90], ah
			jmp startspri2
skipspri2d:
			mov ah, 255
			je startspri2a
			jmp enditspri2
startspri2b:
			add di, 270
			cmp al, 255
			je skipspri2b
			mov es:[di-270], al
			mov es:[di-180], al
			cmp ah, 255
			je startspri2
skipspri2b:
			mov es:[di-90], ah
			jmp startspri2
startspri2c:
			add di, 360
			cmp al, 255
			je skipspri2c
			mov es:[di-360], al
			mov es:[di-270], al
			cmp ah, 255
			je startspri2
skipspri2c:
			mov es:[di-180], ah
			mov es:[di-90], ah
			jmp startspri2
skipspri2e:
			xor dh, dh
			add dx, bx
			cmp dh, 3
			je skipspri2f
			ja skipspri2g
			add di, 180
			jmp startspri2
skipspri2f:
			add di, 270
			jmp startspri2
skipspri2g:
			add di, 360
			jmp startspri2
enditspri2:
			pop ds
			jmp returnit
begless192a:
			mov si, picplc
			mov cx, si
			and cx, 0x0fc0
			add cx, 65
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri3:
			lodsw
			cmp si, cx
			jae skipspri3g
startspri3a:
			xor dh, dh
			add dx, bx
			cmp dh, 5
			je startspri3b
			ja startspri3c
			cmp al, 255
			je skipspri3a
			mov es:[di], al
			mov es:[di+90], al
skipspri3a:
			cmp ah, 255
			je skipspri3b
			mov es:[di+180], ah
			mov es:[di+270], ah
skipspri3b:
			add di, 360
			jmp startspri3
startspri3b:
			cmp al, 255
			je skipspri3c
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri3c:
			cmp ah, 255
			je skipspri3d
			mov es:[di+270], ah
			mov es:[di+360], ah
skipspri3d:
			add di, 450
			jmp startspri3
startspri3c:
			cmp al, 255
			je skipspri3e
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri3e:
			cmp ah, 255
			je skipspri3f
			mov es:[di+270], ah
			mov es:[di+360], ah
			mov es:[di+450], ah
skipspri3f:
			add di, 540
			jmp startspri3
skipspri3g:
			mov ah, 255
			jne enditspri3
			jmp startspri3a
enditspri3:
			pop ds
			jmp returnit
begless256a:
			mov si, picplc
			mov cx, si
			and cx, 0x0fc0
			add cx, 65
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri4:
			lodsw
			cmp si, cx
			jae skipspri4g
startspri4a:
			xor dh, dh
			add dx, bx
			cmp dh, 7
			je startspri4b
			ja startspri4c
			cmp al, 255
			je skipspri4a
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri4a:
			cmp ah, 255
			je skipspri4b
			mov es:[di+270], ah
			mov es:[di+360], ah
			mov es:[di+450], ah
skipspri4b:
			add di, 540
			jmp startspri4
skipspri4g:
			mov ah, 255
			jne enditspri4
			jmp startspri4a
startspri4b:
			cmp al, 255
			je skipspri4c
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
			mov es:[di+270], al
skipspri4c:
			cmp ah, 255
			je skipspri4d
			mov es:[di+360], ah
			mov es:[di+450], ah
			mov es:[di+540], ah
skipspri4d:
			add di, 630
			jmp startspri4
startspri4c:
			cmp al, 255
			je skipspri4e
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
			mov es:[di+270], al
skipspri4e:
			cmp ah, 255
			je skipspri4f
			mov es:[di+360], ah
			mov es:[di+450], ah
			mov es:[di+540], ah
			mov es:[di+630], ah
skipspri4f:
			add di, 720
			jmp startspri4
enditspri4:
			pop ds
			jmp returnit
begmore256a:
			mov di, plc
			mov si, picplc
			mov cx, si
			and cx, 0x0fc0
			add cx, 64
			mov bx, siz
			mov dx, bx
			dec dx
			push ds
			mov ds, picseg
			lodsb
startspri5:
			cmp al, 255
			je skipspri5a
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
			mov es:[di+270], al
skipspri5a:
			add di, 360
			sub dx, 256
			js startspri5c
			or dh, dh
			jnz startspri5
startspri5b:
			cmp al, 255
			je skipspri5b
			mov es:[di], al
skipspri5b:
			add di, 90
			sub dx, 64
			jns startspri5b
startspri5c:
			lodsb
			add dx, bx
			cmp si, cx
			jbe startspri5
			pop ds
returnit:
		}
		return(0);
	}
	if (siz < 128)
	{
		_asm \
		{
			mov si, picplc
			mov cx, pageoffset
			add cx, scrsize
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri6:
			lodsw
			cmp di, cx
			jae skipspri6d
startspri6a:
			cmp ax, 0xffff
			je skipspri6e
			xor dh, dh
			add dx, bx
			cmp dh, 3
			je startspri6b
			ja startspri6c
			add di, 180
			cmp al, 255
			je skipspri6a
			mov es:[di-180], al
			cmp ah, 255
			je startspri6
skipspri6a:
			mov es:[di-90], ah
			jmp startspri6
skipspri6d:
			mov ah, 255
			je startspri6a
			jmp enditspri6
startspri6b:
			add di, 270
			cmp al, 255
			je skipspri6b
			mov es:[di-270], al
			mov es:[di-180], al
			cmp ah, 255
			je startspri6
skipspri6b:
			mov es:[di-90], ah
			jmp startspri6
startspri6c:
			add di, 360
			cmp al, 255
			je skipspri6c
			mov es:[di-360], al
			mov es:[di-270], al
			cmp ah, 255
			je startspri6
skipspri6c:
			mov es:[di-180], ah
			mov es:[di-90], ah
			jmp startspri6
skipspri6e:
			xor dh, dh
			add dx, bx
			cmp dh, 3
			je skipspri6f
			ja skipspri6g
			add di, 180
			jmp startspri6
skipspri6f:
			add di, 270
			jmp startspri6
skipspri6g:
			add di, 360
			jmp startspri6
enditspri6:
			pop ds
		}
		return(0);
	}
	if (siz < 192)
	{
		_asm \
		{
			mov si, picplc
			mov cx, pageoffset
			add cx, scrsize
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri7:
			lodsw
			cmp di, cx
			jae skipspri7g
startspri7a:
			xor dh, dh
			add dx, bx
			cmp dh, 5
			je startspri7b
			ja startspri7c
			cmp al, 255
			je skipspri7a
			mov es:[di], al
			mov es:[di+90], al
skipspri7a:
			cmp ah, 255
			je skipspri7b
			mov es:[di+180], ah
			mov es:[di+270], ah
skipspri7b:
			add di, 360
			jmp startspri7
startspri7b:
			cmp al, 255
			je skipspri7c
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri7c:
			cmp ah, 255
			je skipspri7d
			mov es:[di+270], ah
			mov es:[di+360], ah
skipspri7d:
			add di, 450
			jmp startspri7
startspri7c:
			cmp al, 255
			je skipspri7e
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri7e:
			cmp ah, 255
			je skipspri7f
			mov es:[di+270], ah
			mov es:[di+360], ah
			mov es:[di+450], ah
skipspri7f:
			add di, 540
			jmp startspri7
skipspri7g:
			mov ah, 255
			jae enditspri7
			jmp startspri7a
enditspri7:
			pop ds
		}
		return(0);
	}
	if (siz < 256)
	{
		_asm \
		{
			mov si, picplc
			mov cx, pageoffset
			add cx, scrsize
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri8:
			lodsw
			cmp di, cx
			jae skipspri8g
startspri8a:
			xor dh, dh
			add dx, bx
			cmp dh, 7
			je startspri8b
			ja startspri8c
			cmp al, 255
			je skipspri8a
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri8a:
			cmp ah, 255
			je skipspri8b
			mov es:[di+270], ah
			mov es:[di+360], ah
			mov es:[di+450], ah
skipspri8b:
			add di, 540
			jmp startspri8
skipspri8g:
			mov ah, 255
			jae enditspri8
			jmp startspri8a
startspri8b:
			cmp al, 255
			je skipspri8c
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
			mov es:[di+270], al
skipspri8c:
			cmp ah, 255
			je skipspri8d
			mov es:[di+360], ah
			mov es:[di+450], ah
			mov es:[di+540], ah
skipspri8d:
			add di, 630
			jmp startspri8
startspri8c:
			cmp al, 255
			je skipspri8e
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
			mov es:[di+270], al
skipspri8e:
			cmp ah, 255
			je skipspri8f
			mov es:[di+360], ah
			mov es:[di+450], ah
			mov es:[di+540], ah
			mov es:[di+630], ah
skipspri8f:
			add di, 720
			jmp startspri8
enditspri8:
			pop ds
		}
		return(0);
	}
	_asm \
	{
		mov di, plc
		mov si, picplc
		mov cx, pageoffset
		add cx, scrsize
		mov bx, siz
		mov dx, bx
		dec dx
		push ds
		mov ds, picseg
		lodsb
		cmp al, 255
		je startspri9d
startspri9:
		mov es:[di], al
		mov es:[di+90], al
		mov es:[di+180], al
		mov es:[di+270], al
		add di, 360
		cmp di, cx
		jae enditspri9
		sub dx, 256
		js startspri9c
		cmp dh, 0
		jg startspri9
startspri9b:
		mov es:[di], al
		add di, 90
		sub dx, 64
		jns startspri9b
startspri9c:
		lodsb
		add dx, bx
		cmp al, 255
		jne startspri9
startspri9d:
		add di, 360
		cmp di, cx
		jae enditspri9
		sub dx, 256
		js startspri9c
		cmp dh, 0
		jg startspri9d
startspri9e:
		add di, 90
		sub dx, 64
		jns startspri9e
		jmp startspri9c
enditspri9:
		pop ds
	}
}

convallocate(numparagraphs)
unsigned numparagraphs;
{
	unsigned segnum;

	_asm \
	{
		mov ah, 0x48
		mov bx, numparagraphs
		int 0x21
		mov segnum, ax
		jnc allocated
		mov segnum, -1
allocated:
	}
	return(segnum);
}

convdeallocate(segnum)
unsigned segnum;
{
	_asm \
	{
		mov ah, 0x49
		mov es, segnum
		int 0x21
		mov segnum, 0
		jnc deallocated
		mov segnum, -1
deallocated:
	}
	return(segnum);
}

void interrupt far keyhandler()
{
	oldreadch = readch;
	_asm \
	{
		in al, 0x60
		mov readch, al
		in al, 0x61
		or al, 0x80
		out 0x61, al
		and al, 0x7f
		out 0x61, al
	}
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
			keystatus[(readch&127)+extended] = ((readch>>7)^1);
		extended = 0;
	}
	_asm \
	{
		mov al, 0x20
		out 0x20, al
	}
}

loadtables()
{
	int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&tempbuf[0],4096);
		read(fil,&tantable[0],4096);
		close(fil);
	}
	_asm \
	{
		mov cx, 2048
		xor bx, bx
		xor si, si
convsintable:
		mov ax, word ptr tempbuf[bx]
		cwd
		mov word ptr sintable[si+0], ax
		mov word ptr sintable[si+2], dx
		add bx, 2
		add si, 4
		loop convsintable
	}
}

loadboard()
{
	int fil, i;

	if ((fil = open("boards.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&i,2), posx = (((long)i)<<5);
		read(fil,&i,2), posy = (((long)i)<<5);
		read(fil,&ang,2);
		read(fil,&numlines,2);
		read(fil,&picnum[0],numlines<<1);
		for(i=0;i<numlines;i++)
			xa1[i] = (((long)picnum[i])<<5);
		read(fil,&picnum[0],numlines<<1);
		for(i=0;i<numlines;i++)
			ya1[i] = (((long)picnum[i])<<5);
		read(fil,&picnum[0],numlines<<1);
		for(i=0;i<numlines;i++)
			xa2[i] = (((long)picnum[i])<<5);
		read(fil,&picnum[0],numlines<<1);
		for(i=0;i<numlines;i++)
			ya2[i] = (((long)picnum[i])<<5);
		read(fil,&picnum[0],numlines<<1);
		close(fil);
	}
}

hline(xl, xr, yp, walnume, xc1, yc1, xc2, yc2, shadecoffs)
unsigned xl, xr, yp;
int walnume;
long xc1, yc1, xc2, yc2;
unsigned char shadecoffs;
{
	int i, siz, picplc, tempint;
	unsigned p, x, y, xc, yc;
	long templong;

	if (xl == xr)
		return(-1);
	if (xl > xr)
	{
		tempint = xl, xl = xr, xr = tempint;
		templong = xc1, xc1 = xc2, xc2 = templong;
		templong = yc1, yc1 = yc2, yc2 = templong;
	}
	siz = xr-xl+1;
	if (siz <= 0)
		return(-1);
	p = times90[yp]+(xl>>2)+pageoffset;
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
	}
	xc = ((xc2-xc1)<<8)/siz;
	yc = ((yc2-yc1)<<8)/siz;
	x = ((((unsigned)xc1)&0x3ff)<<6);
	y = ((((unsigned)yc1)&0x3ff)<<6);
	_asm \
	{
		cld

		mov dx, 0x3c4
		mov al, 0x2
		out dx, al
		inc dx
		mov al, 0x3
		out dx, al

		mov cx, siz
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov bx, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1a+2], ax
		mov ax, yc
		mov word ptr cs:[mach2a+2], ax
		mov al, shadecoffs
		mov byte ptr cs:[mach3a+1], al
		mov si, walnume
		shl si, 1
		push ds
		mov ds, word ptr walseg[si]
begindrawa:
mach1a:add bx, 0x1234
mach2a:add dx, 0x1234
		mov ah, bh
		mov al, dh
		shr ah, cl
		shr ax, cl
		mov si, ax
		lodsb
mach3a:add al, 0x12
		stosb
		sub ch, 2
		jnz begindrawa
		pop ds

		mov dx, 0x3c5
		mov al, 0xc
		out dx, al

		mov cx, siz
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov bx, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1b+2], ax
		sar ax, 1
		add bx, ax
		mov ax, yc
		mov word ptr cs:[mach2b+2], ax
		sar ax, 1
		add dx, ax
		mov al, shadecoffs
		mov byte ptr cs:[mach3b+1], al
		mov si, walnume
		shl si, 1
		push ds
		mov ds, word ptr walseg[si]
begindrawb:
mach1b:add bx, 0x1234
mach2b:add dx, 0x1234
		mov ah, bh
		mov al, dh
		shr ah, cl
		shr ax, cl
		mov si, ax
		lodsb
mach3b:add al, 0x12
		stosb
		sub ch, 2
		jnz begindrawb
		pop ds
	}
	/*_asm \
	{
		mov dx, 0x3c5                          ;Higher precision
		mov al, 0x2
		out dx, al

		mov cx, siz
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov bx, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1c+2], ax
		sar ax, 1
		sar ax, 1
		add bx, ax
		mov ax, yc
		mov word ptr cs:[mach2c+2], ax
		sar ax, 1
		sar ax, 1
		add dx, ax
		mov al, shadecoffs
		mov byte ptr cs:[mach3c+1], al
		mov si, walnume
		shl si, 1
		push ds
		mov ds, word ptr walseg[si]
begindrawc:
mach1c:add bx, 0x1234
mach2c:add dx, 0x1234
		mov ah, bh
		mov al, dh
		shr ah, cl
		shr ax, cl
		mov si, ax
		lodsb
mach3c:add al, 0x12
		stosb
		sub ch, 2
		jnz begindrawc
		pop ds

		mov dx, 0x3c5
		mov al, 0x8
		out dx, al

		mov cx, siz
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov bx, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1d+2], ax
		sar ax, 1
		add bx, ax
		sar ax, 1
		add bx, ax
		mov ax, yc
		mov word ptr cs:[mach2d+2], ax
		sar ax, 1
		add dx, ax
		sar ax, 1
		add dx, ax
		mov al, shadecoffs
		mov byte ptr cs:[mach3d+1], al
		mov si, walnume
		shl si, 1
		push ds
		mov ds, word ptr walseg[si]
begindrawd:
mach1d:add bx, 0x1234
mach2d:add dx, 0x1234
		mov ah, bh
		mov al, dh
		shr ah, cl
		shr ax, cl
		mov si, ax
		lodsb
mach3d:add al, 0x12
		stosb
		sub ch, 2
		jnz begindrawd
		pop ds
	}*/
}

loadpics()
{
	int fil, i;

	if ((fil=open("pics.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		return(-1);
	read(fil,&tempbuf[0],1024);
	for(i=0;i<numwalls;i++)
	{
		read(fil,&tempbuf[0],4096);
		_asm \
		{
			cld
			mov cx, 2048
			mov bx, i
			shl bx, 1
			mov es, word ptr walseg[bx]
			xor di, di
			mov si, offset tempbuf
			mov ax, seg tempbuf
			push ds
			mov ds, ax
			rep movsw
			pop ds
		}
	}
	close(fil);
}

void interrupt far ksmhandler()
{
	clockspeed++;
	_asm \
	{
		mov al, 0x20
		out 0x20, al
	}
}

setmode360240()
{
	outp(0x3c4,0x4); outp(0x3c5,0x6);
	outp(0x3c4,0x0); outp(0x3c5,0x1);
	outp(0x3c2,0xe7);
	outp(0x3c4,0x0); outp(0x3c5,0x3);
	outp(0x3d4,0x11); outp(0x3d5,inp(0x3d5)&0x7f);      //Unlock indices 0-7
	outp(0x3d4,0x0); outp(0x3d5,0x6b);
	outp(0x3d4,0x1); outp(0x3d5,0x59);
	outp(0x3d4,0x2); outp(0x3d5,0x5a);
	outp(0x3d4,0x3); outp(0x3d5,0x8e);
	outp(0x3d4,0x4); outp(0x3d5,0x5e);
	outp(0x3d4,0x5); outp(0x3d5,0x8a);
	outp(0x3d4,0x6); outp(0x3d5,0xd);
	outp(0x3d4,0x7); outp(0x3d5,0x3e);
	outp(0x3d4,0x9); outp(0x3d5,0x41);
	outp(0x3d4,0x10); outp(0x3d5,0xea);
	outp(0x3d4,0x11); outp(0x3d5,0xac);
	outp(0x3d4,0x12); outp(0x3d5,0xdf);
	outp(0x3d4,0x13); outp(0x3d5,45);
	outp(0x3d4,0x14); outp(0x3d5,0x0);
	outp(0x3d4,0x15); outp(0x3d5,0xe7);
	outp(0x3d4,0x16); outp(0x3d5,0x6);
	outp(0x3d4,0x17); outp(0x3d5,0xe3);
}
