' "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
' Ken Silverman's official web site: "http://www.advsys.net/ken"
' See the included license file "BUILDLIC.TXT" for license info.

DECLARE SUB allocache (newhandle&, newbytes&, newlockptr&)
DECLARE SUB initcache (dacachestart&, dacachesize&)
DECLARE SUB uninitcache (lockstat&)

CONST MAXCACHEOBJECTS = 4096

DIM SHARED cachestart&, cachesize&, cacheplc&
DIM SHARED cachelistplc&, cachelistend&
DIM SHARED handleptr&(MAXCACHEOBJECTS), cacheleng&(MAXCACHEOBJECTS)
DIM SHARED cachelock&(MAXCACHEOBJECTS)
DIM SHARED cachecount&

cachestart& = 0: cachesize& = 0: cacheplc& = 0
cachelistplc& = 0: cachelistend& = 0: cachecount& = 0

SCREEN 12

DIM SHARED buf%(640)
CALL initcache(1, 640)

DO
   newbytes& = INT(80 * RND) + 20
   IF INT(16 * RND) = 0 THEN newlockptr& = 1 ELSE newlockptr& = 0
   CALL allocache(newhandle&, newbytes&, newlockptr&)
   z$ = INPUT$(1)
LOOP WHILE z$ <> CHR$(27)

SUB allocache (newhandle&, newbytes&, newlockptr&)
   IF (cachesize& < newbytes&) THEN
	 PRINT "Cachesize:"; cachesize&; "Newbytes:"; newbytes&; "Newhandle:"; newhandle&; "Newlockptr:"; newlockptr&
	 PRINT "BUFFER TOO BIG TO FIT IN CACHE!"
	 END
   END IF

   startcachelistplc& = cachelistplc&
   DO WHILE (cachelistplc& <> cachelistend&)
	 IF (cacheplc& + newbytes& > cachesize&) THEN
	    DO WHILE (cachelistplc& <> cachelistend&)
		  IF (handleptr&(cachelistplc&) - cachestart& < cacheplc&) THEN EXIT DO
		  cachelistplc& = ((cachelistplc& + 1) AND (MAXCACHEOBJECTS - 1))
	    LOOP
	    cacheplc& = 0
	 END IF
	 i& = handleptr&(cachelistplc&) - cachestart&
	 IF ((i& + cacheleng&(cachelistplc&) <= cacheplc&) OR (i& >= cacheplc& + newbytes&)) THEN EXIT DO
	 IF (cachelock&(cachelistplc&) <> 0) THEN cacheplc& = i& + cacheleng&(cachelistplc&)
	 cachelistplc& = ((cachelistplc& + 1) AND (MAXCACHEOBJECTS - 1))
   LOOP

	 'actually remove from cache here
   DO WHILE (startcachelistplc& <> cachelistplc&)
	 i& = handleptr&(startcachelistplc&) - cachestart&
	 IF ((i& + cacheleng&(startcachelistplc&) > cacheplc&) AND (i& < cacheplc& + newbytes&)) THEN
	    IF (cachelock&(startcachelistplc&) <> 0) THEN
		  PRINT "CACHE SPACE ALL LOCKED UP!"
		  END
	    END IF
	   
	    z& = startcachelistplc&
	    LINE (handleptr&(z&) - 1, 0)-(handleptr&(z&) + cacheleng&(z&) - 2, 31), 0, BF

	    handleptr&(startcachelistplc&) = 0
	 ELSE
	    handleptr&(cachelistend&) = handleptr&(startcachelistplc&)
	    cacheleng&(cachelistend&) = cacheleng&(startcachelistplc&)
	    cachelock&(cachelistend&) = cachelock&(startcachelistplc&)
	    cachelistend& = ((cachelistend& + 1) AND (MAXCACHEOBJECTS - 1))
	 END IF
	 startcachelistplc& = ((startcachelistplc& + 1) AND (MAXCACHEOBJECTS - 1))
   LOOP

   'handleptr&(cachelistend&) = newhandle&
   newhandle& = cachestart& + cacheplc&
   handleptr&(cachelistend&) = newhandle&

   cacheleng&(cachelistend&) = newbytes&
   cachelock&(cachelistend&) = newlockptr&
  
   z& = cachelistend&
   x1& = handleptr&(z&) - 1: x2& = handleptr&(z&) + cacheleng&(z&) - 2
   LINE (x1&, 0)-(x2&, 31), (cachecount& MOD 6) + 2, BF
   IF cachelock&(z&) <> 0 THEN
	 LINE (x1&, 0)-(x2&, 31), (cachecount& MOD 6) + 10
	 LINE (x1&, 31)-(x2&, 0), (cachecount& MOD 6) + 10
   END IF
   LINE (x1&, 0)-(x2&, 0), (cachecount& MOD 6) + 10
   LINE (x1&, 0)-(x1&, 31), (cachecount& MOD 6) + 10
   LINE (x2&, 0)-(x2&, 31), 8
   LINE (x1&, 31)-(x2&, 31), 8

   cachelistend& = ((cachelistend& + 1) AND (MAXCACHEOBJECTS - 1))

   cachecount& = cachecount& + 1
   cacheplc& = cacheplc& + newbytes&
END SUB

SUB initcache (dacachestart&, dacachesize&)
   CALL uninitcache(1)
   cachestart& = dacachestart&
   cachesize& = dacachesize&
   cacheplc& = 0
   cachelistplc& = 0
   cachelistend& = 0
END SUB

SUB uninitcache (lockstat&)  'lockstat: 0-don't free locked, 1-free all
		'Suck everything out of cache
   startcachelistend& = cachelistend&
   WHILE (cachelistplc& <> startcachelistend&)
	 IF ((cachelock&(cachelistplc&) = 0) OR (lockstat& <> 0)) THEN
	    handleptr&(cachelistplc&) = 0
	 ELSE
	    handleptr&(cachelistend&) = handleptr&(cachelistplc&)
	    cacheleng&(cachelistend&) = cacheleng&(cachelistplc&)
	    cachelock&(cachelistend&) = cachelock&(cachelistplc&)
	    cachelistend& = ((cachelistend& + 1) AND (MAXCACHEOBJECTS - 1))
	 END IF
	 cachelistplc& = ((cachelistplc& + 1) AND (MAXCACHEOBJECTS - 1))
   WEND
END SUB

