DECLARE FUNCTION insidebox% (x&, y&, fatclip%, wallnum%)
DECLARE FUNCTION intersect% (x1l1&, y1l1&, x2l1&, y2l1&, l%)
DECLARE SUB movesprite (z%)
DECLARE SUB drawlines ()
DECLARE SUB insertsprites (z%)
DECLARE SUB drawsprite (z%)
DECLARE FUNCTION inside% (x&, y&)
DECLARE SUB getlines ()
DECLARE SUB filllines ()
CONST xdim = 320, ydim = 200, maxwalls = 1024, maxsprites = 1024
COMMON SHARED numwalls%, numsprites%, firstsprite%, pag%, posx&, posy&

TYPE walltype
   x AS LONG
   y AS LONG
   point2 AS INTEGER
END TYPE

TYPE spritetype
   x AS LONG
   y AS LONG
   fatclip AS INTEGER
   point2 AS INTEGER
END TYPE

DIM SHARED wall(maxwalls) AS walltype
DIM SHARED sprite(maxsprites) AS spritetype

CALL getlines
'CALL filllines
CALL insertsprites(16)

posx& = 160: posy& = 100
DO
   LINE (0, 0)-(319, 199), 0, BF
   CALL drawlines
   j% = firstsprite%
   DO
      CALL movesprite(j%)
      CALL drawsprite(j%)
      j% = sprite(j%).point2
   LOOP WHILE j% <> -1
  
   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   CIRCLE (posx&, posy&), 4, 6
   PAINT (posx&, posy&), 6, 6
   CIRCLE (posx&, posy&), 4, 14
   posx& = posx& + regs%(2)
   posy& = posy& + regs%(3)
   IF posx& < 0 THEN posx& = 0
   IF posx& >= 320 THEN posx& = 319
   IF posy& < 0 THEN posy& = 0
   IF posy& >= 200 THEN posy& = 199
  
   pag% = 1 - pag%: SCREEN 7, , pag%, 1 - pag%
LOOP WHILE INKEY$ = ""

SUB drawlines
   FOR z% = 0 TO numwalls% - 1
      LINE (wall(z%).x, wall(z%).y)-(wall(wall(z%).point2).x, wall(wall(z%).point2).y), 4
   NEXT z%
END SUB

SUB drawsprite (z%)
   x& = sprite(z%).x
   y& = sprite(z%).y
   fatclip% = sprite(z%).fatclip
   LINE (x& - fatclip% + 1, y& - fatclip% + 1)-(x& + fatclip% - 1, y& + fatclip% - 1), 11, BF
   LINE (x& - fatclip%, y& - fatclip%)-(x& + fatclip% - 1, y& - fatclip%), 15, B
   LINE (x& - fatclip%, y& - fatclip%)-(x& - fatclip%, y& + fatclip% - 1), 15, B
   LINE (x& - fatclip% + 1, y& + fatclip%)-(x& + fatclip%, y& + fatclip%), 3, B
   LINE (x& + fatclip%, y& - fatclip% + 1)-(x& + fatclip%, y& + fatclip%), 3, B
   PSET (x& - fatclip% + 2, y& - fatclip% + 2), 0
   PSET (x& + fatclip% - 2, y& - fatclip% + 2), 0
   PSET (x&, y& - 1), 0
   PSET (x&, y&), 0
   LINE (x& - fatclip% + 2, y& + fatclip% - 2)-(x& + fatclip% - 2, y& + fatclip% - 2), 0
END SUB

SUB filllines
   minx& = xdim - 1: maxx& = 0: miny& = ydim - 1: maxy& = 0
   FOR z% = 0 TO numwalls% - 1
      IF wall(z%).x < minx& THEN minx& = wall(z%).x
      IF wall(z%).x > maxx& THEN maxx& = wall(z%).x
      IF wall(z%).y < miny& THEN miny& = wall(z%).y
      IF wall(z%).y > maxy& THEN maxy& = wall(z%).y
   NEXT z%
   LINE (0, 0)-(minx& - 1, ydim - 1), 1, BF
   LINE (xdim - 1, 0)-(maxx& + 1, ydim - 1), 1, BF
   LINE (0, 0)-(xdim - 1, miny& - 1), 1, BF
   LINE (0, ydim - 1)-(xdim - 1, maxy& + 1), 1, BF
   FOR x& = minx& TO maxx&
      FOR y& = miny& TO maxy&
         PSET (x&, y&), inside%(x&, y&) * 14 + 1
      NEXT y&
   NEXT x&
END SUB

SUB getlines
   DIM regs%(7): regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
   pag% = 0: SCREEN 7, , pag%, pag%
   numwalls% = 0
   mousx& = xdim \ 2
   mousy& = ydim \ 2
   oldcol% = 0
   DO
      DO
         regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
         PSET (mousx&, mousy&), oldcol%
         mousx& = mousx& + regs%(2)
         mousy& = mousy& + regs%(3)
         IF mousx& < 0 THEN mousx& = 0
         IF mousx& >= xdim THEN mousx& = xdim - 1
         IF mousy& < 0 THEN mousy& = 0
         IF mousy& >= ydim THEN mousy& = ydim - 1
         oldcol% = POINT(mousx&, mousy&)
         z$ = INKEY$
         IF z$ <> CHR$(13) THEN PSET (mousx&, mousy&), 12
      LOOP WHILE z$ = ""
      IF z$ = " " THEN
         SCREEN 7, , 1 - pag%, pag%
         LINE (0, 0)-(xdim - 1, ydim - 1), 0, BF
         wall(numwalls%).x = mousx&
         wall(numwalls%).y = mousy&
         IF numwalls% > 0 THEN wall(numwalls% - 1).point2% = numwalls%
         wall(numwalls%).point2 = 0
         numwalls% = numwalls% + 1
         FOR z% = 0 TO numwalls% - 1
            z2% = wall(z%).point2
            LINE (wall(z%).x, wall(z%).y)-(wall(z2%).x, wall(z2%).y), 4
         NEXT z%
         pag% = 1 - pag%: SCREEN 7, , pag%, pag%
      END IF
   LOOP WHILE z$ <> CHR$(13)
END SUB

SUB insertsprites (z%)
   numsprites% = z%
   firstsprite% = 0
   FOR z% = 0 TO numsprites% - 1
      sprite(z%).point2 = z% + 1
      DO
         x& = INT(320 * RND)
         y& = INT(200 * RND)
         fatclip% = INT(4 * RND) + 4
         bad% = 0
         IF inside(x&, y&) = 0 THEN
            bad% = 1
         ELSE
            FOR zz% = 0 TO numwalls% - 1
               IF insidebox%(x&, y&, fatclip%, zz%) = 1 THEN bad% = 1
            NEXT zz%
            FOR zz% = 0 TO z% - 1
               IF ABS(sprite(zz%).x - x&) <= sprite(zz%).fatclip + fatclip% THEN
                  IF ABS(sprite(zz%).y - y&) <= sprite(zz%).fatclip + fatclip% THEN
                     bad% = 1
                  END IF
               END IF
            NEXT zz%
         END IF
      LOOP WHILE bad% = 1
      sprite(z%).x = x&
      sprite(z%).y = y&
      sprite(z%).fatclip = fatclip%
      CALL drawsprite(z%)
   NEXT z%
   sprite(numsprites% - 1).point2 = -1
END SUB

FUNCTION inside% (x&, y&)
   cnt% = 0
   FOR z% = 0 TO numwalls% - 1
      x1& = wall(z%).x: x2& = wall(wall(z%).point2).x
      IF (x1& >= x& OR x2& >= x&) THEN
         y1& = wall(z%).y: y2& = wall(wall(z%).point2).y
         IF y1& > y2& THEN SWAP x1&, x2&: SWAP y1&, y2&
         IF (y1& <= y& AND y2& > y&) THEN
            IF x1& * (y& - y2&) + x2& * (y1& - y&) <= x& * (y1& - y2&) THEN cnt% = 1 - cnt%
         END IF
      END IF
   NEXT z%
   inside% = cnt%
END FUNCTION

FUNCTION insidebox% (x&, y&, fatclip%, wallnum%)
   x1& = wall(wallnum%).x
   y1& = wall(wallnum%).y
   x2& = wall(wall(wallnum%).point2).x
   y2& = wall(wall(wallnum%).point2).y
  
   box1& = x& - fatclip%
   boy1& = y& - fatclip%
   box2& = x& + fatclip%
   boy2& = y& + fatclip%
  
   IF (x1& < box1&) AND (x2& < box1&) THEN insidebox% = 0: EXIT FUNCTION
   IF (x1& > box2&) AND (x2& > box2&) THEN insidebox% = 0: EXIT FUNCTION
   IF (y1& < boy1&) AND (y2& < boy1&) THEN insidebox% = 0: EXIT FUNCTION
   IF (y1& > boy2&) AND (y2& > boy2&) THEN insidebox% = 0: EXIT FUNCTION
 
   templong1& = (x2& - x1&) * (boy1& - y1&) - (box1& - x1&) * (y2& - y1&)
   templong2& = (x2& - x1&) * (boy2& - y1&) - (box1& - x1&) * (y2& - y1&)
   IF (templong1& <= 0) <> (templong2& <= 0) THEN insidebox% = 1: EXIT FUNCTION
   templong3& = (x2& - x1&) * (boy1& - y1&) - (box2& - x1&) * (y2& - y1&)
   IF (templong2& <= 0) <> (templong3& <= 0) THEN insidebox% = 1: EXIT FUNCTION
   templong4& = (x2& - x1&) * (boy2& - y1&) - (box2& - x1&) * (y2& - y1&)
   IF (templong3& <= 0) <> (templong4& <= 0) THEN insidebox% = 1: EXIT FUNCTION
 
   insidebox% = 0: EXIT FUNCTION
END FUNCTION

SUB movesprite (z%)
   x& = sprite(z%).x
   y& = sprite(z%).y
   fatclip% = sprite(z%).fatclip

   IF RND < .5 THEN
      IF posx& < x& THEN x& = x& - 1
      IF posx& > x& THEN x& = x& + 1
   ELSE
      IF posy& < y& THEN y& = y& - 1
      IF posy& > y& THEN y& = y& + 1
   END IF
   IF sprite(z%).fatclip = 4 THEN
      IF RND < .5 THEN
         IF posx& < x& THEN x& = x& - 1
         IF posx& > x& THEN x& = x& + 1
      ELSE
         IF posy& < y& THEN y& = y& - 1
         IF posy& > y& THEN y& = y& + 1
      END IF
   END IF

   bad% = 0
   FOR zz% = 0 TO numwalls% - 1
      IF insidebox%(x&, y&, fatclip%, zz%) = 1 THEN bad% = 1
   NEXT zz%
   FOR zz% = 0 TO numsprites% - 1
      IF zz% <> z% THEN
         IF ABS(sprite(zz%).x - x&) <= sprite(zz%).fatclip + fatclip% THEN
            IF ABS(sprite(zz%).y - y&) <= sprite(zz%).fatclip + fatclip% THEN
               bad% = 1
            END IF
         END IF
      END IF
   NEXT zz%

   IF bad% = 0 THEN
      sprite(z%).x = x&
      sprite(z%).y = y&
   END IF
END SUB

