#include <dos.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define MAXKCODESIZE 262144
#define MAXSPRITES 4096
#define MAXTILES 4096
#define MAXTILEFILES 256
#define NUMOPTIONS 6
#define XDIM 320
#define YDIM 200

static char kcodebuf[MAXKCODESIZE], *kcodeptr;
static char kdatabuf[MAXKCODESIZE], *kdataptr;
static long cureax;

static char palette[768];

char picsiz[MAXTILES], *pic[MAXTILEFILES];
short tilesizx[MAXTILES], tilesizy[MAXTILES];
long artversion, numtiles, picanm[MAXTILES], waloff[MAXTILES];
static char artfilename[20];
static long localtilestart[MAXTILEFILES], localtileend[MAXTILEFILES];
static long numtilefiles, picsloaded = 0;

static char tile[XDIM][YDIM];
static char option[NUMOPTIONS];
static long page, tsizx, tsizy;
static char screen[65536];
long frameplace;

static long spritex[MAXSPRITES], spritey[MAXSPRITES];
static long spritexdir[MAXSPRITES], spriteydir[MAXSPRITES];
static long numsprites;

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux copybuf =\
	"rep movsd",\
	parm [esi][edi][ecx]\

#pragma aux kcode =\
	"call eax",\
	parm [eax][edi][ebx]\
	modify [esi edx]\

main()
{
	char ch;
	short spritenum;
	long i;

	if ((i = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{ read(i,&option[0],NUMOPTIONS); close(i); }

	setupscreen();

	if ((i = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{ read(i,&palette[0],768); close(i); }

	outp(0x3c8,0);
	for(i=0;i<768;i++) outp(0x3c9,palette[i]);

	loadpics("tiles000.art");

	spritenum = 0;
	compilesprite(spritenum);

	numsprites = 16;
	randomizesprites(0L,numsprites-1);

	ch = 0;
	while (ch != 27)
	{
		if (option[0] == 0)
		{
			outpw(0x3c4,0x0f02);
			clearbuf(0xa0000+(page<<14),64000>>4,0L);
		}
		else
		{
			clearbuf(frameplace,64000>>2,0L);
		}

		for(i=numsprites-1;i>=0;i--)
		{
			if (option[0] == 0)
			{
				outp(0x3c4,2);
				kcode(FP_OFF(kcodebuf),(long)0xa0000+(spritey[i]>>8)*80+((spritex[i]>>8)>>2)+(page<<14),(1<<(spritex[i]&3))+((1<<(spritex[i]&3))<<4));
			}
			else
			{
				kcode(FP_OFF(kcodebuf),frameplace+(spritey[i]>>8)*320+(spritex[i]>>8),0L);
			}

			spritex[i] += spritexdir[i];
			spritey[i] += spriteydir[i];
			if (spritex[i] >= ((XDIM-tsizx)<<8)) spritex[i] = ((XDIM-tsizx)<<9)-spritex[i], spritexdir[i] = -spritexdir[i];
			if (spritex[i] < 0) spritex[i] = -spritex[i], spritexdir[i] = -spritexdir[i];
			if (spritey[i] >= ((YDIM-tsizy)<<8)) spritey[i] = ((YDIM-tsizy)<<9)-spritey[i], spriteydir[i] = -spriteydir[i];
			if (spritey[i] < 0) spritey[i] = -spritey[i], spriteydir[i] = -spriteydir[i];
		}

		nextpage();
		if (kbhit() != 0)
		{
			ch = getch();
			if ((ch == '-') && (numsprites > 1)) numsprites--;
			if ((ch == '+') && (numsprites < MAXSPRITES))
				{ randomizesprites(numsprites,numsprites); numsprites++; }
			if (ch == '/')
				{ numsprites >>= 1; if (numsprites == 0) numsprites = 1; }
			if (ch == '*')
			{
				i = numsprites;
				numsprites <<= 1;
				if (numsprites > MAXSPRITES) numsprites = MAXSPRITES;
				randomizesprites(i,numsprites-1);
			}
			if (ch == 0)
			{
				ch = getch();
				if ((ch == 73) && (spritenum > 0))
				{
					compilesprite(--spritenum);
					randomizesprites(0L,numsprites-1);
				}
				if ((ch == 81) && (spritenum < MAXTILES-1))
				{
					compilesprite(++spritenum);
					randomizesprites(0L,numsprites-1);
				}
			}
		}
	}

	setvmode(0x3);
	printf("For tile #%d\n",spritenum);
	printf("Number of data bytes: %d\n",tsizx*tsizy);
	printf("Number of code bytes: %d\n",FP_OFF(kcodeptr)-FP_OFF(kcodebuf));
}

setupscreen()
{
	long i;

	setvmode(0x13);

	if (option[0] == 0)
	{
		outpw(0x3c4,0x0604);
		outpw(0x3d4,0x0014);
		outpw(0x3d4,0xe317);

		outpw(0x3c4,0x0f02);
		clearbuf(0xa0000,4096L+4096L+4096L,0L);
		page = 0L;
	}
	else
	{
		frameplace = FP_OFF(screen);
		clearbuf(frameplace,16000L,0L);
	}
}

nextpage()
{
	if (option[0] == 0)
	{
		outp(0x3d4,0xc); outp(0x3d5,page<<6);
		page = ((page+1)&3);
	}
	else
	{
		copybuf(frameplace,0xa0000,64000>>2);
	}
}

loadpics(char filename[20])
{
	long totpicsiz, offscount, siz;
	short int fil, i, j, k;

	strcpy(artfilename,filename);

	for(i=0;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}

	numtilefiles = 0;
	do
	{
		k = numtilefiles;

		artfilename[7] = (k%10)+48;
		artfilename[6] = ((k/10)%10)+48;
		artfilename[5] = ((k/100)%10)+48;
		if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
		{
			read(fil,&artversion,4);
			if (artversion != 1) return(-1);
			read(fil,&numtiles,4);
			read(fil,&localtilestart[k],4);
			read(fil,&localtileend[k],4);
			read(fil,&tilesizx[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&tilesizy[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&picanm[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<2);

			totpicsiz = 0L;
			for(i=localtilestart[k];i<=localtileend[k];i++)
				totpicsiz += (long)(tilesizx[i]*tilesizy[i]);
			pic[k] = (char *)malloc(totpicsiz);

			offscount = 0L;
			for(i=localtilestart[k];i<=localtileend[k];i++)
			{
				waloff[i] = offscount+FP_OFF(pic[k]);
				siz = tilesizx[i]*tilesizy[i];
				if (siz > 0)
				{
					read(fil,&(pic[k])[offscount],siz);
					offscount += siz;
				}
			}
			close(fil);

			numtilefiles++;
		}
	}
	while (k != numtilefiles);

	for(i=0;i<MAXTILES;i++)
	{
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizx[i])) j--;
		picsiz[i] = ((char)j);
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizy[i])) j--;
		picsiz[i] += ((char)(j<<4));
	}

	picsloaded = 1;
	return(0);
}

randomizesprites(long startsprite, long endsprite)
{
	long i;

	for(i=startsprite;i<=endsprite;i++)
	{
		if (tsizx >= XDIM) spritex[i] = 0; else spritex[i] = ((rand()%(XDIM-tsizx))<<8);
		if (tsizy >= YDIM) spritey[i] = 0; else spritey[i] = ((rand()%(YDIM-tsizy))<<8);
		spritexdir[i] = (rand()&511)-256;
		spriteydir[i] = (rand()&511)-256;
	}
}

kcodeb(char dabyte)
{
	*kcodeptr++ = dabyte;
}

kcodew(short daword)
{
	*kcodeptr++ = (char)(daword&255);
	*kcodeptr++ = (char)((daword>>8)&255);
}

kcoded(long dalong)
{
	*kcodeptr++ = (char)(dalong&255);
	*kcodeptr++ = (char)((dalong>>8)&255);
	*kcodeptr++ = (char)((dalong>>16)&255);
	*kcodeptr++ = (char)((dalong>>24)&255);
}

kdatab(char dabyte)
{
	*kdataptr++ = dabyte;
}

kdataw(short daword)
{
	*kdataptr++ = (char)(daword&255);
	*kdataptr++ = (char)((daword>>8)&255);
}

kdatad(long dalong)
{
	*kdataptr++ = (char)(dalong&255);
	*kdataptr++ = (char)((dalong>>8)&255);
	*kdataptr++ = (char)((dalong>>16)&255);
	*kdataptr++ = (char)((dalong>>24)&255);
}

compilesprite(short spritenum)
{
	char plane, *ptr;
	long i, x, y, bufplc, videoplc, nvideoplc;

	tsizx = tilesizx[spritenum]; tsizy = tilesizy[spritenum];
	if ((tsizx*tsizy > 65536) || (tsizx <= 1) || (tsizy <= 1) || (tsizx > XDIM) || (tsizy > YDIM))
	{
		tsizx = 160; tsizy = 100;
		for(x=0;x<tsizx;x++)
			for(y=0;y<tsizy;y++)
			{
				if ((rand()&1) == 0)
					tile[x][y] = (rand()&255);
				else
					tile[x][y] = 255;
			}
	}
	else
	{
		bufplc = waloff[spritenum];
		ptr = (char *)bufplc;
		for(x=0;x<tsizx;x++)
			for(y=0;y<tsizy;y++)
				tile[x][y] = *ptr++;
	}

	kcodeptr = (char *)FP_OFF(kcodebuf);
	kdataptr = (char *)FP_OFF(kdatabuf);

	//kcodeb(0xbe); kcoded(0x88888888);                 //mov esi, 88888888h
	kcodeb(0x8d); kcodeb(0xb0); kcoded(0x88888888); //lea esi, [eax+88888888h]

	videoplc = 0;
	if (option[0] == 0)
	{
		for(plane=0;plane<4;plane++)
		{
			kcodeb(0x66); kcodeb(0xba); kcodew(0x3c5);   //mov dx, 0x3c5
			kcodeb(0x88); kcodeb(0xd8);                  //mov al, bl
			kcodeb(0xee);                                //out dx, al
			kcodeb(0x31); kcodeb(0xc0);                  //xor eax, eax
			cureax = 0;

			for(y=0;y<tsizy;y++)
			{
				x = plane;
				while (x < tsizx)
				{
					if (tile[x][y] == 255) { x += 4; continue; }

					nvideoplc = ((y*320+x)>>2);
					if (nvideoplc != videoplc)
						{ add2edi((nvideoplc-videoplc)&65535); videoplc = nvideoplc; }

					if ((x < tsizx-4) && (tile[x+4][y] != 255))
					{
						if ((x < tsizx-12) && (tile[x+8][y] != 255) && (tile[x+12][y] != 255))
						{
							i = ((long)tile[x][y])+((long)tile[x+4][y]<<8)+
								 ((long)tile[x+8][y]<<16)+((long)tile[x+12][y]<<24);
							if (getseteaxleng(i) < 4)
								{ seteax(i); kcodeb(0xab); }  //stosd
							else
								{ kdatad(i); kcodeb(0xa5); }  //movsd
							videoplc += 4; x += 16; continue;
						}
						i = ((long)tile[x][y])+(((long)tile[x+4][y])<<8);
						if (getsetaxleng(i) < 4)
							{ setax(i); kcodeb(0x66); kcodeb(0xab); }  //stosw
						else
							{ kdataw(i); kcodeb(0x66); kcodeb(0xa5); } //movsw
						videoplc += 2; x += 8; continue;
					}
					i = (long)tile[x][y];
					if (getsetalleng(i) < 2)
						{ setal(i); kcodeb(0xaa); }  //stosb
					else
						{ kdatab(i); kcodeb(0xa4); }  //movsb
					videoplc++; x += 4;
				}
			}

			kcodeb(0xd0); kcodeb(0xc3);                  //rol bl, 1
			kcodeb(0x83); kcodeb(0xd7); kcodeb(0x0);     //adc edi, 0
		}
	}
	else
	{
		kcodeb(0x31); kcodeb(0xc0);                     //xor eax, eax
		cureax = 0;

		for(y=0;y<tsizy;y++)
		{
			x = 0;
			while (x < tsizx)
			{
				if (tile[x][y] == 255) { x++; continue; }

				nvideoplc = y*320+x;
				if (nvideoplc != videoplc)
					{ add2edi((nvideoplc-videoplc)&65535); videoplc = nvideoplc; }

				if ((x < tsizx-1) && (tile[x+1][y] != 255))
				{
					if ((x < tsizx-3) && (tile[x+2][y] != 255) && (tile[x+3][y] != 255))
					{
						i = ((long)tile[x][y])+((long)tile[x+1][y]<<8)+
							 ((long)tile[x+2][y]<<16)+((long)tile[x+3][y]<<24);
						if (getseteaxleng(i) < 4)
							{ seteax(i); kcodeb(0xab); }  //stosd
						else
							{ kdatad(i); kcodeb(0xa5); }  //movsd
						videoplc += 4; x += 4; continue;
					}
					i = ((long)tile[x][y])+(((long)tile[x+1][y])<<8);
					if (getsetaxleng(i) < 4)
						{ setax(i); kcodeb(0x66); kcodeb(0xab); }  //stosw
					else
						{ kdataw(i); kcodeb(0x66); kcodeb(0xa5); } //movsw
					videoplc += 2; x += 2; continue;
				}
				i = (long)tile[x][y];
				if (getsetalleng(i) < 2)
					{ setal(i); kcodeb(0xaa); }  //stosb
				else
					{ kdatab(i); kcodeb(0xa4); }  //movsb
				videoplc++; x++;
			}
		}
	}

	kcodeb(0xc3);

	i = FP_OFF(kcodeptr)-FP_OFF(kcodebuf);
	kcodebuf[2] = (char)(i&255);
	kcodebuf[3] = (char)((i>>8)&255);
	kcodebuf[4] = (char)((i>>16)&255);
	kcodebuf[5] = (char)((i>>24)&255);

	ptr = (char *)FP_OFF(kdatabuf);
	while (ptr != kdataptr) kcodeb(*ptr++);
}

getseteaxleng(long neweax)
{
	if (neweax == cureax) return(0);
	if (((neweax^cureax)&0xffff0000) == 0)
	{
		if (((neweax^cureax)&0x000000ff) == 0) return(2);
		if (((neweax^cureax)&0x0000ff00) == 0) return(2);
		return(4);
	}
	return(5);
}

getsetaxleng(long newax)
{
	long i;

	i = (cureax^newax);
	if ((i&0x0000ffff) == 0) return(0);
	if ((i&0x0000ff00) == 0) { return(2); }
	if ((i&0x000000ff) == 0) { return(2); }
	return(4);
}

getsetalleng(long newal)
{
	if (((newal^cureax)&0x000000ff) == 0) return(0);
	return(2);
}

seteax(long neweax)
{
	if (neweax == cureax) return;

	if (((neweax^cureax)&0xffff0000) == 0) { setax(neweax&0x0000ffff); return; }
	kcodeb(0xb8); kcoded(neweax);

	cureax = neweax;
}

setax(long newax)
{
	long i;

	i = (cureax^newax);
	if ((i&0x0000ffff) == 0) return;
	if ((i&0x0000ff00) == 0) { setal(newax); return; }
	if ((i&0x000000ff) == 0) { setah(newax>>8); return; }

	kcodeb(0x66); kcodeb(0xb8); kcodew((short)newax);      //mov ax, ?
	cureax = ((cureax&0xffff0000)|newax);
}

setal(long newal)
{
	if (((cureax^newal)&0x000000ff) == 0) return;
	kcodeb(0xb0); kcodeb((char)newal);
	cureax = ((cureax&0xffffff00)|newal);
}

setah(long newah)
{
	if (((cureax^(newah<<8))&0x0000ff00) == 0) return;
	kcodeb(0xb4); kcodeb((char)newah);
	cureax = ((cureax&0xffff00ff)|(newah<<8));
}

add2edi(long ediinc)
{
	long i;

	if (ediinc < 3)
	{
		for(i=0;i<ediinc;i++) kcodeb(0x47);          //inc edi
		return;
	}
	if (ediinc < 128)     //add edi, schar
		{ kcodeb(0x83); kcodeb(0xc7); kcodeb((char)ediinc); return; }
	if (ediinc == 128)
	{
		kcodeb(0x83); kcodeb(0xc7); kcodeb(127);     //add edi, schar
		kcodeb(0x47);                                //inc edi
		return;
	}
	if (option[0] == 0)
	{      //Watch out for short page crossing in screen buffer mode!
		kcodeb(0x66); kcodeb(0x81); kcodeb(0xc7);
		kcodew((short)ediinc);                       //add di, short
	}
	else
	{
		kcodeb(0x81); kcodeb(0xc7);
		kcoded(ediinc);                              //add edi, long
	}
}

/*

0x8d 0xb0 long = lea esi, [eax+88888888h]
	  0xbe long = mov esi, 88888888h
			 0xaa = stosb
	  0x66 0xab = stosw
			 0xab = stosd
			 0xa4 = movsb
	  0x66 0xa5 = movsw
			 0xa5 = movsd

	1 pixel modes:
mov al, 88h        (2)
stosb              (1)

stosb              (1)

movsb              (1), (1 later)

	2 pixel modes:
mov ax, 8888h      (4)
stosw              (2)

mov al, 88h        (2)
stosw              (2)

mov ah, 88h        (2)
stosw              (2)

movsw              (2), (2 later)

	4 pixel modes:
mov eax, 88888888h (5)
stosd              (1)

mov ax, 8888h      (4)
stosd              (1)

mov al, 88h        (2)
stosd              (1)

mov ah, 88h        (2)
stosd              (1)

movsd              (1), (4 later)
*/
