DECLARE SUB drawrect (z&, newlock&)
DECLARE SUB allocache (newhandle&, newbytes&, newlockptr&)
DECLARE SUB initcache (dacachestart&, dacachesize&)
DECLARE SUB uninitcache (lockstat&)

CONST MAXCACHEOBJECTS = 4096

DIM SHARED cachestart&, cachesize&, cacnum&, cachecount&
DIM SHARED cacleng&(MAXCACHEOBJECTS)
DIM SHARED handptr&(MAXCACHEOBJECTS)
DIM SHARED lockptr&(MAXCACHEOBJECTS)
cacnum& = 0: cachecount& = 0

SCREEN 13

OUT &H3C8, 0
OUT &H3C9, 0: OUT &H3C9, 0: OUT &H3C9, 0
FOR z% = 1 TO 254
   OUT &H3C9, z% \ 4
   IF z% >= 200 THEN OUT &H3C9, 63 ELSE OUT &H3C9, 0
   OUT &H3C9, 63 - z% \ 4
NEXT z%
OUT &H3C9, 63: OUT &H3C9, 63: OUT &H3C9, 63

DIM SHARED buf%(320)
CALL initcache(1, 320)

CALL drawrect(0&, 0)

DO
   CALL allocache(newhandle&, (INT(64 * RND) AND &H7C) + 8, 199 + (INT(16 * RND) \ 15))
  
   FOR z& = 0 TO cacnum& - 1
	 IF lockptr&(z&) >= 200 THEN
	    IF INT(16 * RND) = 0 THEN lockptr&(z&) = lockptr&(z&) - 1
	 ELSEIF lockptr&(z&) > 16 THEN
	    lockptr&(z&) = lockptr&(z&) - 16
	    IF INT(16 * RND) = 0 THEN lockptr&(z&) = 199
	    CALL drawrect(z&, lockptr&(z&))
	 END IF
   NEXT z&
   'IF INT(8 * RND) = 0 THEN CALL uninitcache(INT(12 * RND) + 4)

LOOP WHILE z$ <> CHR$(27)

SUB allocache (newhandle&, newbytes&, newlockptr&)
   IF newbytes& > cachesize& THEN
	 PRINT "Cachesize:"; cachesize&; "Newbytes:"; newbytes&; "Newhandle:"; newhandle&; "Newlockptr:"; newlockptr&
	 PRINT "BUFFER TOO BIG TO FIT IN CACHE!"
	 END
   END IF

	 'Find best place
   bestval& = &H7FFFFFFF: o1& = 0
   FOR z& = 0 TO cacnum& - 1
	 o2& = o1& + newbytes&
	 IF o2& <= cachesize& THEN
	    endo& = o1&: daval& = 0: zz& = z&
	    DO WHILE endo& < o2&
		  IF lockptr&(zz&) >= 200 THEN daval& = &H7FFFFFFF: EXIT DO
		  IF lockptr&(zz&) > 0 THEN daval& = daval& + (cacleng&(zz&) * 16& + 1024) \ (200 - lockptr&(zz&))
		  IF daval& >= bestval& THEN EXIT DO
		  endo& = endo& + cacleng&(zz&): zz& = zz& + 1
	    LOOP
	    IF daval& < bestval& THEN bestval& = daval&: besto& = o1&: bestz& = z&
	 END IF
	 o1& = o1& + cacleng&(z&)
   NEXT z&

   LINE (besto&, 32)-(besto& + newbytes& - 1, 35), 15, BF
   DO: LOOP WHILE INKEY$ = ""
  
   IF bestval& = &H7FFFFFFF THEN PRINT "CACHE SPACE ALL LOCKED UP!": END
  
	 'Suck things out
   suckedlen& = -newbytes&: suckz& = bestz&: o& = besto&
   WHILE suckedlen& < 0
	    'Suck bestz
	 LINE (o&, 0)-(o& + cacleng&(suckz&) - 1, 31), 0, BF
	 CALL drawrect(suckz&, 0)
	 IF lockptr&(suckz&) <> 0 THEN handptr&(suckz&) = 0
	 o& = o& + cacleng&(suckz&)
	 suckedlen& = suckedlen& + cacleng&(suckz&)
	 suckz& = suckz& + 1
   WEND
  
   suckz& = suckz& - bestz& - 1      'Remove all areas except 1
   cacnum& = cacnum& - suckz&
   FOR z& = bestz& TO cacnum& - 1
	 handptr&(z&) = handptr&(z& + suckz&)
	 cacleng&(z&) = cacleng&(z& + suckz&)
	 lockptr&(z&) = lockptr&(z& + suckz&)
   NEXT z&

   handptr&(bestz&) = cachestart& + besto&
   cacleng&(bestz&) = newbytes&
   lockptr&(bestz&) = newlockptr&
  
   CALL drawrect(bestz&, lockptr&(bestz&))

	 'Add new empty block
   IF suckedlen& > 0 THEN
	 bestz& = bestz& + 1
	 IF bestz& = cacnum& THEN
	    cacnum& = cacnum& + 1
	    cacleng&(bestz&) = suckedlen&
	    lockptr&(bestz&) = 0
	 ELSEIF lockptr&(bestz&) = 0 THEN
	    cacleng&(bestz&) = cacleng&(bestz&) + suckedlen&
	 ELSE
	    cacnum& = cacnum& + 1
	    FOR z& = cacnum& - 1 TO bestz& + 1 STEP -1
		  handptr&(z&) = handptr&(z& - 1)
		  cacleng&(z&) = cacleng&(z& - 1)
		  lockptr&(z&) = lockptr&(z& - 1)
	    NEXT z&
	    cacleng&(bestz&) = suckedlen&
	    lockptr&(bestz&) = 0
	 END IF
	 CALL drawrect(bestz&, 0)
   END IF

   cachecount& = cachecount& + 1

   FOR z& = 0 TO cacnum& - 1
	 CALL drawrect(z&, lockptr&(z&))
   NEXT z&

   LINE (besto&, 32)-(besto& + newbytes& - 1, 35), 0, BF
END SUB

SUB drawrect (z&, newlock&)
   o& = 0
   FOR zx& = 0 TO z& - 1: o& = o& + cacleng&(zx&): NEXT zx&

   x1& = o&: x2& = o& + cacleng&(z&) - 1
   IF newlock& = 0 THEN LINE (x1&, 0)-(x2&, 31), 0, BF
   LINE (x1& + 1, 0)-(x2&, 31), newlock&, BF
   LINE (x1&, 0)-(x1&, 31), 255
END SUB

SUB initcache (dacachestart&, dacachesize&)
   CALL uninitcache(256)

   cachestart& = dacachestart&
   cachesize& = dacachesize&
   cachecount& = 0
  
   cacleng&(0) = cachesize&
   lockptr&(0) = 0
   cacnum& = 1
END SUB

SUB uninitcache (sucklessthanme&)  'lockstat: 0-don't free locked, 1-free all
   FOR z& = cacnum& - 1 TO 0 STEP -1
	 IF lockptr&(z&) > 0 AND lockptr&(z&) < sucklessthanme& THEN
	    CALL drawrect(z&, 0)
	    handptr&(z&) = 0  'use pointer
	    lockptr&(z&) = 0
	    IF z& < cacnum& - 1 AND lockptr&(z& + 1) = 0 THEN
		  cacleng&(z&) = cacleng&(z&) + cacleng&(z& + 1)
		  cacnum& = cacnum& - 1
		  FOR zz& = z& + 1 TO cacnum& - 1
			handptr&(zz&) = handptr&(zz& + 1)
			cacleng&(zz&) = cacleng&(zz& + 1)
			lockptr&(zz&) = lockptr&(zz& + 1)
		  NEXT zz&
	    END IF
	 END IF
   NEXT z&
END SUB

