// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <conio.h>
#include <math.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

static short sintable[2048];
static short radarang[640];
static char textfont[128][8], smalltextfont[128][8];
static char britable[16][64];

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux int10 =\
	"int 0x10",\
	parm [eax][ebx][ecx][edx]\

#pragma aux getpixel =\
	"xor eax, eax",\
	"mov al, [edi]",\
	parm [edi]\

main()
{
	double a, b;
	long fil, i, j;

	printf("Calculating sintable...\n");
	for(i=0;i<2048;i++)
		sintable[i] = (short)(16384*sin((double)i*3.14159265358979/1024));
	printf("Calculating radarangs...\n");
	for(i=0;i<640;i++)          //2048*64 degrees for precision
		radarang[i] = (short)(atan(((double)i-639.5)/160)*64*1024/3.14159265358979);
	makfont16();
	maksmallfont16();
	for(i=0;i<16;i++)
	{
		a = (double)8 / ((double)i+8);
		b = (double)63 / pow((double)63,a);
		for(j=0;j<64;j++)
			britable[i][j] = (char)(pow((double)j,a)*b);
	}

	printf("Saving tables.dat...\n");
	if ((fil = open("tables.dat",O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) != -1)
	{
		write(fil,&sintable[0],2048*2);
		write(fil,&radarang[0],640*2);
		write(fil,&textfont[0],1024);
		write(fil,&smalltextfont[0],1024);
		write(fil,&britable[0],1024);
		close(fil);
	}
	printf("All done!\n");
}

makfont16()
{
	char ch;
	long z, zz, zx;

	setvmode(0x13);
	int10(0x1123L,0L,0L,50L);   //load 8*8 font

	for(zx=0;zx<128;zx++)
	{
		int10(0x200L,0L,0L,0L);  //locate 1,1
		int10(0xa00+zx,1L,1L,0L);  //print character
		for(zz=0;zz<8;zz++)
		{
			ch = 0;
			for(z=0;z<8;z++)
				if (getpixel(zz*320+z+0xa0000) > 0)
					ch += (1<<(7-z));
			textfont[zx][zz] = ch;
		}
	}
	setvmode(3);
}

maksmallfont16()
{
	long fil;

	if ((fil = open("smallfnt.dat",O_BINARY|O_RDWR,S_IREAD)) == -1)
	{
		printf("Can't find smallfnt.dat\n");
		exit(0);
	}
	read(fil,&smalltextfont[0],1024);
	close(fil);
}
