DECLARE SUB fillsector ()
DECLARE FUNCTION clockdir% ()
DECLARE SUB loadtables ()
DECLARE FUNCTION inside% (x&, y&)
DECLARE SUB getlines ()
CONST XDIM = 640, YDIM = 350, MAXWALLS = 1024, MAXCLIPNUM = 256
COMMON SHARED numwalls%, pag%, posx&, posy&
DIM SHARED sintable&(2048)

DIM SHARED fillist&(640)

TYPE walltype
   x AS LONG
   y AS LONG
   point2 AS INTEGER
END TYPE

DIM SHARED wall(MAXWALLS) AS walltype

SCREEN 9
CALL loadtables
CALL getlines

LINE (0, 0)-(XDIM - 1, YDIM - 1), 0, BF
FOR z% = 0 TO numwalls% - 1
   LINE (wall(z%).x \ 16, wall(z%).y \ 16)-(wall(wall(z%).point2).x \ 16, wall(wall(z%).point2).y \ 16), 12
NEXT z%

CALL fillsector

FUNCTION clockdir%
   minx& = &H7FFFFFFF
   themin% = -1
   i% = -1
   DO
      i% = i% + 1
      IF (wall(wall(i%).point2).x < minx&) THEN
         minx& = wall(wall(i%).point2).x
         themin% = i%
      END IF
   LOOP WHILE (wall(i%).point2 <> 0)

   x0& = wall(themin%).x
   y0& = wall(themin%).y
   x1& = wall(wall(themin%).point2).x
   y1& = wall(wall(themin%).point2).y
   x2& = wall(wall(wall(themin%).point2).point2).x
   y2& = wall(wall(wall(themin%).point2).point2).y

   IF ((y1& >= y2&) AND (y1& <= y0&)) THEN clockdir% = 0: EXIT FUNCTION
   IF ((y1& >= y0&) AND (y1& <= y2&)) THEN clockdir% = 1: EXIT FUNCTION

   templong& = (x0& - x1&) * (y2& - y1&) - (x2& - x1&) * (y0& - y1&)
   IF (templong& < 0) THEN
      clockdir% = 0: EXIT FUNCTION
   ELSE
      clockdir% = 1: EXIT FUNCTION
   END IF

END FUNCTION

SUB fillsector
   lborder& = 100: rborder& = XDIM - 100
   uborder& = 100: dborder& = YDIM - 100

   miny& = dborder& - 1
   maxy& = uborder&
   FOR z% = 0 TO numwalls% - 1
      y1& = wall(z%).y \ 16: y2& = wall(wall(z%).point2).y \ 16
      IF y1& < miny& THEN miny& = y1&
      IF y2& < miny& THEN miny& = y2&
      IF y1& > maxy& THEN maxy& = y1&
      IF y2& > maxy& THEN maxy& = y2&
   NEXT z%
   IF miny& < uborder& THEN miny& = uborder&
   IF maxy& >= dborder& THEN maxy& = dborder& - 1
  
   FOR sy& = miny& TO maxy&
      y& = sy& * 16
     
      fillist&(0) = lborder&: fillcnt% = 1
      FOR z% = 0 TO numwalls% - 1
         x1& = wall(z%).x: x2& = wall(wall(z%).point2).x
         IF (x1& >= x& OR x2& >= x&) THEN
            y1& = wall(z%).y: y2& = wall(wall(z%).point2).y
            IF y1& > y2& THEN SWAP x1&, x2&: SWAP y1&, y2&
            IF (y1& <= y& AND y2& > y&) THEN
               IF x1& * (y& - y2&) + x2& * (y1& - y&) <= 0 THEN
                  dax& = (x1& + (y& - y1&) * (x2& - x1&) \ (y2& - y1&)) \ 16
                  IF dax& >= lborder& THEN
                     fillist&(fillcnt%) = dax&
                     fillcnt% = fillcnt% + 1
                  END IF
               END IF
            END IF
          END IF
      NEXT z%
      IF fillcnt% > 0 THEN
         FOR z% = 1 TO fillcnt% - 1
            FOR zz% = 0 TO z% - 1
               IF fillist&(z%) < fillist&(zz%) THEN SWAP fillist&(z%), fillist&(zz%)
            NEXT zz%
         NEXT z%
         
         FOR z% = (fillcnt% AND 1) TO fillcnt% - 2 STEP 2
            IF fillist&(z%) > rborder& THEN EXIT FOR
            IF fillist&(z% + 1) > rborder& THEN fillist&(z% + 1) = rborder&
            LINE (fillist&(z%), sy&)-(fillist&(z% + 1), sy&), 11
         NEXT z%

      END IF

   NEXT sy&
END SUB

SUB getlines
   DIM regs%(7): regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
   pag% = 0: SCREEN 9, , pag%, pag%
   numwalls% = 0
   mousx& = XDIM \ 2
   mousy& = YDIM \ 2
   oldcol% = 0
   obstatus% = 1
   FOR z% = mousx& - 2 TO mousx& + 2
      FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
         PSET (z%, zz%), POINT(z%, zz%) XOR 15
      NEXT zz%
   NEXT z%
   DO
      DO
         z$ = INKEY$
         regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
         IF regs%(2) <> 0 OR regs%(3) <> 0 THEN
            FOR z% = mousx& - 2 TO mousx& + 2
               FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
                  PSET (z%, zz%), POINT(z%, zz%) XOR 15
               NEXT zz%
            NEXT z%
            mousx& = mousx& + regs%(2)
            mousy& = mousy& + regs%(3)
            IF mousx& < 0 THEN mousx& = 0
            IF mousx& >= XDIM THEN mousx& = XDIM - 1
            IF mousy& < 0 THEN mousy& = 0
            IF mousy& >= YDIM THEN mousy& = YDIM - 1
            FOR z% = mousx& - 2 TO mousx& + 2
               FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
                  PSET (z%, zz%), POINT(z%, zz%) XOR 15
               NEXT zz%
            NEXT z%
         END IF
         regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
         obstatus% = bstatus%: bstatus% = regs%(0)
      LOOP WHILE z$ = "" AND bstatus% = obstatus%
      IF z$ = " " OR (bstatus% AND 1) > (obstatus% AND 1) THEN
         SCREEN 9, , 1 - pag%, pag%
         LINE (0, 0)-(XDIM - 1, YDIM - 1), 0, BF
         wall(numwalls%).x = mousx&
         wall(numwalls%).y = mousy&
         IF numwalls% > 0 THEN wall(numwalls% - 1).point2% = numwalls%
         wall(numwalls%).point2 = 0
         numwalls% = numwalls% + 1
         FOR z% = 0 TO numwalls% - 1
            z2% = wall(z%).point2
            LINE (wall(z%).x, wall(z%).y)-(wall(z2%).x, wall(z2%).y), 12
         NEXT z%
         pag% = 1 - pag%: SCREEN 9, , pag%, pag%
         WAIT &H3DA, &H8, &H8
         WAIT &H3DA, &H8
      END IF
   LOOP WHILE z$ <> CHR$(13) AND (bstatus% AND 6) <= (obstatus% AND 6)
  
   IF clockdir% = 1 THEN
      FOR z% = 0 TO numwalls% \ 2 - 1
         SWAP wall(z%).x, wall(numwalls% - 1 - z%).x
         SWAP wall(z%).y, wall(numwalls% - 1 - z%).y
      NEXT z%
   END IF
  
   FOR z% = 0 TO numwalls% - 1
      wall(z%).x = wall(z%).x * 16
      wall(z%).y = wall(z%).y * 16
   NEXT z%
   posx& = mousx& * 16: posy& = mousy& * 16
END SUB

FUNCTION inside% (x&, y&)
   cnt% = 0
   FOR z% = 0 TO numwalls% - 1
      x1& = wall(z%).x: x2& = wall(wall(z%).point2).x
      IF (x1& >= x& OR x2& >= x&) THEN
         y1& = wall(z%).y: y2& = wall(wall(z%).point2).y
         IF y1& > y2& THEN SWAP x1&, x2&: SWAP y1&, y2&
         IF (y1& <= y& AND y2& > y&) THEN
            IF x1& * (y& - y2&) + x2& * (y1& - y&) <= x& * (y1& - y2&) THEN cnt% = 1 - cnt%
         END IF
      END IF
   NEXT z%
   inside% = cnt%
END FUNCTION

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

