typedef struct { long dxc, dyc, dxf, dyf; } gslopetype;
gslopetype gslope[MAXSECTORS];

calcglobslopevariables(short sectnum)
{
	long dx, dy, i, j;
	walltype *wal, *wal2;
	sectortype *sec = &sector[sectnum];

	if ((sec->ceilingstat|sec->floorstat)&2)
	{
		wal = &wall[sec->wallptr]; wal2 = &wall[wal->point2];
		dx = wal2->x-wal->x; dy = wal2->y-wal->y;
		i = (ksqrtasm(dx*dx+dy*dy)<<8); if (i == 0) return;
		if (sec->ceilingstat&2)
		{
			gslope[sectnum].dxc = scale(dx,sec->ceilingheinum,i);
			gslope[sectnum].dyc = scale(dy,sec->ceilingheinum,i);
		}
		if (sec->floorstat&2)
		{
			gslope[sectnum].dxf = scale(dx,sec->floorheinum,i);
			gslope[sectnum].dyf = scale(dy,sec->floorheinum,i);
		}
	}
}

#define precalcedgetzsofslope(sectnum,dax,day,ceilz,florz)    \
{                                                             \
	if (sector[sectnum].ceilingstat&2)                         \
		ceilz = sector[sectnum].ceilingz                        \
				 +gslope[sectnum].dxc*(day-wall[sec->wallptr].x)  \
				 -gslope[sectnum].dyc*(dax-wall[sec->wallptr].y); \
	else ceilz = sector[sectnum].ceilingz;                     \
	if (sector[sectnum].floorstat&2)                           \
		florz = sector[sectnum].floorz                          \
				 +gslope[sectnum].dxf*(day-wall[sec->wallptr].x)  \
				 -gslope[sectnum].dyf*(dax-wall[sec->wallptr].y); \
	else florz = sector[sectnum].floorz;                       \
}
