#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <fcntl.h>
#include <stdio.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define NUMOPTIONS 6

static char option[NUMOPTIONS];
static char tablesloaded = 0;

short int mousx, mousy, moustat, bstatus, obstatus;
static char sndbuffer[32768], sndheader[44];

static char sndspeed, sndvolumetable[256], *sndptr, sndlastfil[13];
static unsigned short sndselector, sndseg = -1, sndportaddr;
static long sndoffs, sndrightaddr, sndwrongaddr, sndleng;

#pragma aux convallocate =\
	"mov ax, 0x100",\
	"int 0x31",\
	"jnc skiperror",\
	"mov ax, -1",\
	"skiperror:",\
	"mov sndselector, dx",\
	parm [bx]\

#pragma aux convdeallocate =\
	"mov ax, 0x101",\
	"mov dx, sndselector",\
	"int 0x31",\
	parm [dx]\

#pragma aux resetsb =\
	"mov al, 1",\
	"mov dx, sndportaddr",\
	"add dx, 0x6",\
	"out dx, al",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"xor al, al",\
	"out dx, al",\
	"add dx, 4",\
	"mov cx, 100",\
	"resetsb1: in al, dx",\
	"cmp al, 0xaa",\
	"je resetsb2",\
	"loop resetsb1",\
	"mov ax, 1",\
	"jmp resetsb3",\
	"resetsb2: xor ax, ax",\
	"resetsb3:",\
	modify [eax ecx edx]\

#pragma aux sbwait =\
	"mov dx, sndportaddr",\
	"add dx, 0xc",\
	"sbwait1: in al, dx",\
	"test al, 0x80",\
	"jnz sbwait1",\
	modify [eax edx]\

#pragma aux sndvolumeadjust =\
	"xor eax, eax",\
	"begadjustvolume: lodsb",\
	"mov al, byte ptr [edx+eax]",\
	"stosb",\
	"loop begadjustvolume",\
	parm [ecx][edx][esi][edi]\
	modify [eax]\

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux copybuf =\
	"rep movsd",\
	parm [esi][edi][ecx]\

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

#pragma aux setupmouse =\
	"mov ax, 0",\
	"int 33h",\
	"mov moustat,1",\
	modify [eax]\

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"sar cx, 1",\
	"sar dx, 1",\
	"mov mousx, cx",\
	"mov mousy, dx",\
	"mov ax, 5d",\
	"int 33h",\
	"mov bx, bstatus",\
	"mov obstatus, bx",\
	"mov bstatus, ax",\
	modify [eax ecx edx]\

main(int argc,char **argv)
{
	char ch, *ptr, filename[80];
	short sndfil, viewside;
	long i, j, x, y, x1, x2, sndstart, sndend, totsndleng, average;

	if ((argc != 2) && (argc != 3))
	{
		printf("Wsay [filename(.wav)][speed(165)]             programmed by Kenneth Silverman");
		exit(0);
	}
	sndspeed = 165;
	if (argc == 3)
		sndspeed = (atoi(argv[2]))&255;

	loadtables();
	initsb(sndspeed);
	if (option[3] == 0) option[3] = 1;
	if (option[3] == 1)
		setupmouse();

	strcpy(filename,argv[1]);
	if (loadsound(filename,sndbuffer) == -1)
	{
		printf("Could not open file\n");
		exit(0);
	}
	totsndleng = sndleng;
	sndstart = 0;
	sndend = totsndleng-1;
	viewside = 0;

	setvmode(0x13);

	drawscreen(sndstart,sndend,totsndleng,viewside);

	ch = 0;
	while ((ch != 27) && (ch != 13))
	{
		if (moustat == 1)
		{
			readmouse();
			if ((bstatus&6) > 0)
			{
				sndend += mousx;
				if (sndend <= sndstart) sndend = sndstart+1;
				if (sndend >= totsndleng) sndend = totsndleng-1;
				viewside = 1;
			}
			if ((bstatus&1) > 0)
			{
				sndstart += mousx;
				if (sndstart < 0) sndstart = 0;
				if (sndstart >= sndend) sndstart = sndend-1;
				viewside = 0;
			}

			if (mousx != 0)
				drawscreen(sndstart,sndend,totsndleng,viewside);
		}

		if (kbhit() != 0)
		{
			ch = getch();
			if ((ch == 'c') || (ch == 'C'))
			{
				outp(97,inp(97)|3);
				average = 0;
				for(i=sndstart;i<=sndend;i++)
					average += sndbuffer[i];

				average /= sndend-sndstart;

				for(i=sndstart;i<=sndend;i++)
				{
					j = ((long)sndbuffer[i]) + (128-average);
					if (j < 0) j = 0;
					if (j > 255) j = 255;
					sndbuffer[i] = (char)j;
				}

				outp(97,inp(97)&252);

				drawscreen(sndstart,sndend,totsndleng,viewside);
			}
			if (ch == 32)
			{
				sndleng = sndend-sndstart;
				copybuf(&sndbuffer[sndstart],(long)sndptr,(sndleng+3)>>2);
				wsay("",-1);
			}
		}
	}

	if (ch == 13)
	{
		savesound(filename,&sndbuffer[sndstart],sndend-sndstart+1);
	}

	setvmode(0x3);

	uninitsb();
}

loadtables()
{
	long i, fil;

	if (tablesloaded == 0)
	{
		if ((fil = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			read(fil,&option[0],NUMOPTIONS);
			close(fil);
		}
		else
		{
			option[1] = 1;
			option[3] = 1;
		}

		tablesloaded = 1;
	}
}

initsb(char sndspeed)
{
	if (option[1] == 0)
		return(0);

	if (sndseg == -1)
	{
		if ((sndseg = convallocate(65536>>4)) == -1)
			return(-1);
		sndoffs = (((long)sndseg)<<4);

		if ((sndoffs&32768) == 0)
		{
			sndrightaddr = sndoffs;
			sndwrongaddr = sndoffs+32768;
		}
		else
		{
			sndrightaddr = sndoffs+32768;
			sndwrongaddr = sndoffs;
		}
		sndptr = (char *)sndwrongaddr;
	}

	sndportaddr = 0x220+(((short)option[1]-1)<<4);
	resetsb();
	sbwait(); outp(sndportaddr+0xc,0xd1);
	sbwait(); outp(sndportaddr+0xc,0x40);
	sbwait(); outp(sndportaddr+0xc,sndspeed);
	sndleng = 1;
	sndlastfil[0] = 0;
	return(0);
}

uninitsb()
{
	if (option[1] == 0)
		return(0);

	resetsb();
	if (sndseg != -1)
	{
		convdeallocate(sndseg);
		sndseg = -1;
	}
	return(0);
}

wsay(char filename[80], short volume)
{
	long i, sndfil;

	if (option[1] == 0)
		return(0);

	if (volume >= 0)
	{
		if (strchr(filename,'.') == 0)
			strcat(filename,".wav");

		i = 0;
		while ((sndlastfil[i] == filename[i]) && (filename[i] != 0))
			i++;

		if (sndlastfil[i] != filename[i])
		{
			for(i=0;i<13;i++)
				sndlastfil[i] = filename[i];

			if ((sndfil = open(filename, O_BINARY, S_IREAD)) == -1)
				return(-1);
			lseek(sndfil,44,SEEK_SET);
			sndleng = read(sndfil,sndptr,32768);
			close(sndfil);
		}
	}
	else
	{
		sndlastfil[0] = 0;
	}

	if (sndleng < 4)
		return(0);

	outp(0xa,0x5);

	if ((volume == 255) || (volume < 0))
		copybuf(sndwrongaddr,sndrightaddr,(sndleng+3)>>2);
	else
	{
		for(i=0;i<256;i++)
			sndvolumetable[i] = (char)((((i-128)*(volume+1))>>8)+128);
		sndvolumeadjust(sndleng,(long)(&sndvolumetable[0]),sndwrongaddr,sndrightaddr);
	}

	outp(0xc,0);
	outp(0xb,0x49);
	outp(0x2,(char)(sndrightaddr&255)); outp(0x2,(char)((sndrightaddr>>8)&255));
	outp(0x3,(char)sndleng&255); outp(0x3,(char)(sndleng>>8)&255);
	outp(0x83,(char)((sndrightaddr>>16)&255));
	outp(0xa,0x1);
	sbwait(); outp(sndportaddr+0xc,0x14);
	sbwait(); outp(sndportaddr+0xc,(char)sndleng&255);
	sbwait(); outp(sndportaddr+0xc,(char)(sndleng>>8)&255);
	return(0);
}

loadsound(char filename[80], char *ptr)
{
	short sndfil;

	if (strchr(filename,'.') == 0)
		strcat(filename,".wav");
	if ((sndfil = open(filename, O_BINARY, S_IREAD)) == -1)
		return(-1);
	read(sndfil,&sndheader[0],44);
	sndleng = read(sndfil,ptr,32768);
	close(sndfil);
	return(0);
}

savesound(char filename[80], char *ptr, long daleng)
{
	short sndfil;

	if (strchr(filename,'.') == 0)
		strcat(filename,".wav");
	if ((sndfil = open(filename,O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) == -1)
		return(-1);

	sndheader[4] = ((daleng+36)&255);
	sndheader[5] = (((daleng+36)>>8)&255);
	sndheader[6] = (((daleng+36)>>16)&255);
	sndheader[7] = (((daleng+36)>>24)&255);
	sndheader[40] = (daleng&255);
	sndheader[41] = ((daleng>>8)&255);
	sndheader[42] = ((daleng>>16)&255);
	sndheader[43] = ((daleng>>24)&255);

	write(sndfil,&sndheader[0],44);
	write(sndfil,ptr,daleng);
	close(sndfil);
	return(0);
}

drawscreen(long sndstart, long sndend, long totsndleng, short viewside)
{
	long i, x1, x2, x, y;

	clearbuf(0xa0000,16000L,0L);

	if (viewside == 0)
		i = sndstart-160;
	else
		i = sndend-160;

	x1 = sndstart-i;
	x2 = sndend-i;

	if ((x1 >= 0) && (x1 < 320))
		for(y=0;y<128;y++)
			drawpixel(0xa0000+x1+(y*320),4);

	if ((x2 >= 0) && (x2 < 320))
		for(y=0;y<128;y++)
			drawpixel(0xa0000+x2+(y*320),4);

	if (x1 < 0) x1 = 0;
	if (x2 >= 319) x2 = 319;
	for(x=x1;x<x2;x++)
	{
		drawpixel(0xa0000+x+0,4);
		drawpixel(0xa0000+x+(128*320),4);
	}

	for(x=0;x<320;x++)
	{
		drawpixel(0xa0000+x+(64*320),8);
		if ((i >= 0) && (i < totsndleng))
			drawpixel(0xa0000+x+((sndbuffer[i]>>1)*320),7);
		i++;
	}
}
