#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#define numwalls 14
#define textwall 13

static int lborder[numwalls+1], rborder[numwalls+1], scrsize;
static unsigned int times90[240], less64inc[64];
static long tantable[1025], sintable[2050];
static int radarang[384];
static unsigned int height[360], sprinum[360];
static unsigned int pageoffset, lastpageoffset;
static unsigned int pic, walseg[numwalls+1];
static unsigned char tempbuf[4096], palette[768];
static unsigned char paldef[16][3] =
{
	0,30,63,28,34,60,0,50,20,41,52,28,63,63,25,63,63,63,63,20,20,63,0,63,
	63,48,27,63,40,25,63,48,48,45,63,45,55,55,63,63,40,63,63,30,20,55,25,30
};
static int startaddressoffset;
static int vidmode, lside, rside, dside, halfheight, tileng[numwalls+1];
static unsigned char textbuf[41];
static int textxpos, textypos;
static unsigned convavailpages, convwalls;
static int savex[64], savey[64], savepic[64], savenum;
static unsigned char board[8][8] =
{
	4,2,3,5,6,3,2,4,
	1,1,1,1,1,1,1,1,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	7,7,7,7,7,7,7,7,
	10,8,9,11,12,9,8,10
};

main(int argc,char **argv)
{
	char ch, buffer[40];
	int i, j, x, y, siz, hvel, zvel, angvel, fil, picseg, ang;
	int walcounter, gap, temp, posz, posh;
	unsigned l;
	time_t tnow;

	loadtables();
	vidmode = 0;
	if (argc == 2)
		if (atoi(argv[1]) < 0)
			vidmode = 1;
	if (vidmode == 0)
	{
		lside = 20;
		rside = 340;
		dside = 200;
		halfheight = 100;
		scrsize = 18000;
	}
	else
	{
		lside = 0;
		rside = 360;
		dside = 240;
		halfheight = 120;
		scrsize = 21600;
	}
	time(&tnow);
	srand((unsigned)tnow);
	convwalls = numwalls;
	pic = convallocate(numwalls<<8);
	l = pic;
	for(i=0;i<numwalls;i++)
	{
		walseg[i] = l;
		l += 256;
	}
	for(i=0;i<360;i++)
		height[i] = 0;
	l = 0;
	for(i=0;i<240;i++)
	{
		times90[i] = l;
		l += 90;
	}
	less64inc[0] = 16384;
	for(i=1;i<64;i++)
		less64inc[i] = 16384 / i;
	_asm \
	{
		mov ax, 0x13
		int 0x10
	}
	if (vidmode == 1)
		setmode360240();
	outp(0x3d4,0x13); outp(0x3d5,45);                   //Bytes per Line
	outp(0x3c4,0x4); outp(0x3c5,inp(0x3c5)&(255-8));    //Chain 4 off
	outp(0x3d4,0x17); outp(0x3d5,inp(0x3d5)|64);        //Word Mode
	outp(0x3d4,0x14); outp(0x3d5,inp(0x3d5)&(255-64));  //Double Word Mode
	loadwalls();
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	x = 180;
	y = halfheight;
	posh = 0;
	posz = 32;
	siz = 64;
	hvel = 0;
	zvel = 0;
	angvel = 0;
	ch = 0;
	pageoffset = 0;
	startaddressoffset = 0;
	if (vidmode == 0)
		startaddressoffset += 1805;
	textxpos = 20;
	if (vidmode == 0)
		textypos = 0;
	else
		textypos = 20;

	lastpageoffset = 2880;
	pageoffset = 2880;
	ang = 0;
	while (ch != 27)
	{
		outp(0x3c4,0x2); outp(0x3c5,255);
		_asm \
		{
			mov ax, 0xa000
			mov es, ax
			cld
		}
		if (vidmode == 0)
			_asm \
			{
				mov di, pageoffset
				mov cx, 9000
				shr cx, 1
				mov ax, 0xe3e3
				rep stosw
				mov di, pageoffset
				add di, 9000
				mov bx, 0
				add di, bx
				mov cx, 9000
				sub cx, bx
				shr cx, 1
				mov ax, 0x8585
				rep stosw
			}
		else
			_asm \
			{
				mov di, pageoffset
				mov cx, 10800
				shr cx, 1
				mov ax, 0xe3e3
				rep stosw
				mov di, pageoffset
				add di, 10800
				mov bx, 0
				add di, bx
				mov cx, 10800
				sub cx, bx
				shr cx, 1
				mov ax, 0x8585
				rep stosw
			}

		savenum = 0;
		for(i=0;i<8;i++)
			for(j=0;j<8;j++)
			{
				if (board[i][j] > 0)
				{
					savex[savenum] = (int)((((long)(i-4))*sintable[(2048+ang)&2047]-((long)(j-4))*sintable[(2560+ang)&2047])>>11);
					savey[savenum] = (int)((((long)(i-4))*sintable[(2560+ang)&2047]+((long)(j-4))*sintable[(2048+ang)&2047])>>11);
					savepic[savenum] = (int)(board[i][j]);
					savenum++;
				}
			}
		gap = (savenum>>1);
		while (gap > 0)
		{
			for(i=0;i<savenum-gap;i++)
			{

				temp = i;
				while (savey[i] > savey[i+gap])
				{
					j = savex[i], savex[i] = savex[i+gap], savex[i+gap] = j;
					j = savey[i], savey[i] = savey[i+gap], savey[i+gap] = j;
					j = savepic[i], savepic[i] = savepic[i+gap], savepic[i+gap] = j;
					temp -= gap;
					if (temp < 0)
						 break;
				}
			}
			gap >>= 1;
		}
		for(i=0;i<savenum;i++)
		{
			siz = 16384/(256-savey[i]);
			spridraw(180+((savex[i]*siz)>>6)-(siz>>1),halfheight-((siz*posz)>>6)+posh,siz,savepic[i]);
		}

		lastpageoffset = pageoffset;
		if (vidmode == 0)
		{
			_asm \
			{
				mov bx, lastpageoffset
				add bx, 5
				mov al, 0xc
				mov ah, bh
				mov cl, 0xd
				mov ch, bl
				mov dx, 0x3d4
				out dx, al
				inc dx
				mov al, ah
				out dx, al
				mov ax, cx
				dec dx
				out dx, al
				inc dx
				mov al, ah
				out dx, al
			}
			if (lastpageoffset < 21312) pageoffset = 21312;
			if (lastpageoffset == 21312) pageoffset = 39744;
			if (lastpageoffset > 21312) pageoffset = 2880;
		}
		else
		{
			_asm \
			{
				mov bx, lastpageoffset
				mov al, 0xc
				mov ah, bh
				mov cl, 0xd
				mov ch, bl
				mov dx, 0x3d4
				out dx, al
				inc dx
				mov al, ah
				out dx, al
				mov ax, cx
				dec dx
				out dx, al
				inc dx
				mov al, ah
				out dx, al
			}
			if (lastpageoffset < 21600) pageoffset = 21600;
			if (lastpageoffset == 21600) pageoffset = 43200;
			if (lastpageoffset > 21600) pageoffset = 0;
		}
		if (kbhit() != 0)
		{
			ch = getch();
			if (ch == 32)
			{
				hvel = 0;
				zvel = 0;
				angvel = 0;
			}
			if (ch == 0)
			{
				ch = getch();
				if (ch == 75) angvel--;
				if (ch == 77) angvel++;
				if (ch == 72) hvel--;
				if (ch == 80) hvel++;
				if (ch == 73) zvel--;
				if (ch == 81) zvel++;
			}
		}
		posh += hvel;
		posz += zvel;
		ang += ((angvel+2048)&2047);
	}
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	convdeallocate(pic);
}

textprint()
{
	unsigned char character;
	int i, x, y, charcnt, picplc, owalnum, walnum;
	unsigned int picseg, plc;

	_asm \
	{
		mov ax, 0xa000
		mov es, ax
	}
	x = textxpos;
	y = textypos;
	outp(0x3c4,0x2);
	plc = times90[y]+(x>>2)+pageoffset;
	charcnt = 0;
	while ((textbuf[charcnt] != 0) && (charcnt < 40))
	{
		character = (textbuf[charcnt])&127;
		owalnum = walnum;
		walnum = (character>>6)+textwall;
		picseg = walseg[walnum-1];
		picplc = ((character&7)<<9)+(((character&63)>>3)<<3);
		for(i=0;i<8;i++)
		{
			if ((x >= lside) && (x < rside))
			{
				outp(0x3c5,1<<(x&3));
				_asm \
				{
					mov cx, 8
					mov si, picplc
					mov di, plc
					push ds
					mov ds, picseg
startlett1:
					lodsb
					cmp al, 255
					je skipitlett1
					mov es:[di], al
skipitlett1:
					add di, 90
					loop startlett1
					pop ds
				}
			}
			picplc += 64;
			x++;
			plc += ((x&3) == 0);
		}
		charcnt++;
	}
}

spridraw(x, y, siz, walnume)
int x, y, siz, walnume;
{
	int i, lsid, rsid, xc, picplc, linesatonce;

	picplc = 0;
	lsid = lborder[walnume];
	rsid = rborder[walnume];
	_asm \
	{
		mov dx, 0x3c4
		mov al, 0x2
		out dx, al
	}
	xc = 64;
	if (siz < 64)
	{
		for(i=0;i<64;i++)
		{
			if (xc >= 64)
			{
				if ((picplc >= lsid) && (picplc < rsid) && (x >= lside) && (x < rside) && (siz >= height[x]))
				{
					_asm \
					{
						mov dx, 0x3c5
						mov cl, x
						and cl, 3
						mov al, 1
						shl al, cl
						out dx, al
					}
					vline(x,y,siz,walnume,picplc);
				}
				xc -= 64;
				x++;
			}
			picplc += 64;
			xc += siz;
		}
	}
	else if (siz >= 64)
	{
		for(i=x;i<x+siz;i++)
		{
			if ((i >= lside) && (i < rside))
			{
				if ((siz >= height[i]) && (picplc >= lsid) && (picplc < rsid))
					sprinum[i] = picplc;
				else
					sprinum[i] = 65535;
			}
			xc += 64;
			if (xc >= siz)
			{
				xc -= siz;
				picplc += 64;
			}
		}
		if ((x+siz) < rside)
			sprinum[x+siz] = 65534;
		for(i=x;i<x+siz;i++)
			if ((i >= lside) && (i < rside) && (sprinum[i] != 65535))
			{
				_asm \
				{
					mov dx, 0x3c5
					mov cl, i
					and cl, 3
					mov al, 1
					shl al, cl
					out dx, al
				}
				linesatonce = 0;
				if (((i&3) < 3) && (sprinum[i] == sprinum[i+1]))
				{
					_asm \
					{
						mov dx, 0x3c5
						mov cl, i
						and cl, 3
						mov al, 3
						shl al, cl
						out dx, al
					}
					linesatonce = 1;
					if (((i&3) < 2) && (sprinum[i] == sprinum[i+2]))
					{
						_asm \
						{
							mov dx, 0x3c5
							mov cl, i
							and cl, 3
							mov al, 7
							shl al, cl
							out dx, al
						}
						linesatonce = 2;
						if (((i&3) == 0) && (sprinum[i] == sprinum[i+3]))
						{
							_asm \
							{
								mov dx, 0x3c5
								mov al, 15
								out dx, al
							}
							linesatonce = 3;
						}
					}
				}
				vline(i,y,siz,walnume,sprinum[i]);
				i += linesatonce;
			}
	}
}

setmode360240()
{
	outp(0x3c4,0x4); outp(0x3c5,0x6);
	outp(0x3c4,0x0); outp(0x3c5,0x1);
	outp(0x3c2,0xe7);
	outp(0x3c4,0x0); outp(0x3c5,0x3);
	outp(0x3d4,0x11); outp(0x3d5,inp(0x3d5)&0x7f);      //Unlock indeces 0-7
	outp(0x3d4,0x0); outp(0x3d5,0x6b);
	outp(0x3d4,0x1); outp(0x3d5,0x59);
	outp(0x3d4,0x2); outp(0x3d5,0x5a);
	outp(0x3d4,0x3); outp(0x3d5,0x8e);
	outp(0x3d4,0x4); outp(0x3d5,0x5e);
	outp(0x3d4,0x5); outp(0x3d5,0x8a);
	outp(0x3d4,0x6); outp(0x3d5,0xd);
	outp(0x3d4,0x7); outp(0x3d5,0x3e);
	outp(0x3d4,0x9); outp(0x3d5,0x41);
	outp(0x3d4,0x10); outp(0x3d5,0xea);
	outp(0x3d4,0x11); outp(0x3d5,0xac);
	outp(0x3d4,0x12); outp(0x3d5,0xdf);
	outp(0x3d4,0x13); outp(0x3d5,45);
	outp(0x3d4,0x14); outp(0x3d5,0x0);
	outp(0x3d4,0x15); outp(0x3d5,0xe7);
	outp(0x3d4,0x16); outp(0x3d5,0x6);
	outp(0x3d4,0x17); outp(0x3d5,0xe3);
}

loadwalls()
{
	int fil, i, j, k;
	unsigned int walsegg;

	if ((fil = open("pics.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		for(i=0;i<numwalls;i++)
		{
			read(fil,&tempbuf[0],4096);
			_asm \
			{
				mov bx, i
				shl bx, 1
				mov ax, walseg[bx]
				mov es, ax
				cld
				xor di, di
				mov cx, 2048
				mov ax, seg tempbuf
				mov si, offset tempbuf
				push ds
				mov ds, ax
				rep movsw
				pop ds

				mov bx, i
				shl bx, 1
				mov di, 0
begcheckltrim:
				cmp es:[di], 255
				jnz endcheckltrim
				inc di
				cmp di, 4096
				jb begcheckltrim
endcheckltrim:
				and di, 0xfc0
				mov lborder[bx+2], di
				mov di, 4095
begcheckrtrim:
				cmp es:[di], 255
				jnz endcheckrtrim
				sub di, 1
				jns begcheckrtrim
endcheckrtrim:
				and di, 0xfc0
				add di, 64
				mov rborder[bx+2], di
			}
		}
		close(fil);
		k = 0;
		for(i=0;i<16;i++)
			for(j=1;j<17;j++)
			{
				palette[k++] = (paldef[i][0]*j)/17;
				palette[k++] = (paldef[i][1]*j)/17;
				palette[k++] = (paldef[i][2]*j)/17;
			}
	}
}

loadtables()
{
	int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],8192);
		read(fil,&tantable[0],4096);
		read(fil,&radarang[0],720);
		close(fil);
	}
}

convallocate(numparagraphs)
unsigned numparagraphs;
{
	unsigned segnum;

	_asm \
	{
		mov ah, 0x48
		mov bx, numparagraphs
		int 0x21
		mov segnum, ax
		jnc convallocated
		mov segnum, -1
		mov convavailpages, bx
convallocated:
	}
	return(segnum);
}

convdeallocate(segnum)
unsigned segnum;
{
	_asm \
	{
		mov ah, 0x49
		mov es, segnum
		int 0x21
		mov segnum, 0
		jnc convdeallocated
		mov segnum, -1
convdeallocated:
	}
	return(segnum);
}

vline(x, y, siz, walnum, picplc)
int x, y, siz, walnum, picplc;
{
	unsigned int picseg, plc;

	if ((siz < 1) || (siz > 4096) || (y > dside) || (y+siz < 0))
		return(0);
	picseg = walseg[walnum-1];
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov bx, y
		or bx, bx
		jns notovertop
		mov bx, 0
notovertop:
		shl bx, 1
		mov ax, times90[bx]
		mov bx, x
		shr bx, 1
		shr bx, 1
		add ax, bx
		add ax, pageoffset
		mov plc, ax
	}
	if (siz < 64)
	{
		_asm \
		{
			mov bx, siz
			shl bx, 1
			mov cx, less64inc[bx]
			mov si, picplc
			mov dx, cx
			shr dx, 1
			mov bh, 0
			mov di, plc
			push ds
			mov ds, picseg
startspri1:
			mov bl, dh
			mov al, ds:[si+bx]
			cmp al, 255
			jb skipitspri1
			add di, 90
			add dx, cx
			cmp dh, 63
			jbe startspri1
			jmp enditspri1
skipitspri1:
			mov es:[di], al
			add di, 90
			add dx, cx
			cmp dh, 63
			jbe startspri1
enditspri1:
			pop ds
		}
		return(0);
	}
	if (y < 0)
	{
		_asm \
		{
			mov ax, y
			neg ax
			mov cl, 6
			rol ax, cl
			mov dx, ax
			and al, 0xc0
			and dx, 0x0f
			mov cx, siz
			div cx
			add picplc, ax           ;ax is dividend
			sub dx, siz              ;dx is remainder
			neg dx

			mov di, x
			shr di, 1
			shr di, 1
			add di, pageoffset
			push ds
			mov ds, picseg
			mov si, picplc           ;remember dx is (siz - remainder)
			lodsb
prespridraw:
			cmp al, 252
			jae prespriskip
			mov es:[di], al
prespriskip:
			add di, 90
			sub dx, 64
			jns prespridraw
			pop ds
			mov plc, di
			mov picplc, si
		}
	}
	if (y+siz < dside)
	{
		if (siz < 128)
		{
			_asm \
			{
				mov si, picplc
				mov cx, si
				and cx, 0x0fc0
				add cx, 65
				mov bx, siz
				mov dx, bx
				dec dx
				shl bx, 1
				shl bx, 1
				shl bx, 1
				mov di, plc
				push ds
				mov ds, picseg
startspri2:
				lodsw
				cmp si, cx
				jae skipspri2d
startspri2a:
				cmp ax, 0xffff
				je skipspri2e
				mov dh, 0
				add dx, bx
				cmp dh, 3
				je startspri2b
				ja startspri2c
				add di, 180
				cmp al, 255
				je skipspri2a
				mov es:[di-180], al
				cmp ah, 255
				je startspri2
skipspri2a:
				mov es:[di-90], ah
				jmp startspri2
skipspri2d:
				mov ah, 255
				je startspri2a
				jmp enditspri2
startspri2b:
				add di, 270
				cmp al, 255
				je skipspri2b
				mov es:[di-270], al
				mov es:[di-180], al
				cmp ah, 255
				je startspri2
skipspri2b:
				mov es:[di-90], ah
				jmp startspri2
startspri2c:
				add di, 360
				cmp al, 255
				je skipspri2c
				mov es:[di-360], al
				mov es:[di-270], al
				cmp ah, 255
				je startspri2
skipspri2c:
				mov es:[di-180], ah
				mov es:[di-90], ah
				jmp startspri2
skipspri2e:
				mov dh, 0
				add dx, bx
				cmp dh, 3
				je skipspri2f
				ja skipspri2g
				add di, 180
				jmp startspri2
skipspri2f:
				add di, 270
				jmp startspri2
skipspri2g:
				add di, 360
				jmp startspri2
enditspri2:
				pop ds
			}
			return(0);
		}
		if (siz < 192)
		{
			_asm \
			{
				mov si, picplc
				mov cx, si
				and cx, 0x0fc0
				add cx, 65
				mov bx, siz
				mov dx, bx
				dec dx
				shl bx, 1
				shl bx, 1
				shl bx, 1
				mov di, plc
				push ds
				mov ds, picseg
startspri3:
				lodsw
				cmp si, cx
				jae skipspri3g
startspri3a:
				mov dh, 0
				add dx, bx
				cmp dh, 5
				je startspri3b
				ja startspri3c
				cmp al, 255
				je skipspri3a
				mov es:[di], al
				mov es:[di+90], al
skipspri3a:
				cmp ah, 255
				je skipspri3b
				mov es:[di+180], ah
				mov es:[di+270], ah
skipspri3b:
				add di, 360
				jmp startspri3
startspri3b:
				cmp al, 255
				je skipspri3c
				mov es:[di], al
				mov es:[di+90], al
				mov es:[di+180], al
skipspri3c:
				cmp ah, 255
				je skipspri3d
				mov es:[di+270], ah
				mov es:[di+360], ah
skipspri3d:
				add di, 450
				jmp startspri3
startspri3c:
				cmp al, 255
				je skipspri3e
				mov es:[di], al
				mov es:[di+90], al
				mov es:[di+180], al
skipspri3e:
				cmp ah, 255
				je skipspri3f
				mov es:[di+270], ah
				mov es:[di+360], ah
				mov es:[di+450], ah
skipspri3f:
				add di, 540
				jmp startspri3
skipspri3g:
				mov ah, 255
				jne enditspri3
				jmp startspri3a
enditspri3:
				pop ds
			}
			return(0);
		}
		if (siz < 256)
		{
			_asm \
			{
				mov si, picplc
				mov cx, si
				and cx, 0x0fc0
				add cx, 65
				mov bx, siz
				mov dx, bx
				dec dx
				shl bx, 1
				shl bx, 1
				shl bx, 1
				mov di, plc
				push ds
				mov ds, picseg
startspri4:
				lodsw
				cmp si, cx
				jae skipspri4g
startspri4a:
				mov dh, 0
				add dx, bx
				cmp dh, 7
				je startspri4b
				ja startspri4c
				cmp al, 255
				je skipspri4a
				mov es:[di], al
				mov es:[di+90], al
				mov es:[di+180], al
skipspri4a:
				cmp ah, 255
				je skipspri4b
				mov es:[di+270], ah
				mov es:[di+360], ah
				mov es:[di+450], ah
skipspri4b:
				add di, 540
				jmp startspri4
skipspri4g:
				mov ah, 255
				jne enditspri4
				jmp startspri4a
startspri4b:
				cmp al, 255
				je skipspri4c
				mov es:[di], al
				mov es:[di+90], al
				mov es:[di+180], al
				mov es:[di+270], al
skipspri4c:
				cmp ah, 255
				je skipspri4d
				mov es:[di+360], ah
				mov es:[di+450], ah
				mov es:[di+540], ah
skipspri4d:
				add di, 630
				jmp startspri4
startspri4c:
				cmp al, 255
				je skipspri4e
				mov es:[di], al
				mov es:[di+90], al
				mov es:[di+180], al
				mov es:[di+270], al
skipspri4e:
				cmp ah, 255
				je skipspri4f
				mov es:[di+360], ah
				mov es:[di+450], ah
				mov es:[di+540], ah
				mov es:[di+630], ah
skipspri4f:
				add di, 720
				jmp startspri4
enditspri4:
				pop ds
			}
			return(0);
		}
		_asm \
		{
			mov di, plc
			mov si, picplc
			mov cx, si
			and cx, 0x0fc0
			add cx, 64
			mov bx, siz
			mov dx, bx
			dec dx
			push ds
			mov ds, picseg
			lodsb
startspri5:
			cmp al, 255
			je skipspri5a
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
			mov es:[di+270], al
skipspri5a:
			add di, 360
			sub dx, 256
			js startspri5c
			or dh, dh
			jnz startspri5
startspri5b:
			cmp al, 255
			je skipspri5b
			mov es:[di], al
skipspri5b:
			add di, 90
			sub dx, 64
			jns startspri5b
startspri5c:
			lodsb
			add dx, bx
			cmp si, cx
			jbe startspri5
			pop ds
			}
		return(0);
	}
	if (siz < 128)
	{
		_asm \
		{
			mov si, picplc
			mov cx, pageoffset
			add cx, scrsize
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri6:
			lodsw
			cmp di, cx
			jae skipspri6d
startspri6a:
			cmp ax, 0xffff
			je skipspri6e
			mov dh, 0
			add dx, bx
			cmp dh, 3
			je startspri6b
			ja startspri6c
			add di, 180
			cmp al, 255
			je skipspri6a
			mov es:[di-180], al
			cmp ah, 255
			je startspri6
skipspri6a:
			mov es:[di-90], ah
			jmp startspri6
skipspri6d:
			mov ah, 255
			je startspri6a
			jmp enditspri6
startspri6b:
			add di, 270
			cmp al, 255
			je skipspri6b
			mov es:[di-270], al
			mov es:[di-180], al
			cmp ah, 255
			je startspri6
skipspri6b:
			mov es:[di-90], ah
			jmp startspri6
startspri6c:
			add di, 360
			cmp al, 255
			je skipspri6c
			mov es:[di-360], al
			mov es:[di-270], al
			cmp ah, 255
			je startspri6
skipspri6c:
			mov es:[di-180], ah
			mov es:[di-90], ah
			jmp startspri6
skipspri6e:
			mov dh, 0
			add dx, bx
			cmp dh, 3
			je skipspri6f
			ja skipspri6g
			add di, 180
			jmp startspri6
skipspri6f:
			add di, 270
			jmp startspri6
skipspri6g:
			add di, 360
			jmp startspri6
enditspri6:
			pop ds
		}
		return(0);
	}
	if (siz < 192)
	{
		_asm \
		{
			mov si, picplc
			mov cx, pageoffset
			add cx, scrsize
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri7:
			lodsw
			cmp di, cx
			jae skipspri7g
startspri7a:
			mov dh, 0
			add dx, bx
			cmp dh, 5
			je startspri7b
			ja startspri7c
			cmp al, 255
			je skipspri7a
			mov es:[di], al
			mov es:[di+90], al
skipspri7a:
			cmp ah, 255
			je skipspri7b
			mov es:[di+180], ah
			mov es:[di+270], ah
skipspri7b:
			add di, 360
			jmp startspri7
startspri7b:
			cmp al, 255
			je skipspri7c
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri7c:
			cmp ah, 255
			je skipspri7d
			mov es:[di+270], ah
			mov es:[di+360], ah
skipspri7d:
			add di, 450
			jmp startspri7
startspri7c:
			cmp al, 255
			je skipspri7e
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri7e:
			cmp ah, 255
			je skipspri7f
			mov es:[di+270], ah
			mov es:[di+360], ah
			mov es:[di+450], ah
skipspri7f:
			add di, 540
			jmp startspri7
skipspri7g:
			mov ah, 255
			jae enditspri7
			jmp startspri7a
enditspri7:
			pop ds
		}
		return(0);
	}
	if (siz < 256)
	{
		_asm \
		{
			mov si, picplc
			mov cx, pageoffset
			add cx, scrsize
			mov bx, siz
			mov dx, bx
			dec dx
			shl bx, 1
			shl bx, 1
			shl bx, 1
			mov di, plc
			push ds
			mov ds, picseg
startspri8:
			lodsw
			cmp di, cx
			jae skipspri8g
startspri8a:
			mov dh, 0
			add dx, bx
			cmp dh, 7
			je startspri8b
			ja startspri8c
			cmp al, 255
			je skipspri8a
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
skipspri8a:
			cmp ah, 255
			je skipspri8b
			mov es:[di+270], ah
			mov es:[di+360], ah
			mov es:[di+450], ah
skipspri8b:
			add di, 540
			jmp startspri8
skipspri8g:
			mov ah, 255
			jae enditspri8
			jmp startspri8a
startspri8b:
			cmp al, 255
			je skipspri8c
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
			mov es:[di+270], al
skipspri8c:
			cmp ah, 255
			je skipspri8d
			mov es:[di+360], ah
			mov es:[di+450], ah
			mov es:[di+540], ah
skipspri8d:
			add di, 630
			jmp startspri8
startspri8c:
			cmp al, 255
			je skipspri8e
			mov es:[di], al
			mov es:[di+90], al
			mov es:[di+180], al
			mov es:[di+270], al
skipspri8e:
			cmp ah, 255
			je skipspri8f
			mov es:[di+360], ah
			mov es:[di+450], ah
			mov es:[di+540], ah
			mov es:[di+630], ah
skipspri8f:
			add di, 720
			jmp startspri8
enditspri8:
			pop ds
		}
		return(0);
	}
	_asm \
	{
		mov di, plc
		mov si, picplc
		mov cx, pageoffset
		add cx, scrsize
		mov bx, siz
		mov dx, bx
		dec dx
		push ds
		mov ds, picseg
		lodsb
		cmp al, 255
		je startspri9d
startspri9:
		mov es:[di], al
		mov es:[di+90], al
		mov es:[di+180], al
		mov es:[di+270], al
		add di, 360
		cmp di, cx
		jae enditspri9
		sub dx, 256
		js startspri9c
		cmp dh, 0
		jg startspri9
startspri9b:
		mov es:[di], al
		add di, 90
		sub dx, 64
		jns startspri9b
startspri9c:
		lodsb
		add dx, bx
		cmp al, 255
		jne startspri9
startspri9d:
		add di, 360
		cmp di, cx
		jae enditspri9
		sub dx, 256
		js startspri9c
		cmp dh, 0
		jg startspri9d
startspri9e:
		add di, 90
		sub dx, 64
		jns startspri9e
		jmp startspri9c
enditspri9:
		pop ds
	}
}
