DECLARE SUB draw3dclipline (bfx0!, bfy0!, bfz0!, bfx1!, bfy1!, bfz1!, col%)
DECLARE FUNCTION clip3dline% (x1!, y1!, z1!, x2!, y2!, z2!)
DECLARE SUB drawrect (x1%, y1%, z1%, x2%, y2%, z2%, col%)
DECLARE SUB setuprotate3d (a1%, a2%, a3%)
DECLARE SUB loadboard ()
DECLARE SUB makeboxbsp ()
DECLARE SUB rotate3d (nx!, ny!, nz!)

CONST XDIM = 640, YDIM = 350
CONST HXDIM = 320, HYDIM = 175
CONST BSIZ = 16
CONST MAXSECTORS = BSIZ * BSIZ * BSIZ

DIM SHARED board%(BSIZ * BSIZ * BSIZ)
DIM SHARED tempshort%(BSIZ * BSIZ * BSIZ)

DIM SHARED numsectors%
DIM SHARED cubesect%(BSIZ * BSIZ * BSIZ)
DIM SHARED sectx1%(MAXSECTORS), secty1%(MAXSECTORS), sectz1%(MAXSECTORS)
DIM SHARED sectx2%(MAXSECTORS), secty2%(MAXSECTORS), sectz2%(MAXSECTORS)

DIM SHARED posx&, posy&, posz&, a1%, a2%, a3%
DIM SHARED gxx, gxy, gxz, gyx, gyy, gyz, gzx, gzy, gzz

DIM SHARED regs%(7)

SCREEN 9: RANDOMIZE TIMER
regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())

DO
   CALL loadboard
   CALL makeboxbsp

   pag% = 1
   DO
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      a3% = a3% + regs%(2): a2% = a2% - regs%(3)
     
      CLS
      CALL setuprotate3d(a1%, a2%, a3%)
 
      IF posx& < 0 OR posx& >= BSIZ * 1024 OR posy& < 0 OR posy& >= BSIZ * 1024 OR posz& < 0 OR posz& >= BSIZ * 1024 THEN
         cursectnum% = -1
      ELSE
         cursectnum% = cubesect%((posx& \ 1024) * BSIZ * BSIZ + (posy& \ 1024) * BSIZ + (posz& \ 1024))
      END IF

      FOR z% = numsectors% - 1 TO 0 STEP -1
         CALL drawrect(sectx1%(z%), secty1%(z%), sectz1%(z%), sectx2%(z%), secty2%(z%), sectz2%(z%), 7)
      NEXT z%
      IF cursectnum% >= 0 THEN
         z% = cursectnum%
         CALL drawrect(sectx1%(z%), secty1%(z%), sectz1%(z%), sectx2%(z%), secty2%(z%), sectz2%(z%), 15)
      END IF

      SCREEN , , pag%, 1 - pag%: pag% = 1 - pag%
      WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8

      DO
         z$ = INKEY$
         IF UCASE$(z$) = "A" THEN posx& = posx& - gxy * 256: posy& = posy& - gyy * 256: posz& = posz& - gzy * 256
         IF UCASE$(z$) = "Z" THEN posx& = posx& + gxy * 256: posy& = posy& + gyy * 256: posz& = posz& + gzy * 256
         IF z$ = CHR$(0) + CHR$(72) THEN posx& = posx& + gxz * 256: posy& = posy& + gyz * 256: posz& = posz& + gzz * 256
         IF z$ = CHR$(0) + CHR$(80) THEN posx& = posx& - gxz * 256: posy& = posy& - gyz * 256: posz& = posz& - gzz * 256
      LOOP WHILE z$ <> "" AND z$ <> CHR$(13) AND z$ <> CHR$(27)
   LOOP WHILE z$ <> CHR$(13) AND z$ <> CHR$(27)
LOOP WHILE z$ <> CHR$(27)

FUNCTION clip3dline% (x1, y1, z1, x2, y2, z2)
   a = 0: b = 1
  
   t1 = z1 + x1: t2 = z2 + x2
   IF ((t1 AND t2) < 0) THEN clip3dline% = 0: EXIT FUNCTION
   IF ((t1 XOR t2) < 0) THEN
      t = t1 / (t1 - t2)
      IF t1 < 0 AND t > a THEN a = t
      IF t1 > 0 AND t < b THEN b = t
   END IF
  
   t1 = z1 - x1: t2 = z2 - x2
   IF ((t1 AND t2) < 0) THEN clip3dline% = 0: EXIT FUNCTION
   IF ((t1 XOR t2) < 0) THEN
      t = t1 / (t1 - t2)
      IF t1 < 0 AND t > a THEN a = t
      IF t1 > 0 AND t < b THEN b = t
   END IF

   t1 = z1 * .625 + y1: t2 = z2 * .625 + y2
   IF ((t1 AND t2) < 0) THEN clip3dline% = 0: EXIT FUNCTION
   IF ((t1 XOR t2) < 0) THEN
      t = t1 / (t1 - t2)
      IF t1 < 0 AND t > a THEN a = t
      IF t1 > 0 AND t < b THEN b = t
   END IF
  
   t1 = t1 - (y1 + y1): t2 = t2 - (y2 + y2)
   IF ((t1 AND t2) < 0) THEN clip3dline% = 0: EXIT FUNCTION
   IF ((t1 XOR t2) < 0) THEN
      t = t1 / (t1 - t2)
      IF t1 < 0 AND t > a THEN a = t
      IF t1 > 0 AND t < b THEN b = t
   END IF

   IF a <> 0 THEN x1 = (x2 - x1) * a + x1: y1 = (y2 - y1) * a + y1: z1 = (z2 - z1) * a + z1
   IF b <> 1 THEN x2 = (x2 - x1) * b + x1: y2 = (y2 - y1) * b + y1: z2 = (z2 - z1) * b + z1

   clip3dline% = 1
END FUNCTION

SUB draw3dclipline (bfx0, bfy0, bfz0, bfx1, bfy1, bfz1, col%)
   fx0 = bfx0: fy0 = bfy0: fz0 = bfz0
   fx1 = bfx1: fy1 = bfy1: fz1 = bfz1
   CALL rotate3d(fx0, fy0, fz0)
   CALL rotate3d(fx1, fy1, fz1)
   IF ((fz0 <= 0) AND (fz1 <= 0)) THEN EXIT SUB
   IF (clip3dline(fx0, fy0, fz0, fx1, fy1, fz1) = 0) THEN EXIT SUB
   IF ((fz0 <= 0) OR (fz1 <= 0)) THEN EXIT SUB
   ft0 = HXDIM / fz0: ft1 = HXDIM / fz1
   LINE (fx0 * ft0 + HXDIM, fy0 * ft0 + HYDIM)-(fx1 * ft1 + HXDIM, fy1 * ft1 + HYDIM), col%
END SUB

SUB drawrect (x1%, y1%, z1%, x2%, y2%, z2%, col%)
   x0 = (x1% + 0) * 1024 - posx&: y0 = (y1% + 0) * 1024 - posy&: z0 = (z1% + 0) * 1024 - posz&
   x1 = (x2% + 1) * 1024 - posx&: y1 = (y1% + 0) * 1024 - posy&: z1 = (z1% + 0) * 1024 - posz&
   x2 = (x1% + 0) * 1024 - posx&: y2 = (y2% + 1) * 1024 - posy&: z2 = (z1% + 0) * 1024 - posz&
   x3 = (x2% + 1) * 1024 - posx&: y3 = (y2% + 1) * 1024 - posy&: z3 = (z1% + 0) * 1024 - posz&
   x4 = (x1% + 0) * 1024 - posx&: y4 = (y1% + 0) * 1024 - posy&: z4 = (z2% + 1) * 1024 - posz&
   x5 = (x2% + 1) * 1024 - posx&: y5 = (y1% + 0) * 1024 - posy&: z5 = (z2% + 1) * 1024 - posz&
   x6 = (x1% + 0) * 1024 - posx&: y6 = (y2% + 1) * 1024 - posy&: z6 = (z2% + 1) * 1024 - posz&
   x7 = (x2% + 1) * 1024 - posx&: y7 = (y2% + 1) * 1024 - posy&: z7 = (z2% + 1) * 1024 - posz&
  
   CALL draw3dclipline(x0, y0, z0, x4, y4, z4, col%)
   CALL draw3dclipline(x1, y1, z1, x5, y5, z5, col%)
   CALL draw3dclipline(x2, y2, z2, x6, y6, z6, col%)
   CALL draw3dclipline(x3, y3, z3, x7, y7, z7, col%)
  
   CALL draw3dclipline(x0, y0, z0, x1, y1, z1, col%)
   CALL draw3dclipline(x2, y2, z2, x3, y3, z3, col%)
   CALL draw3dclipline(x4, y4, z4, x5, y5, z5, col%)
   CALL draw3dclipline(x6, y6, z6, x7, y7, z7, col%)
  
   CALL draw3dclipline(x0, y0, z0, x2, y2, z2, col%)
   CALL draw3dclipline(x1, y1, z1, x3, y3, z3, col%)
   CALL draw3dclipline(x4, y4, z4, x6, y6, z6, col%)
   CALL draw3dclipline(x5, y5, z5, x7, y7, z7, col%)
END SUB

SUB loadboard
   OPEN "board.cub" FOR BINARY AS #1
   GET #1, , versionum&: IF versionum& <> &HCBE THEN PRINT "Wrong cube version": END
   GET #1, , posx&
   GET #1, , posy&
   GET #1, , posz&
   GET #1, , a1&: a1% = a1&
   GET #1, , a2&: a2% = a2&
   GET #1, , a3&: a3% = a3&
   FOR z% = 0 TO BSIZ * BSIZ * BSIZ - 1: GET #1, , board%(z%): NEXT z%
   CLOSE #1
END SUB

SUB makeboxbsp
   a% = 0
   FOR i% = BSIZ * BSIZ * BSIZ - 1 TO 0 STEP -1
      IF board%(i%) < 0 THEN cubesect%(i%) = -2: tempshort%(a%) = i%: a% = a% + 1
   NEXT i%
  
   numsectors% = 0
   DO
      i% = INT(a% * RND)
      x% = tempshort%(i%) \ (BSIZ * BSIZ)
      y% = (tempshort%(i%) \ BSIZ) MOD BSIZ
      z% = tempshort%(i%) MOD BSIZ
      IF cubesect%(tempshort%(i%)) = -2 THEN
         x1% = x%: y1% = y%: z1% = z%: x2% = x%: y2% = y%: z2% = z%: bad% = 0
         DO
            IF (bad% AND 1) = 0 THEN
               x2% = x2% + 1
               FOR yy% = y1% TO y2%
                  FOR zz% = z1% TO z2%
                     IF cubesect%(x2% * BSIZ * BSIZ + yy% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 1: x2% = x2% - 1: EXIT FOR
                  NEXT zz%
               NEXT yy%
            END IF
            IF (bad% AND 2) = 0 THEN
               y2% = y2% + 1
               FOR xx% = x1% TO x2%
                  FOR zz% = z1% TO z2%
                     IF cubesect%(xx% * BSIZ * BSIZ + y2% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 2: y2% = y2% - 1: EXIT FOR
                  NEXT zz%
               NEXT xx%
            END IF
            IF (bad% AND 4) = 0 THEN
               z2% = z2% + 1
               FOR xx% = x1% TO x2%
                  FOR yy% = y1% TO y2%
                     IF cubesect%(xx% * BSIZ * BSIZ + yy% * BSIZ + z2%) <> -2 THEN bad% = bad% OR 4: z2% = z2% - 1: EXIT FOR
                  NEXT yy%
               NEXT xx%
            END IF
            IF (bad% AND 8) = 0 THEN
               x1% = x1% - 1
               FOR yy% = y1% TO y2%
                  FOR zz% = z1% TO z2%
                     IF cubesect%(x1% * BSIZ * BSIZ + yy% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 8: x1% = x1% + 1: EXIT FOR
                  NEXT zz%
               NEXT yy%
            END IF
            IF (bad% AND 16) = 0 THEN
               y1% = y1% - 1
               FOR xx% = x1% TO x2%
                  FOR zz% = z1% TO z2%
                     IF cubesect%(xx% * BSIZ * BSIZ + y1% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 16: y1% = y1% + 1: EXIT FOR
                  NEXT zz%
               NEXT xx%
            END IF
            IF (bad% AND 32) = 0 THEN
               z1% = z1% - 1
               FOR xx% = x1% TO x2%
                  FOR yy% = y1% TO y2%
                     IF cubesect%(xx% * BSIZ * BSIZ + yy% * BSIZ + z1%) <> -2 THEN bad% = bad% OR 32: z1% = z1% + 1: EXIT FOR
                  NEXT yy%
               NEXT xx%
            END IF
         LOOP WHILE bad% <> 63

         FOR x% = x1% TO x2%
            FOR y% = y1% TO y2%
               FOR z% = z1% TO z2%
                  cubesect%(x% * BSIZ * BSIZ + y% * BSIZ + z%) = numsectors%
               NEXT z%
            NEXT y%
         NEXT x%
         sectx1%(numsectors%) = x1%: sectx2%(numsectors%) = x2%
         secty1%(numsectors%) = y1%: secty2%(numsectors%) = y2%
         sectz1%(numsectors%) = z1%: sectz2%(numsectors%) = z2%
         numsectors% = numsectors% + 1
      ELSE
         a% = a% - 1: IF a% <= 0 THEN EXIT SUB
         tempshort%(i%) = tempshort%(a%)
      END IF
   LOOP
END SUB

SUB rotate3d (nx, ny, nz)
   x = nx: y = ny: z = nz
   nx = x * gxx + y * gyx + z * gzx
   ny = x * gxy + y * gyy + z * gzy
   nz = x * gxz + y * gyz + z * gzz
END SUB

SUB setuprotate3d (a1%, a2%, a3%)
   cosa1 = COS(a1% * 3.141592 / 1024): sina1 = SIN(a1% * 3.141592 / 1024)
   cosa2 = COS(a2% * 3.141592 / 1024): sina2 = SIN(a2% * 3.141592 / 1024)
   cosa3 = COS(a3% * 3.141592 / 1024): sina3 = SIN(a3% * 3.141592 / 1024)
   c1c3 = cosa1 * cosa3: c1s3 = cosa1 * sina3
   s1c3 = sina1 * cosa3: s1s3 = sina1 * sina3
   gxx = s1s3 * sina2 + c1c3: gyx = -sina1 * cosa2: gzx = s1c3 * sina2 - c1s3
   gxy = -c1s3 * sina2 + s1c3: gyy = cosa1 * cosa2: gzy = -c1c3 * sina2 - s1s3
   gxz = cosa2 * sina3: gyz = sina2: gzz = cosa2 * cosa3
END SUB

