' "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
' Ken Silverman's official web site: "http://www.advsys.net/ken"
' See the included license file "BUILDLIC.TXT" for license info.

DECLARE SUB show2dboard ()
DECLARE SUB convertboard (fil$)
DECLARE SUB vline (x&, y1&, y2&, siz&, picplc&, walnume%)
DECLARE SUB florscan (xb1&, xb2&, sectnum%)
DECLARE SUB ceilscan (xb1&, xb2&, sectnum%)
DECLARE SUB loadnewall (bufplc&, wallnum%)
DECLARE SUB hline (xl&, xr&, yp&, sectnum%)
DECLARE SUB setupscreen ()
DECLARE SUB checksector (ox&, oy&, nx&, ny&)
DECLARE FUNCTION intersect% (x1l1&, y1l1&, x2l1&, y2l1&, l%)
DECLARE FUNCTION front% (l1%, l2%)
DECLARE SUB drawall (z%)
DECLARE SUB loadboard ()
DECLARE SUB loadtables ()
DECLARE SUB show3dboard ()
DECLARE SUB addboxlinum (sectore%, walle%)
DECLARE SUB scansector (sectnum%)

CONST maxsector = 4
CONST maxwalls = 64
CONST maxtiles = 4096
CONST numpalookups = 32
CONST xdim = 320
CONST ydim = 200

TYPE sectortype
   wallptr AS INTEGER
   wallnum AS INTEGER
  
   cstat1 AS INTEGER  'char  (Parallax, Groudraw)
   z1 AS INTEGER
   zosc1 AS INTEGER   'char
   picnum1 AS INTEGER
   heinum1 AS INTEGER
   shade1 AS INTEGER  'char
  
   cstat2 AS INTEGER  'char  (Parallax, Groudraw)
   z2 AS INTEGER
   zosc2 AS INTEGER   'char
   picnum2 AS INTEGER
   heinum2 AS INTEGER
   shade2 AS INTEGER  'char

END TYPE

TYPE walltype
   xa1 AS LONG
   ya1 AS LONG
   point2 AS INTEGER
   cstat AS INTEGER   'char  (Clip XOR)
   picnum AS INTEGER
   shade AS INTEGER   'char
   xrepeat AS INTEGER 'char
   yrepeat AS INTEGER 'char
   nextsector1 AS INTEGER
   nextwall1 AS INTEGER
   nextsector2 AS INTEGER
   nextwall2 AS INTEGER
END TYPE

DIM SHARED sector(maxsector) AS sectortype
DIM SHARED wall(maxwalls) AS walltype
DIM SHARED buf%(12288), tempbuf%(maxwalls)
DIM SHARED picsiz%(maxtiles), picanm%(maxtiles)
DIM SHARED sintable&(2048), got%(maxsector), linum&(xdim)
DIM SHARED umost%(xdim), dmost%(xdim), h&(xdim), uplc&(xdim), dplc&(xdim)
DIM SHARED xb1&(maxwalls), yb1&(maxwalls), xb2&(maxwalls), yb2&(maxwalls)
DIM SHARED thesector%(maxwalls), thewall%(maxwalls)
DIM SHARED llinum%(maxwalls%), rlinum%(maxwalls%)
DIM SHARED lastx&(201), palookup%(numpalookups, 256)
COMMON SHARED numsectors%, numwalls%, numscans%, cursectnum%
COMMON SHARED posx&, posy&, posz&, ang%

CALL loadtables
CALL loadboard
'CALL convertboard("boards2.dat")

CALL setupscreen
CALL loadnewall(0&, 2)
CALL loadnewall(4096&, 20)
CALL loadnewall(8192&, 40)

pag% = 0: OUT &H3CD, pag%
DO
   
   LINE (0, 0)-(319, 199), 0, BF
   'CALL show2dboard
   CALL show3dboard
   LOCATE 1, 1: PRINT cursectnum%;
  
   OUT &H3D4, &HC: OUT &H3D5, pag% * 64
   pag% = 1 - pag%
   OUT &H3CD, pag%
  
   DO
      z$ = INKEY$
   LOOP WHILE z$ = ""
  
   oldposx& = posx&: oldposy& = posy&
   IF z$ = CHR$(0) + CHR$(72) THEN
      posx& = posx& + sintable&((ang% + 512) AND 2047) \ 64
      posy& = posy& + sintable&(ang% AND 2047) \ 64
   END IF
   IF z$ = CHR$(0) + CHR$(80) THEN
      posx& = posx& - sintable&((ang% + 512) AND 2047) \ 64
      posy& = posy& - sintable&(ang% AND 2047) \ 64
   END IF
   IF posx& <> oldposx& OR posy& <> oldposy& THEN CALL checksector(oldposx&, oldposy&, posx&, posy&)
   IF z$ = CHR$(0) + CHR$(75) THEN ang% = (ang% + 1984) AND 2047
   IF z$ = CHR$(0) + CHR$(77) THEN ang% = (ang% + 64) AND 2047
   IF z$ = "A" OR z$ = "a" THEN posz& = posz& - 4
   IF z$ = "Z" OR z$ = "z" THEN posz& = posz& + 4
LOOP WHILE z$ <> CHR$(27)

SUB addboxlinum (sectore%, walle%)
  
   x1& = wall(walle%).xa1 - posx&
   y1& = wall(walle%).ya1 - posy&
   x2& = wall(wall(walle%).point2).xa1 - posx&
   y2& = wall(wall(walle%).point2).ya1 - posy&

   xp1& = (x1& * sintable&((ang% + 0) AND 2047) - y1& * sintable&((ang% + 512) AND 2047)) \ 65536
   yp1& = (x1& * sintable&((ang% + 512) AND 2047) + y1& * sintable&((ang% + 0) AND 2047)) \ 65536
   xp2& = (x2& * sintable&((ang% + 0) AND 2047) - y2& * sintable&((ang% + 512) AND 2047)) \ 65536
   yp2& = (x2& * sintable&((ang% + 512) AND 2047) + y2& * sintable&((ang% + 0) AND 2047)) \ 65536
 
   good% = 7
   IF ((ABS(xp1&) <= yp1&) AND (yp1& > 0)) THEN good% = good% - 1
   IF ((ABS(xp2&) <= yp2&) AND (yp2& > 0)) THEN good% = good% - 2
   IF ((good% = 7) AND ((yp1& > 0) OR (yp2& > 0)) AND ((xp1& < 0) = (0 < xp2&))) THEN good% = 3
   yb1&(numscans%) = -1
   yb2&(numscans%) = -1
 
   IF (good% < 7) THEN
      IF ((good% AND 3) > 0) THEN templong& = xp2& * yp1& - xp1& * yp2&
      IF ((good% AND 1) = 0) THEN
         xb1&(numscans%) = 160& - ((xp1& * 160&) \ yp1&)
         yb1&(numscans%) = yp1&
         llinum%(numscans%) = 0
      ELSE
         IF (xp1& < 0) THEN
            IF ((xp1& < 0) <> (0 < xp2&)) THEN EXIT SUB
            IF ((yp1& < 0) <> (0 < yp2&)) THEN EXIT SUB
            IF ABS(xp1& * yp2&) > ABS(xp2& * yp1&) THEN EXIT SUB
         END IF
         xb1&(numscans%) = 0
         templong1& = yp1& - yp2& + xp2& - xp1&
         IF templong1& <> 0 THEN yb1&(numscans%) = templong& \ templong1&
         
         xc& = ((160& - xb1&(numscans%)) * yb1&(numscans%)) \ 160&
         yc& = yb1&(numscans%)
         llinum%(numscans%) = (4095& * (ABS(xc& - xp1&) + ABS(yc& - yp1&))) \ (ABS(xp2& - xp1&) + ABS(yp2& - yp1&))

      END IF
      IF ((good% AND 2) = 0) THEN
         xb2&(numscans%) = 160& - ((xp2& * 160&) \ yp2&)
         yb2&(numscans%) = yp2&
         rlinum%(numscans%) = 4095
      ELSE
         IF (xp2& > 0) THEN
            IF (xp1& < 0) <> (0 < xp2&) THEN EXIT SUB
            IF (yp1& < 0) <> (0 < yp2&) THEN EXIT SUB
            IF ABS(xp1& * yp2&) < ABS(xp2& * yp1&) THEN EXIT SUB
         END IF
         xb2&(numscans%) = 319
         templong1& = yp2& - yp1& + xp2& - xp1&
         IF templong1& <> 0 THEN yb2&(numscans%) = templong& \ templong1&
        
         xc& = ((160& - xb2&(numscans%)) * yb2&(numscans%)) \ 160&
         yc& = yb2&(numscans%)
         rlinum%(numscans%) = (4095& * (ABS(xc& - xp1&) + ABS(yc& - yp1&))) \ (ABS(xp2& - xp1&) + ABS(yp2& - yp1&))

      END IF
      IF (yb1&(numscans%) > 0) AND (yb2&(numscans%) > 0) THEN
         IF (xb1&(numscans%) < xb2&(numscans%)) THEN
            thesector%(numscans%) = sectore%
            thewall%(numscans%) = walle%
            numscans% = numscans% + 1
         END IF
      END IF
   END IF
END SUB

SUB ceilscan (xb1&, xb2&, sectnum%)
   'umost[] as top, lowest of dmost[] and uplc[] as bottom

   FOR z% = 0 TO ydim
      lastx&(z%) = -1
   NEXT z%
   y1& = uplc&(xb1&): y2& = y1& - 1

   FOR x& = xb1& TO xb2&
      y1g& = umost%(x&)
      y2g& = uplc&(x&)
      IF y2g& < -1 THEN y2g& = -1
      IF y2g& > dmost%(x&) THEN y2g& = dmost%(x&)
   
      WHILE y1g& > y1&
         IF lastx&(y1& + 1) >= 0 THEN
            CALL hline(lastx&(y1& + 1), x& - 1, y1&, sectnum%)
            lastx&(y1& + 1) = -1
         END IF
         y1& = y1& + 1
      WEND
   
      WHILE y2g& < y2&
         IF lastx&(y2& + 1) >= 0 THEN
            CALL hline(lastx&(y2& + 1), x& - 1, y2&, sectnum%)
            lastx&(y2& + 1) = -1
         END IF
         y2& = y2& - 1
      WEND
  
      IF y1& > y2& + 1 THEN y1& = y2& + 1
      WHILE y1g& < y1&
         y1& = y1& - 1
         lastx&(y1& + 1) = x&
      WEND
      y1& = y1g&
  
      IF y1& > y2& + 1 THEN y2& = y1& - 1
      WHILE y2g& > y2&
         y2& = y2& + 1
         lastx&(y2& + 1) = x&
      WEND
      y2& = y2g&

   NEXT x&

   FOR y& = y1& TO y2&
      IF lastx&(y& + 1) >= 0 THEN
         CALL hline(lastx&(y& + 1), xb2&, y&, sectnum%)
         lastx&(y& + 1) = -1
      END IF
   NEXT y&

END SUB

SUB checksector (ox&, oy&, nx&, ny&)
   startwall% = sector(cursectnum%).wallptr
   endwall% = startwall% + sector(cursectnum%).wallnum - 1
   z% = startwall%
   lastwall% = -1
   WHILE z% <= endwall%
      IF wall(z%).nextsector1 >= 0 THEN
         IF intersect(ox&, oy&, nx&, ny&, z%) = 1 AND z% <> lastwall% THEN
            lastwall% = wall(z%).nextwall1
            cursectnum% = wall(z%).nextsector1
            startwall% = sector(cursectnum%).wallptr
            endwall% = startwall% + sector(cursectnum%).wallnum - 1
            z% = startwall% - 1
         END IF
      END IF
      z% = z% + 1
   WEND
END SUB

SUB convertboard (fil$)
   numsectors% = 0
   numwalls% = 0

   cursectnum% = 0       'WHAT IS IT REALLY NOW?
   posx& = 4608
   posy& = 512
   posz& = 0
   ang% = 1024

   sector(0).wallptr = 0: sector(0).wallnum = 6
   sector(0).cstat1 = 0: sector(0).z1 = -32: sector(0).zosc1 = 0
   sector(0).picnum1 = 9: sector(0).heinum1 = 0: sector(0).shade1 = 0
   sector(0).cstat2 = 0: sector(0).z2 = 32: sector(0).zosc2 = 0
   sector(0).picnum2 = 10: sector(0).heinum2 = 0: sector(0).shade2 = 0

   wall(0).xa1 = 0: wall(0).ya1 = 2048: wall(0).point2 = 1
   wall(0).cstat = 0
   wall(0).picnum = 15: wall(0).shade = 0
   wall(0).xrepeat = 8: wall(0).yrepeat = 8
   wall(0).nextsector1 = -1: wall(0).nextwall1 = -1
   wall(0).nextsector2 = -1: wall(0).nextwall2 = -1

END SUB

SUB drawall (z%)
   wallnum% = thewall%(z%)
   sectnum% = thesector%(z%)
 
   top& = 0: topinc& = (rlinum%(z%) - llinum%(z%)) * yb1&(z%)
   bot& = (xb2&(z%) - xb1&(z%)) * yb2&(z%): botinc& = yb1&(z%) - yb2&(z%)
  
   yb1&(z%) = 524288 \ yb1&(z%)
   yb2&(z%) = 524288 \ yb2&(z%)
  
   FOR x& = xb1&(z%) TO xb2&(z%)
      IF xb1&(z%) <> xb2&(z%) THEN
         h&(x&) = (yb1&(z%) * (xb2&(z%) - x&) + yb2&(z%) * (x& - xb1&(z%))) \ (xb2&(z%) - xb1&(z%))
      ELSE
         h&(x&) = yb1&(z%)
      END IF
      uplc&(x&) = 100 + (h&(x&) * (sector(sectnum%).z1 - posz&)) \ 1024
      dplc&(x&) = 100 + (h&(x&) * (sector(sectnum%).z2 - posz&)) \ 1024
      IF uplc&(x&) < umost%(x&) THEN uplc&(x&) = umost%(x&)
      IF uplc&(x&) > dmost%(x&) THEN uplc&(x&) = dmost%(x&)
      IF dplc&(x&) < umost%(x&) THEN dplc&(x&) = umost%(x&)
      IF dplc&(x&) > dmost%(x&) THEN dplc&(x&) = dmost%(x&)
     
      IF (bot& <> 0) THEN linum&(x&) = llinum%(z%) + (top& \ bot&)
      top& = top& + topinc&
      bot& = bot& + botinc&
      IF ((top& AND &HC0000000) <> 0) THEN
         top& = top& \ 2
         bot& = bot& \ 2
         topinc& = topinc& \ 2
         botinc& = botinc& \ 2
      END IF
   NEXT x&
  
   CALL ceilscan(xb1&(z%), xb2&(z%), sectnum%)
   CALL florscan(xb1&(z%), xb2&(z%), sectnum%)

   nextsectnum% = wall(wallnum%).nextsector1
  
   IF nextsectnum% = -1 THEN
      FOR x& = xb1&(z%) TO xb2&(z%)
         uplc&(x&) = 100 + (h&(x&) * (sector(sectnum%).z1 - posz&)) \ 1024
         dplc&(x&) = 100 + (h&(x&) * (sector(sectnum%).z2 - posz&)) \ 1024
         CALL vline(x&, uplc&(x&) * 65536, dplc&(x&) * 65536, h&(x&) * 32768, linum&(x&), wallnum%)
         umost%(x&) = 200
         dmost%(x&) = -1
      NEXT x&
   ELSE
      IF sector(nextsectnum%).z1 <= sector(sectnum%).z1 THEN
         FOR x& = xb1&(z%) TO xb2&(z%)
            IF uplc&(x&) > umost%(x&) THEN umost%(x&) = uplc&(x&)
         NEXT x&
      ELSE
         FOR x& = xb1&(z%) TO xb2&(z%)
            y& = 100 + (h&(x&) * (sector(nextsectnum%).z1 - posz&)) \ 1024
          
            uplc&(x&) = 100 + (h&(x&) * (sector(sectnum%).z1 - posz&)) \ 1024
            CALL vline(x&, uplc&(x&) * 65536, y& * 65536, h&(x&) * 32768, linum&(x&), wallnum%)
          
            IF y& > dmost%(x&) THEN y& = dmost%(x&)
            IF y& > umost%(x&) THEN umost%(x&) = y&
         NEXT x&
      END IF
      IF sector(nextsectnum%).z2 >= sector(sectnum%).z2 THEN
         FOR x& = xb1&(z%) TO xb2&(z%)
            IF dplc&(x&) < dmost%(x&) THEN dmost%(x&) = dplc&(x&)
         NEXT x&
      ELSE
         FOR x& = xb1&(z%) TO xb2&(z%)
            y& = 100 + (h&(x&) * (sector(nextsectnum%).z2 - posz&)) \ 1024
          
            dplc&(x&) = 100 + (h&(x&) * (sector(sectnum%).z2 - posz&)) \ 1024
            CALL vline(x&, y& * 65536, dplc&(x&) * 65536, h&(x&) * 32768, linum&(x&), wallnum%)
             
            IF y& < umost%(x&) THEN y& = umost%(x&)
            IF y& < dmost%(x&) THEN dmost%(x&) = y&
         NEXT x&
      END IF
   END IF
     
   xb1bak& = xb1&(z%)
   xb2bak& = xb2&(z%)

   numscans% = numscans% - 1
   IF z% <> numscans% THEN
      xb1&(z%) = xb1&(numscans%)
      yb1&(z%) = yb1&(numscans%)
      xb2&(z%) = xb2&(numscans%)
      yb2&(z%) = yb2&(numscans%)
      llinum%(z%) = llinum%(numscans%)
      rlinum%(z%) = rlinum%(numscans%)
      thesector%(z%) = thesector%(numscans%)
      thewall%(z%) = thewall%(numscans%)
   END IF

   IF nextsectnum% >= 0 THEN
      IF got%(nextsectnum%) = 0 THEN
         FOR x& = xb1bak& TO xb2bak&
            IF umost%(x&) < dmost%(x&) THEN
               CALL scansector(nextsectnum%)
               EXIT FOR
            END IF
         NEXT x&
      END IF
   END IF
END SUB

SUB florscan (xb1&, xb2&, sectnum%)
   'dmost[] as bottom, highest of umost[] and dplc[] as bottom

   FOR z% = 0 TO ydim
      lastx&(z%) = -1
   NEXT z%
   y2& = dplc&(xb1&)
   IF y2& < 1 THEN y2& = 1
   y1& = y2& + 1

   FOR x& = xb1& TO xb2&
      y2g& = dmost%(x&)
      y1g& = dplc&(x&)
      IF y1g& < umost%(x&) THEN y1g& = umost%(x&)
  
      WHILE y1g& > y1&
         IF lastx&(y1& + 1) >= 0 THEN
            CALL hline(lastx&(y1& + 1), x& - 1, y1&, sectnum%)
            lastx&(y1& + 1) = -1
         END IF
         y1& = y1& + 1
      WEND
  
      WHILE y2g& < y2&
         IF lastx&(y2& + 1) >= 0 THEN
            CALL hline(lastx&(y2& + 1), x& - 1, y2&, sectnum%)
            lastx&(y2& + 1) = -1
         END IF
         y2& = y2& - 1
      WEND
 
      IF y1& > y2& + 1 THEN y1& = y2& + 1
      WHILE y1g& < y1&
         y1& = y1& - 1
         lastx&(y1& + 1) = x&
      WEND
      y1& = y1g&
 
      IF y1& > y2& + 1 THEN y2& = y1& - 1
      WHILE y2g& > y2&
         y2& = y2& + 1
         lastx&(y2& + 1) = x&
      WEND
      y2& = y2g&

   NEXT x&

   FOR y& = y1& TO y2&
      IF lastx&(y& + 1) >= 0 THEN
         CALL hline(lastx&(y& + 1), xb2&, y&, sectnum%)
         lastx&(y& + 1) = -1
      END IF
   NEXT y&

END SUB

FUNCTION front% (l1%, l2%)
 
   x1l1& = wall(thewall%(l1%)).xa1
   y1l1& = wall(thewall%(l1%)).ya1
   x2l1& = wall(wall(thewall%(l1%)).point2).xa1
   y2l1& = wall(wall(thewall%(l1%)).point2).ya1
   x1l2& = wall(thewall%(l2%)).xa1
   y1l2& = wall(thewall%(l2%)).ya1
   x2l2& = wall(wall(thewall%(l2%)).point2).xa1
   y2l2& = wall(wall(thewall%(l2%)).point2).ya1

   templong1& = (x1l2& - x1l1&) * (y2l1& - y1l1&) - (x2l1& - x1l1&) * (y1l2& - y1l1&)    'p1(l2) vs. l1
   templong2& = (x2l2& - x1l1&) * (y2l1& - y1l1&) - (x2l1& - x1l1&) * (y2l2& - y1l1&)    'p2(l2) vs. l1
   IF templong1& = 0 THEN templong1& = templong2&
   IF templong2& = 0 THEN templong2& = templong1&
   IF (templong1& < 0) = (templong2& < 0) THEN
      templong0& = (posx& - x1l1&) * (y2l1& - y1l1&) - (x2l1& - x1l1&) * (posy& - y1l1&) 'pos vs. l1
      IF (templong1& < 0) = (templong0& < 0) THEN front% = l2% ELSE front% = l1%
      EXIT FUNCTION
   END IF

   templong1& = (x1l1& - x1l2&) * (y2l2& - y1l2&) - (x2l2& - x1l2&) * (y1l1& - y1l2&)     'p1(l1) vs. l2
   templong2& = (x2l1& - x1l2&) * (y2l2& - y1l2&) - (x2l2& - x1l2&) * (y2l1& - y1l2&)     'p2(l1) vs. l2
   IF templong1& = 0 THEN templong1& = templong2&
   IF templong2& = 0 THEN templong2& = templong1&
   IF (templong1& < 0) = (templong2& < 0) THEN
      templong0& = (posx& - x1l2&) * (y2l2& - y1l2&) - (x2l2& - x1l2&) * (posy& - y1l2&)  'pos vs. l2
      IF (templong1& < 0) = (templong0& < 0) THEN front% = l1% ELSE front% = l2%
      EXIT FUNCTION
   END IF

   front% = -2: EXIT FUNCTION
 
END FUNCTION

SUB hline (xl&, xr&, yp&, sectnum%)
   IF ((yp& = ydim \ 2) OR (picsiz%(walnume%) = 0)) THEN EXIT SUB
   IF xl& > xr& THEN SWAP xl&, xr&
   siz& = xr& - xl& + 1
  
   IF yp& < (ydim \ 2) THEN
      zd& = (sector(sectnum%).z1 - posz&) * 256&
      bufplc& = 0& 'sector(sectnum%).picnum1
   ELSE
      zd& = (posz& - sector(sectnum%).z2) * 256&
      bufplc& = 4096& 'sector(sectnum%).picnum2
   END IF

   hd& = (zd& * 16384&) \ (xdim * ABS(ydim \ 2 - yp&))
   IF ABS(hd&) > 131072 THEN EXIT SUB
   xc& = (hd& * sintable&((2048 + ang%) AND 2047)) \ 1024&
   yc& = (hd& * sintable&((2560 + ang%) AND 2047)) \ 1024&
   x& = xc& * xl& - (xc& + yc&) * (xdim \ 2) + (posx& * 16384&)
   y& = yc& * xl& + (xc& - yc&) * (xdim \ 2) - (posy& * 16384&)
   IF yp& > (ydim \ 2) THEN
      y& = y& XOR &HFFFFFFFF
      yc& = yc& XOR &HFFFFFFFF
   END IF
 
   shade% = ABS(hd&) \ 4096&
   IF shade% < 0 THEN shade% = 0
   IF shade% >= numpalookups THEN shade% = numpalookups - 1
    
   p& = yp& * 320& + xl&: DEF SEG = &HA000
      
   FOR zx& = 1 TO siz&
      POKE p&, palookup%(shade%, buf%(((x& \ 262144) AND 63) * 64& + ((y& \ 262144) AND 63) + bufplc&))
      p& = p& + 1
      x& = x& + xc&
      y& = y& + yc&
   NEXT zx&
END SUB

FUNCTION intersect% (x1l1&, y1l1&, x2l1&, y2l1&, l%)

   x1l2& = wall(l%).xa1
   y1l2& = wall(l%).ya1
   x2l2& = wall(wall(l%).point2).xa1
   y2l2& = wall(wall(l%).point2).ya1

   value% = 0

   IF (x1l1& < x2l1&) = (x2l1& < x2l1&) THEN
      IF (x1l1& < x2l2&) = (x2l1& < x2l2&) THEN
         IF (x1l1& < x2l1&) = (x1l1& < x2l2&) THEN
            IF (y1l1& < y2l1&) = (y2l1& < y2l1&) THEN
               IF (y1l1& < y2l2&) = (y2l1& < y2l2&) THEN
                  IF (y1l1& < y2l1&) = (y1l1& < y2l2&) THEN
                     value% = -1
                  END IF
               END IF
            END IF
         END IF
      END IF
   END IF
  
   IF value% = 0 THEN
      templong1& = (x1l2& - x1l1&) * (y2l1& - y1l1&) - (x2l1& - x1l1&) * (y1l2& - y1l1&)    'p1(l2) vs. l1
      templong2& = (x2l2& - x1l1&) * (y2l1& - y1l1&) - (x2l1& - x1l1&) * (y2l2& - y1l1&)    'p2(l2) vs. l1
      IF (templong1& < 0) = (templong2& < 0) THEN value% = -1
      IF templong1& = 0 OR templong2& = 0 THEN value% = 0
   END IF

   IF value% = 0 THEN
      templong1& = (x1l1& - x1l2&) * (y2l2& - y1l2&) - (x2l2& - x1l2&) * (y1l1& - y1l2&)     'p1(l1) vs. l2
      templong2& = (x2l1& - x1l2&) * (y2l2& - y1l2&) - (x2l2& - x1l2&) * (y2l1& - y1l2&)     'p2(l1) vs. l2
      IF (templong1& < 0) = (templong2& < 0) THEN value% = -1
      IF templong1& = 0 OR templong2& = 0 THEN value% = 0
   END IF

   IF value% >= 0 THEN
      templong2& = (x2l1& - x1l2&) * (y2l2& - y1l2&) - (x2l2& - x1l2&) * (y2l1& - y1l2&)     'p2(l1) vs. l2
      IF templong2& >= 0 THEN value% = 1 ELSE value% = 2
   END IF

   intersect% = value%

END FUNCTION

SUB loadboard
   numsectors% = 3
   numwalls% = 20

   cursectnum% = 1
   posx& = 4608
   posy& = 512
   posz& = 0
   ang% = 1024

   sector(0).wallptr = 0
   sector(0).wallnum = 6
   sector(0).cstat1 = 0
   sector(0).z1 = -32
   sector(0).zosc1 = 0
   sector(0).picnum1 = 9
   sector(0).heinum1 = 0
   sector(0).shade1 = 0
   sector(0).cstat2 = 0
   sector(0).z2 = 32
   sector(0).zosc2 = 0
   sector(0).picnum2 = 10
   sector(0).heinum2 = 0
   sector(0).shade2 = 0

   sector(1).wallptr = 6
   sector(1).wallnum = 11
   sector(1).cstat1 = 0
   sector(1).z1 = -48
   sector(1).zosc1 = 0
   sector(1).picnum1 = 11
   sector(1).heinum1 = 0
   sector(1).shade1 = 0
   sector(1).cstat2 = 0
   sector(1).z2 = 48
   sector(1).zosc2 = 0
   sector(1).picnum2 = 12
   sector(1).heinum2 = 0
   sector(1).shade2 = 0

   sector(2).wallptr = 17
   sector(2).wallnum = 3
   sector(2).cstat1 = 0
   sector(2).z1 = -48
   sector(2).zosc1 = 0
   sector(2).picnum1 = 13
   sector(2).heinum1 = 0
   sector(2).shade1 = 0
   sector(2).cstat2 = 0
   sector(2).z2 = 20
   sector(2).zosc2 = 0
   sector(2).picnum2 = 6
   sector(2).heinum2 = 0
   sector(2).shade2 = 0

   wall(0).xa1 = 0: wall(0).ya1 = 2048: wall(0).point2 = 1
   wall(0).cstat = 0
   wall(0).picnum = 15: wall(0).shade = 0
   wall(0).xrepeat = 8: wall(0).yrepeat = 8
   wall(0).nextsector1 = -1: wall(0).nextwall1 = -1
   wall(0).nextsector2 = -1: wall(0).nextwall2 = -1
 
   wall(1).xa1 = 0: wall(1).ya1 = 1024: wall(1).point2 = 2
   wall(1).cstat = 0
   wall(1).picnum = 15: wall(1).shade = 0
   wall(1).xrepeat = 8: wall(1).yrepeat = 8
   wall(1).nextsector1 = -1: wall(1).nextwall1 = -1
   wall(1).nextsector2 = -1: wall(1).nextwall2 = -1

   wall(2).xa1 = 1024: wall(2).ya1 = 0: wall(2).point2 = 3
   wall(2).cstat = 0
   wall(2).picnum = 15: wall(2).shade = 0
   wall(2).xrepeat = 8: wall(2).yrepeat = 8
   wall(2).nextsector1 = -1: wall(2).nextwall1 = -1
   wall(2).nextsector2 = -1: wall(2).nextwall2 = -1

   wall(3).xa1 = 3072: wall(3).ya1 = 0: wall(3).point2 = 4
   wall(3).cstat = 0
   wall(3).picnum = 15: wall(3).shade = 0
   wall(3).xrepeat = 8: wall(3).yrepeat = 8
   wall(3).nextsector1 = 1: wall(3).nextwall1 = 8
   wall(3).nextsector2 = -1: wall(3).nextwall2 = -1

   wall(4).xa1 = 3072: wall(4).ya1 = 1024: wall(4).point2 = 5
   wall(4).cstat = 0
   wall(4).picnum = 15: wall(4).shade = 0
   wall(4).xrepeat = 8: wall(4).yrepeat = 8
   wall(4).nextsector1 = -1: wall(4).nextwall1 = -1
   wall(4).nextsector2 = -1: wall(4).nextwall2 = -1

   wall(5).xa1 = 2048: wall(5).ya1 = 2048: wall(5).point2 = 0
   wall(5).cstat = 0
   wall(5).picnum = 15: wall(5).shade = 0
   wall(5).xrepeat = 8: wall(5).yrepeat = 8
   wall(5).nextsector1 = -1: wall(5).nextwall1 = -1
   wall(5).nextsector2 = -1: wall(5).nextwall2 = -1

   wall(6).xa1 = 2048: wall(6).ya1 = 3072: wall(6).point2 = 7
   wall(6).cstat = 0
   wall(6).picnum = 14: wall(6).shade = 0
   wall(6).xrepeat = 23: wall(6).yrepeat = 8
   wall(6).nextsector1 = -1: wall(6).nextwall1 = -1
   wall(6).nextsector2 = -1: wall(6).nextwall2 = -1

   wall(7).xa1 = 4096: wall(7).ya1 = 1024: wall(7).point2 = 8
   wall(7).cstat = 0
   wall(7).picnum = 14: wall(7).shade = 0
   wall(7).xrepeat = 8: wall(7).yrepeat = 8
   wall(7).nextsector1 = -1: wall(7).nextwall1 = -1
   wall(7).nextsector2 = -1: wall(7).nextwall2 = -1

   wall(8).xa1 = 3072: wall(8).ya1 = 1024: wall(8).point2 = 9
   wall(8).cstat = 0
   wall(8).picnum = 14: wall(8).shade = 0
   wall(8).xrepeat = 8: wall(8).yrepeat = 8
   wall(8).nextsector1 = 0: wall(8).nextwall1 = 3
   wall(8).nextsector2 = -1: wall(8).nextwall2 = -1

   wall(9).xa1 = 3072: wall(9).ya1 = 0: wall(9).point2 = 10
   wall(9).cstat = 0
   wall(9).picnum = 14: wall(9).shade = 0
   wall(9).xrepeat = 16: wall(9).yrepeat = 8
   wall(9).nextsector1 = -1: wall(9).nextwall1 = -1
   wall(9).nextsector2 = -1: wall(9).nextwall2 = -1

   wall(10).xa1 = 5120: wall(10).ya1 = 0: wall(10).point2 = 11
   wall(10).cstat = 0
   wall(10).picnum = 14: wall(10).shade = 0
   wall(10).xrepeat = 32: wall(10).yrepeat = 8
   wall(10).nextsector1 = -1: wall(10).nextwall1 = -1
   wall(10).nextsector2 = -1: wall(10).nextwall2 = -1

   wall(11).xa1 = 5120: wall(11).ya1 = 4096: wall(11).point2 = 12
   wall(11).cstat = 0
   wall(11).picnum = 14: wall(11).shade = 0
   wall(11).xrepeat = 40: wall(11).yrepeat = 8
   wall(11).nextsector1 = -1: wall(11).nextwall1 = -1
   wall(11).nextsector2 = -1: wall(11).nextwall2 = -1

   wall(12).xa1 = 0: wall(12).ya1 = 4096: wall(12).point2 = 13
   wall(12).cstat = 0
   wall(12).picnum = 14: wall(12).shade = 0
   wall(12).xrepeat = 8: wall(12).yrepeat = 8
   wall(12).nextsector1 = -1: wall(12).nextwall1 = -1
   wall(12).nextsector2 = -1: wall(12).nextwall2 = -1

   wall(13).xa1 = 0: wall(13).ya1 = 3072: wall(13).point2 = 6
   wall(13).cstat = 0
   wall(13).picnum = 14: wall(13).shade = 0
   wall(13).xrepeat = 16: wall(13).yrepeat = 8
   wall(13).nextsector1 = -1: wall(13).nextwall1 = -1
   wall(13).nextsector2 = -1: wall(13).nextwall2 = -1

   wall(14).xa1 = 3072: wall(14).ya1 = 3072: wall(14).point2 = 15
   wall(14).cstat = 0
   wall(14).picnum = 14: wall(14).shade = 0
   wall(14).xrepeat = 8: wall(14).yrepeat = 8
   wall(14).nextsector1 = 2: wall(14).nextwall1 = 18
   wall(14).nextsector2 = -1: wall(14).nextwall2 = -1

   wall(15).xa1 = 4096: wall(15).ya1 = 3072: wall(15).point2 = 16
   wall(15).cstat = 0
   wall(15).picnum = 14: wall(15).shade = 0
   wall(15).xrepeat = 8: wall(15).yrepeat = 8
   wall(15).nextsector1 = 2: wall(15).nextwall1 = 17
   wall(15).nextsector2 = -1: wall(15).nextwall2 = -1

   wall(16).xa1 = 4096: wall(16).ya1 = 2048: wall(16).point2 = 14
   wall(16).cstat = 0
   wall(16).picnum = 14: wall(16).shade = 0
   wall(16).xrepeat = 8: wall(16).yrepeat = 8
   wall(16).nextsector1 = 2: wall(16).nextwall1 = 19
   wall(16).nextsector2 = -1: wall(16).nextwall2 = -1

   wall(17).xa1 = 4096: wall(17).ya1 = 2048: wall(17).point2 = 18
   wall(17).cstat = 0
   wall(17).picnum = 13: wall(17).shade = 0
   wall(17).xrepeat = 8: wall(17).yrepeat = 8
   wall(17).nextsector1 = 1: wall(17).nextwall1 = 15
   wall(17).nextsector2 = -1: wall(17).nextwall2 = -1

   wall(18).xa1 = 4096: wall(18).ya1 = 3072: wall(18).point2 = 19
   wall(18).cstat = 0
   wall(18).picnum = 13: wall(18).shade = 0
   wall(18).xrepeat = 8: wall(18).yrepeat = 8
   wall(18).nextsector1 = 1: wall(18).nextwall1 = 14
   wall(18).nextsector2 = -1: wall(18).nextwall2 = -1

   wall(19).xa1 = 3072: wall(19).ya1 = 3072: wall(19).point2 = 17
   wall(19).cstat = 0
   wall(19).picnum = 13: wall(19).shade = 19
   wall(19).xrepeat = 8: wall(19).yrepeat = 8
   wall(19).nextsector1 = 1: wall(19).nextwall1 = 16
   wall(19).nextsector2 = -1: wall(19).nextwall2 = -1

END SUB

SUB loadnewall (bufplc&, wallnum%)
   OPEN "pics.dat" FOR BINARY AS #1

   SEEK #1, 1
   buf$ = STRING$(maxtiles, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxtiles - 1
      picsiz%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
   buf$ = STRING$(maxtiles, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxtiles - 1
      picanm%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      IF picsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((picsiz%(z%) AND 15) + (picsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxtiles * 2 + 1

   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO 63
      FOR zz% = 0 TO 63
         buf%(bufplc& + z% * 64 + zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

SUB scansector (sectnum%)
   got%(sectnum%) = 1
   startwall% = sector(sectnum%).wallptr
   endwall% = startwall% + sector(sectnum%).wallnum - 1
   FOR z% = startwall% TO endwall%
      CALL addboxlinum(sectnum%, z%)
   NEXT z%
END SUB

SUB setupscreen
   SCREEN 13
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   pal$ = STRING$(256, 0)
   FOR z% = 0 TO numpalookups
      GET #1, , pal$
      FOR zz% = 0 TO 255
         palookup%(z%, zz%) = ASC(MID$(pal$, zz% + 1, 1))
      NEXT zz%
   NEXT z%
   CLOSE #1
END SUB

SUB show2dboard
   FOR z% = 0 TO numsectors% - 1
      startwall% = sector(z%).wallptr
      endwall% = startwall% + sector(z%).wallnum - 1
      FOR zz% = startwall% TO endwall%
         IF wall(zz%).nextsector1 = -1 AND wall(zz%).nextsector2 = -1 THEN
            LINE (xdim \ 2 + (wall(zz%).xa1 - posx&) \ 32, ydim \ 2 + (wall(zz%).ya1 - posy&) \ 32)-(xdim \ 2 + (wall(wall(zz%).point2).xa1 - posx&) \ 32, ydim \ 2 + (wall(wall(zz%).point2).ya1 - posy&) \ 32), 31
         ELSE
            LINE (xdim \ 2 + (wall(zz%).xa1 - posx&) \ 32, ydim \ 2 + (wall(zz%).ya1 - posy&) \ 32)-(xdim \ 2 + (wall(wall(zz%).point2).xa1 - posx&) \ 32, ydim \ 2 + (wall(wall(zz%).point2).ya1 - posy&) \ 32), 120
         END IF
      NEXT zz%
   NEXT z%
   xv& = sintable&((ang% + 2560) AND 2047) \ 2048
   yv& = sintable&((ang% + 2048) AND 2047) \ 2048
   LINE (xdim \ 2 + xv&, ydim \ 2 + yv&)-(xdim \ 2 - xv&, ydim \ 2 - yv&), 15
   LINE (xdim \ 2 + xv&, ydim \ 2 + yv&)-(xdim \ 2 - yv&, ydim \ 2 + xv&), 15
   LINE (xdim \ 2 + xv&, ydim \ 2 + yv&)-(xdim \ 2 + yv&, ydim \ 2 - xv&), 15
END SUB

SUB show3dboard
   FOR z% = 0 TO numsectors% - 1
      got%(z%) = 0
   NEXT z%
   FOR z% = 0 TO xdim - 1
      umost%(z%) = -1
      dmost%(z%) = 200
   NEXT z%

   numscans% = 0
   CALL scansector(cursectnum%)
   WHILE numscans% > 0
     
      tempbuf%(0) = 1
      FOR z% = 1 TO numscans%
         tempbuf%(z%) = 0
      NEXT z%
      
      closest% = 0

      FOR z% = 0 TO numscans% - 1
         IF tempbuf%(z%) = 0 THEN
            IF xb1&(z%) < xb2&(closest%) AND xb1&(closest%) < xb2&(z%) THEN
               IF front%(z%, closest%) = z% THEN
                  closest% = z%
                  tempbuf%(z%) = 1
                  z% = 0
               END IF
            END IF
         END IF
      NEXT z%
     
      CALL drawall(closest%)
   WEND

END SUB

SUB vline (x&, y1&, y2&, siz&, picplc&, walnume%)
   y1v% = y1& \ 65536
   y2v% = y2& \ 65536
   sizv% = siz& \ 65536
   thesiz% = y2v% - y1v%
 
   IF (y1v% > dmost%(x&)) OR (y2v% < umost%(x&)) OR (thesiz% <= 0) OR (sizv% <= 0) OR (x& < 0) OR (x& >= xdim) THEN EXIT SUB

   picplc& = (picplc& * wall(walnume%).xrepeat) \ 8
   picplc& = picplc& AND &HFC0
   vinc& = (33554432 * 32) \ (siz& \ 2048)
   vplc& = ((((y1& AND 65535 XOR 65535) * (vinc& \ 256)) \ 256) AND 65535)
   IF (y1v% < umost%(x&)) THEN
      vplc& = vplc& + (umost%(x&) - y1v%) * vinc&
      y1v% = umost%(x&)
   END IF
   IF (y2v% >= dmost%(x&)) THEN y2v% = dmost%(x&) - 1
   thesiz% = y2v% - y1v%
   IF (thesiz% < 1) OR (thesiz% > dmost%(x&)) THEN EXIT SUB

   shade% = vinc& \ 16384&
   IF shade% < 0 THEN shade% = 0
   IF shade% >= numpalookups THEN shade% = numpalookups - 1

   picplc& = picplc& + 8192&   'wall(walnume%).picnum

   DEF SEG = &HA000
   p& = y1v% * 320& + x&
   FOR zx% = 0 TO thesiz%
      vplc& = vplc& + vinc&
      POKE p&, palookup%(shade%, buf%(picplc& + ((vplc& \ 65536) AND 63)))
      p& = p& + 320
   NEXT zx%
END SUB

