// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <stdio.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>

#define maxwalls 4096
#define numpalookups 32

static char *pic;
static short int mousx, mousy, bstatus, moustat, videocard;
static unsigned char col, trailstatus, tempbuf[4096];
static unsigned char xfillbuf[2048], yfillbuf[2048];
static unsigned char picsiz[maxwalls], picanm[maxwalls], printbuf[128];
static unsigned char buf[256][256], buf2[256][256], buf3[256][256];
static long waloff[maxwalls], totpicmem, xdim, ydim, asksave, c, d, picnum;
static long scale, pplc, totpicsiz, oxdim, oydim, animspeed;
static short int sintable[2048];

static unsigned char palookup[numpalookups][256], palette[768];
static char palette2[768], palookupe[256];

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux clearupperleftbox =\
	"mov edi, 0xa0000",\
	"mov ebx, 192",\
	"xor eax, eax",\
	"moreclear: mov ecx, 48d",\
	"rep stosd",\
	"add edi, 128",\
	"sub ebx, 1",\
	"jnc moreclear",\
	modify [eax ebx ecx edi]\

#pragma aux getpixel =\
	"xor eax, eax",\
	"mov al, [edi+0xa0000]",\
	parm [edi]\

#pragma aux getpixels =\
	"xor eax, eax",\
	"mov ax, [edi+0xa0000]",\
	parm [edi]\

#pragma aux getpixelses =\
	"mov eax, [edi+0xa0000]",\
	parm [edi]\

#pragma aux drawpixel =\
	"mov [edi+0xa0000], al",\
	parm [edi][eax]\

#pragma aux drawpixels =\
	"mov [edi+0xa0000], ax",\
	parm [edi][eax]\

#pragma aux drawpixelses =\
	"mov [edi+0xa0000], eax",\
	parm [edi][eax]\

#pragma aux plotchar =\
	"int 0x10",\
	"mov eax, esi",\
	"mov ebx, edi",\
	"mov ecx, 1",\
	"int 0x10",\
	parm [eax][ebx][ecx][edx][esi][edi]\
	modify [eax ebx ecx edx esi edi]\

#pragma aux setupmouse =\
	"mov ax, 0",\
	"int 33h",\
	"mov moustat,1",\

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"sar cx, 1",\
	"sar dx, 1",\
	"mov mousx, cx",\
	"mov mousy, dx",\
	"mov ax, 5d",\
	"int 33h",\
	"mov bstatus, ax",\
	modify [eax ebx ecx edx]\

#pragma aux limitrate =\
	"mov dx, 0x3da",\
	"wait1: in al, dx",\
	"test al, 8",\
	"jnz wait1",\
	"wait2: in al, dx",\
	"test al, 8",\
	"jz wait2",\

#pragma aux vidcopy =\
	"mov esi, 0xa0000",\
	"mov edi, 0xa0000",\
	"mov ecx, 16000",\
	"rep movsd",\
	modify [esi edi ecx]\

#pragma aux clearseg =\
	"mov edi, 0xa0000",\
	"mov ecx, 16384",\
	"xor eax, eax",\
	"rep stosd",\
	modify [eax edi ecx]\

#pragma aux drawrow =\
	"cld",\
	"mov ecx, 80d",\
	"mov esi, offset tempbuf",\
	"mov edi, pplc",\
	"rep movsd",\
	modify [edi esi ecx]\

#pragma aux cleartext =\
	"mov edi, 0xaf000",\
	"mov ecx, 640d",\
	"xor eax, eax",\
	"rep stosd",\
	modify [eax edi ecx]\

#pragma aux checkvesa =\
	"mov ax, 0x4f00",\
	"int 0x10",\
	"cmp ax, 0x004f",\
	"sete al",\
	"and eax, 0x000000ff",\
	modify [eax]\

#pragma aux vesasetmode =\
	"mov ax, 0x4f02",\
	"int 0x10",\
	parm [ebx]\
	modify [eax ebx]\

#pragma aux vesasetpage =\
	"mov ax, 0x4f05",\
	"xor bx, bx",\
	"int 0x10",\
	parm [edx]\
	modify [eax ebx]\

main()
{
	char ch, *keystateptr, keystate, filename[40], filenamelen, tempchar;
	long i, j, k, l, m, n, x, y, x2, y2, fil, templong, dat, good, vidpos;
	long markx, marky, markxlen, markylen, *longptr1, *longptr2;
	long xstep, ystep;

	loadtables();
	setupmouse();
	videocard = getcard();
	mousx = 0;
	mousy = 0;
	bstatus = 0;
	if ((fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&palette[0],768);
		read(fil,&palookup[0][0],numpalookups*256);
		close(fil);
	}
	loadpicsandsuckallmem("pics.dat");
	filename[0] = '_';
	filename[1] = 0;
	filenamelen = 0;
	picnum = 0;
	keystateptr = (char *)0x417;
	col = 0;
	trailstatus = 0;
	ch = 0;
	loadwall(buf,picnum);
	c = (xdim>>1);
	d = (ydim>>1);
	markx = 0;
	marky = 0;
	markxlen = 0;
	markylen = 0;
	oxdim = -1;
	oydim = -1;
	animspeed = 4;
	drawmainscreen();
	while (ch != 27)
	{
		if (kbhit() != 0)
		{
			ch = getch();
			if ((ch == 't') || (ch == 'T'))
			{
				buf[c][d] = col, asksave = 1;
				trailstatus = 1-trailstatus;
				cleartext();
				if (trailstatus == 0)
					printstr(0,24,15,"Trail OFF");
				else
					printstr(0,24,15,"Trail ON");
			}
			if ((ch == 32) || (trailstatus == 1))
				buf[c][d] = col, asksave = 1;
			if (ch == 92)                             // It'a a \!
			{
				drawdot(buf[c][d]);
				c = (xdim>>1);
				d = (ydim>>1);
				drawdot((buf[c][d]+16)&255);
			}
			if (ch == '|')
			{
				cleartext();
				sprintf(&printbuf,"Cursor coordinates are: (%d,%d)",c,d);
				printstr(0,24,15,&printbuf);
			}
			if (ch == 8)
			{
				drawcolordot(col);
				col = 255;
				drawcolordot((col+16)&255);
			}
			if ((ch == ',') || (ch == '.') || (ch == '<') || (ch == '>'))
			{
				xstep = 0;
				ystep = 0;
				if (markx > c) xstep = 1;
				if (markx < c) xstep = -1;
				if (marky > d) ystep = 1;
				if (marky < d) ystep = -1;
				i = c-xstep;
				do
				{
					i += xstep;
					j = d-ystep;
					do
					{
						j += ystep;
						if ((buf[i][j]&31) > 0)
							if (ch == ',') buf[i][j]--;
						if ((buf[i][j]&31) < 31)
							if (ch == '.') buf[i][j]++;
						if (ch == '<')
						{
							buf[i][j] += 224;
							buf[i][j] &= 255;
						}
						if (ch == '>')
						{
							buf[i][j] += 32;
							buf[i][j] &= 255;
						}
					}
					while (j != marky);
				}
				while (i != markx);
				showall(buf);
				asksave = 1;
			}
			if ((ch == 'M') || (ch == 'm'))
			{
				for(i=0;i<xdim;i++)
					for(j=0;j<xdim;j++)
						buf3[i][j] = buf[i][j];
				cleartext();
				printstr(0,24,15,"Tile backed up to memory (P to restore)");
			}
			if ((ch == 'P') || (ch == 'p'))
			{
				for(i=0;i<xdim;i++)
					for(j=0;j<xdim;j++)
						buf[i][j] = buf3[i][j];
				showall(buf);
				asksave = 1;
				cleartext();
				printstr(0,24,15,"Tile restored from memory");
			}
			if ((ch == 'J') || (ch == 'j'))
			{
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if (buf[i][j] == buf[c][d])
							if ((rand()&15) == 0)
								buf[i][j] = col;
				showall(buf);
				asksave = 1;
			}
			if (ch == ']')
			{
				k = (buf[c][d]>>5);
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						buf2[i][j] = buf[i][j];
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if ((buf[i][j]>>5) == k)
						{
							m = buf2[(i+0)&(xdim-1)][(j+0)&(ydim-1)]*2, n = 2;
							tempchar = buf2[(i+1)&(xdim-1)][(j+0)&(ydim-1)];
							if ((tempchar>>5) == k)
								m += tempchar, n += 1;
							tempchar = buf2[(i-1)&(xdim-1)][(j+0)&(ydim-1)];
							if ((tempchar>>5) == k)
								m += tempchar, n += 1;
							tempchar = buf2[(i+0)&(xdim-1)][(j+1)&(ydim-1)];
							if ((tempchar>>5) == k)
								m += tempchar, n += 1;
							tempchar = buf2[(i+0)&(xdim-1)][(j-1)&(ydim-1)];
							if ((tempchar>>5) == k)
								m += tempchar, n += 1;

							buf[i][j] = (buf[i][j]&0xe0)+(((m+(n>>1))/n)&31);
						}
				showall(buf);
				asksave = 1;
			}
			if (ch == '[')
			{
				k = (buf[c][d]>>5);
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						buf2[i][j] = buf[i][j];
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if ((buf[i][j]>>5) == k)
						{
							m = buf2[(i+0)&(xdim-1)][(j+0)&(ydim-1)]*2, n = 2;

							l = rand();
							tempchar = buf2[(i+1)&(xdim-1)][(j+0)&(ydim-1)];
							if (((tempchar>>5) == k) && ((l&0x03) == 0))
								m += tempchar, n++;
							tempchar = buf2[(i-1)&(xdim-1)][(j+0)&(ydim-1)];
							if (((tempchar>>5) == k) && ((l&0x0c) == 0))
								m += tempchar, n++;
							tempchar = buf2[(i+0)&(xdim-1)][(j+1)&(ydim-1)];
							if (((tempchar>>5) == k) && ((l&0x30) == 0))
								m += tempchar, n++;
							tempchar = buf2[(i+0)&(xdim-1)][(j-1)&(ydim-1)];
							if (((tempchar>>5) == k) && ((l&0xc0) == 0))
								m += tempchar, n++;

							buf[i][j] = (buf[i][j]&0xe0)+(((m+(n>>1))/n)&31);
						}
				showall(buf);
				asksave = 1;
			}
			if (ch == 39)     // It's a '
			{
				k = (buf[c][d]>>5);
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if ((buf[i][j]>>5) == k)
						{
							m = (buf[i][j]&31);
							tempchar = buf[(i+1)&(xdim-1)][(j+0)&(ydim-1)];
							if ((tempchar>>5) != k)
								m--;
							tempchar = buf[(i-1)&(xdim-1)][(j+0)&(ydim-1)];
							if ((tempchar>>5) != k)
								m++;
							tempchar = buf[(i+0)&(xdim-1)][(j+1)&(ydim-1)];
							if ((tempchar>>5) != k)
								m--;
							tempchar = buf[(i+0)&(xdim-1)][(j-1)&(ydim-1)];
							if ((tempchar>>5) != k)
								m++;

							if (m < 0) m = 0;
							if (m > 31) m = 31;
							buf[i][j] = (buf[i][j]&0xe0)+m;
						}
				showall(buf);
				asksave = 1;
			}
			if (ch == ';')
			{
				k = (buf[c][d]>>5);
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if ((buf[i][j]>>5) == k)
						{
							m = (buf[i][j]&31);
							tempchar = buf[(i+1)&(xdim-1)][(j+0)&(ydim-1)];
							if ((tempchar>>5) != k)
								m++;
							tempchar = buf[(i-1)&(xdim-1)][(j+0)&(ydim-1)];
							if ((tempchar>>5) != k)
								m--;
							tempchar = buf[(i+0)&(xdim-1)][(j+1)&(ydim-1)];
							if ((tempchar>>5) != k)
								m++;
							tempchar = buf[(i+0)&(xdim-1)][(j-1)&(ydim-1)];
							if ((tempchar>>5) != k)
								m--;

							if (m < 0) m = 0;
							if (m > 31) m = 31;
							buf[i][j] = (buf[i][j]&0xe0)+m;
						}
				showall(buf);
				asksave = 1;
			}
			if ((ch == 'R') || (ch == 'r'))
			{
				cleartext();
				printstr(0,24,15,"Rotate tile which way? (Use arrow keys)");
				ch = getch();
				if (ch == 0)
				{
					ch = getch();
					if (ch == 75)
						for(i=xdim-1;i>=1;i--)
							for(j=0;j<ydim;j++)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[(i+1)&(xdim-1)][j];
								buf[(i+1)&(xdim-1)][j] = tempchar;
							}
					if (ch == 77)
						for(i=1;i<xdim;i++)
							for(j=0;j<ydim;j++)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[(i+1)&(xdim-1)][j];
								buf[(i+1)&(xdim-1)][j] = tempchar;
							}
					if (ch == 72)
						for(i=0;i<xdim;i++)
							for(j=ydim-1;j>=1;j--)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[i][(j+1)&(ydim-1)];
								buf[i][(j+1)&(ydim-1)] = tempchar;
							}
					if (ch == 80)
						for(i=0;i<xdim;i++)
							for(j=1;j<ydim;j++)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[i][(j+1)&(ydim-1)];
								buf[i][(j+1)&(ydim-1)] = tempchar;
							}
					showall(buf);
				}
				asksave = 1;
				cleartext();
			}
			if ((ch == 'C') || (ch == 'c'))
			{
				tempchar = buf[c][d];
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if (buf[i][j] == tempchar)
							buf[i][j] = col;
				showall(buf);
				asksave = 1;
			}
			if (ch == '1')
			{
				markx = c;
				marky = d;
				cleartext();
				printstr(0,24,15,"1st corner set for copy/paste (2 - copy)");
			}
			if (ch == '2')
			{
				x = markx, y = marky, x2 = c, y2 = d;
				if (x > x2)
					templong = x, x = x2, x2 = templong;
				if (y > y2)
					templong = y, y = y2, y2 = templong;
				markxlen = x2-x+1;
				markylen = y2-y+1;
				for(i=0;i<markxlen;i++)
					for(j=0;j<markylen;j++)
						buf2[i][j] = buf[i+x][j+y];
				cleartext();
				printstr(0,24,15,"Region copied into buffer (3 - paste)");
			}
			if (ch == '3')
			{
				for(i=0;i<markxlen;i++)
					for(j=0;j<markylen;j++)
						if ((i+c < xdim) && (j+d < ydim) && (buf2[i][j] != 255))
							buf[i+c][j+d] = buf2[i][j];
				showall(buf);
				asksave = 1;
			}
			if (ch == '4')
			{
				for(i=0;i<(markxlen>>1);i++)
					for(j=0;j<markylen;j++)
					{
						templong = buf2[i][j];
						buf2[i][j] = buf2[markxlen-1-i][j];
						buf2[markxlen-1-i][j] = templong;
					}
				cleartext();
				printstr(0,24,15,"Region flipped x-wise");
			}
			if (ch == '5')
			{
				for(i=0;i<markxlen;i++)
					for(j=0;j<(markylen>>1);j++)
					{
						templong = buf2[i][j];
						buf2[i][j] = buf2[i][markylen-1-j];
						buf2[i][markylen-1-j] = templong;
					}
				cleartext();
				printstr(0,24,15,"Region flipped y-wise");
			}
			if (ch == '6')
			{
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if (i > j)
						{
							templong = buf2[j][i];
							buf2[j][i] = buf2[i][j];
							buf2[i][j] = templong;
						}
				templong = markxlen;
				markxlen = markylen;
				markylen = templong;
				cleartext();
				printstr(0,24,15,"X and Y coordinates of region swapped");
			}
			if (ch == '/')
			{
				markxlen = (markxlen>>1)+1, markylen = (markylen>>1)+1;
				for(i=0;i<markxlen;i++)
					for(j=0;j<markylen;j++)
						buf2[i][j] = buf2[i<<1][j<<1];
				cleartext();
				printstr(0,24,15,"Region now half-size");
			}
			if (ch == '*')
			{
				markxlen <<= 1, markylen <<= 1;
				if (markxlen > 256) markxlen = 256;
				if (markylen > 256) markylen = 256;
				for(i=markxlen;i>=0;i--)
					for(j=markylen;j>=0;j--)
						if ((i < xdim) && (j < ydim))
							buf2[i][j] = buf2[i>>1][j>>1];
				cleartext();
				printstr(0,24,15,"Region now double-size");
			}
			if ((ch == 'F') || (ch == 'f'))
			{
				fillregion(c,d,col,col);
				showall(buf);
				cleartext();
				printstr(0,24,15,"Flood Fill");
				asksave = 1;
			}
			if (ch == 9)
			{
				drawcolordot(col);
				col = buf[c][d];
				drawcolordot((col+16)&255);
				cleartext();
				printstr(0,24,15,"Current color updated");
			}
			if ((ch == '+') || (ch == '-'))
			{
				if ((ch == '+') && ((picanm[picnum]&63) < 63))
					picanm[picnum]++;
				if (ch == '-')
				{
					if ((picanm[picnum]&63) > 0)
						picanm[picnum]--;
					else
						picanm[picnum] = ((picanm[picnum]+64)&255);
				}
				showall(buf);
			}
			if ((ch == 's') || (ch == 'S'))
			{
				cleartext();
				printstr(0,24,15,"Re-size tile (Use arrow keys)");
				x = xdim;
				y = ydim;
				k = picsiz[picnum];
				while ((ch != 13) && (ch != 27))
				{
					ch = getch();
					if (ch == 0)
					{
						ch = getch();
						if ((ch == 75) && (xdim > 1)) xdim >>= 1, k--;
						if ((ch == 77) && (xdim < 128)) xdim <<= 1, k++;
						if ((ch == 72) && (ydim > 1)) ydim >>= 1, k -= 16;
						if ((ch == 80) && (ydim < 128)) ydim <<= 1, k += 16;
						scale = 3;
						if ((xdim > 64) || (ydim > 64))
							scale = 1;
						showall(buf);
					}
				}
				if (ch == 13)
				{
					templong = (xdim*ydim) - (x*y);    //templong = bytes to add
					if ((xdim == 1) && (ydim == 1)) templong--;
					if ((x == 1) && (y == 1)) templong++;
					if (totpicsiz+templong > totpicmem)
					{
						xdim = x;
						ydim = y;
						scale = 3;
						if ((xdim > 64) || (ydim > 64))
							scale = 1;
						showall(buf);
						cleartext();
						printstr(0,24,15,"OUT OF MEMORY!  (Re-size cancelled)");
					}
					else
					{
						j = 0L;
						for(i=0;i<picnum;i++)
							if (picsiz[i] > 0)
								j += (1<<((picsiz[i]&15)+(picsiz[i]>>4)));
						if (templong < 0)
						{
							longptr1 = (long *)(FP_OFF(pic)+j-templong);
							longptr2 = (long *)(FP_OFF(pic)+j);
							for(i=j-templong;i<totpicsiz;i+=4)
							{
								dat = *longptr1++;
								*longptr2++ = dat;
							}
						}
						else if (templong > 0)
						{
							longptr1 = (long *)(FP_OFF(pic)+totpicsiz-1);
							longptr2 = (long *)(FP_OFF(pic)+totpicsiz-1+templong);
							for(i=j;i<totpicsiz;i+=4)
							{
								dat = *longptr1--;
								*longptr2-- = dat;
							}
						}
						for(j=picnum+1;j<maxwalls;j++)
							waloff[j] += templong;
						totpicsiz += templong;
						picsiz[picnum] = k;
						if (templong != 0)
						{
							asksave = 2;
							savewall(buf,picnum);
						}
					}
					cleartext();
				}
				else
				{
					xdim = x;
					ydim = y;
					scale = 3;
					if ((xdim > 64) || (ydim > 64))
						scale = 1;
					showall(buf);
					cleartext();
				}
				ch = 255;
			}
			if ((ch == 'u') || (ch == 'U'))
			{
				cleartext();
				printstr(0,24,15,"Update filename:");
				printstr(17,24,15,&filename);
				ch = 0;
				while ((ch != 13) && (ch != 27))
				{
					ch = getch();
					if ((ch >= 32) && (filenamelen < 12))
					{
						filename[filenamelen] = ch;
						filename[filenamelen+1] = '_';
						filename[filenamelen+2] = 32;
						filename[filenamelen+3] = 0;
						filenamelen++;
						printstr(17,24,15,&filename);
					}
					if ((ch == 8) && (filenamelen > 0))
					{
						filenamelen--;
						filename[filenamelen] = '_';
						filename[filenamelen+1] = 32;
						filename[filenamelen+2] = 0;
						printstr(17,24,15,&filename);
					}
				}
				if (ch == 13)
				{
					filename[filenamelen] = 0;
					j = 0;
					while ((filename[j] != '.') && (j < filenamelen))
						j++;
					good = -1;
					if ((filename[j+1] == 'b') || (filename[j+1] == 'B'))
						good = loadbmp(filename,(char *)0x000a0000);
					if ((filename[j+1] == 'p') || (filename[j+1] == 'P'))
						good = loadpcx(filename,(char *)0x000a0000);
					filename[filenamelen] = '_';
					if (good == -1)
					{
						cleartext();
						printstr(0,24,15,"INVALID FILENAME");
					}
					else
					{
						outp(0x3c7,0);
						for(i=0;i<768;i++)
							palette2[i] = inp(0x3c9);
						ch = 0;
						x = 160-(xdim>>1);
						y = 100-(ydim>>1);
						outp(0x3cd,0x01), vidcopy();
						outp(0x3cd,0x10), drawopenbox(x,y,x+xdim-1,y+ydim-1,31);
						while ((ch != 13) && (ch != 27))
						{
							if (kbhit() != 0)
							{
								ch = getch();
								if ((ch == 'p') || (ch == 'P'))
								{
									outp(0x3cd,0x0);
									printstr(0,24,15,"Make this the new build palette?");
									do
									{
										ch = getch();
									}
									while ((ch != 'y') && (ch != 'Y') && (ch != 'n') && (ch != 'N'));
									if ((ch == 'y') || (ch == 'Y'))
									{
										for(i=0;i<768;i++)
											palette[i] = palette2[i];
										getpalookup();
										if ((fil = open("palette.dat",O_BINARY|O_CREAT|O_WRONLY,S_IWRITE)) != -1)
										{
											write(fil,&palette[0],768);
											write(fil,&palookup[0][0],numpalookups*256);
											close(fil);
										}
									}
									outp(0x3cd,0x10), vidcopy();
									outp(0x3cd,0x10), drawopenbox(x,y,x+xdim-1,y+ydim-1,31);
								}
								if (ch == 0)
								{
									ch = getch();
									outp(0x3cd,0x10);
									fixopenbox(x,y,x+xdim-1,y+ydim-1);
									if ((ch == 75) && (x > 0)) x--;
									if ((ch == 77) && (x < 320-xdim)) x++;
									if ((ch == 72) && (y > 0)) y--;
									if ((ch == 80) && (y < 200-ydim)) y++;
									outp(0x3cd,0x10);
									drawopenbox(x,y,x+xdim-1,y+ydim-1,31);
								}
							}
							if (moustat == 1)
							{
								readmouse();
								if ((mousx != 0) || (mousy != 0))
								{
									outp(0x3cd,0x10);
									fixopenbox(x,y,x+xdim-1,y+ydim-1);
									x += mousx;
									y += mousy;
									if (x < 0) x = 0;
									if (x >= 320-xdim) x = 320-xdim;
									if (y < 0) y = 0;
									if (y >= 200-ydim) y = 200-ydim;
									outp(0x3cd,0x10);
									drawopenbox(x,y,x+xdim-1,y+ydim-1,31);
								}
							}
						}
						if (ch == 13)
						{
							getpaletteconversion();
							asksave = 1;
							outp(0x3cd,0x10);
							vidpos = y*320+x;
							for(j=0;j<ydim;j++)
							{
								for(i=0;i<xdim;i++)
								{
									buf[i][j] = palookupe[getpixel(vidpos)];
									vidpos++;
								}
								vidpos += 320-xdim;
							}
						}
						outp(0x3cd,0);
						drawmainscreen();
					}
				}
				ch = 255;
			}
			if ((ch == 'v') || (ch == 'V'))
			{
				savewall(buf,picnum);
				if (videocard == 1)
					setvmode(0x38);
				else
					vesasetmode(0x105);
				outp(0x3c8,0);
				for(i=0;i<768;i++)
					outp(0x3c9,palette[i]);
				templong = picnum;
				j = (templong&0xfff0)-96;
				if (j < 0) j = 0;
				j = checkforscroll(j, templong);
				for(i=0;i<192;i+=16)
					drawsvgarow(i+j);
				backupboxsvga(templong);
				while ((ch != 13) && (ch != 27))
				{
					if (kbhit() != 0)
					{
						ch = getch();
						if (ch == 0)
						{
							ch = getch();
							restoreboxsvga(templong);
							if ((ch == 75) && (templong > 0)) templong--;
							if ((ch == 77) && (templong < maxwalls-1)) templong++;
							if ((ch == 72) && (templong >= 16)) templong-=16;
							if ((ch == 80) && (templong < maxwalls-16)) templong+=16;
							j = checkforscroll(j, templong);
							backupboxsvga(templong);
						}
					}
					if (moustat == 1)
					{
						readmouse();
						if ((mousx != 0) || (mousy != 0))
						{
							restoreboxsvga(templong);
							if ((mousx < 0) && ((templong&15) > 0)) templong--;
							if ((mousx > 0) && ((templong&15) < 15)) templong++;
							if ((mousy < 0) && (templong >= 16)) templong-=16;
							if ((mousy > 0) && (templong < maxwalls-16)) templong+=16;
							j = checkforscroll(j, templong);
							backupboxsvga(templong);
						}
					}
					limitrate();
					drawopenboxsvga(templong,31);
					limitrate();
					drawopenboxsvga(templong,0);
				}
				if (ch == 13)
					picnum = templong;
				loadwall(buf,picnum);
				drawmainscreen();
				ch = 255;
			}
			if (((ch == 'a') || (ch == 'A')) && ((picanm[picnum]&192) > 0) && ((picanm[picnum]&63) > 0))
			{
				savewall(buf,picnum);
				cleartext();
				sprintf(&printbuf,"Press +/- to change animation speed",animspeed);
				printstr(0,24,15,&printbuf);
				outp(0x3cd,1), vidcopy();
				outp(0x3cd,2), vidcopy();
				i = 1;
				ch = 0;
				while ((ch != 13) && (ch != 27))
				{
					templong = picnum;
					switch(picanm[templong]&192)
					{
						case 64:
							k = (i%((picanm[templong]&63)<<1));
							if (k < (picanm[templong]&63))
								templong += k;
							else
								templong += (((picanm[templong]&63)<<1)-k);
							break;
						case 128:
							templong += (i%((picanm[templong]&63)+1));
							break;
						case 192:
							templong -= (i%((picanm[templong]&63)+1));
					}
					if ((templong >= 0) && (templong < maxwalls))
						loadwall(buf,templong);
					outp(0x3cd,i%3);
					showall(buf);
					for(j=0;j<animspeed;j++)
						limitrate();
					outp(0x3d4,0xc); outp(0x3d5,(i%3)<<6);
					i = ((i+1)&65535);
					if (kbhit() != 0)
					{
						ch = getch();
						if ((ch == '+') && (animspeed > 0))
							animspeed--;
						if ((ch == '-') && (animspeed < 16))
							animspeed++;
					}
				}
				outp(0x3cd,0);
				cleartext();
				loadwall(buf,picnum);
				showall(buf);
				outp(0x3d4,0xc); outp(0x3d5,0);
				ch = 255;
			}
			if (ch == 0)
			{
				ch = getch();
				keystate = *keystateptr;
				if ((keystate&3) == 0)
				{
					drawdot(buf[c][d]);
					if ((ch == 75) && (c > 0)) c--;
					if ((ch == 77) && (c < xdim-1)) c++;
					if ((ch == 72) && (d > 0)) d--;
					if ((ch == 80) && (d < ydim-1)) d++;
					drawdot((buf[c][d]+16)&255);
				}
				else
				{
					drawcolordot(col);
					if ((ch == 75) && (col > 15)) col -= 16;
					if ((ch == 77) && (col < 240)) col += 16;
					if ((ch == 72) && (col > 0)) col--;
					if ((ch == 80) && (col < 255)) col++;
					drawcolordot((col+16)&255);
				}
				if ((ch == 73) && (picnum > 0))
				{
					savewall(buf,picnum);
					picnum--;
					loadwall(buf,picnum);
					showall(buf);
					drawdot((buf[c][d]+16)&255);
				}
				if ((ch == 81) && (picnum < maxwalls-1))
				{
					savewall(buf,picnum);
					picnum++;
					loadwall(buf,picnum);
					showall(buf);
					drawdot((buf[c][d]+16)&255);
				}
				ch = 0;
			}
		}
		if (moustat == 1)
		{
			readmouse();
			if ((mousx != 0) || (mousy != 0))
			{
				drawdot(buf[c][d]);
				c += mousx;
				d += mousy;
				if (c < 0) c = 0;
				if (c >= xdim) c = xdim-1;
				if (d < 0) d = 0;
				if (d >= ydim) d = ydim-1;
				drawdot((buf[c][d]+16)&255);
			}
			if (bstatus > 0)
				buf[c][d] = col, asksave = 1;
		}
	}
	savewall(buf,picnum);
	cleartext();
	printstr(0,24,15,"Save ALL changes?");
	do
	{
		ch = getch();
	}
	while ((ch != 'y') && (ch != 'Y') && (ch != 'n') && (ch != 'N'));
	if ((ch == 'y') || (ch == 'Y'))
	{
		cleartext();
		printstr(0,24,15,"Saving...");
		savepics("pics.dat");
	}
	setvmode(0x3);
	return(0);
}

loadtables()
{
	short int fil;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		close(fil);
	}
	return(0);
}

loadpicsandsuckallmem(filename)
char filename[20];
{
	long templong, offscount, siz;
	short int fil, i;

	if ((fil = open(filename,O_BINARY|O_RDONLY,S_IREAD)) == -1)
		return(-1);
	read(fil,&picsiz[0],maxwalls);
	read(fil,&picanm[0],maxwalls);
	totpicsiz = 0L;
	for(i=0;i<maxwalls;i++)
		if (picsiz[i] > 0)
			totpicsiz += (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
	totpicmem = 16777216L;
	while ((pic = (char *)malloc(totpicmem)) == 0)
		totpicmem -= 4096L;
	if (totpicmem < totpicsiz)
	{
		printf("Not enough memory to fit artwork data.\n");
		exit(0);
	}
	offscount = 0L;
	for(i=0;i<maxwalls;i++)
	{
		waloff[i] = offscount+FP_OFF(pic);
		if (picsiz[i] > 0)
		{
			siz = (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
			read(fil,&pic[offscount],siz);
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}

savepics(filename)
char filename[20];
{
	long templong, totpicsiz, offscount, siz;
	short int fil, i;

	if ((fil = open(filename,O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IWRITE))==-1)
		return(-1);
	write(fil,&picsiz[0],maxwalls);
	write(fil,&picanm[0],maxwalls);
	offscount = 0L;
	for(i=0;i<maxwalls;i++)
		if (picsiz[i] > 0)
		{
			siz = (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
			if (write(fil,&pic[offscount],siz) < siz)
				printf("SAVE UNSUCCESSFUL!\n");
			offscount += siz;
		}
	close(fil);
	return(0);
}

loadwall(char *bufptr, long wallnum)
{
	long i, j, vidpos, dat;
	char *picptr;

	if (picsiz[wallnum] == 0)
	{
		xdim = 1;
		ydim = 1;
		return(-1);
	}
	picptr = (char *)(waloff[wallnum]);
	xdim = (1<<(picsiz[wallnum]&15));
	ydim = (1<<(picsiz[wallnum]>>4));
	scale = 3;
	if ((xdim > 64) || (ydim > 64))
		scale = 1;

	vidpos = 0;
	for(i=0;i<xdim;i++)
		for(j=0;j<ydim;j++)
		{
			dat = *picptr++;
			*(bufptr+(i<<8)+j) = dat;
		}
	asksave = 0;
	if (c >= xdim) c = xdim-1;
	if (d >= ydim) d = ydim-1;
	return(0);
}

savewall(char *bufptr, long wallnum)
{
	long i, j, vidpos, dat;
	char *picptr, ch;

	if (picsiz[wallnum] == 0)
		return(-1);

	if (asksave != 0)
	{
		if (asksave == 1)
		{
			asksave = 0;
			cleartext();
			printstr(4,12,15,"Save changes?");
			do
			{
				ch = getch();
			}
			while ((ch != 'y') && (ch != 'Y') && (ch != 'n') && (ch != 'N'));
			if ((ch == 'n') || (ch == 'N'))
				return(-1);
		}

		picptr = (char *)(waloff[wallnum]);
		xdim = (1<<(picsiz[wallnum]&15));
		ydim = (1<<(picsiz[wallnum]>>4));

		vidpos = 0;
		for(i=0;i<xdim;i++)
			for(j=0;j<ydim;j++)
			{
				dat = *(bufptr+(i<<8)+j);
				*picptr++ = dat;
			}
	}
	return(0);
}

showall(char *bufptr)
{
	long i, j, vidpos, totsiz, dat, dat1, dat2, dat3, dat4;
	char *picptr;

	if ((oxdim != xdim) || (oydim != ydim))
	{
		clearupperleftbox();
		oxdim = xdim;
		oydim = ydim;
	}

	switch(picanm[picnum]&192)
	{
		case 0: printstr(25,21,15,"NoAnm: "); break;
		case 64: printstr(25,21,15,"Oscil: "); break;
		case 128: printstr(25,21,15,"AnmFD: "); break;
		case 192: printstr(25,21,15,"AnmBK: "); break;
	}
	sprintf(&printbuf,"%d ",picanm[picnum]&63);
	printstr(32,21,15,&printbuf);
	if ((xdim == 1) && (ydim == 1))
		sprintf(&printbuf,"-blank-    ");
	else
		sprintf(&printbuf,"%d * %d  ",xdim,ydim);
	printstr(25,22,15,&printbuf);
	sprintf(&printbuf,"Tile %d ",picnum);
	printstr(25,23,15,&printbuf);

	if (picsiz[picnum] == 0)
		return(-1);
	if (scale == 1)
	{
		for(i=0;i<xdim;i+=4)
		{
			vidpos = i;
			for(j=0;j<ydim;j++)
			{
				dat = *(bufptr+(i<<8)+j);
				dat += ((*(bufptr+(i<<8)+j+256))<<8);
				dat += ((*(bufptr+(i<<8)+j+512))<<16);
				dat += ((*(bufptr+(i<<8)+j+768))<<24);
				drawpixelses(vidpos,dat);
				vidpos += 320;
			}
		}
	}
	else if (scale == 3)
	{
		if (xdim < 4)
		{
			for(i=0;i<xdim;i++)
			{
				vidpos = i+i+i;
				for(j=0;j<ydim;j++)
				{
					dat = *(bufptr+(i<<8)+j);
					dat += (dat<<8);
					drawpixels(vidpos,dat);
					drawpixel(vidpos+2,dat);
					drawpixels(vidpos+320,dat);
					drawpixel(vidpos+322,dat);
					drawpixels(vidpos+640,dat);
					drawpixel(vidpos+642,dat);
					vidpos += 960;
				}
			}
		}
		else
		{
			for(i=0;i<xdim;i+=4)
			{
				vidpos = i+i+i;
				for(j=0;j<ydim;j++)
				{
					dat1 = *(bufptr+(i<<8)+j);
					dat2 = *(bufptr+((i+1)<<8)+j);
					dat3 = *(bufptr+((i+2)<<8)+j);
					dat4 = *(bufptr+((i+3)<<8)+j);
					dat = dat1+(dat1<<8)+(dat1<<16)+(dat2<<24);
					drawpixelses(vidpos,dat);
					drawpixelses(vidpos+320,dat);
					drawpixelses(vidpos+640,dat);
					dat = dat2+(dat2<<8)+(dat3<<16)+(dat3<<24);
					drawpixelses(vidpos+4,dat);
					drawpixelses(vidpos+324,dat);
					drawpixelses(vidpos+644,dat);
					dat = dat3+(dat4<<8)+(dat4<<16)+(dat4<<24);
					drawpixelses(vidpos+8,dat);
					drawpixelses(vidpos+328,dat);
					drawpixelses(vidpos+648,dat);
					vidpos += 960;
				}
			}
		}
	}
	return(0);
}

printstr(short xpos, short ypos, char col, char *bufptr)
{
	char dat;

	do
	{
		dat = *bufptr++;
		plotchar(512L,0L,1L,(long)(ypos<<8)+xpos,(long)(0xa<<8)+dat,(long)col);
		xpos++;
	}
	while (*bufptr != 0);
}

drawdot(char col)
{
	long vidpos, dat;

	dat = col;
	if (picsiz[picnum] == 0)
		return(-1);
	if (scale == 1)
	{
		vidpos = d*320+c;
		drawpixel(vidpos,dat);
		vidpos += 320;
	}
	else if (scale == 3)
	{
		dat += (dat<<8);
		vidpos = d*960+c*3;
		drawpixels(vidpos,dat);
		drawpixel(vidpos+2,dat);
		drawpixels(vidpos+320,dat);
		drawpixel(vidpos+322,dat);
		drawpixels(vidpos+640,dat);
		drawpixel(vidpos+642,dat);
	}
	return(0);
}

drawcolordot(char thecol)
{
	drawpixel(((col&15)*3+76)*320+((col>>4)*3+204),(long)thecol);
	return(0);
}

loadpcx(char filename[20],char *ptr)
{
	unsigned char dat;
	long fil, i, p, datcnt, leng;

	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) == -1)
		return(-1);
	read(fil,&tempbuf[0],128);
	p = 64000;
	read(fil,&tempbuf[0],4096), datcnt = 0;
	while (p > 0)
	{
		dat = tempbuf[datcnt++];
		if (datcnt == 4096)
			read(fil,&tempbuf[0],4096), datcnt = 0;
		if ((dat&0xc0) == 0xc0)
		{
			leng = (dat&0x3f);
			dat = tempbuf[datcnt++];
			if (datcnt == 4096)
				read(fil,&tempbuf[0],4096), datcnt = 0;
			for(i=0;i<leng;i++)
			{
				*ptr = dat;
				ptr++;
			}
			p -= leng;
		}
		else
		{
			*ptr = dat;
			ptr++;
			p--;
		}
	}
	dat = tempbuf[datcnt++];
	if (datcnt == 4096)
		read(fil,&tempbuf[0],4096), datcnt = 0;
	if (dat == 0xc)
	{
		outp(0x3c8,0);
		for(i=0;i<768;i++)
		{
			dat = tempbuf[datcnt++];
			if (datcnt == 4096)
				read(fil,&tempbuf[0],4096), datcnt = 0;
			outp(0x3c9,dat>>2);
		}
	}
	close(fil);
	return(0);
}

loadbmp(char filename[20],char *ptr)
{
	short int fil, i;

	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) == -1)
		return(-1);
	read(fil,&tempbuf[0],54);
	read(fil,&tempbuf[0],1024);
	outp(0x3c8,0);
	for(i=0;i<1024;i++)
		if ((i&3) != 0)
			outp(0x3c9,tempbuf[i^3]>>2);
	pplc = ((long)ptr)+64000L-320L;
	for(i=0;i<200;i++)
	{
		read(fil,&tempbuf[0],320);
		drawrow();
		pplc -= 320L;
	}
	close(fil);
	return(0);
}

drawmainscreen()
{
	long i, j, templong, dat;

	setvmode(0x13);

	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	for(i=0;i<16;i++)
		for(j=0;j<16;j++)
		{
			templong = (j+j+j+75)*320+(i+i+i+203);
			dat = (i<<4)+j;
			dat += (dat<<8);
			drawpixels(templong,dat);
			drawpixel(templong+2,dat);
			drawpixels(templong+320,dat);
			drawpixel(templong+322,dat);
			drawpixels(templong+640,dat);
			drawpixel(templong+642,dat);
		}

	showall(buf);
	drawdot((buf[c][d]+16)&255);
	drawcolordot((col+16)&255);
}

drawopenbox(long x1, long y1, long x2, long y2, char col)
{
	long i, vidpos1, vidpos2, dat, temp;

	dat = (long)col;
	dat += (dat<<8);
	if (x1 > x2)
		temp = x1, x1 = x2, x2 = temp;
	if (y1 > y2)
		temp = y1, y1 = y2, y2 = temp;
	vidpos1 = y1*320+x1;
	vidpos2 = y1*320+x2;
	for(i=y1;i<y2;i+=2)
	{
		drawpixel(vidpos1,dat);
		drawpixel(vidpos2,dat);
		vidpos1 += 640;
		vidpos2 += 640;
	}
	vidpos1 = y1*320+x1;
	vidpos2 = y2*320+x1;
	for(i=x1;i<x2;i+=2)
	{
		drawpixel(vidpos1,dat);
		drawpixel(vidpos2,dat);
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

fixopenbox(long x1, long y1, long x2, long y2)
{
	long i, vidpos1, vidpos2, dat, temp;

	dat = (long)col;
	dat += (dat<<8);
	if (x1 > x2)
		temp = x1, x1 = x2, x2 = temp;
	if (y1 > y2)
		temp = y1, y1 = y2, y2 = temp;
	vidpos1 = y1*320+x1;
	vidpos2 = y1*320+x2;
	for(i=y1;i<y2;i+=2)
	{
		drawpixel(vidpos1,getpixel(vidpos1));
		drawpixel(vidpos2,getpixel(vidpos2));
		vidpos1 += 640;
		vidpos2 += 640;
	}
	vidpos1 = y1*320+x1;
	vidpos2 = y2*320+x1;
	for(i=x1;i<x2;i+=2)
	{
		drawpixel(vidpos1,getpixel(vidpos1));
		drawpixel(vidpos2,getpixel(vidpos2));
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

getpaletteconversion()
{
	long i, j, totintens1, totintens2, brichang, c1, c2, c3, bestcol, dadist;
	long zx;

	totintens1 = 0;
	totintens2 = 0;
	for(i=0;i<768;i++)
	{
		totintens1 += palette[i];
		totintens2 += palette2[i];
	}
	brichang = (totintens1-totintens2)/768;
	for(i=0;i<768;i+=3)
	{
		c1 = palette2[i]+brichang;
		c2 = palette2[i+1]+brichang;
		c3 = palette2[i+2]+brichang;
		bestcol = 0;
		dadist = 65536;
		for(j=0;j<768;j+=3)
		{
			zx = 30*(c1-palette[j])*(c1-palette[j]);
			zx += 59*(c2-palette[j+1])*(c2-palette[j+1]);
			zx += 11*(c3-palette[j+2])*(c3-palette[j+2]);
			if (zx < dadist)
				dadist = zx, bestcol = j/3;
		}
		palookupe[i/3] = bestcol;
	}
}

drawsvgarow(long picstart)
{
	long i, j, vidpos, vidpos2, dat, wallnum;
	char *picptr;

	if (videocard == 1)
		outp(0x3cd,(picstart>>4)&15);
	else
		vesasetpage((picstart>>4)&15);

	vidpos = 0;
	clearseg();
	for(wallnum=picstart;wallnum<picstart+16;wallnum++)
	{
		if (picsiz[wallnum] != 0)
		{
			picptr = (char *)(waloff[wallnum]);
			xdim = (1<<(picsiz[wallnum]&15));
			ydim = (1<<(picsiz[wallnum]>>4));

			if ((xdim <= 64) && (ydim <= 64))
			{
				vidpos2 = vidpos;
				for(i=0;i<xdim;i++)
				{
					for(j=0;j<ydim;j++)
					{
						dat = *picptr++;
						drawpixel(vidpos2, dat);
						vidpos2 += 1024L;
					}
					vidpos2 = (vidpos2&1023)+1;
				}
			}
			else
			{
				vidpos2 = vidpos;
				for(i=0;i<xdim;i+=2)
				{
					for(j=0;j<ydim;j+=2)
					{
						dat = *picptr;
						picptr += 2;
						drawpixel(vidpos2, dat);
						vidpos2 += 1024L;
					}
					vidpos2 = (vidpos2&1023)+1;
					picptr += ydim;
				}
			}
		}
		vidpos += 64;
	}
	return(0);
}

drawopenboxsvga(long picstart, char col)
{
	long i, vidpos, vidpos1, vidpos2, dat;

	dat = (long)col;
	dat += (dat<<8);
	if (videocard == 1)
		outp(0x3cd,(picstart>>4)&15);
	else
		vesasetpage((picstart>>4)&15);
	vidpos = ((picstart&15)<<6);
	vidpos1 = vidpos;
	vidpos2 = vidpos+62;
	for(i=0;i<64;i++)
	{
		drawpixels(vidpos1,dat);
		drawpixels(vidpos2,dat);
		vidpos1 += 1024;
		vidpos2 += 1024;
	}
	vidpos1 = vidpos;
	vidpos2 = (63<<10)+vidpos;
	for(i=0;i<62;i+=2)
	{
		drawpixels(vidpos1,dat);
		drawpixels(vidpos1+1024L,dat);
		drawpixels(vidpos2,dat);
		drawpixels(vidpos2-1024L,dat);
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

backupboxsvga(long picstart)
{
	long i, vidpos, vidpos1, vidpos2, tempbufcnt;

	if (videocard == 1)
		outp(0x3cd,((picstart>>4)&15)<<4);
	else
		vesasetpage(((picstart>>4)&15)<<4);
	vidpos = ((picstart&15)<<6);
	vidpos1 = vidpos;
	vidpos2 = vidpos+62;
	tempbufcnt = 0;
	for(i=0;i<64;i++)
	{
		tempbuf[tempbufcnt++] = getpixel(vidpos1);
		tempbuf[tempbufcnt++] = getpixel(vidpos1+1);
		tempbuf[tempbufcnt++] = getpixel(vidpos2);
		tempbuf[tempbufcnt++] = getpixel(vidpos2+1);
		vidpos1 += 1024;
		vidpos2 += 1024;
	}
	vidpos1 = vidpos;
	vidpos2 = (63<<10)+vidpos;
	for(i=0;i<62;i+=2)
	{
		tempbuf[tempbufcnt++] = getpixel(vidpos1);
		tempbuf[tempbufcnt++] = getpixel(vidpos1+1);
		tempbuf[tempbufcnt++] = getpixel(vidpos1+1024);
		tempbuf[tempbufcnt++] = getpixel(vidpos1+1025);
		tempbuf[tempbufcnt++] = getpixel(vidpos2);
		tempbuf[tempbufcnt++] = getpixel(vidpos2+1);
		tempbuf[tempbufcnt++] = getpixel(vidpos2-1024);
		tempbuf[tempbufcnt++] = getpixel(vidpos2-1023);
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

restoreboxsvga(long picstart)
{
	long i, vidpos, vidpos1, vidpos2, tempbufcnt;

	if (videocard == 1)
		outp(0x3cd,(picstart>>4)&15);
	else
		vesasetpage((picstart>>4)&15);
	vidpos = ((picstart&15)<<6);
	vidpos1 = vidpos;
	vidpos2 = vidpos+62;
	tempbufcnt = 0;
	for(i=0;i<64;i++)
	{
		drawpixel(vidpos1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos1+1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2+1,tempbuf[tempbufcnt++]);
		vidpos1 += 1024;
		vidpos2 += 1024;
	}
	vidpos1 = vidpos;
	vidpos2 = (63<<10)+vidpos;
	for(i=0;i<62;i+=2)
	{
		drawpixel(vidpos1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos1+1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos1+1024,tempbuf[tempbufcnt++]);
		drawpixel(vidpos1+1025,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2+1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2-1024,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2-1023,tempbuf[tempbufcnt++]);
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

checkforscroll(long currentscreenplace, long realplace)
{
	long place;

	if (realplace < currentscreenplace)
	{
		currentscreenplace -= 16L;
		drawsvgarow(currentscreenplace);
	}
	if (realplace >= currentscreenplace+192)
	{
		drawsvgarow(currentscreenplace+192);
		currentscreenplace += 16L;
	}
	place = (((currentscreenplace>>4)&15)<<6);
	outp(0x3d4,0x33); outp(0x3d5,place>>8);
	outp(0x3d4,0xc); outp(0x3d5,place&255);
	return(currentscreenplace);
}

fillregion(long x, long y, char col, char bound)
{
	unsigned char tstat, bstat, tlast, blast;
	int i, leftz, z, zz, c;

	c = 1;
	xfillbuf[c] = x;
	yfillbuf[c] = y;
	if (buf[x][y] == bound)
		return(-1);
	while (c > 0)
	{
		z = xfillbuf[c];
		zz = yfillbuf[c];
		c--;
		while ((buf[z-1][zz] != bound) && (z > 0))
			z--;
		leftz = z;
		tlast = 0;
		blast = 0;
		while ((buf[z][zz] != bound) && (z < xdim))
		{
			if (zz > 0)
			{
				tstat = buf[z][zz-1];
				if ((tstat != bound) && (tstat != col))
				{
					if (tlast == 0)
					{
						c++;
						xfillbuf[c] = z;
						yfillbuf[c] = zz-1;
						tlast = 1;
					}
				}
				else
					tlast = 0;
			}
			if (zz < ydim-1)
			{
				bstat = buf[z][zz+1];
				if ((bstat != bound) && (bstat != col))
				{
					if (blast == 0)
					{
						c++;
						xfillbuf[c] = z;
						yfillbuf[c] = zz+1;
						blast = 1;
					}
				}
				else
					blast = 0;
			}
			z++;
		}
		z--;
		while (z >= leftz)
		{
			if ((z >= 0) && (z < xdim))
				buf[z][zz] = col;
			z--;
		}
	}
	return(0);
}

int getcard()         //returns: 0 = nothing, 1 = TSENG ET4000, 2 = VESA
{
	int value, newvalue, oldvalue, bas, tseng, vesa, card;

	outp(0x3bf,3);                       //Check TSENG
	if ((inp(0x3cc)&1) == 1)
		outp(0x3d8, 0xa0);
	else
		outp(0x3b8, 0xa0);
	inp(0x3da); outp(0x3c0,0x16); oldvalue = inp(0x3c1);
	inp(0x3da); outp(0x3c0,0x16); newvalue = (oldvalue^16);
	outp(0x3c0, newvalue);
	inp(0x3da); outp(0x3c0,0x16); value = inp(0x3c1);
	inp(0x3da); outp(0x3c0,0x16); outp(0x3c0,oldvalue);
	tseng = 0;
	if (value == newvalue)
	{
		if ((inp(0x3cc)&1) == 1)
			bas = 0x3d0;
		else
			bas = 0x3b0;
		outp(bas+4,0x33); oldvalue = inp(bas+5);
		outp(bas+5,oldvalue^15); newvalue = inp(bas+5);
		outp(bas+5,oldvalue);
		if (newvalue == (oldvalue^15))
			tseng = 4000;  //TSENG ET4000
		else
			tseng = 3000;  //TSENG ET3000
	}

	vesa = checkvesa();                   //Check VESA

	if (tseng == 4000)
		card = 1;
	else if (vesa == 1)
		card = 2;
	else
		card = 0;

	return(card);
}

getpalookup()
{
	long i, j, k, dist, mindist, c1, c2, c3, closest;

	for(i=0;i<numpalookups;i++)
	{
		for(j=0;j<256;j++)
		{
			c1 = (palette[j+j+j+0]*((numpalookups-1)-i))/numpalookups;
			c2 = (palette[j+j+j+1]*((numpalookups-1)-i))/numpalookups;
			c3 = (palette[j+j+j+2]*((numpalookups-1)-i))/numpalookups;

			mindist = 32767, closest = -1;
			for(k=0;k<256;k++)
			{
				dist = (c1-palette[k+k+k+0])*(c1-palette[k+k+k+0]);
				dist += (c2-palette[k+k+k+1])*(c2-palette[k+k+k+1]);
				dist += (c3-palette[k+k+k+2])*(c3-palette[k+k+k+2]);
				if (dist < mindist)
				{
					mindist = dist;
					closest = k;
				}
			}

			palookup[i][j] = closest;
		}
	}
}
