#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

static long sintable[2048], tantable[1024];
static unsigned char tempbuf[4096];

main()
{
	long posx, posy;
	int ang, incr1, incr2, xc, yc, x, y, xdir, ydir;

	loadtables();
	_asm \
	{
		mov ax, 0x13
		int 0x10
	}
	posx = (32L<<10);
	posy = (32L<<10);
	for(ang=0;ang<2048;ang+=4)
	{
		incr1 = (int)(sintable[(2560+ang)&2047]);
		incr2 = (int)(sintable[(2048+ang)&2047]);
		x = (int)(posx>>10), xc = (int)((posx&1023)<<4);
		y = (int)(posy>>10), yc = (int)((posy&1023)<<4);
		if (incr1 > 0)
			xdir = 1;
		else
			xdir = -1, incr1 = -incr1, xc ^= 16383;
		if (incr2 > 0)
			ydir = 1;
		else
			ydir = -1, incr2 = -incr2, yc ^= 16383;
		check(x,y);
		do
		{
			xc = (xc+incr1)&16383, yc = (yc+incr2)&16383;
			if ((xc < incr1) && (yc < incr2))
			{
				if (((long)xc)*((long)incr2) > ((long)yc)*((long)incr1))
					x += xdir, check(x,y), y += ydir, check(x,y);
				else
					y += ydir, check(x,y), x += xdir, check(x,y);
			}
			else
			{
				if (xc < incr1) x += xdir, check(x,y);
				if (yc < incr2) y += ydir, check(x,y);
			}
		}
		while (((x|y)&0xffc0) == 0);
	}
	getch();
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
}

check(x,y)
int x, y;
{
	if (((x|y)&0xffc0) != 0)
		return(0);
	_asm \
	{
		cld
		mov ax, 0xa000
		mov es, ax
		mov di, y
		add di, di
		add di, y
		mov cl, 6
		shl di, cl
		mov ax, di
		shl di, 1
		shl di, 1
		add di, ax
		mov ax, x
		add di, ax
		add di, ax
		add di, ax
		mov byte ptr es:[di+0], 20
		mov byte ptr es:[di+1], 21
		mov byte ptr es:[di+2], 22
		mov byte ptr es:[di+320], 21
		mov byte ptr es:[di+321], 22
		mov byte ptr es:[di+322], 23
		mov byte ptr es:[di+640], 22
		mov byte ptr es:[di+641], 23
		mov byte ptr es:[di+642], 24
	}
}

loadtables()
{
	int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&tempbuf[0],4096);
		read(fil,&tantable[0],4096);
		close(fil);
	}
	_asm \
	{
		mov cx, 2048
		xor bx, bx
		xor si, si
convsintable:
		mov ax, word ptr tempbuf[bx]
		cwd
		mov word ptr sintable[si+0], ax
		mov word ptr sintable[si+2], dx
		add bx, 2
		add si, 4
		loop convsintable
	}
}
