// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#define MAIN
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include "build.h"

static unsigned char tempbuf[maxlines];
static unsigned short tempbufword[maxlines];
static struct walldata
{
	short unsigned int xa1, ya1, xa2, ya2;
	short unsigned int picnum, picnum1, picnum2, heinum1, heinum2;
	char shade, shade1, shade2, z1, z2, got, cstat, zosc, repeat;
};
extern short int numlines;
extern struct walldata lin[maxlines+2];

main(short int argc,char **argv)
{
	long i, j, highlight;
	char boardfilename[80];

	if (argc >= 2)
	{
		strcpy(&boardfilename,argv[1]);
		if(strchr(boardfilename,'.') == 0)
			strcat(boardfilename,".dat");
	}
	else
		strcpy(&boardfilename,"boards.dat");

	loadpics("pics.dat");
	loadboard(boardfilename);
	setgamemode();
	initengine();
	while (keystatus[1] == 0)
	{
		highlight = gethighlight();
		lin[highlight].picnum = (rand()&63);
		lin[highlight].shade = (rand()&255);

		//prepareboard();  //use only when wall's inserted, deleted, or moved.
		drawscreen(0);
		engineinput();
		nextpage();
	}
	uninitengine();
	saveboard(boardfilename);
	setvmode(0x3);
}

saveboard(filename)
char filename[20];
{
	short int fil, i;
	unsigned short tempword;
	long templong;

	if ((fil = open(filename,O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) != -1)
	{
		tempword = (unsigned short)(posx>>5), write(fil,&tempword,2);
		tempword = (unsigned short)(posy>>5), write(fil,&tempword,2);
		write(fil,&ang,2);
		write(fil,&numlines,2);

		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].xa1>>5);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].ya1>>5);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].xa2>>5);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].ya2>>5);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].picnum);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].picnum1);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].picnum2);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].heinum1);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].heinum2);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].shade;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].shade1;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].shade2;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].z1;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].z2;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].cstat;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].zosc;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].repeat;
		write(fil,&tempbuf[0],numlines);
		close(fil);
	}
	return(0);
}

long gethighlight()
{
	//write this, you but!
}
