DECLARE FUNCTION divscale& (eax&, ebx&, ecx&)
DECLARE FUNCTION scale& (eax&, ebx&, ecx&)
DECLARE FUNCTION keepaway% (x&, y&, clipwall%)
DECLARE SUB getcliplines (x&, y&, goalx&, goaly&)
DECLARE FUNCTION raytrace% (x&, y&, xvect&, yvect&, intx&, inty&)
DECLARE FUNCTION clockdir% ()
DECLARE SUB clipmove (x&, y&, xvect&, yvect&)
DECLARE SUB loadtables ()
DECLARE FUNCTION inside% (x&, y&)
DECLARE SUB getlines ()
CONST xdim = 640, ydim = 350, MAXWALLS = 1024, MAXCLIPNUM = 256
COMMON SHARED numwalls%, pag%, posx&, posy&
DIM SHARED sintable&(2048)

COMMON SHARED clipnum%, walldist&
DIM SHARED clipx1&(MAXCLIPNUM), clipy1&(MAXCLIPNUM)
DIM SHARED clipx2&(MAXCLIPNUM), clipy2&(MAXCLIPNUM)
DIM SHARED theclipwall%(MAXCLIPNUM)

TYPE walltype
   x AS LONG
   y AS LONG
   point2 AS INTEGER
END TYPE

DIM SHARED wall(MAXWALLS) AS walltype

CALL loadtables
CALL getlines

walldist& = 256
numhits% = 0
ang% = 1536
vel% = 32
angvel% = 0
DO
   LINE (0, 0)-(xdim - 1, ydim - 1), 0, BF
   FOR z% = 0 TO numwalls% - 1
      LINE (wall(z%).x \ 16, wall(z%).y \ 16)-(wall(wall(z%).point2).x \ 16, wall(wall(z%).point2).y \ 16), 12
   NEXT z%
   
   z$ = INKEY$
   IF z$ = CHR$(0) + CHR$(75) THEN angvel% = angvel% - 4
   IF z$ = CHR$(0) + CHR$(77) THEN angvel% = angvel% + 4
   IF z$ = CHR$(0) + CHR$(72) THEN vel% = vel% + 16
   IF z$ = CHR$(0) + CHR$(80) THEN vel% = vel% - 16
   IF z$ = " " THEN vel% = 0: angvel% = 0

   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   ang% = ((ang% + regs%(2) + angvel% + 2048) AND 2047)
  
   davel% = vel% - regs%(3)
   IF davel% <> 0 THEN
      cosang& = sintable&((ang% + 2560) AND 2047) * davel%
      sinang& = sintable&((ang% + 2048) AND 2047) * davel%
      CALL clipmove(posx&, posy&, cosang&, sinang&)
   END IF

   CIRCLE (posx& \ 16, posy& \ 16), 3, 15
  
   LINE ((posx& - walldist&) \ 16, (posy& - walldist&) \ 16)-((posx& + walldist&) \ 16, (posy& + walldist&) \ 16), 7, B
   LINE (posx& \ 16, posy& \ 16)-((posx& + sintable&((ang% + 2560) AND 2047) \ 64) \ 16, (posy& + sintable&((ang% + 2048) AND 2047) \ 64) \ 16), 15
  
   pag% = 1 - pag%: SCREEN 9, , pag%, 1 - pag%
   WAIT &H3DA, &H8, &H8
   WAIT &H3DA, &H8
LOOP WHILE z$ <> CHR$(27)
END

SUB clipmove (x&, y&, xvect&, yvect&)
   DIM hitwalls%(3)

   IF (xvect& OR yvect&) = 0 THEN EXIT SUB
  
   oxvect& = xvect&: oyvect& = yvect&
  
   goalx& = x& + xvect& \ 16384
   goaly& = y& + yvect& \ 16384

   CALL getcliplines(x&, y&, goalx&, goaly&)
  
   hitwall% = 0
   cnt% = 3
   WHILE (xvect& OR yvect&) <> 0 AND hitwall% >= 0 AND cnt% > 0
     
      hitwall% = raytrace%(x&, y&, xvect&, yvect&, intx&, inty&)

      IF hitwall% >= 0 THEN
         lx& = clipx2&(hitwall%) - clipx1&(hitwall%)
         ly& = clipy2&(hitwall%) - clipy1&(hitwall%)
         bot& = lx& * lx& + ly& * ly&
         IF bot& > 0 THEN
            top& = (goalx& - intx&) * lx& + (goaly& - inty&) * ly&
            t& = divscale&(top&, bot&, 14)
            xvect& = lx& * t&
            yvect& = ly& * t&
         END IF
        
         bad% = 0
         templong1& = lx& * (oxvect& \ 64) + ly& * (oyvect& \ 64)
         FOR z% = cnt% + 1 TO 3
            templong2& = (clipx2&(hitwalls%(z%)) - clipx1&(hitwalls%(z%))) * (oxvect& \ 64) + (clipy2&(hitwalls%(z%)) - clipy1&(hitwalls%(z%))) * (oyvect& \ 64)
            IF (templong1& < 0) <> (templong2& < 0) THEN bad% = 1: EXIT SUB
         NEXT z%
        
         IF bad% = 0 THEN
            LINE (x& \ 16, y& \ 16)-(x& \ 16 + xvect& \ 2048, y& \ 16 + yvect& \ 2048), 15
            goalx& = intx& + xvect& \ 16384
            goaly& = inty& + yvect& \ 16384
            snot% = keepaway%(goalx&, goaly&, hitwall%)
            xvect& = (goalx& - intx&) * 16384
            yvect& = (goaly& - inty&) * 16384
         END IF
        
         hitwalls%(cnt%) = hitwall%
         cnt% = cnt% - 1
      END IF

      x& = intx&
      y& = inty&
     
   WEND

END SUB

FUNCTION clockdir%
   minx& = &H7FFFFFFF
   themin% = -1
   i% = -1
   DO
      i% = i% + 1
      IF (wall(wall(i%).point2).x < minx&) THEN
         minx& = wall(wall(i%).point2).x
         themin% = i%
      END IF
   LOOP WHILE (wall(i%).point2 <> 0)

   x0& = wall(themin%).x
   y0& = wall(themin%).y
   x1& = wall(wall(themin%).point2).x
   y1& = wall(wall(themin%).point2).y
   x2& = wall(wall(wall(themin%).point2).point2).x
   y2& = wall(wall(wall(themin%).point2).point2).y

   IF ((y1& >= y2&) AND (y1& <= y0&)) THEN clockdir% = 0: EXIT FUNCTION
   IF ((y1& >= y0&) AND (y1& <= y2&)) THEN clockdir% = 1: EXIT FUNCTION

   templong& = (x0& - x1&) * (y2& - y1&) - (x2& - x1&) * (y0& - y1&)
   IF (templong& < 0) THEN
      clockdir% = 0: EXIT FUNCTION
   ELSE
      clockdir% = 1: EXIT FUNCTION
   END IF

END FUNCTION

FUNCTION divscale& (eax&, ebx&, ecx&)
   'divscale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 99                                cdq
   '66 0f a5 c2                          shld    edx,eax,cl
   '66 d3 e0                             shl     eax,cl
   '66 f7 fb                             idiv    ebx
 
   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax
 
   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(divscale&): offset& = VARPTR(divscale&)

   DIM asmprog%(27)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &H99
   POKE p& + 28, &H66: POKE p& + 29, &HF: POKE p& + 30, &HA5: POKE p& + 31, &HC2
   POKE p& + 32, &H66: POKE p& + 33, &HD3: POKE p& + 34, &HE0
   POKE p& + 35, &H66: POKE p& + 36, &HF7: POKE p& + 37, &HFB
   POKE p& + 38, &H26: POKE p& + 39, &HA3: POKE p& + 40, offset& AND 255: POKE p& + 41, (offset& \ 256) AND 255
   POKE p& + 42, &H66: POKE p& + 43, &HC1: POKE p& + 44, &HE8: POKE p& + 45, &H10
   POKE p& + 46, &H26: POKE p& + 47, &HA3: POKE p& + 48, (offset& + 2) AND 255: POKE p& + 49, ((offset& + 2) \ 256) AND 255
   POKE p& + 50, &H5D                                         'pop bp
   POKE p& + 51, &HCA: POKE p& + 52, &H2: POKE p& + 53, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

SUB getcliplines (x&, y&, goalx&, goaly&)
   clipnum% = 0
  
   cx& = (x& + goalx&) \ 2
   cy& = (y& + goaly&) \ 2
   rad& = SQR((goalx& - x&) * (goalx& - x&) + (goaly& - y&) * (goaly& - y&)) + walldist& + 8
   xmin& = cx& - rad&: ymin& = cy& - rad&
   xmax& = cx& + rad&: ymax& = cy& + rad&

   LINE (xmin& \ 16, ymin& \ 16)-(xmax& \ 16, ymax& \ 16), 1, BF
  
  
   FOR z% = 0 TO numwalls% - 1
      x1& = wall(z%).x: y1& = wall(z%).y
      x2& = wall(wall(z%).point2).x: y2& = wall(wall(z%).point2).y
     
      bad% = 0
      IF (x1& < xmin& AND x2& < xmin&) THEN bad% = 1
      IF (x1& > xmax& AND x2& > xmax&) THEN bad% = 1
      IF (y1& < ymin& AND y2& < ymin&) THEN bad% = 1
      IF (y1& > ymax& AND y2& > ymax&) THEN bad% = 1
     
      IF y2& > y1& THEN
         IF x2& > x1& THEN
            IF (x2& - x1&) * (ymin& - y1&) - (xmax& - x1&) * (y2& - y1&) >= 0 THEN bad% = 1
         ELSE
            IF (x2& - x1&) * (ymax& - y1&) - (xmax& - x1&) * (y2& - y1&) >= 0 THEN bad% = 1
         END IF
      ELSE
         IF x2& > x1& THEN
            IF (x2& - x1&) * (ymin& - y1&) - (xmin& - x1&) * (y2& - y1&) >= 0 THEN bad% = 1
         ELSE
            IF (x2& - x1&) * (ymax& - y1&) - (xmin& - x1&) * (y2& - y1&) >= 0 THEN bad% = 1
         END IF
      END IF
      
      IF bad% = 0 THEN
         IF x2& > x1& THEN
            y1& = y1& + walldist&: y2& = y2& + walldist&
         ELSE
            y1& = y1& - walldist&: y2& = y2& - walldist&
         END IF
         IF y2& > y1& THEN
            x1& = x1& - walldist&: x2& = x2& - walldist&
         ELSE
            x1& = x1& + walldist&: x2& = x2& + walldist&
         END IF
        
         clipx1&(clipnum%) = x1&: clipy1&(clipnum%) = y1&
         clipx2&(clipnum%) = x2&: clipy2&(clipnum%) = y2&
         theclipwall%(clipnum%) = z%
         LINE (x1& \ 16, y1& \ 16)-(x2& \ 16, y2& \ 16), 8
         PSET (x1& \ 16, y1& \ 16), 7
         PSET (x2& \ 16, y2& \ 16), 7
         clipnum% = clipnum% + 1
      END IF
   NEXT z%
  
   theclipnum% = clipnum%
  
   FOR z% = 0 TO theclipnum% - 1
      zz% = theclipwall%(z%)
      x1& = wall(zz%).x: y1& = wall(zz%).y
      x2& = wall(wall(zz%).point2).x: y2& = wall(wall(zz%).point2).y
     
      IF goalx& > x& THEN
         clipx1&(clipnum%) = x1& - walldist&
         clipy1&(clipnum%) = y1& - walldist&
         clipx2&(clipnum%) = x1& - walldist&
         clipy2&(clipnum%) = y1& + walldist&
      ELSE
         clipx1&(clipnum%) = x1& + walldist&
         clipy1&(clipnum%) = y1& + walldist&
         clipx2&(clipnum%) = x1& + walldist&
         clipy2&(clipnum%) = y1& - walldist&
      END IF
      LINE (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16)-(clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 8
      PSET (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16), 7
      PSET (clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 7
      clipnum% = clipnum% + 1
     
      IF goaly& > y& THEN
         clipx1&(clipnum%) = x1& + walldist&
         clipy1&(clipnum%) = y1& - walldist&
         clipx2&(clipnum%) = x1& - walldist&
         clipy2&(clipnum%) = y1& - walldist&
      ELSE
         clipx1&(clipnum%) = x1& - walldist&
         clipy1&(clipnum%) = y1& + walldist&
         clipx2&(clipnum%) = x1& + walldist&
         clipy2&(clipnum%) = y1& + walldist&
      END IF
      LINE (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16)-(clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 8
      PSET (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16), 7
      PSET (clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 7
      clipnum% = clipnum% + 1
     
      IF goalx& > x& THEN
         clipx1&(clipnum%) = x2& - walldist&
         clipy1&(clipnum%) = y2& - walldist&
         clipx2&(clipnum%) = x2& - walldist&
         clipy2&(clipnum%) = y2& + walldist&
      ELSE
         clipx1&(clipnum%) = x2& + walldist&
         clipy1&(clipnum%) = y2& + walldist&
         clipx2&(clipnum%) = x2& + walldist&
         clipy2&(clipnum%) = y2& - walldist&
      END IF
      LINE (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16)-(clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 8
      PSET (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16), 7
      PSET (clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 7
      clipnum% = clipnum% + 1
    
      IF goaly& > y& THEN
         clipx1&(clipnum%) = x2& + walldist&
         clipy1&(clipnum%) = y2& - walldist&
         clipx2&(clipnum%) = x2& - walldist&
         clipy2&(clipnum%) = y2& - walldist&
      ELSE
         clipx1&(clipnum%) = x2& - walldist&
         clipy1&(clipnum%) = y2& + walldist&
         clipx2&(clipnum%) = x2& + walldist&
         clipy2&(clipnum%) = y2& + walldist&
      END IF
      LINE (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16)-(clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 8
      PSET (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16), 7
      PSET (clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 7
      clipnum% = clipnum% + 1
     
   NEXT z%
END SUB

SUB getlines
   DIM regs%(7): regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
   pag% = 0: SCREEN 9, , pag%, pag%
   numwalls% = 0
   mousx& = xdim \ 2
   mousy& = ydim \ 2
   oldcol% = 0
   obstatus% = 1
   FOR z% = mousx& - 2 TO mousx& + 2
      FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
         PSET (z%, zz%), POINT(z%, zz%) XOR 15
      NEXT zz%
   NEXT z%
   DO
      DO
         z$ = INKEY$
         regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
         IF regs%(2) <> 0 OR regs%(3) <> 0 THEN
            FOR z% = mousx& - 2 TO mousx& + 2
               FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
                  PSET (z%, zz%), POINT(z%, zz%) XOR 15
               NEXT zz%
            NEXT z%
            mousx& = mousx& + regs%(2)
            mousy& = mousy& + regs%(3)
            IF mousx& < 0 THEN mousx& = 0
            IF mousx& >= xdim THEN mousx& = xdim - 1
            IF mousy& < 0 THEN mousy& = 0
            IF mousy& >= ydim THEN mousy& = ydim - 1
            FOR z% = mousx& - 2 TO mousx& + 2
               FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
                  PSET (z%, zz%), POINT(z%, zz%) XOR 15
               NEXT zz%
            NEXT z%
         END IF
         regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
         obstatus% = bstatus%: bstatus% = regs%(0)
      LOOP WHILE z$ = "" AND bstatus% = obstatus%
      IF z$ = " " OR (bstatus% AND 1) > (obstatus% AND 1) THEN
         SCREEN 9, , 1 - pag%, pag%
         LINE (0, 0)-(xdim - 1, ydim - 1), 0, BF
         wall(numwalls%).x = mousx&
         wall(numwalls%).y = mousy&
         IF numwalls% > 0 THEN wall(numwalls% - 1).point2% = numwalls%
         wall(numwalls%).point2 = 0
         numwalls% = numwalls% + 1
         FOR z% = 0 TO numwalls% - 1
            z2% = wall(z%).point2
            LINE (wall(z%).x, wall(z%).y)-(wall(z2%).x, wall(z2%).y), 12
         NEXT z%
         pag% = 1 - pag%: SCREEN 9, , pag%, pag%
         WAIT &H3DA, &H8, &H8
         WAIT &H3DA, &H8
      END IF
   LOOP WHILE z$ <> CHR$(13) AND (bstatus% AND 6) <= (obstatus% AND 6)
  
   IF clockdir% = 1 THEN
      FOR z% = 0 TO numwalls% \ 2 - 1
         SWAP wall(z%).x, wall(numwalls% - 1 - z%).x
         SWAP wall(z%).y, wall(numwalls% - 1 - z%).y
      NEXT z%
   END IF
  
   FOR z% = 0 TO numwalls% - 1
      wall(z%).x = wall(z%).x * 16
      wall(z%).y = wall(z%).y * 16
   NEXT z%
   posx& = mousx& * 16: posy& = mousy& * 16
END SUB

FUNCTION inside% (x&, y&)
   cnt% = 0
   FOR z% = 0 TO numwalls% - 1
      x1& = wall(z%).x: x2& = wall(wall(z%).point2).x
      IF (x1& >= x& OR x2& >= x&) THEN
         y1& = wall(z%).y: y2& = wall(wall(z%).point2).y
         IF y1& > y2& THEN SWAP x1&, x2&: SWAP y1&, y2&
         IF (y1& <= y& AND y2& > y&) THEN
            IF x1& * (y& - y2&) + x2& * (y1& - y&) <= x& * (y1& - y2&) THEN cnt% = 1 - cnt%
         END IF
      END IF
   NEXT z%
   inside% = cnt%
END FUNCTION

FUNCTION keepaway% (x&, y&, clipwall%)
   bakx& = 0: baky& = 0
   IF clipx2&(clipwall%) > clipx1&(clipwall%) THEN baky& = 1
   IF clipx2&(clipwall%) < clipx1&(clipwall%) THEN baky& = -1
   IF clipy2&(clipwall%) > clipy1&(clipwall%) THEN bakx& = -1
   IF clipy2&(clipwall%) < clipy1&(clipwall%) THEN bakx& = 1
 
   IF ABS(clipx2&(clipwall%) - clipx1&(clipwall%)) > ABS(clipy2&(clipwall%) - clipy1&(clipwall%)) THEN
      first% = 0
   ELSE
      first% = 1
   END IF

   daside& = (clipx2&(clipwall%) - clipx1&(clipwall%)) * (y& - clipy1&(clipwall%)) - (x& - clipx1&(clipwall%)) * (clipy2&(clipwall%) - clipy1&(clipwall%))
   WHILE daside& <= 0
     IF first% = 0 THEN
        x& = x& + bakx&
     ELSE
        y& = y& + baky&
     END IF
     first% = 1 - first%
     daside& = (clipx2&(clipwall%) - clipx1&(clipwall%)) * (y& - clipy1&(clipwall%)) - (x& - clipx1&(clipwall%)) * (clipy2&(clipwall%) - clipy1&(clipwall%))
   WEND

   bad% = 0
   z% = clipwall% + 1: IF z% >= clipnum% THEN z% = z% - clipnum%
   zz% = clipwall% + clipnum% - 1: IF zz% >= clipnum% THEN zz% = zz% - clipnum%
   IF clipx1&(z%) <> clipx2&(clipwall%) OR clipy1&(z%) <> clipy2&(clipwall%) THEN
      daside& = (clipx2&(z%) - clipx1&(z%)) * (y& - clipy1&(z%)) - (x& - clipx1&(z%)) * (clipy2&(z%) - clipy1&(z%))
      IF daside& < 0 THEN bad% = 1
   END IF
   IF clipx2&(zz%) <> clipx1&(clipwall%) OR clipy2&(zz%) <> clipy1&(clipwall%) THEN
      daside& = (clipx2&(zz%) - clipx1&(zz%)) * (y& - clipy1&(zz%)) - (x& - clipx1&(zz%)) * (clipy2&(zz%) - clipy1&(zz%))
      IF daside& < 0 THEN bad% = 1
   END IF
 
   keepaway% = bad%
END FUNCTION

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

FUNCTION raytrace% (x&, y&, xvect&, yvect&, intx&, inty&)
  
   x3& = x&: y3& = y&
   x4& = x3& + xvect& \ 16384: y4& = y3& + yvect& \ 16384
   intx& = x4&: inty& = y4&
   hitwall% = -1

   FOR z% = 0 TO clipnum% - 1
      x1& = clipx1&(z%): y1& = clipy1&(z%)
      x2& = clipx2&(z%): y2& = clipy2&(z%)

      templong1& = (x2& - x1&) * (y3& - y1&) - (x3& - x1&) * (y2& - y1&)
      templong2& = (x2& - x1&) * (y4& - y1&) - (x4& - x1&) * (y2& - y1&)
      IF (templong1& >= 0) AND (templong2& < 0) THEN
         templong3& = (x4& - x3&) * (y1& - y3&) - (x1& - x3&) * (y4& - y3&)
         templong4& = (x4& - x3&) * (y2& - y3&) - (x2& - x3&) * (y4& - y3&)
         IF (templong3& <= 0) AND (templong4& > 0) THEN
            bot& = (x2& - x1&) * (y3& - y4&) - (x3& - x4&) * (y2& - y1&)
            IF bot& <> 0 THEN
              
               topu& = (x2& - x1&) * (y3& - y1&) - (x3& - x1&) * (y2& - y1&)
               'LOCATE 1, 1: PRINT topu&
               abortval& = topu& - 256
               DO
                  nintx& = x3& + ((x4& - x3&) * topu&) \ bot&
                  ninty& = y3& + ((y4& - y3&) * topu&) \ bot&
                  daside& = (x2& - x1&) * (ninty& - y1&) - (nintx& - x1&) * (y2& - y1&)
                  topu& = topu& - 1
               LOOP WHILE daside& < 0 AND topu& > abortval&
               IF topu& <= abortval& THEN intx& = x3&: inty& = y3&: raytrace% = z%: EXIT FUNCTION
               'LOCATE 2, 1: PRINT (topu& - 256) - abortval&

               IF ABS(x3& - nintx&) + ABS(y3& - ninty&) < ABS(x3& - intx&) + ABS(y3& - inty&) THEN
                  intx& = nintx&
                  inty& = ninty&
                  hitwall% = z%
               END IF
            END IF
         END IF
      END IF
   NEXT z%

   raytrace% = hitwall%
END FUNCTION

FUNCTION scale& (eax&, ebx&, ecx&)
   'scale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 f7 eb                             imul    ebx
   '66 f7 f9                             idiv    ecx
 
   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax
 
   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(scale&): offset& = VARPTR(scale&)

   DIM asmprog%(25)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &HF7: POKE p& + 28, &HEB
   POKE p& + 29, &H66: POKE p& + 30, &HF7: POKE p& + 31, &HF9
   POKE p& + 32, &H26: POKE p& + 33, &HA3: POKE p& + 34, offset& AND 255: POKE p& + 35, (offset& \ 256) AND 255
   POKE p& + 36, &H66: POKE p& + 37, &HC1: POKE p& + 38, &HE8: POKE p& + 39, &H10
   POKE p& + 40, &H26: POKE p& + 41, &HA3: POKE p& + 42, (offset& + 2) AND 255: POKE p& + 43, ((offset& + 2) \ 256) AND 255
   POKE p& + 44, &H5D                                         'pop bp
   POKE p& + 45, &HCA: POKE p& + 46, &H2: POKE p& + 47, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

