' "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
' Ken Silverman's official web site: "http://www.advsys.net/ken"
' See the included license file "BUILDLIC.TXT" for license info.

DECLARE SUB initcache (dacachestart&, dacachesize&)
DECLARE SUB uninitcache ()
DECLARE FUNCTION allocache& (newhandle&, newbytes&, newlock&, snothead%)

CONST MAXCACHEOBJECTS = 4096
CONST MAXBUFS = 4096

DIM SHARED cachestart&, cachesize&, cacheplc&
DIM SHARED cachelistplc&, cachelistend&
DIM SHARED handleptr&(MAXCACHEOBJECTS), cacheleng&(MAXCACHEOBJECTS)
DIM SHARED cachelock&(MAXCACHEOBJECTS)

DIM SHARED bufoffs&(MAXBUFS), bufsiz&(MAXBUFS), buflock&(MAXBUFS)

SCREEN 13
RANDOMIZE 3

CALL initcache(1&, 320&)

z% = 0
DO
	bufsiz&(z%) = (INT(8 * RND) + 1) * 8  'INT(32 * RND) + 5
	buflock&(z%) = INT(8 * RND) \ 7
  
	LINE (cacheplc&, 16)-(cacheplc& + bufsiz&(z%) - 1, 16), 15
	DO: LOOP WHILE INKEY$ = ""
  
	dahandle& = allocache&(bufoffs&(z%), bufsiz&(z%), buflock&(z%), z%)

	'z& = INT(((cachelistend& - cachelistplc&) AND (MAXCACHEOBJECTS - 1)) * RND)
	'z& = ((z& + cachelistplc&) AND (MAXCACHEOBJECTS - 1))
	'cachelock&(z&) = INT(8 * RND) \ 7
	'buflock&(handleptr&(z&)) = cachelock&(z&)
  
	WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
	LINE (0, 0)-(319, 16), 0, BF
	LINE (0, 0)-(319, 15), 8, B
	zz& = cachelistplc&
	DO WHILE zz& <> cachelistend&
		z& = handleptr&(zz&)
		IF bufoffs&(z&) <> 0 THEN
			LINE (bufoffs&(z&) - 1, 0)-(bufoffs&(z&) + bufsiz&(z&) - 2, 15), (z& AND 3) + 12, BF
			IF buflock&(z&) <> 0 THEN
				LINE (bufoffs&(z&) - 1, 0)-(bufoffs&(z&) + bufsiz&(z&) - 2, 15), 0
				LINE (bufoffs&(z&) - 1, 15)-(bufoffs&(z&) + bufsiz&(z&) - 2, 0), 0
			END IF
			LINE (bufoffs&(z&) - 1, 0)-(bufoffs&(z&) + bufsiz&(z&) - 2, 15), (z& AND 3) + 4, B
		END IF
		zz& = ((zz& + 1) AND (MAXCACHEOBJECTS - 1))
	LOOP

	z% = ((z% + 1) AND (MAXBUFS - 1))
LOOP

FUNCTION allocache& (newhandle&, newbytes&, newlock&, snothead%)
	startcachelistplc& = cachelistplc&

	IF (cachesize& < newbytes&) THEN PRINT "TOO BIG TO FIT IN CACHE": END

	DO WHILE (cachelistplc& <> cachelistend&)
		IF cacheplc& + newbytes& > cachesize& THEN
			DO WHILE (cachelistplc& <> cachelistend&)
				IF (bufoffs&(handleptr&(cachelistplc&)) - cachestart& < cacheplc&) THEN EXIT DO
				cachelistplc& = ((cachelistplc& + 1) AND (MAXCACHEOBJECTS - 1))
			LOOP
			cacheplc& = 0
		END IF
		i& = bufoffs&(handleptr&(cachelistplc&)) - cachestart&
		IF ((i& < cacheplc&) OR (i& >= cacheplc& + newbytes&)) THEN EXIT DO
		IF cachelock&(cachelistplc&) <> 0 THEN
			cacheplc& = bufoffs&(handleptr&(cachelistplc&)) + cacheleng&(cachelistplc&) - 1
		END IF
		cachelistplc& = ((cachelistplc& + 1) AND (MAXCACHEOBJECTS - 1))
	LOOP
	  
		'actually remove from cache here
	DO WHILE startcachelistplc& <> cachelistplc&
		i& = bufoffs&(handleptr&(startcachelistplc&)) - cachestart&
		IF ((i& >= cacheplc&) AND (i& < cacheplc& + newbytes&)) THEN
			IF cachelock&(startcachelistplc&) <> 0 THEN
				PRINT "CACHE SPACE ALL LOCKED UP": END
			END IF
			bufoffs&(handleptr&(startcachelistplc&)) = 0  'handleptr&(cachelistplc&) = 0
		ELSE
			handleptr&(cachelistend&) = handleptr&(startcachelistplc&)
			cacheleng&(cachelistend&) = cacheleng&(startcachelistplc&)
			cachelock&(cachelistend&) = cachelock&(startcachelistplc&)
			cachelistend& = ((cachelistend& + 1) AND (MAXCACHEOBJECTS - 1))
		END IF
		startcachelistplc& = ((startcachelistplc& + 1) AND (MAXCACHEOBJECTS - 1))
	LOOP
  
	handleptr&(cachelistend&) = snothead%  'newhandle&
	newhandle& = cachestart& + cacheplc&
		 
	cacheleng&(cachelistend&) = newbytes&
	cachelock&(cachelistend&) = newlock&
	cachelistend& = ((cachelistend& + 1) AND (MAXCACHEOBJECTS - 1))
  
	cacheplc& = cacheplc& + newbytes&

	allocache& = ((cachelistend& - 1) AND (MAXCACHEOBJECTS - 1))
END FUNCTION

SUB initcache (dacachestart&, dacachesize&)
	CALL uninitcache
	cachestart& = dacachestart&
	cachesize& = dacachesize&
	cacheplc& = 0
	cachelistplc& = 0
	cachelistend& = 0
END SUB

SUB lockcacheitem (daindex&)
	cachelock&(daindex&) = 1
END SUB

SUB uninitcache
	  'Suck everything out of cache
	WHILE (cachelistplc& <> cachelistend&)
		handleptr&(cachelistplc&) = 0
		cachelistplc& = ((cachelistplc& + 1) AND (MAXCACHEOBJECTS - 1))
	WEND
	FOR i& = MAXCACHEOBJECTS - 1 TO 0 STEP -1: cachelock&(i&) = 0: NEXT i&
	cacheplc& = 0
	cachesize& = 0
END SUB

SUB unlockcacheitem (daindex&)
	cachelock&(daindex&) = 0
END SUB

