#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <dos.h>
#include <stdlib.h>

#define XDIM 640
#define YDIM 480
#define MAXTILES 4096
#define MAXMOVES 4096
#define MAXRECURSION 8

#define NUMOPTIONS 8
#define NUMKEYS 19
static char option[NUMOPTIONS];
static char keys[NUMKEYS];
static char textfont[1024];

static long digihz[7] = {6000,8000,11025,16000,22050,32000,44100};

static char board[64], startboard[64] =
{
	20,17,0,0,0,0,9,12,
	18,17,0,0,0,0,9,10,
	19,17,0,0,0,0,9,11,
	21,17,0,0,0,0,9,13,
	22,17,0,0,0,0,9,14,
	19,17,0,0,0,0,9,11,
	18,17,0,0,0,0,9,10,
	20,17,0,0,0,0,9,12,
};
static char validmove[MAXRECURSION+1][64];
static char validmovecnt[MAXRECURSION+1];
static char *globalvalidptr;

static long globnodes, turn = 0, timermode = 0;
static long recursecnt, globrecursion, movelist[4096], movelistcnt = 0;
static char c = 4, d = 4;
static long rank2[24], rank[24] =
{
	0,0,0,0,0,0,0,0,
	0,+1,+3,+3,+5,+15,+1024,0,
	0,-1,-3,-3,-5,-15,-1024,0
};

static char buf[24576], palette[768];
static short tilesizx[MAXTILES], tilesizy[MAXTILES];
static long picanm[MAXTILES];

static char *screen, vesapageshift, curpag = 0;
static short randarray[4096], randprob[1024], randcnt = 4095;
static long frameplace, ylookup[YDIM];

static char tempbuf[576];
	//ENGINE CONTROLLED MULTIPLAYER VARIABLES:
#define MAXPLAYERS 16
extern short numplayers, myconnectindex;
extern short connecthead, connectpoint2[MAXPLAYERS];   //Player linked list variables (indeces, not connection numbers)

	//Variables that let you type messages to other player
static char getmessage[162], getmessageleng;
static long getmessagetimeoff;
static char typemessage[162], typemessageleng = 0, typemode = 0;
static char scantoasc[128] =
{
	0,0,'1','2','3','4','5','6','7','8','9','0','-','=',0,0,
	'q','w','e','r','t','y','u','i','o','p','[',']',0,0,'a','s',
	'd','f','g','h','j','k','l',';',39,'`',0,92,'z','x','c','v',
	'b','n','m',',','.','/',0,'*',0,32,0,0,0,0,0,0,
	0,0,0,0,0,0,0,'7','8','9','-','4','5','6','+','1',
	'2','3','0','.',0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};
static char scantoascwithshift[128] =
{
	0,0,'!','@','#','$','%','^','&','*','(',')','_','+',0,0,
	'Q','W','E','R','T','Y','U','I','O','P','{','}',0,0,'A','S',
	'D','F','G','H','J','K','L',':',34,'~',0,'|','Z','X','C','V',
	'B','N','M','<','>','?',0,'*',0,32,0,0,0,0,0,0,
	0,0,0,0,0,0,0,'7','8','9','-','4','5','6','+','1',
	'2','3','0','.',0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};

volatile unsigned char keystatus[256], readch, oldreadch, extended;
void (__interrupt __far *oldkeyhandler)();
void __interrupt __far keyhandler(void);

volatile long totalclock;
void (__interrupt __far *oldtimerhandler)();
void __interrupt __far timerhandler(void);

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

#pragma aux drawpixels =\
	"mov word ptr [edi], ax",\
	parm [edi][eax]\

#pragma aux drawpixelses =\
	"mov dword ptr [edi], eax",\
	parm [edi][eax]\

#pragma aux klabs =\
	"test eax, eax",\
	"jns skipnegate",\
	"neg eax",\
	"skipnegate:",\
	parm [eax]\

#pragma aux ksgn =\
	"add ebx, ebx",\
	"sbb eax, eax",\
	"cmp eax, ebx",\
	"adc eax, 0",\
	parm [ebx]\

#pragma aux limitrate =\
	"mov dx, 0x3da",\
	"wait1: in al, dx",\
	"test al, 8",\
	"jnz wait1",\
	"wait2: in al, dx",\
	"test al, 8",\
	"jz wait2",\
	modify [eax edx]\

#pragma aux readtimer =\
	"mov al, 0xd2",\
	"out 0x43, al",\
	"in al, 0x40",\
	"mov ah, al",\
	"in al, 0x40",\
	"xchg al, ah",\
	"and eax, 0x0000ffff",\
	modify [eax]\

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux copybuf =\
	"rep movsd",\
	parm [esi][edi][ecx]\

#pragma aux clearbufbyte =\
	"shr ecx, 1",\
	"jnc skip1",\
	"stosb",\
	"skip1: shr ecx, 1",\
	"jnc skip2",\
	"stosw",\
	"skip2: test ecx, ecx",\
	"jz skip3",\
	"rep stosd",\
	"skip3:",\
	parm [edi][ecx][eax]\

#pragma aux vesasetmode =\
	"mov ax, 0x4f02",\
	"int 0x10",\
	"and eax, 0x0000ffff",\
	parm [ebx]\
	modify [eax ebx]\

#pragma aux vesasetpage =\
	"mov cl, vesapageshift",\
	"shl dx, cl",\
	"cmp dl, curpag",\
	"je skipsetpage",\
	"mov curpag, dl",\
	"mov ax, 0x4f05",\
	"xor bx, bx",\
	"int 0x10",\
	"skipsetpage:",\
	parm [edx]\
	modify [eax ebx ecx]\

#pragma aux readkey =\
	"in al, 0x60",\
	"mov readch, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\
	modify [eax]\

void __interrupt __far keyhandler()
{
	oldreadch = readch;
	readkey();
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
		{
			if ((readch&128) == 0)
			{
				if (keystatus[(readch&127)+extended] == 0)
					keystatus[(readch&127)+extended] = 1;
			}
			else
				keystatus[(readch&127)+extended] = 0;
		}
		extended = 0;
	}
	outp(0x20,0x20);
	if (keystatus[1] > 0) cleanexit();
}

main(short int argc,char **argv)
{
	short other;
	long i, smartness[2], fil, x, y;

	initgroupfile("stuff.dat");
	if ((fil = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&option[0],NUMOPTIONS);
		read(fil,&keys[0],NUMKEYS);
		close(fil);
	}
	if ((fil = kopen4load("tables.dat",0)) != -1)
	{
		klseek(fil,4096+4096+640,SEEK_SET);
		kread(fil,&textfont[0],1024);
		kclose(fil);
	}

	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();

	inittimer();
	initmultiplayers(option[4],option[5]);

		//Init digitized sound
	initsb(option[1],option[2],digihz[option[7]>>4],((option[7]&4)>0)+1,((option[7]&2)>0)+1,60,option[7]&1);
	loadsong("neatsong.kdm");
	musicon();

	smartness[0] = 0;    //0 is so stupid it's a human
	smartness[1] = 4;    //4 is very smart and quick
	if (argc == 3)
	{
		smartness[0] = atol(argv[1]);
		if (smartness[0] < 0)
		{
			smartness[1] = -smartness[0];
			if (smartness[1] < 1) smartness[1] = 1;
			if (smartness[1] > 5) smartness[1] = 5;
			timermode = atol(argv[2]);
			if (timermode < 1) timermode = 1;
			if (timermode > 120*60*10) timermode = 120*60*10;
			smartness[0] = 0;
		}
		else
		{
			if (smartness[0] > 5) smartness[0] = 5;
			smartness[1] = atol(argv[2]);
			if (smartness[1] < 0) smartness[1] = 0;
			if (smartness[1] > 5) smartness[1] = 5;
		}
	}

	srand(readtimer());
	for(i=4095;i>=0;i--) randarray[i] = rand();
	for(i=1023;i>0;i--) randprob[i] = 32768/i;

	copybuf(startboard,board,64>>2);
	initpics();

	drawboard(0L,0L,XDIM-1L,YDIM-1L);
	nextpage(0L,0L,XDIM-1L,YDIM-1L);

	if (option[4] > 0)
	{
		sendlogon();

		x = (XDIM>>1)-(27<<2); y = (YDIM>>1);
		printext256(x,y,24L,-1L,"Waiting for other player...");
		nextpage(x,y,x+(27<<3),y+8);

		while (numplayers < 2)
		{
			if (getpacket(&other,tempbuf) > 0)
				if (tempbuf[0] == 255) cleanexit();
		}

		drawboard(x,y,x+(27<<3),y+8);
		nextpage(x,y,x+(27<<3),y+8);

		if (myconnectindex == connecthead)
			smartness[0] = 0, smartness[1] = -1;   //-1 means remote player
		else
			smartness[0] = -1, smartness[1] = 0;
		timermode = 0;
	}

	wsay("opendoor.wav",4096L,255L,255L);

	while (keystatus[1] == 0)
	{
		pickmove(turn,smartness[turn]);
		drawboard(0L,0L,XDIM-1L,YDIM-1L);
		nextpage(0L,0L,XDIM-1L,YDIM-1L);
	}
	cleanexit();
}

cleanexit()
{
	sendlogoff();         //Signing off
	setvmode(0x3);
	uninitmultiplayers();
	uninittimer();
	_disable(); _dos_setvect(0x9, oldkeyhandler); _enable();
	musicoff();
	uninitsb();
	uninitgroupfile();
	exit(0);
}

inittimer()
{
	outp(0x43,54); outp(0x40,9942&255); outp(0x40,9942>>8);  //120 times/sec
	oldtimerhandler = _dos_getvect(0x8);
	_disable(); _dos_setvect(0x8, timerhandler); _enable();
}

uninittimer()
{
	outp(0x43,54); outp(0x40,255); outp(0x40,255);           //18.2 times/sec
	_disable(); _dos_setvect(0x8, oldtimerhandler); _enable();
}

void __interrupt __far timerhandler()
{
	totalclock++;
	outp(0x20,0x20);
}

initpics()
{
	long fil, i;

	setgamemode();

	if ((fil = kopen4load("palette.dat",0)) == -1) return;
	kread(fil,&palette[0],768);
	kclose(fil);
	outp(0x3c8,0);
	for(i=0;i<768;i++) outp(0x3c9,palette[i]);

	for(i=0;i<6;i++) loadnewall(i<<12,i+140);
}

loadnewall (long bufplc, long wallnum)
{
	long fil, version, numtiles, localtilestart, localtileend, totsiz, z;

	if ((fil = kopen4load("tiles000.art",0)) == -1) return;

	kread(fil,&version,4);
	kread(fil,&numtiles,4);
	kread(fil,&localtilestart,4);
	kread(fil,&localtileend,4);
	kread(fil,&tilesizx[0],(localtileend-localtilestart+1)<<1);
	kread(fil,&tilesizy[0],(localtileend-localtilestart+1)<<1);
	kread(fil,&picanm[0],(localtileend-localtilestart+1)<<2);

	totsiz = 0;
	for(z=0;z<wallnum;z++) totsiz += tilesizx[z]*tilesizy[z];
	klseek(fil,totsiz+16+((localtileend-localtilestart+1)<<3),SEEK_SET);
	kread(fil,&buf[bufplc],tilesizx[wallnum]*tilesizy[wallnum]);

	kclose(fil);
}

drawboard(long cx1, long cy1, long cx2, long cy2)
{
	long x1, y1, x2, y2, rad;
	char x, y, dat, *boardptr;

	boardptr = (char *)(FP_OFF(board));

	rad = ((YDIM<<5)/480L);

	if (cx1 < ((XDIM-YDIM)>>1))
		fillrectangle(max(0L,cx1),max(0L,cy1),min(((XDIM-YDIM)>>1)-1,cx2),min(YDIM-1,cy2),0);
	if (cx2 >= XDIM-((XDIM-YDIM)>>1))
		fillrectangle(max(XDIM-((XDIM-YDIM)>>1),cx1),max(0L,cy1),min(XDIM-1,cx2),min(YDIM-1,cy2),0);

	x1 = ((XDIM-YDIM)>>1); x2 = x1+(YDIM>>3)-1;
	for(x=0;x<8;x++)
	{
		y1 = 0; y2 = (YDIM>>3)-1;
		for(y=0;y<8;y++)
		{
			if ((x1 <= cx2) && (cx1 <= x2) && (y1 <= cy2) && (cy1 <= y2))
				fillrectangle(max(x1,cx1),max(y1,cy1),min(x2,cx2),min(y2,cy2),(((x^y)&1^1)<<1)+12);
			dat = *boardptr++;
			if (dat != 0)
			{
				x1 += (YDIM>>4); y1 += (YDIM>>4);
				if ((x1-rad <= cx2) && (cx1 <= x1+rad))
					if ((y1-rad <= cy2) && (cy1 <= y1+rad))
						drawchesspicture(x1,y1,(YDIM<<8)/480L,(long)dat-1);
				x1 -= (YDIM>>4); y1 -= (YDIM>>4);
			}
			y1 += (YDIM>>3); y2 += (YDIM>>3);
		}
		x1 += (YDIM>>3); x2 += (YDIM>>3);
	}
}

drawchesspicture (long dax, long day, long siz, long picnum)
{
	long dashade, xdim, ydim, nxdim, nydim, bufoffs, bufinc, x, y;
	long p, dat;

	if (picnum >= 16) dashade = -12; else dashade = 0;
	picnum &= 7;

	xdim = tilesizx[picnum+140]; nxdim = ((xdim*siz)>>8); dax -= (nxdim>>1);
	ydim = tilesizy[picnum+140]; nydim = ((ydim*siz)>>8); day -= (nydim>>1);
	if (day < 0) day = 0;

	bufinc = 65536/siz;
	for(x=0;x<nxdim;x++)
	{
		bufoffs = ((((x<<8)/siz)*ydim + (picnum<<12)) << 8);
		p = ylookup[day] + (x+dax) + frameplace;
		for(y=0;y<nydim;y++)
		{
			dat = buf[bufoffs>>8];
			if (dat != 255) drawpixel(p,dat+dashade);
			p += XDIM;
			bufoffs += bufinc;
		}
	}
}

pickmove(long dacol, long smartness)
{
	long i, j;
	short tempbufleng, other;
	char x1, y1, x2, y2;

	if (smartness <= 0)
	{
		if (smartness == 0)
		{
			playermove(dacol,&x1,&y1,&x2,&y2);

			if (option[4] != 0)
			{
				tempbuf[0] = 0;
				tempbuf[1] = (x1<<3)+y1;
				tempbuf[2] = (x2<<3)+y2;
				if (myconnectindex == connecthead)
					sendpacket(connectpoint2[connecthead],tempbuf,3);
				else
					sendpacket(connecthead,tempbuf,3);
			}
		}
		else
		{
			x1 = 255;
			while (x1 == 255)
			{
				if ((tempbufleng = getpacket(&other,tempbuf)) > 0)
				{
					switch(tempbuf[0])
					{
						case 0:  //Send move
							x1 = (tempbuf[1]>>3);
							y1 = (tempbuf[1]&7);
							x2 = (tempbuf[2]>>3);
							y2 = (tempbuf[2]&7);
							break;
						case 2:
							drawboard(0L,YDIM-64L,XDIM-1L,YDIM-1L);
							nextpage(0L,YDIM-64L,XDIM-1L,YDIM-1L);

							getmessageleng = tempbufleng-1;
							for(j=getmessageleng-1;j>=0;j--) getmessage[j] = tempbuf[j+1];
							getmessagetimeoff = totalclock+360+(getmessageleng<<4);
							break;
						case 255:  //[255] (logout)
							cleanexit();
					}
				}

				checktypemode();
			}
		}
	}
	else
	{
		computermove(dacol,&x1,&y1,&x2,&y2,smartness);
	}

	movepiece(x1,y1,x2,y2,0);
}

playermove (long dacol, char *x1, char *y1, char *x2, char *y2)
{
	char ch, spaceset, bakc, bakd, good, pat[8];
	short tempbufleng, other;
	long x, y, z, i, j, timestart;

	drawrect(c,d,95);

	spaceset = 0;
	timestart = totalclock;
	while (1)
	{
		if ((timermode > 0) && (totalclock > timestart+timermode))
		{
			drawrect(c,d,(((c^d)&1^1)<<1)+12);
			computermove(dacol,x1,y1,x2,y2,1L);
			return;
		}

		if (option[4] != 0)
		{
			if ((tempbufleng = getpacket(&other,tempbuf)) > 0)
			{
				switch(tempbuf[0])
				{
					case 2:
						drawboard(0L,YDIM-64L,XDIM-1L,YDIM-1L);
						nextpage(0L,YDIM-64L,XDIM-1L,YDIM-1L);

						getmessageleng = tempbufleng-1;
						for(j=getmessageleng-1;j>=0;j--) getmessage[j] = tempbuf[j+1];
						getmessagetimeoff = totalclock+360+(getmessageleng<<4);
						break;
					case 255:  //[255] (logout)
						cleanexit();
				}
			}
		}
		checktypemode();

		if ((keystatus[0xcb]) && (c > 0))
		{
			keystatus[0xcb] = 0;

			drawrect(c,d,(((c^d)&1^1)<<1)+12);
			c--;
			drawrect(c,d,95);
		}
		if ((keystatus[0xcd]) && (c < 7))
		{
			keystatus[0xcd] = 0;
			drawrect(c,d,(((c^d)&1^1)<<1)+12);
			c++;
			drawrect(c,d,95);
		}
		if ((keystatus[0xc8]) && (d > 0))
		{
			keystatus[0xc8] = 0;
			drawrect(c,d,(((c^d)&1^1)<<1)+12);
			d--;
			drawrect(c,d,95);
		}
		if ((keystatus[0xd0]) && (d < 7))
		{
			keystatus[0xd0] = 0;
			drawrect(c,d,(((c^d)&1^1)<<1)+12);
			d++;
			drawrect(c,d,95);
		}

		if (keystatus[0x39])
		{
			keystatus[0x39] = 0;

			i = (c<<3)+d;
			if ((board[i] != 0) && ((board[i]&24) == (dacol<<3)+8))
				{ spaceset = 1; bakc = c; bakd = d; }
		}

		if ((keystatus[0x23]) && (typemode == 0))  //H
		{
			keystatus[0x23] = 0;

			drawrect(c,d,(((c^d)&1^1)<<1)+12);

			i = -1;
			while (i < 0)
			{
				if (keystatus[0x2] > 0) keystatus[0x2] = 0, i = 1;
				if (keystatus[0x3] > 0) keystatus[0x3] = 0, i = 2;
				if (keystatus[0x4] > 0) keystatus[0x4] = 0, i = 3;
				if (keystatus[0x5] > 0) keystatus[0x5] = 0, i = 4;
				if (keystatus[0x6] > 0) keystatus[0x6] = 0, i = 5;
			}
			computermove(dacol,x1,y1,x2,y2,i);

			drawrect(*x1,*y1,95);
			drawrect(*x2,*y2,95);

			keystatus[0x1c] = 0;
			keystatus[0x39] = 0;
			while ((keystatus[0x39] == 0) && (keystatus[0x23] == 0))
			{
				if (keystatus[0x1c] > 0)
				{
					drawrect(*x1,*y1,(((*x1^*x2)&1^1)<<1)+12);
					drawrect(*x2,*y2,(((*x2^*y2)&1^1)<<1)+12);
					return;
				}
			}
			drawrect(*x1,*y1,(((*x1^*x2)&1^1)<<1)+12);
			drawrect(*x2,*y2,(((*x2^*y2)&1^1)<<1)+12);
			drawrect(c,d,95);
		}
		if ((keystatus[0x1c]) && (spaceset != 0))
		{
			keystatus[0x1c] = 0;

			if ((bakc|bakd|7) == 7)
			{
				getvalidmoves(bakc,bakd,0L);
				for(z=validmovecnt[0]-1;z>=0;z--)
					if (validmove[0][z] == (c<<3)+d)
					{
							//Do move
						qmovepiece((long)(bakc<<3)+bakd,(long)(c<<3)+d,pat);

						good = check4check(dacol);

							//Patch back move
						board[pat[0]] = pat[1]; board[pat[2]] = pat[3];
						if (pat[4] != 255) { board[pat[4]] = pat[5]; board[pat[6]] = pat[7]; }

						if (good)
						{
							drawrect(c,d,(((c^d)&1^1)<<1)+12);
							*x1 = bakc; *y1 = bakd; *x2 = c; *y2 = d;
							return;
						}
					}
				wsay("watchit.wav",4096L,255L,255L);
			}
		}
	}
}

drawrect(char c, char d, char col)
{
	long x, y;

	x = (long)c*(YDIM>>3)+((XDIM-YDIM)>>1); y = (long)d*(YDIM>>3);
	openrectangle(x,y,x+(YDIM>>3)-1,y+(YDIM>>3)-1,col);
	nextpage(x,y,x+(YDIM>>3)-1,y+(YDIM>>3)-1);
}

computermove (long dacol, char *x1, char *y1, char *x2, char *y2, long smartness)
{
	char bestx1, besty1, bestx2, besty2, good, pat[8];
	long i, j, bestmove, score[2];

	score[0] = 0; score[1] = 0;
	for(i=63;i>=0;i--)
	{
		j = board[i];
		if (((j-1)&7) < 5) score[(j>>3)-1] += rank[j];
	}
	if (score[0] > score[1]) score[0] = 3, score[1] = 2;
	else                     score[0] = 2, score[1] = 3;
	for(i=8;i<16;i++) rank2[i] = rank[i]*score[0];
	for(i=16;i<24;i++) rank2[i] = rank[i]*score[1];

	do
	{
		globrecursion = smartness; recursecnt = 0;
		globalvalidptr = (char *)(FP_OFF(validmove)+((recursecnt-1)<<6));
		globnodes = 0;

		if (dacol == 0)
			i = getminrank(dacol,0L,&bestmove);
		else
			i = getmaxrank(dacol,0L,&bestmove);

			//Do move
		qmovepiece((((bestmove>>24)&7)<<3)+((bestmove>>16)&7),(((bestmove>>8)&7)<<3)+(bestmove&7),pat);

		good = check4check(dacol);

			//Patch back move
		board[pat[0]] = pat[1]; board[pat[2]] = pat[3];
		if (pat[4] != 255) { board[pat[4]] = pat[5]; board[pat[6]] = pat[7]; }

		smartness++;
	}
	while (good == 0);

	drawboard(0L,YDIM-64L,XDIM-1L,YDIM-1L);

	sprintf(getmessage,"%ld %ld",globnodes,i);
	getmessageleng = strlen(getmessage);
	getmessagetimeoff = totalclock+360+(getmessageleng<<4);
	checktypemode();

	nextpage(0L,YDIM-64L,XDIM-1L,YDIM-1L);

	*x1 = (char)(bestmove>>24);
	*y1 = (char)((bestmove>>16)&7);
	*x2 = (char)((bestmove>>8)&7);
	*y2 = (char)(bestmove&7);
}

getmaxrank(long dacol, long currank, long *bestmove)
{
	char x1, y1, x2, y2, boardi, pat[8];
	long bestrank, darank, i, j, z, zz, numchoices;

	recursecnt++; globalvalidptr += 64;

	bestrank = 0x80000000; numchoices = 0;

	zz = ((dacol+1)<<3);
	for(i=63;i>=0;i--)
		if ((board[i]&24) == zz)
		{
			x1 = (i>>3); y1 = (i&7);
			getvalidmoves(x1,y1,recursecnt-1);
			globnodes += validmovecnt[recursecnt-1];
			for(z=validmovecnt[recursecnt-1]-1;z>=0;z--)
			{
				j = globalvalidptr[z]; x2 = (j>>3); y2 = (j&7);

				//   //x1,y1,x2,y2 is the next possibility
				//darank = currank + qmovepiece(i,j,pat);

				boardi = board[i]; pat[4] = 255;
				pat[0] = (char)i; pat[1] = boardi;
				pat[2] = (char)j; pat[3] = board[j];
				darank = currank + rank2[pat[3]];
				switch(boardi&7)
				{
					case 1:                         //Pawn becomes Queen
						if (((j+1)&7) < 2)
						{
							darank += (rank2[boardi]-rank2[boardi+4]);
							boardi += 4;
						}
						break;
					case 6:                        //Castle
						if (((i&0x38) == (4<<3)) && ((j&0x38) == (6<<3)))
						{
							pat[4] = (char)i+8; pat[5] = board[i+8];
							pat[6] = (char)i+24; pat[7] = board[i+24];
							board[i+8] = board[i+24]; board[i+24] = 0;
						}
						break;
				}
				board[i] = 0; board[j] = boardi;

				if (recursecnt < globrecursion)
					if (klabs(darank) < 256)
						darank += getminrank(1-dacol,darank,&j);

				if (darank > bestrank)
				{
					numchoices = 1;
					bestrank = darank;
					*bestmove = (((long)x1)<<24) + (((long)y1)<<16) + (((long)x2)<<8) + ((long)y2);
				}
				else if (darank == bestrank)
				{
					j = randarray[randcnt--]; if (randcnt < 0) randcnt = 4095;
					if (j <= randprob[++numchoices])
					{
						bestrank = darank;
						*bestmove = (((long)x1)<<24) + (((long)y1)<<16) + (((long)x2)<<8) + ((long)y2);
					}
				}

				board[pat[0]] = pat[1];
				board[pat[2]] = pat[3];
				if (pat[4] != 255)
				{
					board[pat[4]] = pat[5];
					board[pat[6]] = pat[7];
				}
			}
		}

	recursecnt--; globalvalidptr -= 64;
	return(bestrank);
}

getminrank(long dacol, long currank, long *bestmove)
{
	char x1, y1, x2, y2, boardi, pat[8];
	long bestrank, darank, i, j, z, zz, zzz, numchoices;

	recursecnt++; globalvalidptr += 64;

	bestrank = 0x7fffffff; numchoices = 0;

	zz = ((dacol+1)<<3);
	for(i=63;i>=0;i--)
		if ((board[i]&24) == zz)
		{
			x1 = (i>>3); y1 = (i&7);
			getvalidmoves(x1,y1,recursecnt-1);
			globnodes += validmovecnt[recursecnt-1];
			for(z=validmovecnt[recursecnt-1]-1;z>=0;z--)
			{
				j = globalvalidptr[z]; x2 = (j>>3); y2 = (j&7);

				//   //x1,y1,x2,y2 is the next possibility
				//darank = currank + qmovepiece(i,j,pat);

					//x1,y1,x2,y2 is the next possibility
				boardi = board[i]; pat[4] = 255;
				pat[0] = (char)i; pat[1] = boardi;
				pat[2] = (char)j; pat[3] = board[j];
				darank = currank + rank2[pat[3]];
				switch(boardi&7)
				{
					case 1:                         //Pawn becomes Queen
						if (((j+1)&7) < 2)
						{
							darank += (rank2[boardi]-rank2[boardi+4]);
							boardi += 4;
						}
						break;
					case 6:                        //Castle
						if (((i&0x38) == (4<<3)) && ((j&0x38) == (6<<3)))
						{
							pat[4] = (char)i+8; pat[5] = board[i+8];
							pat[6] = (char)i+24; pat[7] = board[i+24];
							board[i+8] = board[i+24]; board[i+24] = 0;
						}
						break;
				}
				board[i] = 0; board[j] = boardi;

				if (recursecnt < globrecursion)
					if (klabs(darank) < 256)
						darank += getmaxrank(1-dacol,darank,&j);

				if (darank < bestrank)
				{
					numchoices = 1;
					bestrank = darank;
					*bestmove = (((long)x1)<<24) + (((long)y1)<<16) + (((long)x2)<<8) + ((long)y2);
				}
				else if (darank == bestrank)
				{
					j = randarray[randcnt--]; if (randcnt < 0) randcnt = 4095;
					if (j <= randprob[++numchoices])
					{
						bestrank = darank;
						*bestmove = (((long)x1)<<24) + (((long)y1)<<16) + (((long)x2)<<8) + ((long)y2);
					}
				}

				board[pat[0]] = pat[1];
				board[pat[2]] = pat[3];
				if (pat[4] != 255)
				{
					board[pat[4]] = pat[5];
					board[pat[6]] = pat[7];
				}
			}
		}

	recursecnt--; globalvalidptr -= 64;
	return(bestrank);
}

getvalidmoves (char x, char y, long daboard)
{
	char *vptr, *svptr, *boardj, piece, playeroffs, xorplayeroffs, z;
	long i, j;

	svptr = (char *)(FP_OFF(validmove) + (daboard<<6));
	vptr = svptr;

	j = (x<<3)+y;
	boardj = (char *)(FP_OFF(board)+j);
	piece = *boardj;
	if (piece == 0) { validmovecnt[daboard] = 0; return; }
	playeroffs = (piece&24); xorplayeroffs = playeroffs^24;
	piece &= 7;

	if (piece == 1)             //pawn
	{
		if (playeroffs >= 16)
		{
			if (boardj[1] == 0)
			{
				*vptr++ = j+1;
				if ((y == 1) && (boardj[2] == 0)) *vptr++ = j+2;
			}
			if ((x != 0) && ((boardj[-8+1]&24) == xorplayeroffs)) *vptr++ = j-8+1;
			if ((x != 7) && ((boardj[8+1]&24) == xorplayeroffs)) *vptr++ = j+8+1;
			validmovecnt[daboard] = (((long)vptr)-((long)svptr));
			return;
		}
		else
		{
			if (boardj[-1] == 0)
			{
				*vptr++ = j-1;
				if ((y == 6) && (boardj[-2] == 0)) *vptr++ = j-2;
			}
			if ((x != 0) && ((boardj[-8-1]&24) == xorplayeroffs)) *vptr++ = j-8-1;
			if ((x != 7) && ((boardj[8-1]&24) == xorplayeroffs)) *vptr++ = j+8-1;
			validmovecnt[daboard] = (((long)vptr)-((long)svptr));
			return;
		}
	}
  
	if (piece == 2)             //horse
	{
		if (x > 1)
		{
			if ((y != 0) && ((boardj[-17]&24) != playeroffs)) *vptr++ = j-17;
			if ((y != 7) && ((boardj[-15]&24) != playeroffs)) *vptr++ = j-15;
		}
		if (x < 6)
		{
			if ((y != 0) && ((boardj[15]&24) != playeroffs)) *vptr++ = j+15;
			if ((y != 7) && ((boardj[17]&24) != playeroffs)) *vptr++ = j+17;
		}
		if (y > 1)
		{
			if ((x != 0) && ((boardj[-10]&24) != playeroffs)) *vptr++ = j-10;
			if ((x != 7) && ((boardj[6]&24) != playeroffs)) *vptr++ = j+6;
		}
		if (y < 6)
		{
			if ((x != 0) && ((boardj[-6]&24) != playeroffs)) *vptr++ = j-6;
			if ((x != 7) && ((boardj[10]&24) != playeroffs)) *vptr++ = j+10;
		}
		validmovecnt[daboard] = (((long)vptr)-((long)svptr));
		return;
	}

	if (piece == 6)                          //king
	{
		if (y != 0)
		{
			if ((boardj[-1]&24) != playeroffs) *vptr++ = j-1;
			if ((x != 0) && ((boardj[-9]&24) != playeroffs)) *vptr++ = j-9;
			if ((x != 7) && ((boardj[7]&24) != playeroffs)) *vptr++ = j+7;
		}
		if (y != 7)
		{
			if ((boardj[1]&24) != playeroffs) *vptr++ = j+1;
			if ((x != 0) && ((boardj[-7]&24) != playeroffs)) *vptr++ = j-7;
			if ((x != 7) && ((boardj[9]&24) != playeroffs)) *vptr++ = j+9;
		}
		if ((x != 0) && ((boardj[-8]&24) != playeroffs)) *vptr++ = j-8;
		if ((x != 7) && ((boardj[8]&24) != playeroffs)) *vptr++ = j+8;

		if (x == 4)
			if (((y+1)&7) < 2)
				if (boardj[8] == 0)
					if (boardj[16] == 0)
						if (boardj[24] == playeroffs+4)
							*vptr++ = j+16;

		validmovecnt[daboard] = (((long)vptr)-((long)svptr));
		return;
	}
  
	if (piece != 4)         //bishop/queen
	{
		i = j;
		for(z=min(x,y);z>0;z--)
		{
			i += (-8-1);
			if (board[i] != 0)
			{
				if ((board[i]&24) == xorplayeroffs) *vptr++ = i;
				break;
			}
			*vptr++ = i;
		}

		i = j;
		for(z=min(x^7,y);z>0;z--)
		{
			i += (8-1);
			if (board[i] != 0)
			{
				if ((board[i]&24) == xorplayeroffs) *vptr++ = i;
				break;
			}
			*vptr++ = i;
		}

		i = j;
		for(z=min(x,y^7);z>0;z--)
		{
			i += (-8+1);
			if (board[i] != 0)
			{
				if ((board[i]&24) == xorplayeroffs) *vptr++ = i;
				break;
			}
			*vptr++ = i;
		}

		i = j;
		for(z=min(x^7,y^7);z>0;z--)
		{
			i += (8+1);
			if (board[i] != 0)
			{
				if ((board[i]&24) == xorplayeroffs) *vptr++ = i;
				break;
			}
			*vptr++ = i;
		}
	}

	if (piece != 3)         //rook/queen
	{
		i = j;
		for(z=x;z>0;z--)
		{
			i -= 8;
			if (board[i] != 0)
			{
				if ((board[i]&24) == xorplayeroffs) *vptr++ = i;
				break;
			}
			*vptr++ = i;
		}

		i = j;
		for(z=(x^7);z>0;z--)
		{
			i += 8;
			if (board[i] != 0)
			{
				if ((board[i]&24) == xorplayeroffs) *vptr++ = i;
				break;
			}
			*vptr++ = i;
		}

		i = j;
		for(z=y;z>0;z--)
		{
			i--;
			if (board[i] != 0)
			{
				if ((board[i]&24) == xorplayeroffs) *vptr++ = i;
				break;
			}
			*vptr++ = i;
		}

		i = j;
		for(z=(y^7);z>0;z--)
		{
			i++;
			if (board[i] != 0)
			{
				if ((board[i]&24) == xorplayeroffs) *vptr++ = i;
				break;
			}
			*vptr++ = i;
		}
	}
	validmovecnt[daboard] = (((long)vptr)-((long)svptr));
}

qmovepiece (long i, long j, char pat[8])
{
	char boardi;
	long deltarank;

	boardi = board[i]; pat[4] = 255;
	pat[0] = (char)i; pat[1] = boardi;
	pat[2] = (char)j; pat[3] = board[j];
	deltarank = rank2[pat[3]];
	switch(boardi&7)
	{
		case 1:                         //Pawn becomes Queen
			if (((j+1)&7) < 2)
			{
				deltarank += (rank2[boardi]-rank2[boardi+4]);
				boardi += 4;
			}
			break;
		case 6:                        //Castle
			if (((i&0x38) == (4<<3)) && ((j&0x38) == (6<<3)))
			{
				pat[4] = (char)i+8; pat[5] = board[i+8];
				pat[6] = (char)i+24; pat[7] = board[i+24];
				board[i+8] = board[i+24]; board[i+24] = 0;
			}
			break;
	}
	board[i] = 0; board[j] = boardi;

	return(deltarank);
}

movepiece (char x1, char y1, char x2, char y2, char movestat)
{
	char oboardi, oboardj, castleit;
	long i, j, deltarank, score[2], bestmove;
	long t, tx, ty, txinc, tyinc, tx2, txinc2;

	i = (x1<<3)+y1; oboardi = board[i];
	j = (x2<<3)+y2; oboardj = board[j];
	deltarank = rank2[oboardj];
	board[i] = 0;

	if (movestat == 0)
	{
		movelist[movelistcnt++] = (((long)x1)<<24) + (((long)y1)<<16) + (((long)x2)<<8) + ((long)y2);

		tx = ((x1*(YDIM>>3)+((XDIM-YDIM)>>1)+(YDIM>>4))<<16);
		ty = ((y1*(YDIM>>3)+(YDIM>>4))<<16);
		txinc = (((x2-x1)*(YDIM>>3))<<(16-5));
		tyinc = (((y2-y1)*(YDIM>>3))<<(16-5));
		castleit = 0;
		if (((oboardi&7) == 6) && (x1 == 4) && (x2 == 6))
		{
			castleit = 1;
			board[i+24] = 0;
			tx2 = ((7*(YDIM>>3)+((XDIM-YDIM)>>1)+(YDIM>>4))<<16);
			txinc2 = (((5-7)*(YDIM>>3))<<(16-5));
		}

		if (castleit == 0)
		{
			switch(oboardi&7)
			{
				case 1: wsay("zipguns.wav",4096L,255-((x1+x2)<<4),255-((14-(x1+x2))<<4)); break;
				case 2: wsay("shoot2.wav",4096L,255-((x1+x2)<<4),255-((14-(x1+x2))<<4)); break;
				case 3: wsay("shoot2.wav",4096L,255-((x1+x2)<<4),255-((14-(x1+x2))<<4)); break;
				case 4: wsay("shoot2.wav",4096L,255-((x1+x2)<<4),255-((14-(x1+x2))<<4)); break;
				case 5: wsay("shoot3.wav",4096L,255-((x1+x2)<<4),255-((14-(x1+x2))<<4)); break;
				case 6: wsay("warp.wav",4096L,255-((x1+x2)<<4),255-((14-(x1+x2))<<4)); break;
			}
		}
		else
			wsay("warp.wav",4096L,255L,255L);

		for(t=0;t<32;t++)
		{
			if (castleit == 0)
			{
				drawboard((tx>>16)-((YDIM<<5)/480L)-8,(ty>>16)-((YDIM<<5)/480L)-8,(tx>>16)+((YDIM<<5)/480L)+8,(ty>>16)+((YDIM<<5)/480L)+8);
				drawchesspicture((long)tx>>16,(long)ty>>16,(YDIM<<8)/480L,(long)oboardi-1);
				nextpage((tx>>16)-((YDIM<<5)/480L)-8,(ty>>16)-((YDIM<<5)/480L)-8,(tx>>16)+((YDIM<<5)/480L)+8,(ty>>16)+((YDIM<<5)/480L)+8);
			}
			else
			{
				drawboard((min(tx,tx2)>>16)-((YDIM<<5)/480L)-8,(ty>>16)-((YDIM<<5)/480L)-8,(max(tx,tx2)>>16)+((YDIM<<5)/480L)+8,(ty>>16)+((YDIM<<5)/480L)+8);
				drawchesspicture((long)tx2>>16,(long)ty>>16,(YDIM<<8)/480L,(long)oboardi-3);
				tx2 += txinc2;
				drawchesspicture((long)tx>>16,(long)ty>>16,(YDIM<<8)/480L,(long)oboardi-1);
				nextpage((min(tx,tx2)>>16)-((YDIM<<5)/480L)-8,(ty>>16)-((YDIM<<5)/480L)-8,(max(tx,tx2)>>16)+((YDIM<<5)/480L)+8,(ty>>16)+((YDIM<<5)/480L)+8);
			}
			tx += txinc; ty += tyinc;
		}
		turn ^= 1;
	}

	switch(oboardi&7)
	{
		case 1:                         //Pawn becomes Queen
			if (((y2+1)&7) < 2)
			{
				deltarank += (rank2[oboardi]-rank2[oboardi+4]);
				oboardi += 4;
			}
			break;
		case 6:                        //Castle
			if ((x1 == 4) && (x2 == 6))
			{
				board[i+8] = oboardi-2;
				board[i+24] = 0;
			}
			break;
	}
	board[j] = oboardi;

	if (movestat == 0)
	{
		switch(oboardj&7)
		{
			case 0: break;
			case 1: wsay("getstuff.wav",4096L,255-(x2<<5),255-((7-x2)<<5)); break;
			case 2: wsay("blowup.wav",4096L,255-(x2<<5),255-((7-x2)<<5)); break;
			case 3: wsay("blowup.wav",4096L,255-(x2<<5),255-((7-x2)<<5)); break;
			case 4: wsay("blowup.wav",4096L,255-(x2<<5),255-((7-x2)<<5)); break;
			case 5: wsay("death.wav",4096L,255-(x2<<5),255-((7-x2)<<5)); break;
			case 6: wsay("closdoor.wav",4096L,255-(x2<<5),255-((7-x2)<<5)); break;
		}

		if (!check4mate(turn))
			wsay("closdoor.wav",4096L,255L,255L);
		else if (!check4check(turn))
			wsay("alarm.wav",4096L,255L,255L);

		if ((oboardj&7) == 6)
		{
			drawboard(0L,0L,XDIM-1L,YDIM-1L);
			nextpage(0L,0L,XDIM-1L,YDIM-1L);
			while (keystatus[0x1c] != 0);
			while (keystatus[0x1c] == 0);
			setvmode(0x3);
			if (oboardj < 16)
				printf("Black wins!\n");
			else
				printf("White wins!\n");
			cleanexit();
		}
	}
}

openrectangle(long x1, long y1, long x2, long y2, char col)
{
	long i, x, y, p;

	if (x1 > x2) i = x1, x1 = x2, x2 = i;
	if (x1 < 0) x1 = 0;
	if (x2 >= XDIM) x2 = XDIM-1;

	if (y1 > y2) i = y1, y1 = y2, y2 = i;
	if (y1 < 0) y1 = 0;
	if (y2 >= YDIM) y2 = YDIM-1;

	if (x1 <= x2)
	{
		p = ylookup[y1]+x1+frameplace;
		i = x2-x1;
		for(y=y1;y<=y2;y++)
		{
			drawpixel(p,col);
			drawpixel(p+i,col);
			p += XDIM;
		}
	}
	if (y1 <= y2)
	{
		p = ylookup[y1]+x1+frameplace;
		i = ylookup[y2-y1];
		for(x=x1;x<=x2;x++)
		{
			drawpixel(p,col);
			drawpixel(p+i,col);
			p++;
		}
	}
}

fillrectangle(long x1, long y1, long x2, long y2, char col)
{
	long i, p, xcnt, dacol;

	if (x1 > x2) i = x1, x1 = x2, x2 = i;
	if (x1 < 0) x1 = 0;
	if (x2 >= XDIM) x2 = XDIM-1;
	if (y1 > y2) i = y1, y1 = y2, y2 = i;
	if (y1 < 0) y1 = 0;
	if (y2 >= YDIM) y2 = YDIM-1;
	if ((x1 > x2) || (y1 > y2)) return;

	dacol = ((long)col)+(((long)col)<<8); dacol += (dacol<<16);
	xcnt = x2-x1+1;

	p = ylookup[y1]+x1+frameplace;
	for(i=y2-y1;i>=0;i--)
	{
		clearbufbyte(p,xcnt,dacol);
		p += XDIM;
	}
}

setgamemode()
{
	long y, p;

	screen = (char *)malloc(XDIM*(YDIM+4));
	frameplace = FP_OFF(screen)+(XDIM<<2);
	clearbuf(frameplace,(XDIM*YDIM)>>2,0L);

	p = 0;
	for(y=0;y<YDIM;y++)
		ylookup[y] = p, p += XDIM;

	if ((XDIM == 320) && (YDIM == 200)) setvmode(0x13);
	if ((XDIM == 640) && (YDIM == 480)) setvesamode(0x101);
	if ((XDIM == 800) && (YDIM == 600)) setvesamode(0x103);
	if ((XDIM == 1024) && (YDIM == 768)) setvesamode(0x105);
	if ((XDIM == 1280) && (YDIM == 1024)) setvesamode(0x107);
	if ((XDIM == 1600) && (YDIM == 1200)) setvesamode(0x120);
}

setvesamode(short vesamode)
{
	static struct rminfo
	{
		long EDI, ESI, EBP, ESP, EBX, EDX, ECX, EAX;
		short flags, ES, DS, FS, GS, IP, CS, SP, SS;
	} RMI;

	union REGS regs;
	struct SREGS sregs;
	short selector, segment;
	short *ptr, gran;

	memset(&sregs,0,sizeof(sregs));
	regs.w.ax = 0x0100;
	regs.w.bx = (256>>4);             //Number of paragraphs
	int386x(0x31,&regs,&regs,&sregs); // DPMI call 100h allocates DOS memory
	segment = regs.w.ax;
	selector = regs.w.dx;

	memset(&RMI,0,sizeof(RMI));    // Set up real-mode call structure
	RMI.EAX = 0x00004f01;
	RMI.ECX = (long)vesamode;
	RMI.ES = segment;
	RMI.EDI = 0;

	regs.w.ax = 0x0300;            // Use DMPI call 300h to issue the DOS interrupt
	regs.h.bl = 0x10;
	regs.h.bh = 0;
	regs.w.cx = 0;
	sregs.es = FP_SEG(&RMI);
	regs.x.edi = FP_OFF(&RMI);
	int386x(0x31,&regs,&regs,&sregs);

	if ((RMI.EAX&65535) != 0x004f)
		return(-1);

	ptr = (short *)((((long)segment)<<4)+4);
	gran = 64 / (*ptr);
	vesapageshift = 0;
	while (gran > 1)
	{
		vesapageshift++;
		gran >>= 1;
	}

	if (vesasetmode(vesamode) != 0x4f)
		return(-1);

	return(0);
}

nextpage(long x1, long y1, long x2, long y2)
{
	long i, leng, totbytes, p1, p2;

	totbytes = XDIM*YDIM;
	p1 = y1*XDIM+x1;
	p2 = y2*XDIM+x2;
	for(i=0;i<totbytes;i+=65536)
	{
		leng = min(totbytes-i,65536);
		if ((p1 < i+leng) && (i < p2))
		{
			vesasetpage(i>>16);
			copybuf(frameplace+i,0xa0000,min(leng,p2-i+1)>>2);
		}
	}
}

printext256(long xpos, long ypos, long col, long bacol, char *dabuf)
{
	long i, x, y, p, dat, dat2;

	for(i=0;i<strlen(dabuf);i++)
	{
		dat = (dabuf[i]<<3);
		for(y=0;y<8;y++)
		{
			p = ylookup[y+ypos]+xpos+frameplace;
			dat2 = textfont[dat+y];
			for(x=128;x>0;x>>=1)
			{
				if (dat2&x)
					drawpixel(p,col);
				else if (bacol >= 0)
					drawpixel(p,bacol);
				p++;
			}
		}
		xpos += 8;
	}
	nextpage(xpos-(strlen(dabuf)<<3),ypos,xpos,ypos+8);
}

checktypemode()
{
	long i, j, charsperline;

	if (typemode == 1)
	{
		charsperline = 80;
		for(i=0;i<=typemessageleng;i+=charsperline)
		{
			for(j=0;j<charsperline;j++) tempbuf[j] = typemessage[i+j];
			if (typemessageleng < i+charsperline)
			{
				tempbuf[(typemessageleng-i)] = '_';
				tempbuf[(typemessageleng-i)+1] = 0;
			}
			else
				tempbuf[charsperline] = 0;
			printext256(0L,(i/charsperline)<<3,183L,0L,tempbuf);
		}
	}
	if (getmessageleng > 0)
	{
		charsperline = 80;
		for(i=0;i<=getmessageleng;i+=charsperline)
		{
			for(j=0;j<charsperline;j++)
				tempbuf[j] = getmessage[i+j];
			if (getmessageleng < i+charsperline)
				tempbuf[getmessageleng-i] = 0;
			else
				tempbuf[charsperline] = 0;

			printext256(0L,((i/charsperline)<<3)+(YDIM-32-8)-(((getmessageleng-1)/charsperline)<<3),151L,0L,tempbuf);
		}
		if (totalclock > getmessagetimeoff)
		{
			getmessageleng = 0;
			drawboard(0L,YDIM-64L,XDIM-1,YDIM-1);
			nextpage(0L,YDIM-64L,XDIM-1,YDIM-1);
		}
	}

	if (typemode == 0)
	{
		if ((keystatus[0xe]) && (numplayers < 2))
		{
			keystatus[0xe] = 0;

			if (movelistcnt >= 2)
			{
				movelistcnt -= 2;
				copybuf(startboard,board,64>>2);
				for(i=0;i<movelistcnt;i++)
				{
					j = movelist[i];
					movepiece((char)(j>>24),(char)((j>>16)&7),(char)((j>>8)&7),(char)(j&7),1);
				}

				drawboard(0L,0L,XDIM-1L,YDIM-1L);
				nextpage(0L,0L,XDIM-1L,YDIM-1L);

				wsay("ouch.wav",4096L,255L,255L);
			}
		}

		if ((keystatus[keys[18]]) > 0)   //Typing mode
		{
			keystatus[keys[18]] = 0;
			typemode = 1;
		}
	}
	else
	{
		for(i=0;i<128;i++)
			if (keystatus[i] > 0)
			{
				if ((keystatus[0x2a]|keystatus[0x36]) > 0)
				{
					if (scantoascwithshift[i] != 0)
					{
						keystatus[i] = 0;
						if (typemessageleng < 159)
							typemessage[typemessageleng++] = scantoascwithshift[i];
					}
				}
				else
				{
					if (scantoasc[i] != 0)
					{
						keystatus[i] = 0;
						if (typemessageleng < 159)
							typemessage[typemessageleng++] = scantoasc[i];
					}
				}
			}

		if (keystatus[0xe] > 0)   //Backspace
		{
			keystatus[0xe] = 0;
				//Here's a trick of making key repeat after a 1/2 second
			if (typemessageleng > 0) typemessageleng--; else typemode = 0;

			drawboard(0L,0L,XDIM-1L,64L);
			nextpage(0L,0L,XDIM-1L,64L);
		}

		if ((keystatus[0x1c]|keystatus[0x9c]) > 0)  //Either ENTER
		{
			if (typemessageleng > 0)
			{
				i = 0;
				tempbuf[i++] = 2;          //Sending text is message type 4
				for(j=0;j<typemessageleng;j++)
					tempbuf[i++] = typemessage[j];

				for(i=connecthead;i>=0;i=connectpoint2[i])
					if (i != myconnectindex)
						sendpacket(i,tempbuf,j+1);

				drawboard(0L,0L,XDIM-1,64);
				nextpage(0L,0L,XDIM-1,64);
			}

			typemessageleng = 0;
			keystatus[0x1c] = 0;
			keystatus[0x9c] = 0;
			typemode = 0;
		}

		if ((keystatus[0xf]) > 0) //Tab
		{
			keystatus[0xf] = 0;
			typemode = 0;
		}
	}
}

check4check(long dacol)
{
	long i, j, bestmove;

	for(i=23;i>=0;i--) rank2[i] = rank[i];

	globrecursion = 1; recursecnt = 0;

	globalvalidptr = (char *)(FP_OFF(validmove)+((recursecnt-1)<<6));
	if (dacol == 0)
		i = getmaxrank(dacol^1,0L,&bestmove);
	else
		i = getminrank(dacol^1,0L,&bestmove);
	return((board[(((bestmove>>8)&7)<<3)+(bestmove&7)]&7) != 6);
}

check4mate(long dacol)
{
	char pat[8], good;
	long i, j, bestmove;

	for(i=23;i>=0;i--) rank2[i] = rank[i];

	globrecursion = 2; recursecnt = 0;

	globalvalidptr = (char *)(FP_OFF(validmove)+((recursecnt-1)<<6));
	if (dacol == 0)
		i = getminrank(dacol,0L,&bestmove);
	else
		i = getmaxrank(dacol,0L,&bestmove);

		//Do move
	qmovepiece((((bestmove>>24)&7)<<3)+((bestmove>>16)&7),(((bestmove>>8)&7)<<3)+(bestmove&7),pat);

	good = check4check(dacol);

		//Patch back move
	board[pat[0]] = pat[1]; board[pat[2]] = pat[3];
	if (pat[4] != 255) { board[pat[4]] = pat[5]; board[pat[6]] = pat[7]; }

	return(good);
}
