//To compile:  masm k.asm;
//             wcl386 kcode k.obj

#include <dos.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define MAXKCODESIZE 65536
#define MAXSPRITES 4096
#define MAXTILES 4096
#define MAXTILEFILES 256
#define NUMOPTIONS 6
#define XDIM 320
#define YDIM 200

extern long getkcodeoff();
extern long kcode(long, long);
#pragma aux kcode parm [edi][ebx];
long kcodeoff, kcodecnt;
char *kcodeptr;

static char palette[768];

char picsiz[MAXTILES], *pic[MAXTILEFILES];
short tilesizx[MAXTILES], tilesizy[MAXTILES];
long artversion, numtiles, picanm[MAXTILES], waloff[MAXTILES];
static char artfilename[20];
static long localtilestart[MAXTILEFILES], localtileend[MAXTILEFILES];
static long numtilefiles, picsloaded = 0;

static char tile[XDIM][YDIM];
static char option[NUMOPTIONS];
static long page, tsizx, tsizy;
static char screen[65536];
long frameplace;

static long spritex[MAXSPRITES], spritey[MAXSPRITES];
static long spritexdir[MAXSPRITES], spriteydir[MAXSPRITES];
static long numsprites;

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux copytovideo =\
	"cld",\
	"mov esi, frameplace",\
	"mov edi, 0xa0000",\
	"mov ecx, 16000",\
	"rep movsd",\
	modify [esi edi ecx]\

main()
{
	char ch;
	short spritenum;
	long i;

	loadtables();
	setupscreen();

	if ((i = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(i,&palette[0],768);
		close(i);
	}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);

	loadpics("tiles000.art");

	spritenum = 0;
	compilesprite(spritenum);

	numsprites = 16;
	randomizesprites(0L,numsprites-1);

	ch = 0;
	while (ch != 27)
	{
		if (option[0] == 0)
		{
			outpw(0x3c4,0x0f02);
			clearbuf(0xa0000+(page<<14),4000L,0L);
		}
		else
		{
			clearbuf(frameplace,16000L,0L);
		}

		for(i=0;i<numsprites;i++)
		{
			if (option[0] == 0)
			{
				outp(0x3c4,2);
				kcode((long)0xa0000+spritey[i]*80+(spritex[i]>>2)+(page<<14),(1<<(spritex[i]&3))+((1<<(spritex[i]&3))<<4));
			}
			else
			{
				kcode(frameplace+spritey[i]*320+spritex[i],0L);
			}

			spritex[i] += spritexdir[i];
			spritey[i] += spriteydir[i];
			if (spritex[i] > XDIM-tsizx) spritex[i] = XDIM-tsizx, spritexdir[i] = -1;
			if (spritex[i] < 0) spritex[i] = 0, spritexdir[i] = 1;
			if (spritey[i] > YDIM-tsizy) spritey[i] = YDIM-tsizy, spriteydir[i] = -1;
			if (spritey[i] < 0) spritey[i] = 0, spriteydir[i] = 1;
		}

		nextpage();
		if (kbhit() != 0)
		{
			ch = getch();
			if ((ch == '-') && (numsprites > 1))
			{
				numsprites--;
			}
			if ((ch == '+') && (numsprites < MAXSPRITES))
			{
				numsprites++;
				randomizesprites(numsprites-1,numsprites-1);
			}
			if (ch == '/')
			{
				numsprites >>= 1;
				if (numsprites < 1) numsprites = 1;
			}
			if (ch == '*')
			{
				i = numsprites;
				numsprites <<= 1;
				if (numsprites > MAXSPRITES) numsprites = MAXSPRITES;
				randomizesprites(i,numsprites-1);
			}
			if (ch == 0)
			{
				ch = getch();
				if ((ch == 73) && (spritenum > 0))
				{
					spritenum--;
					compilesprite(spritenum);
					randomizesprites(0L,numsprites-1);
				}
				if ((ch == 81) && (spritenum < MAXTILES-1))
				{
					spritenum++;
					compilesprite(spritenum);
					randomizesprites(0L,numsprites-1);
				}
			}
		}
	}

	setvmode(0x3);
	printf("For tile #%d\n",spritenum);
	printf("Number of data bytes: %d\n",tsizx*tsizy);
	printf("Number of code bytes: %d\n",kcodecnt);
}

initkcode()
{
	kcodeoff = getkcodeoff();
	kcodeptr = (char *)kcodeoff;
	kcodecnt = 0;
}

kcodeb(char dabyte)
{
	if (kcodecnt >= MAXKCODESIZE-1)
		return(-1);
	*kcodeptr++ = dabyte;
	kcodecnt++;
	return(0);
}

kcodew(short daword)
{
	if (kcodecnt >= MAXKCODESIZE-2)
		return(-1);
	*kcodeptr++ = (char)(daword&255);
	*kcodeptr++ = (char)((daword>>8)&255);
	kcodecnt += 2;
	return(0);
}

kcoded(long dalong)
{
	if (kcodecnt >= MAXKCODESIZE-4)
		return(-1);
	*kcodeptr++ = (char)(dalong&255);
	*kcodeptr++ = (char)((dalong>>8)&255);
	*kcodeptr++ = (char)((dalong>>16)&255);
	*kcodeptr++ = (char)((dalong>>24)&255);
	kcodecnt += 4;
	return(0);
}

setupscreen()
{
	long i;

	setvmode(0x13);

	if (option[0] == 0)
	{
		outpw(0x3c4,0x0604);
		outpw(0x3d4,0x0014);
		outpw(0x3d4,0xe317);

		outpw(0x3c4,0x0f02);
		clearbuf(0xa0000,4096L+4096L+4096L,0L);
		page = 0L;
	}
	else
	{
		frameplace = FP_OFF(screen);
		clearbuf(frameplace,16000L,0L);
	}
}

nextpage()
{
	if (option[0] == 0)
	{
		outp(0x3d4,0xc); outp(0x3d5,page<<6);
		page++;
		if (page == 4) page = 0;
	}
	else
	{
		copytovideo();
	}
}

loadpics(char filename[20])
{
	long totpicsiz, offscount, siz;
	short int fil, i, j, k;

	strcpy(artfilename,filename);

	for(i=0;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}

	numtilefiles = 0;
	do
	{
		k = numtilefiles;

		artfilename[7] = (k%10)+48;
		artfilename[6] = ((k/10)%10)+48;
		artfilename[5] = ((k/100)%10)+48;
		if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
		{
			read(fil,&artversion,4);
			if (artversion != 1) return(-1);
			read(fil,&numtiles,4);
			read(fil,&localtilestart[k],4);
			read(fil,&localtileend[k],4);
			read(fil,&tilesizx[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&tilesizy[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&picanm[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<2);

			totpicsiz = 0L;
			for(i=localtilestart[k];i<=localtileend[k];i++)
				totpicsiz += (long)(tilesizx[i]*tilesizy[i]);
			pic[k] = (char *)malloc(totpicsiz);

			offscount = 0L;
			for(i=localtilestart[k];i<=localtileend[k];i++)
			{
				waloff[i] = offscount+FP_OFF(pic[k]);
				siz = tilesizx[i]*tilesizy[i];
				if (siz > 0)
				{
					read(fil,&(pic[k])[offscount],siz);
					offscount += siz;
				}
			}
			close(fil);

			numtilefiles++;
		}
	}
	while (k != numtilefiles);

	for(i=0;i<MAXTILES;i++)
	{
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizx[i]))
			j--;
		picsiz[i] = ((char)j);
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizy[i]))
			j--;
		picsiz[i] += ((char)(j<<4));
	}

	picsloaded = 1;
	return(0);
}

randomizesprites(long startsprite, long endsprite)
{
	long i;

	for(i=startsprite;i<=endsprite;i++)
	{
		if (tsizx < XDIM)
			spritex[i] = rand()%(XDIM-tsizx);
		else
			spritex[i] = 0;
		if (tsizy < YDIM)
			spritey[i] = rand()%(YDIM-tsizy);
		else
			spritey[i] = 0;
		spritexdir[i] = ((rand()&1)<<1)-1;
		spriteydir[i] = ((rand()&1)<<1)-1;
	}
}

compilesprite(short spritenum)
{
	char plane, *ptr;
	long i, x, y, dist, bufplc, videoplc, nvideoplc, videodelta, lasteax, col;

	tsizx = tilesizx[spritenum];
	tsizy = tilesizy[spritenum];
	if ((tsizx*tsizy > 16384) || (tsizx <= 1) || (tsizy <= 1))
	{
		tsizx = 160;
		tsizy = 100;
		for(x=0;x<tsizx;x++)
			for(y=0;y<tsizy;y++)
			{
				if ((rand()&1) == 0)
					tile[x][y] = (rand()&255);
				else
					tile[x][y] = 255;
			}
	}
	else
	{
		bufplc = waloff[spritenum];
		ptr = (char *)bufplc;
		for(x=0;x<tsizx;x++)
			for(y=0;y<tsizy;y++)
			{
				if ((x < XDIM) && (y < YDIM))
					tile[x][y] = *ptr;
				ptr++;
			}
		if (tsizx > XDIM) tsizx = XDIM;
		if (tsizy > YDIM) tsizy = YDIM;
	}


	initkcode();

	kcodeb(0x31); kcodeb(0xc0);      //xor eax, eax
	lasteax = 0;

	if (option[0] == 0)
	{
		videoplc = 0;
		for(plane=0;plane<4;plane++)
		{
			kcodeb(0x66); kcodeb(0xba); kcodew(0x3c5);   //mov dx, 0x3c5
			kcodeb(0x88); kcodeb(0xd8);                  //mov al, bl
			lasteax = ((lasteax&0xffffff00)|0xd8);
			kcodeb(0xee);                                //out dx, al

			for(y=0;y<tsizy;y++)
			{
				x = plane;
				while (x < tsizx)
				{
					if (tile[x][y] != 255)
					{
						nvideoplc = y*80+(x>>2);
						if (nvideoplc != videoplc)
						{
							videodelta = ((nvideoplc+65536-videoplc)&65535);
							if (videodelta < 5)
							{
								for(i=0;i<videodelta;i++)
									kcodeb(0x47);   //inc edi
							}
							else
							{
								kcodeb(0x66); kcodeb(0x81); kcodeb(0xc7);  //add di, short
								kcodew((unsigned short)videodelta);
							}
							videoplc = nvideoplc;
						}
						if ((x < tsizx-12) && (tile[x+4][y] != 255) && (tile[x+8][y] != 255) && (tile[x+12][y] != 255))
						{
							col = ((unsigned long)tile[x][y])+((unsigned long)tile[x+4][y]<<8)+((unsigned long)tile[x+8][y]<<16)+((unsigned long)tile[x+12][y]<<24);
							if (col != lasteax)
							{
								lasteax = col;
								kcodeb(0xb8); kcoded(col);
							}
							kcodeb(0xab);
							videoplc += 4;
							x += 16;
						}
						else if ((x < tsizx-4) && (tile[x+4][y] != 255))
						{
							col = ((unsigned long)tile[x][y])+((unsigned long)tile[x+4][y]<<8);
							if (col != (lasteax&65535))
							{
								lasteax = ((lasteax&0xffff0000)|col);
								kcodeb(0x66); kcodeb(0xb8); kcodew((unsigned short)col&65535);
							}
							kcodeb(0x66); kcodeb(0xab);
							videoplc += 2;
							x += 8;
						}
						else if (x < tsizx)
						{
							col = (unsigned long)tile[x][y];
							if (col != (lasteax&255))
							{
								lasteax = ((lasteax&0xffffff00)|col);
								kcodeb(0xb0); kcodeb((char)col&255);
							}
							kcodeb(0xaa);
							videoplc++;
							x += 4;
						}
					}
					else
					{
						x += 4;
					}
				}
			}

			kcodeb(0xd0); kcodeb(0xc3);                  //rol bl, 1
			kcodeb(0x83); kcodeb(0xd7); kcodeb(0x0);     //adc edi, 0
		}
	}
	else
	{
		videoplc = 0;

		for(y=0;y<tsizy;y++)
		{
			x = 0;
			while (x < tsizx)
			{
				if (tile[x][y] != 255)
				{
					nvideoplc = y*320+x;
					if (nvideoplc != videoplc)
					{
						videodelta = ((nvideoplc+65536-videoplc)&65535);
						if (videodelta < 6)
						{
							for(i=0;i<videodelta;i++)
								kcodeb(0x47);   //inc edi
						}
						else
						{
							kcodeb(0x81); kcodeb(0xc7);  //add edi, long
							kcoded(videodelta);
						}
						videoplc = nvideoplc;
					}
					if ((x < tsizx-3) && (tile[x+1][y] != 255) && (tile[x+2][y] != 255) && (tile[x+3][y] != 255))
					{
						col = ((unsigned long)tile[x][y])+((unsigned long)tile[x+1][y]<<8)+((unsigned long)tile[x+2][y]<<16)+((unsigned long)tile[x+3][y]<<24);
						if (col != lasteax)
						{
							lasteax = col;
							kcodeb(0xb8); kcoded(col);
						}
						kcodeb(0xab);
						videoplc += 4;
						x += 4;
					}
					else if ((x < tsizx-1) && (tile[x+1][y] != 255))
					{
						col = ((unsigned long)tile[x][y])+((unsigned long)tile[x+1][y]<<8);
						if (col != (lasteax&65535))
						{
							lasteax = ((lasteax&0xffff0000)|col);
							kcodeb(0x66); kcodeb(0xb8); kcodew((unsigned short)col);
						}
						kcodeb(0x66); kcodeb(0xab);
						videoplc += 2;
						x += 2;
					}
					else if (x < tsizx)
					{
						col = ((unsigned long)tile[x][y]);
						if (col != (lasteax&255))
						{
							lasteax = ((lasteax&0xffffff00)|col);
							kcodeb(0xb0); kcodeb((char)col);
						}
						kcodeb(0xaa);
						videoplc++;
						x++;
					}
				}
				else
				{
					x++;
				}
			}
		}
	}

	kcodeb(0xc3);
}

loadtables()
{
	short fil;

	//if (tablesloaded == 0)
	//{
		if ((fil = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			read(fil,&option[0],NUMOPTIONS);
			close(fil);
			//tablesloaded = 1;
		}
	//}
	return(0);
}
