#define LAVASIZ 128
#define LAVALOGSIZ 7
#define LAVAMAXDROPS 32

static char pic[LAVASIZ*LAVASIZ];

static char lavabakpic[(LAVASIZ+2)*(LAVASIZ+2)], lavainc[LAVASIZ];
static long lavanumdrops, lavanumframes;
static long lavadropx[LAVAMAXDROPS], lavadropy[LAVAMAXDROPS];
static long lavadropsiz[LAVAMAXDROPS], lavadropsizlookup[LAVAMAXDROPS];
static long lavaradx[32][128], lavarady[32][128], lavaradcnt[32];

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

#pragma aux drawpixels =\
	"mov word ptr [edi], ax",\
	parm [edi][eax]\

#pragma aux klabs =\
	"test eax, eax",\
	"jns skipnegate",\
	"neg eax",\
	"skipnegate:",\
	parm [eax]\

#pragma aux copybuf =\
	"rep movsd",\
	parm [esi][edi][ecx]\

main()
{
	setvmode(0x13);

	initlava();

	while (kbhit() == 0)
	{
		drawpic(pic);
		movelava(pic);
	}

	setvmode(0x3);
}

drawpic (char *pic)
{
	long x, y, offs, p;

	p = 0xa0000;
	for(y=0;y<200;y++)
	{
		offs = ((y-100+(LAVASIZ>>1))&(LAVASIZ-1)) + (((-160+(LAVASIZ>>1))&(LAVASIZ-1))<<6);
		for(x=0;x<320;x+=2)
		{
			drawpixels(p,pic[offs]+(pic[((offs+LAVASIZ)&(LAVASIZ*LAVASIZ-1))]<<8));
			p+=2;
			offs = ((offs+(LAVASIZ<<1))&(LAVASIZ*LAVASIZ-1));
		}
	}
}

ksqrt(long num)
{
	long root, temp;

	if (num < 0)
		return(-1);
	root = 128;
	do
	{
		temp = root;
		root = ((root+(num/root))>>1);
	}
	while (klabs(temp-root) > 1);
	return(root);
}

initlava()
{
	long x, y, z, r;

	for(x=-16;x<=16;x++)
		for(y=-16;y<=16;y++)
		{
			r = ksqrt(x*x + y*y);
			lavaradx[r][lavaradcnt[r]] = x;
			lavarady[r][lavaradcnt[r]] = y;
			lavaradcnt[r]++;
		}

	for(z=0;z<16;z++)
		lavadropsizlookup[z] = 8 / (ksqrt(z)+1);

	for(z=0;z<LAVASIZ;z++)
		lavainc[z] = klabs((((z^17)>>4)&7)-4)+12;

	outp(0x3c8,0);
	for(z=0;z<32;z++)
	{
		outp(0x3c9,z<<1);   //red
		outp(0x3c9,z>>1);
		outp(0x3c9,z);
		//outp(0x3c9,z>>1);   //blue
		//outp(0x3c9,z);
		//outp(0x3c9,z<<1);
	}

	lavanumdrops = 0;
	lavanumframes = 0;
}

movelava(char *dapic)
{
	char dat, *ptr;
	long x, y, z, zx, dalavadropsiz, dadropsizlookup, offs, offs2;
	long dalavax, dalavay;

	z = 3;
	if (lavanumdrops+z >= LAVAMAXDROPS)
		z = LAVAMAXDROPS-lavanumdrops-1;
	while (z >= 0)
	{
		lavadropx[lavanumdrops] = (rand()&(LAVASIZ-1));
		lavadropy[lavanumdrops] = (rand()&(LAVASIZ-1));
		lavadropsiz[lavanumdrops] = 1;
		lavanumdrops++;
		z--;
	}

	z = lavanumdrops-1;
	while (z >= 0)
	{
		dadropsizlookup = lavadropsizlookup[lavadropsiz[z]]*(((z&1)<<1)-1);
		dalavadropsiz = lavadropsiz[z];
		dalavax = lavadropx[z]; dalavay = lavadropy[z];
		for(zx=lavaradcnt[lavadropsiz[z]]-1;zx>=0;zx--)
		{
			offs = (((lavaradx[dalavadropsiz][zx]+dalavax)&(LAVASIZ-1))<<LAVALOGSIZ);
			offs += ((lavarady[dalavadropsiz][zx]+dalavay)&(LAVASIZ-1));
			dapic[offs] += dadropsizlookup;
			if (((signed char)dapic[offs]) < 0) dapic[offs] = 0;
		}

		lavadropsiz[z]++;
		if (lavadropsiz[z] > 10)
		{
			lavanumdrops--;
			lavadropx[z] = lavadropx[lavanumdrops];
			lavadropy[z] = lavadropy[lavanumdrops];
			lavadropsiz[z] = lavadropsiz[lavanumdrops];
		}
		z--;
	}

		//Back up dapic with 1 pixel extra on each boundary
		//(to prevent anding for wrap-around)
	offs = ((long)dapic);
	offs2 = (LAVASIZ+2)+1+((long)lavabakpic);
	for(x=0;x<LAVASIZ;x++)
	{
		copybuf(offs,offs2,LAVASIZ>>2);
		offs += LAVASIZ;
		offs2 += LAVASIZ+2;
	}
	for(y=0;y<LAVASIZ;y++)
	{
		lavabakpic[y+1] = dapic[y+((LAVASIZ-1)<<LAVALOGSIZ)];
		lavabakpic[y+1+(LAVASIZ+1)*(LAVASIZ+2)] = dapic[y];
	}
	for(x=0;x<LAVASIZ;x++)
	{
		lavabakpic[(x+1)*(LAVASIZ+2)] = dapic[(x<<LAVALOGSIZ)+(LAVASIZ-1)];
		lavabakpic[(x+1)*(LAVASIZ+2)+(LAVASIZ+1)] = dapic[x<<LAVALOGSIZ];
	}
	lavabakpic[0] = dapic[LAVASIZ*LAVASIZ-1];
	lavabakpic[LAVASIZ+1] = dapic[LAVASIZ*(LAVASIZ-1)];
	lavabakpic[(LAVASIZ+2)*(LAVASIZ+1)] = dapic[LAVASIZ-1];
	lavabakpic[(LAVASIZ+2)*(LAVASIZ+2)-1] = dapic[0];

	for(x=LAVASIZ-1;x>=0;x--)
	{
		offs = (x+1)*(LAVASIZ+2)+1;
		ptr = (char *)((x<<LAVALOGSIZ) + (long)dapic);

		zx = ((x+lavanumframes)&(LAVASIZ-1));

		offs2 = LAVASIZ-1;
		for(y=offs;y<offs+LAVASIZ;y++)
		{
			dat = lavainc[(offs2--)&zx];
			dat += lavabakpic[y-(LAVASIZ+2)-1];
			dat += lavabakpic[y-(LAVASIZ+2)];
			dat += lavabakpic[y-(LAVASIZ+2)+1];
			dat += lavabakpic[y-1];
			dat += lavabakpic[y+1];
			dat += lavabakpic[y+(LAVASIZ+2)];
			dat += lavabakpic[y+(LAVASIZ+2)-1];
			*ptr++ = (dat>>3);
		}
	}

	lavanumframes++;
}
