#include <conio.h>

#define TEXTXDIM 320

static char textfont[128][8];
static char reversemask[16] = {0,8,4,12,2,10,6,14,1,9,5,13,3,11,7,15};

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux int10 =\
	"int 0x10",\
	parm [eax][ebx][ecx][edx]\

#pragma aux getpixel =\
	"xor eax, eax",\
	"mov al, [edi]",\
	parm [edi]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

main(short argc, char **argv)
{
	long i, j, mode;

	mode = 0;
	if (argc >= 2)
	{
		mode = (atol(argv[1]));
		if (mode < 0) mode = 0;
		if (mode > 1) mode = 1;
	}
	makfontmask();
	if (mode == 0)
	{
		setvmode(0x13);
		outp(0x3c4,0x4); outp(0x3c5,0x6);
		outp(0x3d4,0x14); outp(0x3d5,0x0);
		outp(0x3d4,0x17); outp(0x3d5,0xe3);
		outp(0x3c4,2); outp(0x3c5,15);
		for(i=0;i<65536;i++)
			drawpixel(i+0xa0000,0);
		outp(0x3d4,0x13); outp(0x3d5,TEXTXDIM>>3);
		while (kbhit() == 0)
		{
			printext256(rand()%320L,rand()%200L,rand()&255,-1,"Hi everybody!");
		}
	}
	else
	{
		setvmode(0x12);
		outp(0x3ce,0x0); outp(0x3cf,15);  //set/reset
		outp(0x3ce,0x1); outp(0x3cf,15);  //enable set/reset
		outp(0x3ce,0x5); outp(0x3cf,(inp(0x3cf)&(255-3))+2);
		while (kbhit() == 0)
		{
			printext16(rand()%640L,rand()%480L,rand()&15,-1,"Hi everybody!");
		}
	}
	setvmode(0x3);
}

makfontmask()
{
	char ch;
	long z, zz, zx;

	setvmode(0x13);
	int10(0x1123L,0L,0L,50L);   //load 8*8 font

	for(zx=0;zx<128;zx++)
	{
		int10(0x200L,0L,0L,0L);  //locate 1,1
		int10(0xa00+zx,1L,1L,0L);  //print character
		for(zz=0;zz<8;zz++)
		{
			ch = 0;
			for(z=0;z<8;z++)
				if (getpixel(zz*320+z+0xa0000) > 0)
					ch += (1<<(7-z));
			textfont[zx][zz] = ch;
		}
	}
}

printext16(long xpos, long ypos, short col, short backcol, char name[82])
{
	char ch, dat;
	short mask;
	long p, startp, z, zz;

	startp = ypos*80 + (xpos>>3)+0xa0000;
  
	outp(0x3ce,0x8);

	z = 0;
	mask = (1<<(8-(xpos&7)))-1;
	while (name[z] != 0)
	{
		ch = name[z];
		z++;

		p = startp;
		if ((xpos&7) == 0)
		{
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					outp(0x3cf,255);
					drawpixel(p,(long)backcol);
				}
				outp(0x3cf,textfont[ch][zz]);
				getpixel(p), drawpixel(p,col);
				p += 80;
			}
		}
		else
		{
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					outp(0x3cf,mask);
					getpixel(p), drawpixel(p,backcol);
					outp(0x3cf,255-mask);
					getpixel(p+1), drawpixel(p+1,backcol);
				}
				dat = textfont[ch][zz];
				outp(0x3cf,mask&(dat>>(xpos&7)));
				getpixel(p), drawpixel(p,col);
				outp(0x3cf,(255-mask)&(dat<<(8-(xpos&7))));
				getpixel(p+1), drawpixel(p+1,col);
				p += 80;
			}
		}
		startp++;
	}
}

printext256(long xpos, long ypos, short col, short backcol, char name[82])
{
	char ch;
	short shift;
	long p, startp, z, zz;

	outp(0x3c4,2);
	startp = ((ypos*TEXTXDIM+xpos)>>2)+0xa0000;

	z = 0;
	while (name[z] != 0)
	{
		ch = name[z];
		z++;

		if ((xpos&3) == 0)
		{
			p = startp;
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					outp(0x3c5,15-reversemask[textfont[ch][zz]>>4]);
					drawpixel(p,backcol);
					outp(0x3c5,15-reversemask[textfont[ch][zz]&15]);
					drawpixel(p+1,backcol);
				}
				outp(0x3c5,reversemask[textfont[ch][zz]>>4]);
				drawpixel(p,col);
				outp(0x3c5,reversemask[textfont[ch][zz]&15]);
				drawpixel(p+1,col);
				p += (TEXTXDIM>>2);
			}
		}
		else
		{
			shift = (xpos&3);

			p = startp;
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					outp(0x3c5,(16-(1<<shift)) - (reversemask[(textfont[ch][zz]>>(shift+4))&reversemask[16-(1<<shift)]]));
					drawpixel(p,backcol);
					outp(0x3c5,15-reversemask[(textfont[ch][zz]>>shift)&15]);
					drawpixel(p+1,backcol);
					outp(0x3c5,((1<<shift)-1) - (reversemask[(textfont[ch][zz]<<(4-shift))&reversemask[(1<<shift)-1]]));
					drawpixel(p+2,backcol);
				}
				outp(0x3c5,reversemask[(textfont[ch][zz]>>(shift+4))&reversemask[16-(1<<shift)]]);
				drawpixel(p,col);
				outp(0x3c5,reversemask[(textfont[ch][zz]>>shift)&15]);
				drawpixel(p+1,col);
				outp(0x3c5,reversemask[(textfont[ch][zz]<<(4-shift))&reversemask[(1<<shift)-1]]);
				drawpixel(p+2,col);
				p += (TEXTXDIM>>2);
			}
		}

		startp += 2;
	}
	return(0);
}
