DECLARE SUB neartag (xs&, ys&, zs&, sectnum%, ang%, neartagsector%, neartagwall%, neartagsprite%)
DECLARE FUNCTION insertsprite% (sectnum%, statnum%)
DECLARE FUNCTION changespritestat% (spritenum%, newstatnum%)
DECLARE SUB initspritelists ()
DECLARE FUNCTION insertspritestat% (statnum%)
DECLARE FUNCTION deletespritestat% (deleteme%)
DECLARE FUNCTION insertspritesect% (sectnum%)
DECLARE FUNCTION deletespritesect% (deleteme%)
DECLARE FUNCTION deletesprite% (spritenum%)
DECLARE FUNCTION changespritesect% (spritenum%, newsectnum%)
DECLARE SUB hitscan (xs&, ys&, zs&, sectnum%, vx&, vy&, vz&, hitsect%, hitwall%, hitsprite%, hitx&, hity&, hitz&)
DECLARE FUNCTION lintersect% (x1&, y1&, z1&, x2&, y2&, z2&, x3&, y3&, x4&, y4&, intx&, inty&, intz&, datype%)
DECLARE SUB getsector ()
DECLARE FUNCTION inside% (x&, y&, sectnum%)
DECLARE FUNCTION cansee% (xs&, ys&, zs&, cursectnum%, xe&, ye&, ze&, firstsectnum%)
DECLARE SUB loadtables ()
DECLARE SUB draw2dboard (dax&, day&, ang%, zoome&)
DECLARE SUB loadboard (fil$)

CONST MAXSECTORS = 1024 \ 3
CONST MAXWALLS = 4096 \ 3
CONST MAXSPRITES = 4096 \ 3
CONST MAXSTATUS = 1024 \ 3

TYPE sectortype
   wallptr AS INTEGER
   wallnum AS INTEGER
   ceilingpicnum AS INTEGER
   floorpicnum AS INTEGER
   ceilingheinum AS INTEGER
   floorheinum AS INTEGER
   ceilingz AS LONG
   floorz AS LONG
   ceilingshade AS STRING * 1
   floorshade AS STRING * 1
   ceilingxpanning AS STRING * 1
   floorxpanning AS STRING * 1
   ceilingypanning AS STRING * 1
   floorypanning AS STRING * 1
   ceilingstat AS STRING * 1
   floorstat AS STRING * 1
   ceilingpal AS STRING * 1
   floorpal AS STRING * 1
   visibility AS STRING * 1
   lotag AS INTEGER
   hitag AS INTEGER
   extra AS INTEGER
END TYPE
    
TYPE walltype
   x AS LONG
   y AS LONG
   point2 AS INTEGER
   nextsector AS INTEGER
   nextwall AS INTEGER
   picnum AS INTEGER
   overpicnum AS INTEGER
   shade AS STRING * 1
   pal AS STRING * 1
   cstat AS INTEGER
   xrepeat AS STRING * 1
   yrepeat AS STRING * 1
   xpanning AS STRING * 1
   ypanning AS STRING * 1
   lotag AS INTEGER
   hitag AS INTEGER
   extra AS INTEGER
END TYPE
    
TYPE spritetype
   x AS LONG
   y AS LONG
   z AS LONG
   cstat AS INTEGER
   shade AS STRING * 1
   pal AS STRING * 1
   clipdist AS STRING * 1
   xrepeat AS STRING * 1
   yrepeat AS STRING * 1
   xoffset AS STRING * 1
   yoffset AS STRING * 1
   picnum AS INTEGER
   ang AS INTEGER
   xvel AS INTEGER
   yvel AS INTEGER
   zvel AS INTEGER
   owner AS INTEGER
   sectnum AS INTEGER
   statnum AS INTEGER
   lotag AS INTEGER
   hitag AS INTEGER
   extra AS INTEGER
END TYPE

DIM SHARED sector(MAXSECTORS) AS sectortype
DIM SHARED wall(MAXWALLS) AS walltype
DIM SHARED sprite(MAXSPRITES) AS spritetype

DIM SHARED headspritesect%(MAXSECTORS), headspritestat%(MAXSTATUS)
DIM SHARED prevspritesect%(MAXSPRITES), prevspritestat%(MAXSPRITES)
DIM SHARED nextspritesect%(MAXSPRITES), nextspritestat%(MAXSPRITES)

DIM SHARED sintable&(2048), regs%(7), tempshort%(4096)

COMMON SHARED mapversion&, posx&, posy&, posz&, ang%, zoom&
COMMON SHARED cursectnum%, numsectors%, numwalls%, numsprites%

COMMON SHARED firstx&, firsty&, firstz&, firstsectnum%

COMMON SHARED neartagdist&

regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
CALL loadtables
CALL loadboard("boards.map")
pag% = 0: SCREEN 9
neartagdist& = 131072
zoom& = 16: ang% = 0
firstx& = posx&: firsty& = posy&: firstz& = posz&
DO
   LINE (0, 0)-(639, 349), 0, BF
  
   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   posx& = posx& + regs%(2) * zoom&
   posy& = posy& + regs%(3) * zoom&
  
   CALL getsector
   IF cursectnum% >= 0 THEN posz& = sector(cursectnum%).floorz - 32& * 256

   LOCATE 25, 70: PRINT "Sector"; cursectnum%;
   CALL draw2dboard(posx&, posy&, ang%, zoom&)

   z$ = UCASE$(INKEY$)
   IF z$ = " " THEN firstx& = posx&: firsty& = posy&: firstz& = posz&: firstsectnum% = cursectnum%
   IF z$ = "N" THEN
      CALL neartag(posx&, posy&, posz&, cursectnum%, ang%, neartagsector%, neartagwall%, neartagsprite%)
      LOCATE 1, 1: PRINT "Neartagsector = "; neartagsector%;
      LOCATE 2, 1: PRINT "Neartagwall = "; neartagwall%;
      LOCATE 3, 1: PRINT "Neartagsprite = "; neartagsprite%;
   END IF
   IF z$ = "C" THEN
      IF cansee%(posx&, posy&, posz&, cursectnum%, firstx&, firsty&, firstz&, firstsectnum%) = 0 THEN
         LINE (320, 175)-((firstx& - posx&) \ zoom& + 320, (firsty& - posy&) \ zoom& + 175), 5
      ELSE
         LINE (320, 175)-((firstx& - posx&) \ zoom& + 320, (firsty& - posy&) \ zoom& + 175), 14
      END IF
   END IF
   IF z$ = "H" THEN
      CALL hitscan(firstx&, firsty&, firstz&, firstsectnum%, posx& - firstx&, posy& - firsty&, posz& - firstz&, hitsect%, hitwall%, hitsprite%, hitx&, hity&, hitz&)
      LINE ((firstx& - posx&) \ zoom& + 320, (firsty& - posy&) \ zoom& + 175)-((hitx& - posx&) \ zoom& + 320, (hity& - posy&) \ zoom& + 175), 5
      IF hitwall% > 0 THEN
         circsiz% = 2: col% = 15
      ELSEIF hitsprite% >= 0 THEN
         circsiz% = 4: col% = 11
      ELSEIF hitz& = sector(hitsect%).ceilingz THEN
         circsiz% = 6: col% = 14
      ELSE
         circsiz% = 6: col% = 6
      END IF
      CIRCLE ((hitx& - posx&) \ zoom& + 320, (hity& - posy&) \ zoom& + 175), circsiz%, col%
      PAINT ((hitx& - posx&) \ zoom& + 320, (hity& - posy&) \ zoom& + 175), col%, col%
   END IF
   IF z$ = CHR$(0) + CHR$(75) THEN ang% = ((ang% + 2016) AND 2047)
   IF z$ = CHR$(0) + CHR$(77) THEN ang% = ((ang% + 32) AND 2047)
   IF z$ = CHR$(0) + CHR$(72) THEN
      posx& = posx& + sintable&((ang% + 2560) AND 2047) \ 128
      posy& = posy& + sintable&((ang% + 2048) AND 2047) \ 128
   END IF
   IF z$ = CHR$(0) + CHR$(80) THEN
      posx& = posx& - sintable&((ang% + 2560) AND 2047) \ 128
      posy& = posy& - sintable&((ang% + 2048) AND 2047) \ 128
   END IF
   IF UCASE$(z$) = "A" AND zoom& > 4 THEN
      IF zoom& >= 16 THEN
         zoom& = zoom& - zoom& \ 16
      ELSE
         zoom& = zoom& - 1
      END IF
   END IF
   IF UCASE$(z$) = "Z" AND zoom& < 1024 THEN
      IF zoom& >= 16 THEN
         zoom& = zoom& + zoom& \ 16
      ELSE
         zoom& = zoom& + 1
      END IF
   END IF
  
  
   pag% = 1 - pag%: SCREEN 9, , pag%, 1 - pag%
   WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
LOOP WHILE z$ <> CHR$(27)
END

FUNCTION cansee% (xs&, ys&, zs&, cursectnum%, xe&, ye&, ze&, firstsectnum%)
   IF cursectnum% = -1 OR firstsectnum% = -1 THEN cansee% = 0: EXIT FUNCTION
  
   tempshort%(0) = cursectnum%
   tempshort%(1) = firstsectnum%
   tempshortcnt% = 0
   tempshortnum% = 2
   WHILE tempshortcnt% < tempshortnum%
      dasector% = tempshort%(tempshortcnt%)
     
      startwall% = sector(dasector%).wallptr
      endwall% = startwall% + sector(dasector%).wallnum - 1
      FOR z% = startwall% TO endwall%
         x1& = wall(z%).x
         y1& = wall(z%).y
         x2& = wall(wall(z%).point2).x
         y2& = wall(wall(z%).point2).y
         IF lintersect%(xs&, ys&, zs&, xe&, ye&, ze&, x1&, y1&, x2&, y2&, intx&, inty&, intz&, 0) = 1 THEN
            nextsector% = wall(z%).nextsector
            IF nextsector% = -1 THEN
               cansee% = 0: EXIT FUNCTION
            ELSE
               CIRCLE ((intx& - posx&) \ zoom& + 320, (inty& - posy&) \ zoom& + 175), 3, 12
              
               IF intz& <= sector(dasector%).ceilingz THEN cansee% = 0: EXIT FUNCTION
               IF intz& >= sector(dasector%).floorz THEN cansee% = 0: EXIT FUNCTION
               IF intz& <= sector(nextsector%).ceilingz THEN cansee% = 0: EXIT FUNCTION
               IF intz& >= sector(nextsector%).floorz THEN cansee% = 0: EXIT FUNCTION

               CIRCLE ((intx& - posx&) \ zoom& + 320, (inty& - posy&) \ zoom& + 175), 3, 4

               bad% = 0
               FOR zz% = 0 TO tempshortnum% - 1
                  IF tempshort%(zz%) = nextsector% THEN bad% = 1: EXIT FOR
               NEXT zz%
               IF bad% = 0 THEN
                  tempshort%(tempshortnum%) = nextsector%
                  tempshortnum% = tempshortnum% + 1
               END IF
            END IF
         END IF
      NEXT z%

      tempshortcnt% = tempshortcnt% + 1
   WEND
   cansee% = 1: EXIT FUNCTION
END FUNCTION

FUNCTION changespritesect% (spritenum%, newsectnum%)
   IF sprite(spritenum%).sectnum = newsectnum% OR sprite(spritenum%).sectnum = MAXSECTORS THEN
      changespritesect% = -1
      EXIT FUNCTION
   END IF
   zx% = deletespritesect%(spritenum%)
   IF zx% >= 0 THEN
      zx% = insertspritesect%(newsectnum%)
      changespritesect% = 0
   ELSE
      changespritesect% = -1
   END IF
END FUNCTION

FUNCTION changespritestat% (spritenum%, newstatnum%)
   IF sprite(spritenum%).statnum = newstatnum% OR sprite(spritenum%).statnum = MAXSTATUS THEN
      changespritestat% = -1
      EXIT FUNCTION
   END IF
   zx% = deletespritestat%(spritenum%)
   IF zx% >= 0 THEN
      zx% = insertspritestat%(newstatnum%)
      changespritestat% = 0
   ELSE
      changespritestat% = -1
   END IF
END FUNCTION

FUNCTION deletesprite% (spritenum%)
   spritenum1% = deletespritestat(spritenum%)
   spritenum2% = deletespritesect(spritenum%)
   IF spritenum1% <> spritenum2% THEN SOUND 131, 1
   deletesprite% = spritenum2%
END FUNCTION

FUNCTION deletespritesect% (deleteme%)
   IF sprite(deleteme%).sectnum = MAXSECTORS THEN
      deletespritesect% = -1
      EXIT FUNCTION
   END IF

   IF headspritesect%(sprite(deleteme%).sectnum) = deleteme% THEN headspritesect%(sprite(deleteme%).sectnum) = nextspritesect%(deleteme%)

   IF prevspritesect%(deleteme%) >= 0 THEN nextspritesect%(prevspritesect%(deleteme%)) = nextspritesect%(deleteme%)
   IF nextspritesect%(deleteme%) >= 0 THEN prevspritesect%(nextspritesect%(deleteme%)) = prevspritesect%(deleteme%)

   IF headspritesect%(MAXSECTORS) >= 0 THEN prevspritesect%(headspritesect%(MAXSECTORS)) = deleteme%
   prevspritesect%(deleteme%) = -1
   nextspritesect%(deleteme%) = headspritesect%(MAXSECTORS)
   headspritesect%(MAXSECTORS) = deleteme%

   sprite(deleteme%).sectnum = MAXSECTORS
   deletespritesect% = 0
END FUNCTION

FUNCTION deletespritestat% (deleteme%)
   IF sprite(deleteme%).statnum = MAXSTATUS THEN
      deletespritestat% = -1
      EXIT FUNCTION
   END IF
 
   IF headspritestat%(sprite(deleteme%).statnum) = deleteme% THEN headspritestat%(sprite(deleteme%).statnum) = nextspritestat%(deleteme%)

   IF prevspritestat%(deleteme%) >= 0 THEN nextspritestat%(prevspritestat%(deleteme%)) = nextspritestat%(deleteme%)
   IF nextspritestat%(deleteme%) >= 0 THEN prevspritestat%(nextspritestat%(deleteme%)) = prevspritestat%(deleteme%)
 
   IF headspritestat%(MAXSTATUS) >= 0 THEN prevspritestat%(headspritestat%(MAXSTATUS)) = deleteme%
   prevspritestat%(deleteme%) = -1
   nextspritestat%(deleteme%) = headspritestat%(MAXSTATUS)
   headspritestat%(MAXSTATUS) = deleteme%
 
   sprite(deleteme%).statnum = MAXSTATUS
   deletespritestat% = 0
END FUNCTION

SUB draw2dboard (dax&, day&, ang%, zoome&)
   FOR z% = 0 TO numwalls% - 1
      x1& = (wall(z%).x - dax&) \ zoome&
      y1& = (wall(z%).y - day&) \ zoome&
      x2& = (wall(wall(z%).point2).x - dax&) \ zoome&
      y2& = (wall(wall(z%).point2).y - day&) \ zoome&
      IF wall(z%).nextsector = -1 THEN col% = 7 ELSE col% = 4
      bad% = 0
      IF x1& < -320 AND x2& < -320 THEN bad% = 1
      IF x1& > 320 AND x2& > 320 THEN bad% = 1
      IF y1& < -175 AND y2& < -175 THEN bad% = 1
      IF y1& > 175 AND y2& > 175 THEN bad% = 1
      IF bad% = 0 THEN LINE (x1& + 320, y1& + 175)-(x2& + 320, y2& + 175), col%
   NEXT z%

   FOR z% = 0 TO numsprites% - 1
      IF (sprite(z%).statnum < MAXSTATUS) THEN
         x1& = (sprite(z%).x - dax&) \ zoome&
         y1& = (sprite(z%).y - day&) \ zoome&
         IF ABS(x1&) < 320 AND ABS(y1&) < 175 THEN CIRCLE (x1& + 320, y1& + 175), 3, 1
      END IF
   NEXT z%

   x1& = posx& - dax&
   y1& = posy& - day&
   x2& = sintable&((ang% + 2560) AND 2047) \ 128
   y2& = sintable&((ang% + 2048) AND 2047) \ 128

   LINE ((x1& + x2&) \ zoome& + 320, (y1& + y2&) \ zoome& + 175)-((x1& - x2&) \ zoome& + 320, (y1& - y2&) \ zoome& + 175), 15
   LINE ((x1& + x2&) \ zoome& + 320, (y1& + y2&) \ zoome& + 175)-((x1& - y2&) \ zoome& + 320, (y1& + x2&) \ zoome& + 175), 15
   LINE ((x1& + x2&) \ zoome& + 320, (y1& + y2&) \ zoome& + 175)-((x1& + y2&) \ zoome& + 320, (y1& - x2&) \ zoome& + 175), 15
  
   x1& = firstx& - dax&
   y1& = firsty& - day&
   CIRCLE (x1& \ zoome& + 320, y1& \ zoome& + 175), 4, 12
   PAINT (x1& \ zoome& + 320, y1& \ zoome& + 175), 12, 12

END SUB

SUB getsector
   bad% = 0
   IF cursectnum% = -1 THEN
      bad% = 1
   ELSE
      IF inside%(posx&, posy&, cursectnum%) = 0 THEN bad% = 1
   END IF
   IF bad% = 1 THEN
      FOR z% = 0 TO numsectors% - 1
         IF inside%(posx&, posy&, z%) = 1 THEN
            cursectnum% = z%
            EXIT SUB
         END IF
      NEXT z%
      cursectnum% = -1
   END IF
END SUB

SUB hitscan (xs&, ys&, zs&, sectnum%, vx&, vy&, vz&, hitsect%, hitwall%, hitsprite%, hitx&, hity&, hitz&)
   IF sectnum% = -1 THEN hitsect% = -1: EXIT SUB

   xe& = xs& + vx&
   ye& = ys& + vy&
   ze& = zs& + vz&
  
   hitsect% = -1
  
   tempshort%(0) = sectnum%
   tempshortcnt% = 0
   tempshortnum% = 1
   WHILE tempshortcnt% < tempshortnum%
      dasector% = tempshort%(tempshortcnt%)
    
      startwall% = sector(dasector%).wallptr
      endwall% = startwall% + sector(dasector%).wallnum - 1
      FOR z% = startwall% TO endwall%
         x1& = wall(z%).x
         y1& = wall(z%).y
         x2& = wall(wall(z%).point2).x
         y2& = wall(wall(z%).point2).y
         IF lintersect%(xs&, ys&, zs&, xe&, ye&, ze&, x1&, y1&, x2&, y2&, intx&, inty&, intz&, 1) = 1 THEN
            nextsector% = wall(z%).nextsector
            IF nextsector% = -1 THEN
               IF hitsect% = -1 OR ABS(intx& - xs&) + ABS(inty& - ys&) < ABS(hitx& - xs&) + ABS(hity& - ys&) THEN
                  hitsect% = dasector%
                  hitwall% = z%
                  hitsprite% = -1
                  hitx& = intx&
                  hity& = inty&
                  hitz& = intz&
               END IF
            ELSE
               bad% = 0

               IF vz& <> 0 AND (intz& <= sector(dasector%).ceilingz OR intz& >= sector(dasector%).floorz) THEN
                  IF hitsect% = -1 OR ABS(intx& - xs&) + ABS(inty& - ys&) < ABS(hitx& - xs&) + ABS(hity& - ys&) THEN
                     hitsect% = dasector%
                     hitwall% = -1
                     hitsprite% = -1
                     IF vz& > 0 THEN
                        hitz& = sector(dasector%).floorz
                     ELSE
                        hitz& = sector(dasector%).ceilingz
                     END IF
                     hitx& = xs& + ((xe& - xs&) * (hitz& - zs&)) \ vz&
                     hity& = ys& + ((ye& - ys&) * (hitz& - zs&)) \ vz&
                     bad% = 1
                  END IF
               END IF

               IF intz& <= sector(nextsector%).ceilingz OR intz& >= sector(nextsector%).floorz THEN
                  IF hitsect% = -1 OR ABS(intx& - xs&) + ABS(inty& - ys&) < ABS(hitx& - xs&) + ABS(hity& - ys&) THEN
                     hitsect% = dasector%
                     hitwall% = z%
                     hitsprite% = -1
                     hitx& = intx&
                     hity& = inty&
                     hitz& = intz&
                     bad% = 1
                  END IF
               END IF
              
               IF bad% = 0 THEN
                  FOR zz% = 0 TO tempshortnum% - 1
                     IF tempshort%(zz%) = nextsector% THEN bad% = 1: EXIT FOR
                  NEXT zz%
                  IF bad% = 0 THEN
                     tempshort%(tempshortnum%) = nextsector%
                     tempshortnum% = tempshortnum% + 1
                  END IF
               END IF
            END IF
         END IF
      NEXT z%

      z% = headspritesect%(dasector%)
      WHILE z% <> -1
         x1& = sprite(z%).x
         y1& = sprite(z%).y
         z1& = sprite(z%).z
        
         topt& = vx& * (x1& - xs&) + vy& * (y1& - ys&)
         IF topt& > 0 THEN
            bot& = vx& * vx& + vy& * vy&
            IF (bot& \ 256) <> 0 THEN
               intz& = zs& + (vz& * (topt& \ 256)) \ (bot& \ 256)
               daysiz& = (64& * 64&) \ 64&   'Rewrite with tilesizy&yrepeat
               IF intz& <= z1& AND intz& >= z1& - daysiz& * 256& THEN
                  topu& = vx& * (y1& - ys&) - vy& * (x1& - xs&)
              
                  offx& = (vx& * (topu& \ 256)) \ (bot& \ 256)
                  offy& = (vy& * (topu& \ 256)) \ (bot& \ 256)
                  dist& = offx& * offx& + offy& * offy&
                  daxsiz& = ((64& * 64&) * (64& * 64&)) \ 32 'Rewrite with tilesizx&xrepeat
                  IF dist& <= daxsiz& THEN
                     intx& = xs& + (vx& * (topt& \ 256)) \ (bot& \ 256)
                     inty& = ys& + (vy& * (topt& \ 256)) \ (bot& \ 256)
                    
                     IF hitsect% = -1 OR ABS(intx& - xs&) + ABS(inty& - ys&) < ABS(hitx& - xs&) + ABS(hity& - ys&) THEN
                        hitsect% = dasector%
                        hitwall% = -1
                        hitsprite% = z%
                        hitx& = intx&
                        hity& = inty&
                        hitz& = intz&
                     END IF
                  END IF
               END IF
            END IF
         END IF
        
         z% = nextspritesect%(z%)
      WEND


      tempshortcnt% = tempshortcnt% + 1
   WEND

END SUB

SUB initspritelists
   FOR z% = 0 TO MAXSECTORS - 1     'Init doubly-linked sprite sector lists
      headspritesect%(z%) = -1
   NEXT z%
   headspritesect%(MAXSECTORS) = 0
   FOR z% = 0 TO MAXSPRITES - 1
      prevspritesect%(z%) = z% - 1
      nextspritesect%(z%) = z% + 1
      sprite(z%).sectnum = MAXSECTORS
   NEXT z%
   prevspritesect%(0) = -1
   nextspritesect%(MAXSPRITES - 1) = -1

 
   FOR z% = 0 TO MAXSTATUS - 1      'Init doubly-linked sprite status lists
      headspritestat%(z%) = -1
   NEXT z%
   headspritestat%(MAXSTATUS) = 0
   FOR z% = 0 TO MAXSPRITES - 1
      prevspritestat%(z%) = z% - 1
      nextspritestat%(z%) = z% + 1
      sprite(z%).statnum = MAXSTATUS
   NEXT z%
   prevspritestat%(0) = -1
   nextspritestat%(MAXSPRITES - 1) = -1
END SUB

FUNCTION insertsprite% (sectnum%, statnum%)
   spritenum1% = insertspritestat%(statnum%)
   spritenum2% = insertspritesect%(sectnum%)
   IF spritenum1% <> spritenum2% THEN SOUND 131, 1
   insertsprite% = spritenum2%
END FUNCTION

FUNCTION insertspritesect% (sectnum%)
   IF sectnum% >= MAXSECTORS OR headspritesect%(MAXSECTORS) = -1 THEN
      insertspritesect% = -1: EXIT FUNCTION   'list full
   END IF

   blanktouse% = headspritesect%(MAXSECTORS)

   headspritesect%(MAXSECTORS) = nextspritesect%(blanktouse%)
   IF headspritesect%(MAXSECTORS) >= 0 THEN prevspritesect%(headspritesect%(MAXSECTORS)) = -1

   prevspritesect%(blanktouse%) = -1
   nextspritesect%(blanktouse%) = headspritesect%(sectnum%)
   IF headspritesect%(sectnum%) >= 0 THEN prevspritesect%(headspritesect%(sectnum%)) = blanktouse%
   headspritesect%(sectnum%) = blanktouse%

   sprite(blanktouse%).sectnum = sectnum%

   insertspritesect% = blanktouse%
END FUNCTION

FUNCTION insertspritestat% (statnum%)
   IF statnum% >= MAXSTATUS OR headspritestat%(MAXSTATUS) = -1 THEN
      insertspritestat% = -1: EXIT FUNCTION   'list full
   END IF
 
   blanktouse% = headspritestat%(MAXSTATUS)
 
   headspritestat%(MAXSTATUS) = nextspritestat%(blanktouse%)
   IF headspritestat%(MAXSTATUS) >= 0 THEN prevspritestat%(headspritestat%(MAXSTATUS)) = -1
 
   prevspritestat%(blanktouse%) = -1
   nextspritestat%(blanktouse%) = headspritestat%(statnum%)
   IF headspritestat%(statnum%) >= 0 THEN prevspritestat%(headspritestat%(statnum%)) = blanktouse%
   headspritestat%(statnum%) = blanktouse%
 
   sprite(blanktouse%).statnum = statnum%
 
   insertspritestat% = blanktouse%
END FUNCTION

FUNCTION inside% (x&, y&, sectnum%)
   cnt% = 0
   startwall% = sector(sectnum%).wallptr
   endwall% = startwall% + sector(sectnum%).wallnum - 1

   FOR z% = startwall% TO endwall%
      x1& = wall(z%).x: x2& = wall(wall(z%).point2).x
      IF (x1& >= x& OR x2& >= x&) THEN
         y1& = wall(z%).y: y2& = wall(wall(z%).point2).y
         IF y1& > y2& THEN SWAP x1&, x2&: SWAP y1&, y2&
         IF (y1& <= y& AND y2& > y&) THEN
            IF x1& * (y& - y2&) + x2& * (y1& - y&) <= x& * (y1& - y2&) THEN cnt% = 1 - cnt%
         END IF
      END IF
   NEXT z%
   inside% = cnt%
END FUNCTION

FUNCTION lintersect% (x1&, y1&, z1&, x2&, y2&, z2&, x3&, y3&, x4&, y4&, intx&, inty&, intz&, datype%)
   'If datype% = 0 then p1 to p2 is a line segment
   'If datype% = 1 then p1 towards p2 is a ray
  
   intersect% = 0

   IF datype% = 0 THEN
      IF x1& < x3& AND x1& < x4& AND x2& < x3& AND x2& < x4& THEN lintersect% = 0: EXIT FUNCTION
      IF x1& > x3& AND x1& > x4& AND x2& > x3& AND x2& > x4& THEN lintersect% = 0: EXIT FUNCTION
      IF y1& < y3& AND y1& < y4& AND y2& < y3& AND y2& < y4& THEN lintersect% = 0: EXIT FUNCTION
      IF y1& > y3& AND y1& > y4& AND y2& > y3& AND y2& > y4& THEN lintersect% = 0: EXIT FUNCTION
     
      templong1& = (x3& - x1&) * (y2& - y1&) - (y3& - y1&) * (x2& - x1&)
      templong2& = (x4& - x1&) * (y2& - y1&) - (y4& - y1&) * (x2& - x1&)
      IF ((templong1& <= 0) AND (templong2& >= 0)) OR ((templong1& >= 0) AND (templong2& <= 0)) THEN
         templong1& = (x1& - x3&) * (y4& - y3&) - (y1& - y3&) * (x4& - x3&)
         templong2& = (x2& - x3&) * (y4& - y3&) - (y2& - y3&) * (x4& - x3&)
         IF ((templong1& <= 0) AND (templong2& >= 0)) OR ((templong1& >= 0) AND (templong2& <= 0)) THEN
            intersect% = 1
         END IF
      END IF
   ELSE
      templong1& = (x3& - x1&) * (y2& - y1&) - (y3& - y1&) * (x2& - x1&)
      templong2& = (x4& - x1&) * (y2& - y1&) - (y4& - y1&) * (x2& - x1&)
      IF ((templong1& <= 0) AND (templong2& >= 0)) OR ((templong1& >= 0) AND (templong2& <= 0)) THEN
        
         'Case 1:  Dots on opposite sides
         templong1& = (x1& - x3&) * (y4& - y3&) - (y1& - y3&) * (x4& - x3&)
         templong2& = (x2& - x3&) * (y4& - y3&) - (y2& - y3&) * (x4& - x3&)
         IF ((templong1& <= 0) AND (templong2& >= 0)) OR ((templong1& >= 0) AND (templong2& <= 0)) THEN
            intersect% = 1
         END IF
         
         'Case 2:  Closer dot is P2
         IF ABS(templong2&) < ABS(templong1&) THEN
            intersect% = 1
         END IF
     
      END IF
   END IF
  
   IF intersect% = 1 THEN
      bot& = (x2& - x1&) * (y3& - y4&) - (x3& - x4&) * (y2& - y1&)
      topt& = (x3& - x1&) * (y3& - y4&) - (x3& - x4&) * (y3& - y1&)
      'topu& = (x2& - x1&) * (y3& - y1&) - (x3& - x1&) * (y2& - y1&)
      IF (bot& \ 256) = 0 THEN
         intx& = x1&                    'If parallel
         inty& = y1&
         intz& = z1&
      ELSE
         intx& = x1& + ((x2& - x1&) * (topt& \ 256)) \ (bot& \ 256)
         inty& = y1& + ((y2& - y1&) * (topt& \ 256)) \ (bot& \ 256)
         intz& = z1& + ((z2& - z1&) * (topt& \ 256)) \ (bot& \ 256)
      END IF
   END IF
  
   lintersect% = intersect%
END FUNCTION

SUB loadboard (fil$)
   CALL initspritelists
  
   OPEN fil$ FOR BINARY AS #1
  
   GET #1, , mapversion&
   IF mapversion& <> 6 THEN PRINT "NOT MAP VERSION 6": END
  
   GET #1, , posx&
   GET #1, , posy&
   GET #1, , posz&
   GET #1, , ang%
   GET #1, , cursectnum%
  
   GET #1, , numsectors%
   FOR z% = 0 TO numsectors% - 1
      GET #1, , sector(z%)
   NEXT z%
  
   GET #1, , numwalls%
   FOR z% = 0 TO numwalls% - 1
      GET #1, , wall(z%)
   NEXT z%
  
   GET #1, , numsprites%
   FOR z% = 0 TO numsprites% - 1
      GET #1, , sprite(z%)
      snot% = insertsprite%(sprite(z%).sectnum, sprite(z%).statnum)
   NEXT z%

   CLOSE #1
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

SUB neartag (xs&, ys&, zs&, sectnum%, ang%, neartagsector%, neartagwall%, neartagsprite%)
  
   neartagsector% = -1: neartagwall% = -1: neartagsprite% = -1
  
   vx& = sintable&((ang% + 2560) AND 2047) * 8192& \ neartagdist&
   vy& = sintable&((ang% + 2048) AND 2047) * 8192& \ neartagdist&
   vz& = 0
   LINE (320, 175)-(vx& \ zoom& + 320, vy& \ zoom& + 175), 15

   IF sectnum% = -1 THEN EXIT SUB

   xe& = xs& + vx&
   ye& = ys& + vy&
   ze& = zs& + vz&
  
   tempshort%(0) = sectnum%
   tempshortcnt% = 0
   tempshortnum% = 1
   WHILE tempshortcnt% < tempshortnum%
      dasector% = tempshort%(tempshortcnt%)
   
      startwall% = sector(dasector%).wallptr
      endwall% = startwall% + sector(dasector%).wallnum - 1
      FOR z% = startwall% TO endwall%
         good% = 0
         IF wall(z%).nextsector >= 0 THEN
            IF (sector(wall(z%).nextsector).lotag OR sector(wall(z%).nextsector).hitag) <> 0 THEN good% = good% OR 1
         END IF
         IF (wall(z%).lotag OR wall(z%).hitag) <> 0 THEN good% = good% OR 2

         IF good% <> 0 OR wall(z%).nextsector >= 0 THEN
            x1& = wall(z%).x
            y1& = wall(z%).y
            x2& = wall(wall(z%).point2).x
            y2& = wall(wall(z%).point2).y
            IF lintersect%(xs&, ys&, zs&, xe&, ye&, ze&, x1&, y1&, x2&, y2&, intx&, inty&, intz&, 0) = 1 THEN
               IF (good% AND 1) > 0 THEN neartagsector% = wall(z%).nextsector
               IF (good% AND 2) > 0 THEN neartagwall% = z%
              
               'if xs&
               IF wall(z%).nextsector >= 0 THEN
                  nextsector% = wall(z%).nextsector
                  bad% = 0
                  FOR zz% = 0 TO tempshortnum% - 1
                     IF tempshort%(zz%) = nextsector% THEN bad% = 1: EXIT FOR
                  NEXT zz%
                  IF bad% = 0 THEN
                     tempshort%(tempshortnum%) = nextsector%
                     tempshortnum% = tempshortnum% + 1
                  END IF
               END IF

            END IF
         END IF
      NEXT z%

      tempshortcnt% = tempshortcnt% + 1
   WEND

END SUB

