DECLARE SUB loadnewall (bufplc&, wallnum%)
DECLARE SUB loadtables ()
DECLARE SUB setupscreen ()

CONST NUMPALOOKUPS = 32
CONST MAXTILES = 4096
CONST xdim = 320, ydim = 200

COMMON SHARED numwalls%, transcnt&, picsiz&
DIM SHARED buf%(25000)
DIM SHARED palookup%(NUMPALOOKUPS, 256), palookup2%(NUMPALOOKUPS, 256)
DIM SHARED tilesizx%(MAXTILES), tilesizy%(MAXTILES), picanm&(MAXTILES)

DIM SHARED r&(256), g&(256), b&(256)

RANDOMIZE TIMER
CALL setupscreen

OUT &H3C7, 0
FOR z% = 0 TO 255
   r&(z%) = INP(&H3C9)
   g&(z%) = INP(&H3C9)
   b&(z%) = INP(&H3C9)
NEXT z%

r1& = 48: g1& = 16: b1& = 0
r2& = 0: g2& = 48: b2& = 0

FOR shade% = 0 TO 0 'MAXPALOOKUPS - 1
   FOR z% = 0 TO 255
      hue1& = r1& * r1& + g1& * g1& + b1& * b1&
      hue& = r&(z%) * r&(z%) + g&(z%) * g&(z%) + b&(z%) * b&(z%)
      dar& = (r1& * hue&) \ hue1&
      dag& = (g1& * hue&) \ hue1&
      dab& = (b1& * hue&) \ hue1&
      dist& = ABS(r&(z%) - dar&) + (g&(z%) - dag&) + ABS(b&(z%) - dab&)
      IF dist& < 64 THEN
         palookup2%(shade%, z%) = 0
      ELSE
         palookup2%(shade%, z%) = z%
      END IF
   NEXT z%
NEXT shade%

tile% = 0

z$ = " "
DO

   CLS
   CALL loadnewall(0&, tile%)

   DEF SEG = &HA000
 
   FOR z% = 0 TO picsiz& - 1
      p& = (z% MOD tilesizy%(tile%)) * 320& + (z% \ tilesizy%(tile%))
      POKE p&, palookup%(0, buf%(z%))
      POKE p& + 128, palookup2%(0, buf%(z%))
   NEXT z%
 
   DO
      z$ = INKEY$
   LOOP WHILE z$ = ""
   tile% = tile% + 1

LOOP WHILE z$ <> CHR$(27)

SUB loadnewall (bufplc&, wallnum%)
   OPEN "tiles000.art" FOR BINARY AS #1

   SEEK #1, 1
   GET #1, , version&
   GET #1, , numtiles&
   GET #1, , localtilestart&
   GET #1, , localtileend&
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , tilesizx%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , tilesizy%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , picanm&(z%)
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      dasiz& = tilesizx%(z%)
      totsiz& = totsiz& + dasiz& * tilesizy%(z%)
   NEXT z%
   SEEK #1, totsiz& + 16 + (localtileend& - localtilestart& + 1) * 8 + 1

   picsiz& = tilesizx%(z%)
   picsiz& = picsiz& * tilesizy%(z%)
   IF picsiz& > 16384 THEN picsiz& = 16384: tilesizx%(z%) = 16384 \ tilesizy%(z%)

   buf$ = STRING$(picsiz&, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO tilesizx%(wallnum%) - 1
      FOR zz% = 0 TO tilesizy%(wallnum%) - 1
         buf%(bufplc& + z% * tilesizy%(wallnum%) + zz%) = PEEK(offs&)
         offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB setupscreen
   SCREEN 13
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   pal$ = STRING$(256, 0)
   FOR z% = 0 TO NUMPALOOKUPS
      GET #1, , pal$
      FOR zz% = 0 TO 255
         palookup%(z%, zz%) = ASC(MID$(pal$, zz% + 1, 1))
      NEXT zz%
   NEXT z%
   CLOSE #1

END SUB

