#include <malloc.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <dos.h>
#include <conio.h>

#define SNDBUFSIZ 512
#define NUMCHANNELS 4

	//Sound reading information
static char *snd, sndlastfilename[NUMCHANNELS][13];
static long sndvolookup[NUMCHANNELS][256], sndlastfileleng[NUMCHANNELS];
static long splc[NUMCHANNELS], sinc[NUMCHANNELS], soff[NUMCHANNELS];
static long stemp[SNDBUFSIZ>>1];
	//Sound interrupt information
static unsigned short sndportaddr, sndselector, sndseg = -1, omask21;
volatile long sndoffs, sndoffsplc, sndoffsxor, sndplc, sndend;

volatile unsigned char readch, oldreadch, extended, keystatus[256];

void (__interrupt __far *oldsbhandler)();
void __interrupt __far sbplayhandler(void);
void (__interrupt __far *oldkeyhandler)();
void __interrupt __far keyhandler(void);

#pragma aux convallocate =\
	"mov ax, 0x100",\
	"int 0x31",\
	"jnc skiperror",\
	"mov ax, -1",\
	"skiperror:",\
	"mov sndselector, dx",\
	parm [bx]\
	modify [eax edx]\

#pragma aux convdeallocate =\
	"mov ax, 0x101",\
	"mov dx, sndselector",\
	"int 0x31",\
	parm [dx]\
	modify [eax edx]\

#pragma aux resetsb =\
	"mov al, 1",\
	"mov dx, sndportaddr",\
	"add dx, 0x6",\
	"out dx, al",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"xor al, al",\
	"out dx, al",\
	"add dx, 4",\
	"mov cx, 100",\
	"resetsb1: in al, dx",\
	"cmp al, 0xaa",\
	"je resetsb2",\
	"loop resetsb1",\
	"mov ax, 1",\
	"jmp resetsb3",\
	"resetsb2: xor ax, ax",\
	"resetsb3:",\
	modify [eax ecx edx]\

#pragma aux sbout =\
	"mov ah, al",\
	"mov dx, sndportaddr",\
	"add dx, 0xc",\
	"sbwait: in al, dx",\
	"test al, 0x80",\
	"jnz sbwait",\
	"mov al, ah",\
	"out dx, al",\
	parm [eax]\
	modify [eax edx]\

#pragma aux koutp =\
	"out dx, al",\
	parm [edx][eax]\

#pragma aux koutpw =\
	"out dx, ax",\
	parm [edx][eax]\

#pragma aux kinp =\
	"in al, dx",\
	parm [edx]\

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\
	modify [eax]\

#pragma aux readkey =\
	"in al, 0x60",\
	"mov readch, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\
	modify [eax]\

#pragma aux clearbuf =\
	"cld",\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux copybuf =\
	"cld",\
	"rep movsd",\
	parm [esi][edi][ecx]\

main(int argc,char **argv)
{
	long i;

	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();

	initsb();
	printf("Ready...\n");

	while (keystatus[1] == 0)
	{
		for(i=0;i<NUMCHANNELS;i++)
			if (keystatus[i+0x2] > 0)
			{
				keystatus[i+0x2] = 0;
				switch(i)
				{
					case 0: wsay("hello.wav",(long)(rand()&127)+128); break;
					case 1: wsay("blowup.wav",(long)(rand()&127)+128); break;
					case 2: wsay("ouch.wav",(long)(rand()&127)+128); break;
					case 3: wsay("splash.wav",(long)(rand()&127)+128); break;
				}
			}
	}

	uninitsb();
	_dos_setvect(0x9, oldkeyhandler);
}

initsb()
{
	long i;

	if (sndseg == -1)    //Allocate DMA buffer in conventional memory
	{
		if ((sndseg = convallocate(SNDBUFSIZ>>4)) == -1)
			return(-1);
		sndoffs = (((long)sndseg)<<4);
	}

	if ((snd = (char *)malloc(131072)) == NULL)
		return(-1);

	clearbuf(snd,131072>>2,0x80808080);

	sndportaddr = 0x220;
	resetsb();

	sbout(0xd1);                                //Turn speaker on

	sbout(0x40);
	sbout(256-(1000000/11025));                 //Speed

	omask21 = kinp(0x21);                        //Unmask IRQ7
	koutp(0x21,omask21&127);

	oldsbhandler = _dos_getvect(0xf);           //Set new IRQ7 vector
	_disable(); _dos_setvect(0xf, sbplayhandler); _enable();

	for(i=0;i<NUMCHANNELS;i++)                  //Clear channels
		splc[i] = -1, sinc[i] = 0, soff[i] = 0;


		//Jump start DMA interrupts
	sndoffsplc = sndoffs;
	sndoffsxor = sndoffsplc ^ (sndoffsplc+(SNDBUFSIZ>>1));

	preparesndbuf(sndoffsplc,(long)SNDBUFSIZ>>1);
	wplay(sndoffsplc,(long)(SNDBUFSIZ>>1));
	sndoffsplc ^= sndoffsxor;
	preparesndbuf(sndoffsplc,(long)SNDBUFSIZ>>1);

	return(0);
}

uninitsb()
{
	sbout(0xd3);                           //Turn speaker off

	if (sndseg != -1)
		convdeallocate(sndseg), sndseg = -1;

	koutp(0x21,omask21);
	_disable(); _dos_setvect(0xf, oldsbhandler); _enable();
}

wsay(char *dafilename, long volume)
{
	long i, j, chanum, bad, good, dafilenameleng;

	dafilenameleng = strlen(dafilename);

		//First check to see if sound is already loaded in inactive slot
	chanum = -1;
	for(i=0;i<NUMCHANNELS;i++)
		if (splc[i] < 0)
		{
			bad = 0;
			for(j=0;j<dafilenameleng;j++)
				if (sndlastfilename[i][j] != dafilename[j])
				{
					bad = 1;
					break;
				}

			if (bad == 0)
				chanum = i;
		}

	if (chanum == -1)
	{
		chanum = 0;
		for(i=1;i<NUMCHANNELS;i++)
			if (splc[i] < splc[chanum])
				chanum = i;

			//Now check to see if sound is already loaded in an active slot (copy)
		good = 0;
		for(i=0;i<NUMCHANNELS;i++)
			if (i != chanum)
			{
				bad = 0;
				for(j=0;j<dafilenameleng;j++)
					if (sndlastfilename[i][j] != dafilename[j])
					{
						bad = 1;
						break;
					}

				if (bad == 0)
				{
					copybuf(&snd[i<<15],&snd[chanum<<15],32768>>2);
					sndlastfileleng[chanum] = sndlastfileleng[i];
					good = 1;
					break;
				}
			}

		if (good == 0)
			sndlastfileleng[chanum] = loadwave(dafilename,chanum<<15);

		for(j=0;j<dafilenameleng;j++)
			sndlastfilename[chanum][j] = dafilename[j];
	}

	splc[chanum] = -1;     //Disable channel temporarily for clean switch

		//Set 256-byte volume lookup table
	if (volume >= 255)
	{
		for(i=0;i<256;i++)
			sndvolookup[chanum][i] = (long)(i-128);
	}
	else if (volume > 0)
	{
		for(i=0;i<256;i++)
			sndvolookup[chanum][i] = (((i-128)*volume)>>8);
	}
	else
	{
		for(i=0;i<256;i++)
			sndvolookup[chanum][i] = 0L;
	}

		//frequency
	sinc[chanum] = (rand()&511)+3600;
	soff[chanum] = (chanum<<15)+sndlastfileleng[chanum];
		//splc should be last thing modified
	splc[chanum] = (sndlastfileleng[chanum]<<12);
}

loadwave(char *dafilename, long loadsndoffs)
{
	long i, fil;

	fil = open(dafilename,O_BINARY|O_RDWR,S_IREAD);
	lseek(fil,44L,SEEK_SET);
	i = read(fil,&snd[loadsndoffs],32768);
	close(fil);
	return(i);
}

wplay(long addr, long leng)
{
	sndplc = addr; sndend = sndplc+leng;

		//Play entire sound
	if ((sndplc&0xffff0000) == (sndend&0xffff0000))
		wplayblock(sndplc,sndend-sndplc);
	else
		wplayblock(sndplc,65536-(sndplc&65535));
}

wplayblock(long addr, long leng)
{
		//Play 1 sound block
	koutp(0xa,0x5);                    //Set up DMA REGISTERS
	koutp(0xc,0);
	koutp(0xb,0x49);                   //&H59 - continuous play, &H49 - 1-shot rec
	koutp(0x2,addr&255); koutp(0x2,(addr>>8)&255);
	koutp(0x3,(leng-1)&255); koutp(0x3,((leng-1)>>8)&255);
	koutp(0x83,((addr>>16)&255));
	koutp(0xa,0x1);

	sbout(0x14);                            //Length
	sbout((leng-1)&255);
	sbout(((leng-1)>>8)&255);
}

void __interrupt __far sbplayhandler()
{
	sndplc = ((sndplc+65536)&0xffff0000);
	if (sndplc < sndend)                     //If more blocks left in sound
	{
		if ((sndplc&0xffff0000) == (sndend&0xffff0000))
			wplayblock(sndplc,sndend-sndplc);
		else
			wplayblock(sndplc,65536);
	}
	else                                     //Play & prepare next sound
	{
		wplay(sndoffsplc,(long)(SNDBUFSIZ>>1));
		sndoffsplc ^= sndoffsxor;
		preparesndbuf(sndoffsplc,(long)SNDBUFSIZ>>1);
	}

	kinp(sndportaddr+0xe);                    //Acknowledge SB
	koutp(0x20,0x20);
}

preparesndbuf(long addr, long numbytes)
{
	long i, j, k;
	char *ptr;

	ptr = (char *)addr;

	for(k=0;k<numbytes;k++)            //Actually calculate sound wave!
	{
		j = 128;
		for(i=0;i<NUMCHANNELS;i++)
			if (splc[i] >= 0)
			{
				j += sndvolookup[i][snd[soff[i]-(splc[i]>>12)]];
				splc[i] -= sinc[i];
			}

		if (j < 0) j = 0;
		if (j > 255) j = 255;

		*ptr++ = (char)j;
	}
}

void __interrupt __far keyhandler()
{
	oldreadch = readch;
	readkey();
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
		{
			if ((readch&128) == 0)
			{
				if (keystatus[(readch&127)+extended] == 0)
					keystatus[(readch&127)+extended] = 1;
			}
			else
				keystatus[(readch&127)+extended] = 0;
		}
		extended = 0;
	}
	interruptend();
}
