#include <stdlib.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#define maxlines 2048
#define maxwalls 1024
#define maxsprites 64

struct walldata
{
	short unsigned int xa1, ya1, xa2, ya2;
	short unsigned int picnum, picnum1, picnum2;
	char shade, shade1, shade2, z1, z2, got, cstat, zosc;
};
static struct walldata lin[maxlines];

static short int sintable[2048], umost[320], dmost[320];
static long int tantable[1024], posx, posy, waloff[maxwalls];
static long xs[maxsprites], ys[maxsprites], sizs[maxsprites];
static short int sline[maxsprites], sord[maxsprites], snum;
static char sumost[maxsprites][320], sdmost[maxsprites][320];
static short int vidmode, xdim, ydim, halfwidth, halfheight, scrsize, page;
static short int takernum, ceilingstat, xtotaldim, type;
unsigned char picanm[maxwalls], picsiz[maxwalls], palette[768];
unsigned short int ang, centeroffset;
static long int numframes;
volatile long int totalclock;
volatile unsigned char readch, oldreadch, keystatus[256], extended;
void (__interrupt __far *oldhand)();
void (__interrupt __far *oldkeyhandler)();
static char *pic;
static short int mousx, mousy, moustat;
unsigned long vplc1, vplc2, vinc1, vinc2, pplc;

#pragma aux setvmode =\
	"int 10h",\
	parm [eax]\

#pragma aux out =\
	"out dx, al",\
	parm [dx][al]\

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\

#pragma aux vlineasm1 =\
	"push ebp",\
	"vlinestart1: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+esi]",\
	"add al,dl",\
	"mov [edi], al",\
	"add edi,320",\
	"add ecx,ebx",\
	"sub dh,1",\
	"jnz vlinestart1",\
	"pop ebp",\
	parm [ebx][ecx][dx][esi][edi]\

#pragma aux vlineasm2l =\
	"push ebp",\
	"vlinestart2l: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+ebx]",\
	"add al,dl",\
	"mov byte ptr [edi],al",\
	"add edi,320",\
	"add ecx,vinc1",\
	"sub eax,65536",\
	"jnc vlinestart2l",\
	"pop ebp",\
	"mov vplc1, ecx",\
	"mov pplc, edi",\
	parm [eax][ebx][ecx][edx][esi][edi]\

#pragma aux vlineasm2r =\
	"push ebp",\
	"vlinestart2r: mov ebp,edx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+esi]",\
	"add al,dl",\
	"mov byte ptr [edi+1],al",\
	"add edi,320",\
	"add edx,vinc2",\
	"sub eax,65536",\
	"jnc vlinestart2r",\
	"pop ebp",\
	"mov vplc2, edx",\
	"mov pplc, edi",\
	parm [eax][ebx][ecx][edx][esi][edi]\

#pragma aux vlineasm2b =\
	"push ebp",\
	"vlinestart2b: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+ebx]",\
	"add al,dl",\
	"mov ebp,edx",\
	"shr ebp,cl",\
	"mov ah,byte ptr [ebp+esi]",\
	"add ah,dl",\
	"mov word ptr [edi],ax",\
	"add edi,320",\
	"add ecx,vinc1",\
	"add edx,vinc2",\
	"sub eax,65536",\
	"jnc vlinestart2b",\
	"pop ebp",\
	"mov vplc1, ecx",\
	"mov vplc2, edx",\
	"mov pplc, edi",\
	parm [eax][ebx][ecx][edx][esi][edi]\

#pragma aux clearscreen =\
	"mov edi, 000a0000h",\
	"mov ecx, 16000",\
	"xor eax, eax",\
	"rep stosd",\
	parm [edi][ax]\

#pragma aux clearvscreen =\
	"mov edi, 000a0000h",\
	"mov ecx, 5120",\
	"xor eax, eax",\
	"rep stosw",\
	"mov edi, 000ad200h",\
	"mov ecx, 5120",\
	"rep stosw",\

#pragma aux hlineasm64 =\
	"push ebp",\
	"or dl,dl",\
	"jz hlineskipdraw",\
	"hlinestart: add ebx,vinc1",\
	"add edx,esi",\
	"mov ebp,ebx",\
	"shr ebp,26",\
	"shld ebp,edx,6",\
	"add ebx,vinc1",\
	"add edx,esi",\
	"mov al,byte ptr [ecx+ebp]",\
	"mov ebp,ebx",\
	"shr ebp,26",\
	"shld ebp,edx,6",\
	"mov ah,byte ptr [ecx+ebp]",\
	"add al,bl",\
	"add ah,bl",\
	"stosw",\
	"sub dl,1",\
	"jnz hlinestart",\
	"hlineskipdraw: bt eax,16",\
	"jnc endhlineasm",\
	"add ebx,vinc1",\
	"add edx,esi",\
	"mov ebp,ebx",\
	"shr ebp,26",\
	"shld ebp,edx,6",\
	"mov al,byte ptr [ecx+ebp]",\
	"add al,bl",\
	"stosb",\
	"endhlineasm: pop ebp",\
	parm [eax][edi][ebx][edx][ecx][esi]\

#pragma aux hlineasm128 =\
	"push ebp",\
	"or dl,dl",\
	"jz hlineskipdraw",\
	"hlinestart: add ebx,vinc1",\
	"add edx,esi",\
	"mov ebp,ebx",\
	"shr ebp,25",\
	"shld ebp,edx,7",\
	"add ebx,vinc1",\
	"add edx,esi",\
	"mov al,byte ptr [ecx+ebp]",\
	"mov ebp,ebx",\
	"shr ebp,25",\
	"shld ebp,edx,7",\
	"mov ah,byte ptr [ecx+ebp]",\
	"add al,bl",\
	"add ah,bl",\
	"stosw",\
	"sub dl,1",\
	"jnz hlinestart",\
	"hlineskipdraw: bt eax,16",\
	"jnc endhlineasm",\
	"add ebx,vinc1",\
	"add edx,esi",\
	"mov ebp,ebx",\
	"shr ebp,25",\
	"shld ebp,edx,7",\
	"mov al,byte ptr [ecx+ebp]",\
	"add al,bl",\
	"stosb",\
	"endhlineasm: pop ebp",\
	parm [eax][edi][ebx][edx][ecx][esi]\

#pragma aux svlineasm1 =\
	"push ebp",\
	"vlinestart1: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+esi]",\
	"cmp al,255",\
	"je vlineskipdraw",\
	"add al,dl",\
	"mov [edi], al",\
	"vlineskipdraw: add edi,320",\
	"add ecx,ebx",\
	"sub dh,1",\
	"jnz vlinestart1",\
	"pop ebp",\
	parm [ebx][ecx][dx][esi][edi]\

#pragma aux clearhscreen =\
	"mov edi, 000a0000h",\
	"mov ecx, 16000",\
	"xor eax, eax",\
	"rep stosd",\
	parm [edi][ax]\

#pragma aux setupmouse =\
	"mov ax, 0",\
	"int 33h",\
	"cmp ax, -1",\
	"sete moustat",\

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"sar cx, 1",\
	"sar dx, 1",\
	"mov mousx, cx",\
	"mov mousy, dx",\

#pragma aux readkey =\
	"in al, 0x60",\
	"mov readch, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\

void __interrupt __far ksmhandler()
{
	totalclock++;
	interruptend();
}

void __interrupt __far keyhandler()
{
	oldreadch = readch;
	readkey();
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
			keystatus[(readch&127)+extended] = ((readch>>7)^1);
		extended = 0;
	}
	interruptend();
}

main(int argc,char **argv)
{
	short int i, j, picnum, posz, y1, y2, y3, y4, x, y, siz;
	unsigned short int l;
	long int templong;

	type = 2;
	if (argc == 2)
	{
		type = atoi(argv[1]);
		if ((type < 0) || (type > 2))
			type = 0;
	}
	ceilingstat = 1;
	vidmode = 0;
	xdim = 320;
	ydim = 200;
	scrsize = 18000;
	xtotaldim = xdim;
	halfwidth = (xdim>>1);
	halfheight = (ydim>>1);
	centeroffset = 0;
	for(i=0;i<320;i++)
	{
		umost[i] = 0;
		dmost[i] = ydim;
	}
	loadtables();
	loadpics();
	setupmouse();
	setvmode(0x13);
	if ((i = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(i,&palette[0],768);
		close(i);
	}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	if (type != 1)
		for(i=0;i<3;i++)
		{
			out(0x3cd,(char)i);
			clearscreen();
		}
	posx = 0;
	posy = 0;
	posz = 8192;
	picnum = 0;
	x = 160;
	y = 100;
	siz = 128;
	j = 0;
	ang = 0;
	numframes = 0;
	totalclock = 0;
	page = 0;
	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();
	oldhand = _dos_getvect(0x8);
	_dos_setvect(0x8, ksmhandler);
	outp(0x43,54); outp(0x40,4972&255); outp(0x40,4972>>8);
	while (keystatus[1] == 0)
	{
		if ((keystatus[0x4e] > 0) && (picnum < maxwalls-1))
		{
			picnum++;
			keystatus[0x4e] = 0;
		}
		if ((keystatus[0x4a] > 0) && (picnum > 0))
		{
			picnum--;
			keystatus[0x4a] = 0;
		}
		if (type == 0)
		{
			if (moustat == 1)
				readmouse();
			if (keystatus[0xcb] > 0) mousx -= 10;
			if (keystatus[0xcd] > 0) mousx += 10;
			if (keystatus[0xc8] > 0) mousy -= 6;
			if (keystatus[0xd0] > 0) mousy += 6;
			ang += mousx;
			posx -= (((long)sintable[(2560+ang)&2047]*mousy)>>12);
			posy -= (((long)sintable[(2048+ang)&2047]*mousy)>>12);
			if ((keystatus[0x1e] > 0) && (posz > 128)) posz -= 128;
			if ((keystatus[0x2c] > 0) && (posz < 16256)) posz += 128;
			for(i=0;i<100;i++)
				hline(0,xdim-1,i,posz,picnum,(char)0);
			for(i=100;i<ydim;i++)
				hline(0,xdim-1,i,16383-posz,picnum,(char)0);
		}
		else if (type == 1)
		{
			clearvscreen();
			for(i=0;i<320;i+=2)
			{
				y1 = 16+(sintable[((numframes<<4)+(i<<4))&2047]>>10);
				y2 = 184-(sintable[(2560-((i*23)-(numframes<<6)))&2047]>>10);
				y3 = 16+(sintable[((numframes<<4)+((i+1)<<4))&2047]>>10);
				y4 = 184-(sintable[(2560-(((i+1)*23)-(numframes<<6)))&2047]>>10);
				//vline(i,y1,y2,(y2-y1)<<2,picnum,i<<6,(char)0);
				//vline(i+1,y3,y4,(y4-y3)<<2,picnum,(i+1)<<6,(char)0);
				vline2(i,y1,y2,y3,y4,(y2-y1)<<2,(y4-y3)<<2,picnum,i<<6,(i+1)<<6,(char)0);
			}
		}
		else if (type == 2)
		{
			if (keystatus[0xcb] > 0) x--;
			if (keystatus[0xcd] > 0) x++;
			if (keystatus[0xc8] > 0) y--;
			if (keystatus[0xd0] > 0) y++;
			if ((keystatus[0xc9] > 0) && (siz > 1)) siz--;
			if (keystatus[0xd1] > 0) siz++;

			clearscreen();
			lin[0].picnum = picnum;
			lin[0].shade = 0;
			snum = 0;
			if (snum < maxsprites-1)
			{
				xs[snum] = x;
				ys[snum] = y;
				sizs[snum] = siz;
				sline[snum] = 0;
				for(j=0;j<xdim;j++)
				{
					sumost[snum][j] = (char)(16+(sintable[((numframes<<4)+(j<<4))&2047]>>10));
					sdmost[snum][j] = (char)(184-(sintable[(2560-((j*23)-(numframes<<6)))&2047]>>10));
				}
				snum++;
			}
			if (snum > 0)
				drawsprites();
		}
		numframes++;
		outp(0x3d4,0xc), outp(0x3d5,page<<6);
		page++;
		if (page == 3)
			page = 0;
		outp(0x3cd,page);
	}
	_dos_setvect(0x8, oldhand);
	_dos_setvect(0x9, oldkeyhandler);
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	free(pic);
	setvmode(0x3);
	if (totalclock != 0)
	{
		templong = (numframes*24000L)/totalclock;
		printf("%d.%1d%1d frames per second\n",(int)(templong/100),(int)((templong/10)%10),(int)(templong%10));
	}
}

loadtables()
{
	short int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		read(fil,&tantable[0],4096);
		close(fil);
	}
}

loadpics()
{
	long totpicsiz, offscount, siz;
	int fil, i;

	if ((fil=open("pics.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		return(-1);
	read(fil,&picsiz[0],1024);
	read(fil,&picanm[0],1024);
	totpicsiz = 0L;
	for(i=0;i<maxwalls;i++)
		if (picsiz[i] > 0)
			totpicsiz += (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
	pic = (char *)malloc(totpicsiz);
	offscount = 0L;
	for(i=0;i<maxwalls;i++)
	{
		waloff[i] = offscount+FP_OFF(pic);
		if (picsiz[i] > 0)
		{
			siz = (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
			read(fil,&pic[offscount],siz);
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}

vline(x, y1, y2, siz, walnume, picplc, shadeoffs)
int x, y1, y2, siz, walnume, picplc;
unsigned char shadeoffs;
{
	unsigned char shiftval;
	unsigned short int thesiz;
	unsigned long vinc, vplc, p;

	thesiz = y2-y1;
	if ((y1 > dmost[x]) || (y2 < umost[x]) || (thesiz <= 0) || (siz <= 0) || (picsiz[walnume] == 0))
		return(0);
	takernum = 5;
	if (ceilingstat >= 3)
		walnume = 55;
	if (picanm[walnume] > 0)
		walnume += (numframes%(picanm[walnume]+1));

	picplc &= ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
	vinc = 33554432L / ((long)siz);
	vplc = (((long)picplc)<<16);
	if (y1 < umost[x])
	{
		vplc += ((long)(umost[x]-y1))*vinc;
		y1 = umost[x];
	}
	if (y2 > dmost[x]) y2 = dmost[x];
	thesiz = y2-y1;
	if ((thesiz < 1) || (thesiz > ydim))
		return(-1);

	if (((char)(vinc>>16)) < 8)
		shadeoffs -= (char)(vinc>>16);
	else
		shadeoffs -= 8;

	shiftval = 32-(picsiz[walnume]>>4);
	vplc <<= (shiftval-16);
	vinc <<= (shiftval-16);
	p = ((long)(y1*320+x))+0x000a0000;
	takernum = 6;
	vlineasm1(vinc&0xffffff00,(vplc&0xffffff00)|shiftval,(thesiz<<8)+shadeoffs,picplc+waloff[walnume],p);
	return(0);
}

vline2(x, y1, y2, y3, y4, siz1, siz2, walnume, picplc1, picplc2, shadeoffs)
int x, y1, y2, y3, y4, siz1, siz2, walnume, picplc1, picplc2;
unsigned char shadeoffs;
{
	unsigned char shiftval;
	unsigned short int thesiz1, thesiz2, doubsiz;
	unsigned long picoffs1, picoffs2;

	thesiz1 = y2-y1;
	thesiz2 = y4-y3;
	if ((y1 > dmost[x]) || (y2 < umost[x]) || (thesiz1 <= 0) || (siz1 <= 0) || (picsiz[walnume] == 0))
	{
		vline(x+1,y3,y4,siz2,walnume,picplc2,shadeoffs);
		return(0);
	}
	if ((y3 > dmost[x+1]) || (y4 < umost[x+1]) || (thesiz2 <= 0) || (siz2 <= 0))
	{
		vline(x,y1,y2,siz1,walnume,picplc1,shadeoffs);
		return(0);
	}
	takernum = 5;
	if (ceilingstat >= 3)
		walnume = 55;
	if (picanm[walnume] > 0)
		walnume += (numframes%(picanm[walnume]+1));

	picplc1 &= ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
	vinc1 = 33554432L / ((long)siz1);
	vplc1 = (((long)picplc1)<<16);
	if (y1 < umost[x])
	{
		vplc1 += ((long)(umost[x]-y1))*vinc1;
		y1 = umost[x];
	}
	if (y2 > dmost[x]) y2 = dmost[x];
	thesiz1 = y2-y1;
	if (thesiz1 < 1)
	{
		vline(x+1,y3,y4,siz2,walnume,picplc2,shadeoffs);
		return(0);
	}

	picplc2 &= ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
	vinc2 = 33554432L / ((long)siz2);
	vplc2 = (((long)picplc2)<<16);
	if (y3 < umost[x+1])
	{
		vplc2 += ((long)(umost[x+1]-y3))*vinc2;
		y3 = umost[x+1];
	}
	if (y4 > dmost[x+1]) y4 = dmost[x+1];
	thesiz2 = y4-y3;
	if (thesiz2 < 1)
	{
		vline(x,y1,y2,siz1,walnume,picplc1,shadeoffs);
		return(0);
	}

	if (((char)(vinc1>>16)) < 8)
		shadeoffs -= (char)(vinc1>>16);
	else
		shadeoffs -= 8;
	shiftval = 32-(picsiz[walnume]>>4);
	vplc1 <<= (shiftval-16);
	vinc1 <<= (shiftval-16);
	vplc2 <<= (shiftval-16);
	vinc2 <<= (shiftval-16);
	vplc1 += shiftval;
	vplc2 += shadeoffs;
	picoffs1 = (long)picplc1+waloff[walnume];
	picoffs2 = (long)picplc2+waloff[walnume];

	takernum = 6;
	if (y1 < y3)
	{
		pplc = ((long)(y1*320+x))+0x000a0000;
		if (y2 < y4)
			doubsiz = y2-y3;
		else
			doubsiz = y4-y3;
	}
	else
	{
		pplc = ((long)(y3*320+x))+0x000a0000;
		if (y2 < y4)
			doubsiz = y2-y1;
		else
			doubsiz = y4-y1;
	}
	if (y1 < y3)
		vlineasm2l(((long)(y3-y1-1))<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	if (y1 > y3)
		vlineasm2r(((long)(y1-y3-1))<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	vlineasm2b(((long)doubsiz-1)<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	if (y2 < y4)
		vlineasm2r(((long)(y4-y2-1))<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	if (y2 > y4)
		vlineasm2l(((long)(y2-y4-1))<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	return(0);
}

hline (xl, xr, yp, zd, walnume, shadeoffs)
unsigned short int xl, xr, yp, zd;
short int walnume;
char shadeoffs;
{
	short int i, siz;
	long hd, x, y, xc, yc;

	if ((yp == halfheight) || (picsiz[walnume] == 0))
		return(-1);
	if (ceilingstat >= 3)
		walnume = 54;
	if (picanm[walnume] > 0)
		walnume += (numframes%(picanm[walnume]+1));
	if (xl > xr)
		i = xl, xl = xr, xr = i;
	siz = xr-xl+1;
	takernum = 7;
	hd = (((long)zd)<<14)/((long)(xtotaldim*abs(halfheight-yp)));
	xc = (hd*(long)sintable[(2048+ang)&2047])>>2;
	yc = (hd*(long)sintable[(2560+ang)&2047])>>2;
	x = xc*(long)xl - (xc+yc)*(long)halfwidth - (posx<<22);
	y = yc*(long)xl + (xc-yc)*(long)halfwidth + (posy<<22);
	if (yp > halfheight)
	{
		y ^= 0xffffffff;
		yc ^= 0xffffffff;
	}
	if ((hd>>13) < 8)
		shadeoffs -= (char)(hd>>13);
	else
		shadeoffs -= 8;
	takernum = 8;
	vinc1 = (xc&0xffffff00);
	if ((picsiz[walnume]&15) == 6)
		hlineasm64(((long)(siz&1))<<16,((long)(yp*320+xl))+0x000a0000,(x&0xffffff00)|shadeoffs,(y&0xffffff00)|(siz>>1),waloff[walnume],yc&0xffffff00);
	else if ((picsiz[walnume]&15) == 7)
		hlineasm128(((long)(siz&1))<<16,((long)(yp*320+xl))+0x000a0000,(x&0xffffff00)|shadeoffs,(y&0xffffff00)|(siz>>1),waloff[walnume],yc&0xffffff00);
	takernum = 4;
	return(0);
}

drawsprites()
{
	unsigned char shiftval, shadeoffs;
	unsigned short int thesiz, walnume, picplc;
	unsigned long vinc, nvinc, vplc, p;
	long siz, y1, y2, ny1, ny2, linume, lininc, pictot, xsiz, ysiz;
	short int i, j, k, lside, rside, maskval, gap, temp, sordi;

	takernum = 2;
	for(i=0;i<snum;i++)
		sord[i] = i;
	gap = (snum>>1);
	while (gap > 0)
	{
		for(i=0;i<snum-gap;i++)
		{
			temp = i;
			while (sizs[temp] > sizs[temp+gap])
			{
				j = sord[temp];
				sord[temp] = sord[temp+gap];
				sord[temp+gap] = j;
				temp -= gap;
				if (temp < 0)
					break;
			}
		}
		gap >>= 1;
	}
	for(i=0;i<snum;i++)
	{
		sordi = sord[i];
		if (sizs[sordi] == 0)
			sizs[sordi] = 1;
		vinc = 4194304L / sizs[sordi];
		shadeoffs = lin[sline[sordi]].shade;
		if (((char)(vinc>>16)) < 8)
			shadeoffs -= (char)(vinc>>16);
		else
			shadeoffs -= 8;
		if ((lin[sline[sordi]].cstat&16) > 0)
		{
			sizs[sordi] >>= 1;
			if (sizs[sordi] == 0)
				sizs[sordi] = 1;
		}
		walnume = lin[sline[sordi]].picnum;
		if (ceilingstat >= 3)
			walnume = 55;
		if (picanm[walnume] > 0)
			walnume += (numframes%(picanm[walnume]+1));
		xsiz = ((sizs[sordi]<<(picsiz[walnume]&15))>>6);
		ysiz = ((sizs[sordi]<<(picsiz[walnume]>>4))>>6);
		lside = (short)(xs[sordi]-(xsiz>>1));
		rside = (short)(lside+xsiz);
		y1 = ys[sordi]-(ysiz>>1);
		y2 = y1+ysiz;
		shiftval = 32-(picsiz[walnume]>>4);
		nvinc = vinc<<(shiftval-16);
		pictot = (1<<((long)((picsiz[walnume]&15)+(picsiz[walnume]>>4))));
		linume = 0L;
		lininc = (pictot<<16)/(xsiz+1);
		maskval = ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
		if ((sizs[sordi] > 1) && (picsiz[walnume] != 0))
			for(j=lside;j<=rside;j++)
			{
				if ((j >= 0) && (j < xdim) && (y1 <= sdmost[sordi][j]) && (y2 >= sumost[sordi][j]))
				{
					ny1 = y1;
					ny2 = y2;
					picplc = ((short)(linume>>16))&maskval;
					vplc = (((long)picplc)<<16);
					if (ny1 < ((long)sumost[sordi][j]))
					{
						vplc += ((((long)sumost[sordi][j]))-ny1)*vinc;
						ny1 = ((long)sumost[sordi][j]);
					}
					if (ny2 > ((long)sdmost[sordi][j])) ny2 = ((long)sdmost[sordi][j]);
					thesiz = ny2-ny1;
					if ((thesiz > 0) && (thesiz <= ydim))
					{
						vplc <<= (shiftval-16);
						p = ((long)(ny1*320+j))+0x000a0000+centeroffset;
						svlineasm1(nvinc&0xffffff00,(vplc&0xffffff00)|shiftval,(thesiz<<8)+shadeoffs,picplc+waloff[walnume],p);
					}
				}
				linume += lininc;
			}
	}
	return(0);
}
