// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <math.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

static long tantable[1024];
static int sintable[2048];
static int radarang[320];

main()
{
	int fil, i, j;

	printf("Calculating sintable...\n");
	for(i=0;i<2048;i++)
		sintable[i] = (int)(16384*sin((double)i*3.141592/1024));
	printf("Calculating tantable...\n");
	for(i=0;i<1024;i++)
		tantable[i] = (long)(65536*tan((double)i*3.141592/1024));
	printf("Calculating radarangs...\n");
	for(i=0;i<160;i++)
		radarang[i] = (int)(atan(((double)i-160)/160)*1024/3.141592)+1;
	for(i=160;i<320;i++)
		radarang[i] = (int)(atan(((double)i-159)/160)*1024/3.141592)-1;
	printf("Saving tables.dat...\n");
	if ((fil = open("tables.dat",O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) != -1)
	{
		write(fil,&sintable[0],4096);
		write(fil,&tantable[0],4096);
		write(fil,&radarang[0],640);
		close(fil);
	}
	printf("All done!\n");
}
